$Adventure::MovementSpeed = 7; //Use a uniform Movement Speed for all Adventure datablocks (i.e. Main and its children)

//Base Adventure Player
datablock PlayerData(PlayerAdventure : PlayerStandardArmor) //Main
{
	canJet = false; //Disable jets (bool) - Default

	canAdventure = true; //Adventure script hook (applies to all of the following datablocks)
	canAdventureAim = true; //Aiming script hook

//	runForce = 4320; //Default (4320)
	jumpForce = 0; //900; ////Default (1080)

	maxForwardSpeed = $Adventure::MovementSpeed; //set uniform movement speed (for all directions)
	maxBackwardSpeed = $Adventure::MovementSpeed; //..
	maxSideSpeed = $Adventure::MovementSpeed; //..

	maxForwardCrouchSpeed = $Adventure::MovementSpeed; //set uniform crouch movement speed (for all directions)
	maxBackwardCrouchSpeed = $Adventure::MovementSpeed; //..
	maxSideCrouchSpeed = $Adventure::MovementSpeed; //..

//	cameraMaxDist = 8; //Default (8)
//	cameraTilt = 0.261; //0.0; //Default (0.261)
//	cameraVerticalOffset = 0.75; //Default (0.75)
//	cameraVerticalOffset = 1.7; //Default (0.75)

//	airControl = 0.1; (0.1 is Default)

	minImpactSpeed = 20; //For Fall Damage Scaling

	uiName = "Adventure Player";
};

//Adventure Hanging Player
datablock PlayerData(PlayerAdventureHang : PlayerAdventure) //Climbing
{
	canAdventureHang = true; //Hanging script hook
	canAdventureAim = false; //Unparent Aiming script hook

	maxStepHeight = 0; //Disable stepping
	
	jumpForce = 0; //Disable jumping (float)
	runForce = 3000; //Standard Player (4320)

	airControl = 0; //Disable Air Control (float)

	maxLookAngle = 0; //Force look straight ahead
	minLookAngle = 0; //..

//	boundingBox = "5 5 10.6"; //"5 5 10"; //makes it easier to Pull-up

	uiName = ""; //clear PlayerAdventure's ui name
};

//No-Jump Player
datablock PlayerData(PlayerAdventureNoJump : PlayerAdventure) //No jumping
{
	canNoJump = true; //No-Jump script hook
	
	jumpForce = 0; //Disable jumping (float)

	uiName = ""; //clear PlayerAdventure's ui name
};
//No-Air-Control Player
datablock PlayerData(PlayerAdventureNoAirCtrl : PlayerAdventureNoJump) //No Air-Control
{
	airControl = 0; //Disable Air Control (float)
};
//No-Move Player
datablock PlayerData(PlayerAdventureNoMove : PlayerAdventureNoAirCtrl) //No Movement
{
	canNoMove = true; //No-Move script hook
	canNoJump = false; //Unparent No-Jump script hook

	jumpForce = 0; //PlayerAdventure.jumpForce; //use Main datablock's jumpForce (otherwise it inherits a value of 0, from its Parents)

	maxForwardSpeed = 0; //nullify movement speed (float)
	maxBackwardSpeed = 0; //..
	maxSideSpeed = 0; //..

	maxForwardCrouchSpeed = 0; //..
	maxBackwardCrouchSpeed = 0; //..
	maxSideCrouchSpeed = 0; //..
};

//Air-Dive Player
datablock PlayerData(PlayerAdventureDive : PlayerAdventureNoJump) //Air-Dive to-Ledge
{
	canAdventureAim = false; //Unparent Aiming script hook
	
	maxLookAngle = -0.2; //Force look, very slightly, diagonally up
	minLookAngle = -0.2; //..
};

//Look-up Player
datablock PlayerData(PlayerAdventureLookUp : PlayerAdventureNoAirCtrl) //Look-up
{
	canAdventureAim = false; //Unparent Aiming script hook
	
	maxLookAngle = -0.6; //Force look diagonally up
	minLookAngle = -0.6; //..
};
//Look-Down Player
datablock PlayerData(PlayerAdventureLookDown : PlayerAdventureLookUp) //Look-Down (Smart Drop)
{
	maxLookAngle = 0.6; //Force look diagonally down
	minLookAngle = 0.6; //..
};
//Smart Drop Player 
datablock PlayerData(PlayerAdventureSmartDrop : PlayerAdventureLookUp) //Look-Down (Smart Drop)
{
	maxLookAngle = 1.4; //Force look far diagonally down
	minLookAngle = 1.4; //..
};


//Sprinting Player
datablock PlayerData(PlayerAdventureRun : PlayerAdventure) //Sprinting
{
	canAdventureRun = true; //reference shortcut
//	jumpForce = 0; //Default (1080)
	
	maxLookAngle = 1.5; //Force look far diagonally down
	minLookAngle = 0; //..	

	cameraMaxDist = 24; //Default is 8
	cameraTilt = -0.3; //Default (0.261)
//	cameraVerticalOffset = 1.7; //Default (0.75)
	
	maxForwardSpeed = $Adventure::MovementSpeed*2; //set uniform movement speed (for all directions)
	maxBackwardSpeed = $Adventure::MovementSpeed*2; //..
	maxSideSpeed = $Adventure::MovementSpeed*2; //..

	maxForwardCrouchSpeed = $Adventure::MovementSpeed*2; //set uniform crouch movement speed (for all directions)
	maxBackwardCrouchSpeed = $Adventure::MovementSpeed*2; //..
	maxSideCrouchSpeed = $Adventure::MovementSpeed*2; //..

	uiName = "";
};