//Craft Hammer
datablock ExplosionData(CraftHammerExplosion : HammerExplosion)
{
   soundProfile = HammerHitSound;
};

datablock ProjectileData(CraftHammerProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 0;
   directDamageType = $DamageType::Generic;
   radiusDamageType = $DamageType::Generic;
   impactImpulse	   = 0;
   verticalImpulse	   = 0;
//   explosion           = CraftHammerExplosion;
   explosion		   = "";
   particleEmitter     = "";

   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;             
   brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   muzzleVelocity      = 00;
   velInheritFactor    = 1.0;

   armingDelay         = 00;
   lifetime            = 00;
   fadeDelay           = 00;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 5.0;
   lightColor  = "0 0.1 0.6";

   uiName = "";
};

datablock ItemData(CraftHammerItem)
{
	category = "Item";  // Mission editor category
	className = "Item"; // For inventory system

	 // Basic Item Properties
	shapeFile = "base/data/shapes/hammer.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "";
	iconName = "";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1";

	 // Dynamic properties defined by the scripts
	image = CraftHammerImage;
	canDrop = true;
};

datablock ShapeBaseImageData(CraftHammerImage)
{
   // Basic Item properties
   shapeFile = "base/data/shapes/hammer.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleVector = false;

   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = CraftHammerProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = true;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = CraftHammerItem.colorShiftColor;

   // Initial start up state
	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "Fire";
	stateTimeoutValue[0] = 0.2;
	stateSequence[0] = "ready";

	stateName[1] = "Ready";
	stateTransitionOnTriggerUp[1] = "Fire";

	stateName[2] = "Fire";
	stateTransitionOnTimeout[2] = "Smoke";
   stateWaitForTimeout[2] = true;
	stateTimeoutValue[2] = 0.1;
	stateFire[2] = true;
	stateAllowImageChange[2] = false;
	stateScript[2] = "onFire";

   stateName[3] = "Smoke";
	stateTimeoutValue[3]            = 0.1;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4] = "Reload";
	stateAllowImageChange[4] = false;
	stateTransitionOnTriggerUp[4] = "FireAkimbo";
	stateSequence[4] = "ready";

	stateName[5] = "FireAkimbo";
	stateTimeoutValue[5] = 0.2;
	stateScript[5] = "onFireAkimbo";
	stateTransitionOnTimeOut[5] = "Ready";
};

function CraftHammerImage::onFireAkimbo(%this,%obj,%slot)
{
   %obj.setImageTrigger(1,1);
}

datablock ShapeBaseImageData(LeftCraftHammerImage)
{
   // Basic Item properties
   shapeFile = "base/data/shapes/hammer.dts";
   emap = true;

   mountPoint = 1;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleVector = true;

   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = CraftHammerProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = false;

   doColorShift = true;
   colorShiftColor = CraftHammerItem.colorShiftColor;

   // Initial start up state
	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "Ready";
	stateTimeoutValue[0] = 0.1;
	stateSequence[0] = "ready";

	stateName[1] = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";

	stateName[2] = "Fire";
	stateTransitionOnTimeout[2] = "Smoke";
   stateWaitForTimeout[2] = true;
	stateTimeoutValue[2] = 0.1;
	stateFire[2] = true;
	stateAllowImageChange[2] = false;
	stateScript[2] = "onFire";

   stateName[3] = "Smoke";
	stateTimeoutValue[3]            = 0.1;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4] = "Reload";
	stateAllowImageChange[4] = false;
	stateTransitionOnTriggerUp[4] = "Ready";
	stateSequence[4] = "ready";
};

function CraftHammerImage::onFire(%this, %obj, %slot)
{
   Parent::onFire(%this,%obj,%slot);
   if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, shiftaway);
}

function LeftCraftHammerImage::onFire(%this, %obj, %slot)
{
   Parent::onFire(%this,%obj,%slot);
   if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, leftrecoil);
}

function CraftHammerImage::onMount(%this, %obj, %slot)
{
   Parent::onMount(%this, %obj, %slot);
   //mount lefthanded gun
   %obj.mountImage(LeftCraftHammerImage, 1);
   %obj.playthread(1,armreadyboth);
}
function CraftHammerImage::onUnMount(%this, %obj, %slot)
{
   Parent::onUnMount(%this, %obj, %slot);
   //unmount lefthanded gun
   %obj.unMountImage(1);
}

function LeftCraftHammerImage::onMount(%this, %obj, %slot)
{
   Parent::onMount(%this, %obj, %slot);
}
function LeftCraftHammerImage::onUnMount(%this, %obj, %slot)
{
   Parent::onUnMount(%this, %obj, %slot);
}




datablock ItemData(CraftHammerRedItem : CraftHammerItem)
{
   shapeFile = "base/data/shapes/hammer.dts";
   uiName = "";
   colorShiftColor = "0.5 0 0 1";
   iconName = "";
   image = CraftHammerRedImage;
};

datablock ShapeBaseImageData(CraftHammerRedImage : CraftHammerImage)
{
   shapeFile = "base/data/shapes/hammer.dts";
   colorShiftColor = CraftHammerRedItem.colorShiftColor;
};

function CraftHammerRedImage::onFireAkimbo(%this,%obj,%slot)
{
   %obj.setImageTrigger(1,1);
}

datablock ShapeBaseImageData(LeftCraftHammerRedImage : LeftCraftHammerImage)
{
   shapeFile = "base/data/shapes/hammer.dts";
   colorShiftColor = CraftHammerRedItem.colorShiftColor;
};

function CraftHammerRedImage::onFire(%this, %obj, %slot)
{
	Parent::onFire(%this,%obj,%slot);
	%obj.playThread(2, shiftaway);
}

function LeftCraftHammerRedImage::onFire(%this, %obj, %slot)
{
	Parent::onFire(%this,%obj,%slot);
	%obj.playThread(2, leftrecoil);
}

function CraftHammerRedImage::onMount(%this, %obj, %slot)
{
   Parent::onMount(%this, %obj, %slot);
   //mount lefthanded gun
   %obj.mountImage(LeftCraftHammerRedImage, 1);
   %obj.playthread(1,armreadyboth);
}
function CraftHammerRedImage::onUnMount(%this, %obj, %slot)
{
   Parent::onUnMount(%this, %obj, %slot);
   //unmount lefthanded gun
   %obj.unMountImage(1);
}