//SFX
datablock AudioProfile(JumpCartoonCSound)
{
   filename    = "./JumpCartoonC.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(JumpWooshBSound)
{
   filename    = "./JumpWooshB.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(GlideStartFixSound)
{
   filename    = "./GlideStartFix.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(KingdomLevelSound)
{
	fileName = "base/data/sound/orchhith.wav";
	description = AudioClosest3d;
	preload = true;
};


//Playertypes
datablock PlayerData(PlayerKingdomHearts : PlayerStandardArmor)
{
	canJet = false;
	canKingdom = true;
	maxTools = 1;
	maxItems = 10;
	maxWeapons = 3;

	maxForwardSpeed = 8;
	maxBackwardSpeed = 5;
	maxSideSpeed = 7;

	maxForwardCrouchSpeed = 4;
	maxBackwardCrouchSpeed = 3;
	maxSideCrouchSpeed = 3;

	airControl = 0.04; //0.1;
	runForce = 10000; //4320;
	pickupRadius = 3; //1.25;

	uiName = "KH Player";
	showEnergyBar = true;
	rechargeRate = 0;
};
datablock PlayerData(PlayerKingdomNoJump : PlayerKingdomHearts) //Super jump fix
{
	jumpForce = 0;
	uiName = "";
};

datablock PlayerData(PlayerKingdomQuickRun : PlayerKingdomNoJump) //Quick Run
{
	airControl = 0;
	maxForwardSpeed = 20;
	maxBackwardSpeed = 20;
	maxSideSpeed = 20;
	maxForwardCrouchSpeed = 10;
	maxBackwardCrouchSpeed = 10;
	maxSideCrouchSpeed = 10;
};
datablock PlayerData(PlayerKingdomGlide0 : PlayerKingdomQuickRun) //Super Glide
{
	canKingdomGlide = true;
	airControl = 0.1;
	maxLookAngle = 1;
	minLookAngle = -1;
	maxForwardCrouchSpeed = 25;
	maxBackwardCrouchSpeed = 0;
	maxSideCrouchSpeed = 0;
};
datablock PlayerData(PlayerKingdomGlide1 : PlayerKingdomGlide0) //Super Glide
{
	maxForwardCrouchSpeed = PlayerKingdomGlide0.maxForwardCrouchSpeed - 1;
};
datablock PlayerData(PlayerKingdomGlide2 : PlayerKingdomGlide0) //Super Glide
{
	maxForwardCrouchSpeed = PlayerKingdomGlide0.maxForwardCrouchSpeed - 2;
};
datablock PlayerData(PlayerKingdomGlide3 : PlayerKingdomGlide0) //Super Glide
{
	maxForwardCrouchSpeed = PlayerKingdomGlide0.maxForwardCrouchSpeed - 3;
};
datablock PlayerData(PlayerKingdomGlide4 : PlayerKingdomGlide0) //Super Glide
{
	maxForwardCrouchSpeed = PlayerKingdomGlide0.maxForwardCrouchSpeed - 4;
};
datablock PlayerData(PlayerKingdomGlide5 : PlayerKingdomGlide0) //Super Glide
{
	maxForwardCrouchSpeed = PlayerKingdomGlide0.maxForwardCrouchSpeed - 5; //=6
};
datablock PlayerData(PlayerKingdomGlide6 : PlayerKingdomGlide0) //Super Glide
{
	maxForwardCrouchSpeed = PlayerKingdomGlide0.maxForwardCrouchSpeed - 6;
};
datablock PlayerData(PlayerKingdomGlide7 : PlayerKingdomGlide0) //Super Glide
{
	maxForwardCrouchSpeed = PlayerKingdomGlide0.maxForwardCrouchSpeed - 7;
};
datablock PlayerData(PlayerKingdomGlide8 : PlayerKingdomGlide0) //Super Glide
{
	maxForwardCrouchSpeed = PlayerKingdomGlide0.maxForwardCrouchSpeed - 8;
};
datablock PlayerData(PlayerKingdomGlide9 : PlayerKingdomGlide0) //Super Glide
{
	maxForwardCrouchSpeed = PlayerKingdomGlide0.maxForwardCrouchSpeed - 9;
};
datablock PlayerData(PlayerKingdomGlide10 : PlayerKingdomGlide0) //Super Glide
{
	maxForwardCrouchSpeed = PlayerKingdomGlide0.maxForwardCrouchSpeed - 10; //= 15
};

//Normal Bot
datablock PlayerData(PlayerKingdomBot : PlayerKingdomHearts)
{
	isKHWeak = true;
	canKingdom = false;

	uiName = "Bot KH Player";
};
//Weak Bot
datablock PlayerData(PlayerKingdomWeak : PlayerKingdomBot)
{
	maxDamage = 50;
	uiName = "Weak KH Player";
};


//Damage Display
datablock StaticShapeData(KingdomHPData)
{
	category = "Static Shapes";
	shapeFile = "base/data/shapes/empty.dts";
};

//Kingdom Glide
datablock StaticShapeData(KGlideData)
{
	category = "Static Shapes";
	shapeFile = "./cube_col.dts";
};


//Status Display Pic
datablock particleData(KingdomStatusPicData)
{
	textureName = "./Head";
};


//Gliding Cloud Emote
datablock ParticleData(KingdomCloudParticle)
{
	dragCoefficient      = 12;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 300;
	lifetimeVarianceMS   = 20;
	textureName          = "base/data/particles/star1";
	spinSpeed			 = 10.0;
	spinRandomMin		 = -50.0;
	spinRandomMax		 = 50.0;
	colors[0]     = "0 1 1 0";
	colors[1]     = "0 1 1 0.1";
	colors[2]     = "1 1 1 0";
	sizes[0]      = 0.3;
	sizes[1]      = 0.3;
	sizes[2]      = 0.6;
	times[0]	  = 0;
	times[1]	  = 0.5;
	times[2]	  = 1;

	useInvAlpha = true;
};
datablock ParticleEmitterData(KingdomCloudEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 8;
   velocityVariance = 4;
   ejectionOffset   = 0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "KingdomCloudParticle";
};
datablock ShapeBaseImageData(KingdomCloudImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

	mountPoint = 2;
	offset = "0 0.1 0.5";
	eyeOffset = "0 0.1 0.5";

	stateName[0]					= "Ready";
	stateTransitionOnTimeout[0]		= "FireA";
	stateTimeoutValue[0]			= 0.1;

	stateName[1]					= "FireA";
	stateTransitionOnTimeout[1]		= "Ready";
	stateWaitForTimeout[1]			= true;
	stateTimeoutValue[1]			= 0.1;
	stateEmitter[1]					= KingdomCloudEmitter;
	stateEmitterTime[1]				= 0.5;
};


//Custom Wand FX
datablock ExplosionData(KingdomWandExplosion : WandExplosion)
{
	soundProfile = "";
	shakeCamera = false;
};
datablock ProjectileData(KingdomWandProjectile)
{
	explosion = KingdomWandExplosion;
};

//Red Wand FX
datablock ParticleData(KingAgilityExplosionParticle : WandExplosionParticle)
{
	colors[0] = "0 1 1 0.87";
	colors[1] = "0 0 0 0";
	times[0]  = 0;
	times[1]  = 0.2;
	times[2]  = 1;
	times[3]  = 2;
};
datablock ParticleEmitterData(KingAgilityExplosionEmitter : WandExplosionEmitter)
{
	particles = "KingAgilityExplosionParticle";
};
datablock ExplosionData(KingAgilityExplosion : KingdomWandExplosion)
{
	emitter[0] = KingAgilityExplosionEmitter;

	lightStartColor = "0.3 1 1";
	lightEndColor = "0 0 0";
};
datablock ProjectileData(KingAgilityProjectile)
{
	explosion = KingAgilityExplosion;
};

//Green Wand FX
datablock ParticleData(GreenWandExplosionParticle : WandExplosionParticle)
{
	colors[0] = "0 0.87 0.67 0.87";
	colors[1] = "0 0.87 0 0";
};
datablock ParticleEmitterData(GreenWandExplosionEmitter : WandExplosionEmitter)
{
	particles = "GreenWandExplosionParticle";
};
datablock ExplosionData(GreenWandExplosion : KingdomWandExplosion)
{
	emitter[0] = GreenWandExplosionEmitter;

	lightStartColor = "0.3 1 0.3";
	lightEndColor = "0 0 0";
};
datablock ProjectileData(GreenWandProjectile)
{
	explosion = GreenWandExplosion;
};

//Sky Wand FX
datablock ParticleData(SkyWandExplosionParticle : WandExplosionParticle)
{
	colors[0] = "0.3 0.4 1 0.87";
	colors[1] = "0 1 1 0";
};
datablock ParticleEmitterData(SkyWandExplosionEmitter : WandExplosionEmitter)
{
	particles = "SkyWandExplosionParticle";
};
datablock ExplosionData(SkyWandExplosion : KingdomWandExplosion)
{
	emitter[0] = SkyWandExplosionEmitter;

	lightStartColor = "0.3 0.4 1";
	lightEndColor = "0 0 0";
};
datablock ProjectileData(SkyWandProjectile)
{
	explosion = SkyWandExplosion;
};

//Orange Wand FX
datablock ParticleData(OrangeWandExplosionParticle : WandExplosionParticle)
{
	colors[0] = "1 0.5 0 0.87";
	colors[1] = "1 0.7 0.2 0";
};
datablock ParticleEmitterData(OrangeWandExplosionEmitter : WandExplosionEmitter)
{
	particles = "OrangeWandExplosionParticle";
};
datablock ExplosionData(OrangeWandExplosion : KingdomWandExplosion)
{
	emitter[0] = OrangeWandExplosionEmitter;

	lightStartColor = "1 0.5 0";
	lightEndColor = "0 0 0";
};
datablock ProjectileData(OrangeWandProjectile)
{
	explosion = OrangeWandExplosion;
};

//Navy Wand FX
datablock ParticleData(NavyWandExplosionParticle : WandExplosionParticle)
{
	colors[0] = "0 0.1 0.3 0.87";
	colors[1] = "0 0.1 0.3 0";
};
datablock ParticleEmitterData(NavyWandExplosionEmitter : WandExplosionEmitter)
{
	particles = "NavyWandExplosionParticle";
};
datablock ExplosionData(NavyWandExplosion : KingdomWandExplosion)
{
	emitter[0] = NavyWandExplosionEmitter;

	lightStartColor = "0 0.1 0.3";
	lightEndColor = "0 0 0";
};
datablock ProjectileData(NavyWandProjectile)
{
	explosion = NavyWandExplosion;
};

//Gold Wand FX
datablock ParticleData(GoldWandExplosionParticle : WandExplosionParticle)
{
	colors[0] = "0.9 0.6 0 0.87";
	colors[1] = "1 0.8 0 0";
};
datablock ParticleEmitterData(GoldWandExplosionEmitter : WandExplosionEmitter)
{
	particles = "GoldWandExplosionParticle";
};
datablock ExplosionData(GoldWandExplosion : KingdomWandExplosion)
{
	emitter[0] = GoldWandExplosionEmitter;

	lightStartColor = "1 0.8 0";
	lightEndColor = "0 0 0";
};
datablock ProjectileData(GoldWandProjectile)
{
	explosion = GoldWandExplosion;
};

//Pink Wand FX
datablock ParticleData(PinkWandExplosionParticle : WandExplosionParticle)
{
	colors[0] = "1 0 0.5 0.87";
	colors[1] = "1 0.3 0.8 0";
};
datablock ParticleEmitterData(PinkWandExplosionEmitter : WandExplosionEmitter)
{
	particles = "PinkWandExplosionParticle";
};
datablock ExplosionData(PinkWandExplosion : KingdomWandExplosion)
{
	emitter[0] = PinkWandExplosionEmitter;

	lightStartColor = "1 0 0.5";
	lightEndColor = "0 0 0";
};
datablock ProjectileData(PinkWandProjectile)
{
	explosion = PinkWandExplosion;
};


//Wall Jump Emitter
datablock ParticleData(KingdomSecondJumpExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 2.5;
	inheritedVelFactor   = 0.2;
	lifetimeMS           = 200;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/thinring";
	spinSpeed			= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.8 0.8 0.8 0.2";
	colors[1]     = "0.8 0.8 0.8 0";
	sizes[0]      = 0.4;
	sizes[1]      = 1.2;

	useInvAlpha = true;
};
datablock ParticleEmitterData(KingdomSecondJumpExplosionEmitter)
{
   ejectionPeriodMS = 1;
   ejectionVelocity = 6;
   velocityVariance = 1;
   thetaMin         = 89;
   thetaMax         = 90;
   phiVariance      = 360;
   particles = "KingdomSecondJumpExplosionParticle";
};

//Wall Jump FX
datablock ExplosionData(KingdomSecondJumpExplosion)
{
   lifeTimeMS = 150;

   emitter[0] = KingdomSecondJumpExplosionEmitter;
   emitter[1] = KingAgilityExplosionEmitter;

   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";
   
   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "0.5 0.5 0.5";
   camShakeDuration = 0.5;
   camShakeRadius = 5.0;
};
datablock ProjectileData(KingdomSecondJumpProjectile)
{
   explosion = KingdomSecondJumpExplosion;
};

//High Jump FX
datablock ExplosionData(KingdomHighJumpExplosion : KingdomSecondJumpExplosion)
{
   emitter[2] = PushBroomExplosionEmitter;
   camShakeAmp = "1 1 1";
};
datablock ProjectileData(KingdomHighJumpProjectile)
{
   explosion = KingdomHighJumpExplosion;
};


//HP Items
datablock itemData(KingdomHPXItem : printGun)
{
	mass = 5;
	density = 1;
	elasticity = 0.9;
	friction = 2;

	uiName = "";
	shapeFile = "./ball.dts";
	canHeal = true;

	doColorShift = true;
	colorShiftColor = "0 1 0 1";
};
function KingdomHPXItem::onPickup(%this,%item,%col)
{
	if(!%col.isBot && %col.getDatablock().canKingdom)
		KingdomInstaUse(%col,%item,"Health");
}

//MP Item
datablock itemData(KingdomMPXItem : KingdomHPXItem)
{
	colorShiftColor = "0 0 1 1";
};
function KingdomMPXItem::onPickup(%this,%item,%col)
{
	if(!%col.isBot && %col.getDatablock().canKingdom)
		KingdomInstaUse(%col,%item,"Magic");
}


//Mystery Potion
datablock itemData(MysteryPotionItem : printGun)
{
	uiName = "";
	shapeFile = "./elixir5.dts";
	doColorShift = true;
	colorShiftColor = "0.9 0.9 0.9 1";
};
function MysteryPotionItem::onPickup(%this,%item,%col)
{
	if(!%col.isBot && %col.getDatablock().canKingdom && %item.miniGame == %col.client.minigame)
		KingdomMysteryGift(%col,%item);
}


package KingdomHearts
{
	//on Damage
	function Armor::Damage(%data,%player,%sourceObject,%position,%damage,%damageType)
	{
		if(%data.canKingdom)
		{
			%client = %player.client;
			if(!%client.KingdomLevelLock) //if client's 'Level Lock' (XP Zero) is disabled
			{
			//	if(%client.KingdomLevel >= $Pref::KingdomHearts::LvlMax || !$Pref::KingdomHearts::Leveling) //Level 8 and up, or Leveling disabled (auto max level)
				//	%damage = %damage/2; //+100 HP
				// else if(%client.KingdomLevel >= 6) //Levels 6 and 7
					// %damage = %damage/1.75; //+75 HP
				// else if(%client.KingdomLevel >= 4) //Levels 4 and 5
					// %damage = %damage/1.5; //+50 HP
				// else if(%client.KingdomLevel >= 2) //Levels 2 and 3
					// %damage = %damage/1.25; //+25 HP
				
				%defHP = $Pref::KingdomHearts::defHP;
				%LvlHP = $Pref::KingdomHearts::LvlHP;
				%curLvl = !$Pref::KingdomHearts::Leveling ? $Pref::KingdomHearts::LvlMax : %client.KingdomLevel; //if Pref: 'Leveling' off - use max level for 'curLvl', else - use client's current saved level
				%maxDam = %data.maxDamage; //datablock's 'max Damage' level
				%damage = %damage / (%defHP + (%LvlHP * %curLvl) / %maxDam);
			}
		}
		if(%player.hasKingdomAero && %damage > 0) //Aero Spell
		{
			%damage = %damage/2; //Half damage
			if(!%player.justDamaged) //just emoted
			{
				%player.spawnExplosion(KingdomAeroProjectile,1); //Do emote
				schedule(100,0,eval,%player@".justDamaged = false;"); //just emoted timeout
				%player.justDamaged = true; //
			}
		}
	//	echo("on Damage  damage =" SPC %damage);
		Parent::Damage(%data,%player,%sourceObject,%position,%damage,%damageType);
	}
	//on Datablock change
	function Armor::onNewDatablock(%data,%player)
	{
		Parent::onNewDatablock(%data,%player);
		
		%client = %player.client; //player's client
		if(!isObject(%client)) //if no client exists (e.g. Bot)
			return; //stop here
		
		if(%data.getName() $= "PlayerKingdomHearts") //if player data = 'Player Kingdom Hearts'
			schedule(1,0,KingdomHeartsGlobalSilentLoop,%player); //start the Global Silent Loop

		if(%data.canKingdom && !%player.lastData.canKingdom) //if current datablock is a 'Kingdomer', and previous datablock was not
		{
			KingdomRemoveInvTool(%player,0);
			%client.KingdomSlot = -1;
			KingdomSetManaPoints(%player,"Magic",%client.KingdomMaxMagic);
		}
		else if(!%data.canKingdom && %player.lastData.canKingdom) //if current datablock is not a 'Kingdomer', and previous datablock was
		{
			commandToClient(%client,'PlayGui_CreateToolHud',%data.maxTools);
			CloseKingdomMenu(%client);
			%player.hasKingBricksReady = false;
			%player.hasKingBottomMessage = false; //Allow external Bottom Prints again
			bottomPrint(%client,"",1);
		}
		KingdomPaintToggle(%player,%data);
		KingdomBuildToggle(%player,%data);
		
		%player.lastData = %data;
	}
	//on Death
	function Armor::onDisabled(%data,%player,%enabled)
	{
		%emote = %player.getMountedImage(2);
		if(isObject(%emote) && %emote.getName() $= "KingdomStoppedImage")
			%player.unmountImage(2);
		if(%data.canKingdom || %data.isKHWeak)
		{
			if(%data.canKingdom)
			{
				KingdomSetManaPoints(%player,"Magic",0); //set Magic Points value to 0
				%player.client.KingdomSlot = -1;
				KingdomStatusBar(%player,true);
				commandToClient(%player.client,'SetScrollMode',3);
				%player.isKingSpelled = false;
				UpdateKingdomMenu(%player.client);
			}
			%num = $Pref::KingdomHearts::OrbNum;
			SpawnMysteryJar(%player);
			for(%a=0;%a<%num;%a++)
				SpawnEnergyOrb(%player);
		}
		KGlideDataDelete(%player.client);
		Parent::onDisabled(%data,%player,%enabled);
	}
	//Shape Kill on Quit
	function GameConnection::OnClientLeaveGame(%client)
	{
		KGlideDataDelete(%client);
		Parent::OnClientLeaveGame(%client);
	}
	//Weapon Pickup
	function Weapon::onPickup(%this,%item,%col)
	{
		%client = %col.client;
		%data = %col.getDatablock();
		if(%data.canKingdom)
		{
			for(%a=0;%a<%data.maxWeapons;%a++)
			{
				if(%this == %col.slotWeapon[%a])
					return;
				if(%col.slotWeapon[%a] $= "" && getMinigameFromObject(%item) == %client.minigame) //Has empty slot
				{
					%canAdd = true;
					break;
				}
			}
			if(%canAdd)
			{
				%weap = %col.tool[%col.currTool];
				%col.slotWeapon[%a] = %this;
				centerPrint(%client,"<font:impact:30><color:FFFFFF>Got  <color:ff4C4C>" @ %this.uiName,2);
				messageClient(%client,'MsgItemPickup','',"","");
				if(isObject(%weap) && %weap.uiName !$= "Keyblade")
					KingdomAddInvTool(%col,%a,%this);
				if(%item.spawnBrick !$= "") //Has spawn brick
				{
					%item.schedule(%item.spawnBrick.itemRespawnTime,fadeIn);
					%item.fadeOut();
				}
				else //No spawn brick
					%item.delete();
			}
		}
		else
			Parent::onPickup(%this,%item,%col);
	}
	//Item Drop
	function serverCmdDropTool(%client,%slot)
	{
		%player = %client.player;
		%tool = %player.tool[%slot];
		%item = %client.invName[%client.KingdomSlot];
		if(isObject(%player) && %player.getDatablock().canKingdom && (!isObject(%tool) || %tool.uiName !$= "Keyblade"))
		{
			if(isObject(%item) && %item.canKUse && !%item.canKPlayer)
				KingdomRemoveInv(%player,%client.KingdomSlot,true);
			else if(isObject(%tool))
				KingdomRemoveInvTool(%player,%slot,true);
		}
		else
			Parent::serverCmdDropTool(%client,%slot);
	}
	//Activate
	function Player::activateStuff(%player)
	{
		%client = %player.client;
		%data = %player.getDatablock();
		%tool = %player.tool[%player.currTool];
		%item = %client.invName[%client.KingdomSlot];

		if(%player.KingJustClicked || %player.isKingSpelled) //if player just clicked, or is under a spell
			return; //stop here

		%time = $KingClickTime;
		if(%player.KingMagnetEnergy > 0)
		{
			messageClient(%client,'MsgItemPickup','',"","");
			return; //stop here
		}
		if(%tool.uiName !$= "Keyblade")
		{
			if(%item.canKMagic)
				%slot = 1;
			else if(%item.canKUse)
				%slot = 2;
			else
				%slot = 3;
		}
		%wep = %player.getMountedImage(0);
		%ready = %data.canKingdom;
		if(%ready && isObject(%tool) && %tool.uiName $= "Keyblade" && !%client.KingJustKeyToggled)
		{
			KingdomInventoryOpen(%client,0);
			%client.KingJustKeyToggled = true;
			schedule(1000,0,eval,%client@".KingJustKeyToggled = false;");
		}
		if(%item $= "KeybladeBrick" && !%client.KingJustKeyToggled)
		{
			KingdomInventoryCheck(%player,true);
			%client.KingJustKeyToggled = true;
			schedule(1000,0,eval,%client@".KingJustKeyToggled = false;");
		}
		else if(%ready && isObject(%tool) && %tool.uiName !$= "Keyblade")
			KingdomInventoryOpen(%client,%slot);
		else if(%ready && %item.canKPlayer) //Back to Magic/Items menu
		{
			%time = $KingMountTime;
			if(%item.canKMagic)
				%image = KingdomMagicImage;
			UpdateKingdomMenu(%client,%slot);
			KingdomInventoryOpen(%client,%client.KUseSlot);
			%client.lastInv[%client.KUseSlot] = "";
			%client.KUseSlot = "";
		}
		else if(%ready && (%item.canKUse || %item.canKMagic)) //Back to main menu
		{
			UpdateKingdomMenu(%client);
			KingdomInventoryOpen(%client,%slot);
		}
		else if(%ready && %item.canKingdom && %item !$= "KeybladeBrick") //Slot 1
			KingdomInventoryOpen(%client,0);
		else if((!isObject(%wep) || !%ready) && %client.KingdomSlot == -1) //Do regular Activate
			Parent::activateStuff(%player);

		%player.hasKingdomSelected = true;
		schedule(%time+50,0,eval,%player@".hasKingdomSelected = false;");
	}
	//Camera Triggers
	function Observer::onTrigger(%data,%camera,%slot,%val)
	{
		Parent::onTrigger(%data,%camera,%slot,%val);
		%player = %camera.player;
		if(isObject(%player))
			%data = %player.getDatablock();
		if(%data.canKingdom)
		{
			if(%slot == 0 && %val)
				KingdomInventoryCheck(%player);
		}
	}
	//Player Triggers
	function Armor::onTrigger(%data,%player,%slot,%val)
	{
		%client = %player.client; //player's client
		Parent::onTrigger(%data,%player,%slot,%val); //do normal onTrigger stuff
		if(!%data.canKingdom) //if wrong playertype
			return; //stop here
		%pos = %player.getPosition(); //player's position
		%off = vectorAdd(%pos,"0 0" SPC -0.25); //offset player position down
		%isFloor = KingdomBoxCheck(%player,2,%off); //search for floor
		if(%slot == 0)
		{
			%player.isKingClicking = %val; //holding click
			if(%val) //clicked
				KingdomInventoryCheck(%player); //Do menu selection
			else //released click
			{
				KingdomMagicSpecial(%player); //Cast special spell
				KingdomUnMagnetize(%player); //release Magnet
			}
		}
		if(%slot == 2)
		{
			%player.isJumping = %val; //holding Jump key
			if(%val) //jumped
			{
				if(!%player.isKingdomHighJump) //if player hasn't High Jumped
					KingdomHighJump(%player); //do High Jump
				if(!%player.isKingdomJumpLagged) //if player has not just special jumped
				{
					if(!%player.isKingdomJetting) //if player is not holding Jet
						KingdomWallJump(%player); //do Wall Jump
					if(!%isFloor && !%player.isKingdomJump2) //If player is not on the ground and hasn't already Double Jumped
						KingdomSecondJump(%player); //do Double Jump
				}
			}
		}
		if(%slot == 3)
		{
			%player.isKingdomCrouching = %val; //holding Crouch key
			if(%val) //crouched
			{
				if(!%isFloor) //midair
					%player.PreKG = schedule(200,0,KingdomGlide,%player,true); //schedule Glide
				else //on ground
					%player.PreKG = schedule(100,0,KingdomQuickRun,%player,true); //schedule Quick Run
			}
			else //if player released Crouch
				cancel(%player.PreKG); //cancel Glide and Quick Run
		}
		if(%slot == 4) //Jetted
			%player.isKingdomJetting = %val; //holding Jet key
	}
	//Bricks Gui Stuff
	function servercmdUseInventory(%client,%slot)
	{
		%player = %client.player;
		if(isObject(%player))
			%data = %player.getDatablock();
		if(!%data.canKingdom)
		{
			Parent::servercmdUseInventory(%client,%slot);
			return;
		}
		%wep = %player.getMountedImage(0);
		if(!isObject(%wep) || !%wep.canKingdom)
		{
			if(!%player.hasKingdomSelected)
				OpenKingdomMenu(%client);
		}
		if(isObject(%item = %client.invName[%client.KingdomSlot])) //If client is in the Command Menu
		{
			if(%item.canKMagic) //If client is in Magic menu
				%image = KingdomMagicImage; //use Magic image
			KingdomInventoryEquip(%client,%image); //equip image
		}
		cancel(%client.hKCFix); //Fix wrong slot when selecting
		if(!%player.hasKingdomSelected)
			%client.KingdomSlot = %slot;
		else if(%client.KingdomSlot != %slot)
			%client.hKCFix = schedule(50,0,eval,%client@".KingdomSlot ="@%slot@";");
	}
	//Brick Fixes
	function servercmdInstantUseBrick(%client,%brickdata)
	{
		%player = %client.player;
		if(isObject(%player))
			%data = %player.getDatablock();
		if(%data.canKingdom)
		{
			UpdateKingdomMenu(%player.client);
			commandToClient(%client,'repurposekeybinds',true);
		}
		else
			Parent::servercmdInstantUseBrick(%client,%brickdata);
	}
	function servercmdBuyBrick(%client,%i,%id)
	{
		%player = %client.player;
		Parent::serverCmdBuyBrick(%client,%i,%id);
		if(isObject(%player) && %player.getDatablock().canKingdom)
			UpdateKingdomMenu(%client);
	}
	//Mount Weapon Image
	function WeaponImage::onMount(%this,%player,%slot)
	{
		Parent::onMount(%this,%player,%slot);
		if(%slot == 0)
			cancel(%player.KSlotFix);
	}
	//Unmount Weapon Image
	function WeaponImage::onUnMount(%this,%player,%slot)
	{
		%client = %player.client;
		Parent::onUnMount(%this,%player,%slot);
		if(%slot != 0 || !%this.canKingdom)
			return;
		if(%player.hasKingdomSelected)
		{
			cancel(%player.KSlotFix);
			%player.KSlotFix = schedule($KingMountTime+50,0,KingdomSlotFix,%client);
		}
		else if(%player.currTool == -1)
		{
			cancel(%player.KSlotFix);
			%player.KSlotFix = schedule($KingClickTime,0,KingdomSlotFix,%client);
		}
	}
	//Equip Tool
	function serverCmdUseTool(%client,%slot)
	{
		%player = %client.player;
		Parent::serverCmdUseTool(%client,%slot);
		%client.KingdomSlot = -1;
		cancel(%player.KSlotFix);
	}
	//Unequip Tool
	function serverCmdUnuseTool(%client)
	{
		%player = %client.player;
		if(isObject(%player))
			%data = %player.getDatablock();
		if(%data.canKingdom && isObject(%tool = %player.tool[%player.currTool]))
		{
			for(%a=0;%a<%data.maxWeapons;%a++)
				KingdomRemoveInvTool(%player,%a); //Remove tools
		}
		Parent::serverCmdUnuseTool(%client);
	}
	//Painting
	function servercmdUseSprayCan(%client,%color)
	{
		%player = %client.player;
		if(!isObject(%player) || !%player.getDatablock().canKingdom)
			Parent::servercmdUseSprayCan(%client,%color);
	}
	function servercmdUseFxCan(%client,%color)
	{
		%player = %client.player;
		if(!isObject(%player) || !%player.getDatablock().canKingdom)
			Parent::servercmdUseFxCan(%client,%color);
	}
	//Bottom Print
	function BottomPrint(%client,%message,%time)
	{
		if((!isObject(%player = %client.player) || !%player.getDatablock().canKingdom) || (!%player.hasKingBottomMessage || %player.isKingBottomMessaging))
		{
			if(%player.isKingBottomMessaging)
				%player.isKingBottomMessaging = false; //Disable messaging after successful print
			return Parent::BottomPrint(%client,%message,%time);
		}
	}
	//Camera Spy Fix
	function SimObject::onCameraEnterOrbit(%player,%camera)
	{
		if(%player.getDatablock().canKingdom) //If playertype is a Kingdom Hearts one
			%player.observerCount++; //raise observer count
		else //otherwise continue normally
			Parent::onCameraEnterOrbit(%player,%camera);
	}
	function SimObject::onCameraLeaveOrbit(%player,%camera)
	{
		if(%player.getDatablock().canKingdom) //If playertype is a Kingdom Hearts one
			%player.observerCount--; //lower observer count
		else //otherwise continue normally
			Parent::onCameraLeaveOrbit(%player,%camera);
	}
};activatePackage(KingdomHearts);


//Fix not having bricks on spawn
function KingdomGiveABrick(%player)
{
	if(%player.hasKingBricksReady)
		return;
	%client = %player.client;
	%client.inventory[0] = 200;
	messageClient(%client,'MsgSetInvData',"",0,200);
}

//Disable Paint
function KingdomPaintToggle(%player,%data)
{
	%client = %player.client;
	if(%data.canKingdom && %client.cannotPaint $= "")
	{
		%client.cannotPaint = "KingdomHearts";
		commandToClient(%client,'SetPaintingDisabled',true);
	}
	else if(!%data.canKingdom && %client.cannotPaint $= "KingdomHearts")
	{
		%mini = %client.minigame;
		if(!isObject(%mini))
			%paint = true;
		else
			%paint = %client.minigame.enablePainting;
		commandToClient(%client,'SetPaintingDisabled',!%paint);
		%client.cannotPaint = "";
	}
}

//Disable Building
function KingdomBuildToggle(%player,%data)
{
	if(%data.canKingdom && %player.canBuild $= "")
	{
		commandToClient(%player.client,'SetBuildingDisabled',false);
		%player.canBuild = "KingdomHearts";
	}
	else if(!%data.canKingdom && %player.canBuild $= "KingdomHearts")
	{
		%client = %player.client;
		%mini = %client.minigame;
		if(!isObject(%mini))
			%paint = true;
		else
			%paint = %client.minigame.enablePainting;
		commandToClient(%client,'SetBuildingDisabled',!%paint);
		%player.canBuild = "";
	}
}


//Spawn HP/MP Orbs
function SpawnEnergyOrb(%player)
{
	%mini = getMiniGameFromObject(%player);
	%rand = getRandom(0,1);
	if(%rand == 0)
		%data = KingdomHPXItem;
	else
		%data = KingdomMPXItem;
	%eye = %player.getEyePoint();
	%item = new item()
	{
		datablock = %data;
		miniGame = %mini;
		player = %player;
		type = drop;
	};missionCleanup.add(%item);
	%scale = 1.5;
	%item.schedulePop();
	%randX = getRandom(-5,5);
	%randY = getRandom(-5,5);
	%item.setScale(%scale SPC %scale SPC %scale);
	%item.setTransform(vectorAdd(%eye,"0 0 3"));
	%item.setVelocity(%randX SPC %randY SPC 0);
}
function KingdomInstaUse(%player,%item,%type)
{
	%pos = %player.getHackPosition();
	%dmg = %player.getDamageLevel();
	%magic = KingdomCheckManaPoints(%player,"Magic");
	if(%type $= "Health")
	{
		%player.setDamageLevel(%dmg-$Pref::KingdomHearts::OrbHP);
		%proj = GreenWandProjectile;
	}
	if(%type $= "Magic")
	{
		KingdomSetManaPoints(%player,"Magic",%magic+$Pref::KingdomHearts::OrbMP);
		%proj = KingdomWandProjectile;
	}
	%item.delete();
	%player.spawnExplosion(%proj,1);
	serverplay3d(lightonsound,%pos);
}


//Mystery Item
function SpawnMysteryJar(%player)
{
	%mini = getMiniGameFromObject(%player);
	%data = MysteryPotionItem;
	%eye = %player.getEyePoint();
	%item = new item()
	{
		datablock = %data;
		miniGame = %mini;
		player = %player;
		type = drop;
	};missionCleanup.add(%item);
	%item.schedulePop();
	%randX = getRandom(-5,5);
	%randY = getRandom(-5,5);
	%item.setTransform(vectorAdd(%eye,"0 0 3"));
	%item.setVelocity(%randX SPC %randY SPC 0);
}
function KingdomMysteryGift(%player,%item)
{
	%client = %player.client;
	%data = %player.getDatablock();

	if(%item.rand[%player] $= "")
		%item.rand[%player] = getRandom(0,4);
	%rand = %item.rand[%player];
	if(%rand == 0)
		%inv = KingdomBrickSlot2B;
	if(%rand == 1)
		%inv = KingdomBrickSlot2C;
	if(%rand == 2)
		%inv = KingdomBrickSlot2D;
	if(%rand == 3)
		%inv = KingdomBrickSlot2E;
	if(%rand == 4)
		%inv = KingdomBrickSlot2F;
	if(strStr(%inv.uiName,"Potion") != -1)
		%color = "<color:B2FF7F>";
	else if(strStr(%inv.uiName,"Ether") != -1)
		%color = "<color:6699FF>";	
	else
		%color = "<color:8FFFFF>";
	for(%a=0;%a<%data.maxItems;%a++)
	{
		if(%player.slotItem[%a] $= "")
		{
			%item.delete();
			%player.slotItem[%a] = %inv;
			centerPrint(%player.client,"<font:impact:30><color:FFFFFF>Got" SPC %color @ %inv.uiName,2);
			messageClient(%player.client,'MsgItemPickup','',"","");
		//	echo("Mystery Gift:   slot =" SPC %a SPC "   name =" SPC %inv SPC "   item =" SPC %player.slotItem[%a]);
			break;
		}
		else //Full of Items
			centerPrint(%player.client,"<font:impact:30><color:666666>Inventory Full<br>" SPC %color @ %inv.uiName,2);
	}
}


//////////////////////
//Global Silent Loop//
//////////////////////

//Kingdom Hearts Group Support
if(!isObject($KingdomHeartsList))
{
	$KingdomHeartsList = new SimGroup()
	{
		class = "KingdomHeartsList";
	};
}

//Kingdom Hearts Global Silent Loop
function KingdomHeartsGlobalSilentLoop(%player)
{
	if(isObject(%player)) //if player arg. defined
		$KingdomHeartsList.add(%player); //add player to Kingdom Hearts list
	
	for(%a=0;%a<$KingdomHeartsList.getCount();%a++) //Search through Kingdom Hearts players
	{
		%player = $KingdomHeartsList.getObject(%a); //get player from Kingdom Hearts list
		if(!isObject(%player) || %player.getState() $= "Dead" || !(%data = %player.getDatablock()).canKingdom) //if player DNE, or player is dead, or datablock is not a Kingdomer
		{
			$KingdomHeartsList.remove(%player); //remove player from Kingdom Hearts list
			continue; //skip player, and continue looping
		}
		KingdomItemGravitate(%player);
		KingdomHPTargetCheck(%player);
		KingdomGiveABrick(%player);
		KingdomStatusBar(%player);
		KingdomAirCheck(%player);
		%isKingdomer = true; //since at least one player was Kingdom Hearts-ready
	}

	if(%isKingdomer) //if a Kingdomer exists
	{
		cancel($KingdomHearts::SilentLoop); //cancel any pending Silent Loop schedules
		$KingdomHearts::SilentLoop = scheduleNoQuota(1,0,KingdomHeartsGlobalSilentLoop); //continue the loop
	}
}


//Give Unlimited MP
function serverCmdUnlimitKingdomMP(%admin,%name,%off)
{
	if(!%admin.isSuperAdmin)
		return;
	%client = findclientbyname(%name);
	if(%off $= "")
	{
		if(isObject(%client.player))
			KingdomSetManaPoints(%client.player,"Magic",%client.KingdomMaxMagic);
		%client.KingMPUnlimited = true;
		%active = "\c2Enabled";
		%take = "\c2Given";
	}
	else
	{
		%client.KingMPUnlimited = false; 
		%client.player.isKingdomUbered = false;
		%active = "\c0Disabled";
		%take = "\c0Taken";
	}
	%admin.chatMessage("\c6Unlimited \c5Kingdom Hearts \c6MP for" SPC %client.player.getShapeName() SPC "is" SPC %active @ "\c6.");
	%client.chatMessage("\c6Unlimited \c5Kingdom Hearts \c6MP" SPC %take SPC "\c6by" SPC %admin.player.getShapeName() @ ".");
}

//Reset Stats Command
function serverCmdResetKingdomXP(%client)
{
	%client.chatMessage("\c5Kingdom Hearts \c6XP \c0Reset");
	%client.KingdomLevel = 1; //Reset Level
	%client.KingdomXP = 0; //Reset Score/XP
	%client.setScore(%client.KingdomXP); //update scoreboard
	if(isObject(%client.player))
		KingdomSetManaPoints(%client.player,"Magic",%client.KingdomMaxMagic); //reset magic
}

//Locked Stats Command
function serverCmdXPZero(%client,%off)
{
	if(%off $= "")
	{
		if(isObject(%client.player) && $Pref::KingdomHearts::Leveling)
			KingdomSetManaPoints(%client.player,"Magic",%client.KingdomMaxMagic); //reset magic
		%client.KingdomLevelLock = true;
		%active = "\c2Enabled";
	}
	else
	{
		%client.KingdomLevelLock = false; 
		%active = "\c0Disabled";
	}
	%client.chatMessage("\c5Kingdom Hearts \c6XP Zero" SPC %active);
}

//Level Up FX
function KingdomLevelUp(%client)
{
	%player = %client.player;
	if(isObject(%player))
	{
		%pos = %player.getHackPosition();
		%player.emote(winStarProjectile,1);
		serverplay3d(KingdomLevelSound,%pos);
	}
//	%level = %client.KingdomLevel;
	%client.chatMessage("<font:impact:30><color:FFE599>Stats Upgraded<font:impact:35><color:FFCC00>" SPC %level);
//	if(%level % 2)
		%client.chatMessage("<font:impact:25>\c6Max" SPC "\c1MP" SPC "\c6Increased");
//	else
		%client.chatMessage("<font:impact:25>\c6Max" SPC "\c2HP" SPC "\c6Increased");
}

//Health, Magic, etc. Display
function KingdomStatusBar(%player,%temp)
{
	%time = %temp ? 1 : -1; //if 'temp' input arg. = true - use "1", else - use "-1"
	%data = %player.getDatablock(); //Playertype
	%maxDam = %data.maxDamage; //Max Damage
	%curDam = %player.getDamageLevel(); //Current Damaged level
	%hp = (%maxDam - %curDam);  //current HP

	%client = %player.client; //player's client
	if(%client.KingMPUnlimited) //Unlimited Magic
		%player.isKingdomUbered = true;

	if(isObject(%client.minigame)) //Only fix score if in a minigame
	{
		if(%client.KingdomLevel < 1) //Load XP from file
			KingdomLoadStats(%client,%client.bl_ID);
		if(%client.score < %client.KingdomXP) //Correct the XP/Score
			%client.setScore(%client.KingdomXP);
		else //otherwise
			%client.KingdomXP = %client.score; //update saved XP to match Score
	}

	%curLvl = %client.KingdomLevel $= "" ? 1 : %client.KingdomLevel; //set Level to 1 (by default)
	if(!$Pref::KingdomHearts::Leveling && !%client.KingdomLevelLock) //If Leveling disabled, and 'Level Lock' (XP Zero) disabled
		%curLvl = $Pref::KingdomHearts::LvlMax; //auto-max level
	else if(!%client.KingdomLevelLock) //otherwise, if 'Level Lock' (XP Zero) disabled
	{
		%maxLvl = $Pref::KingdomHearts::LvlMax; //Max Level
		%lvlXP = $Pref::KingdomHearts::LvlXP; //XP required to Level-up
		for(%n=0;%n<%maxLvl;%n++)
		{
			if((%client.score >= (%n*%lvlXP)) && (%curLvl < %n)) //if client's score is greater than or equal to ('level test number' * 'Level XP requirement'), AND (current level is less than 'level test number')
				%newLvl = %n+1; //update stored Level value (e.g. if n = 0 (and XP < 'level XP requirement'), Level = 1)
		}
		if(%curLvl < %newLvl && %newLvl > 1) //if new level and level > 1
		{
			KingdomLevelUp(%client); //Do level up FX
			%curLvl = %newLvl; //Use 'new Level' for Level display
		}
	}
	
	%client.KingdomLevel = %curLvl; //Store new Level to client

	%defMP = $Pref::KingdomHearts::defMP; //Starting Level 1 MP //50 by default
	%defHP = $Pref::KingdomHearts::defHP; //Starting Level 1 HP //50 by default
	
	%lvlMP = $Pref::KingdomHearts::LvlMP; //MP Add per Level //50 by default
	%lvlHP = $Pref::KingdomHearts::LvlHP; //HP Add per Level //50 by default
	
	if(%curLvl <= 1) //if Level
	{
		%maxMP = %defMP;
		%maxHP = %defHP;
	}
	else
	{
		%maxMP = %defMP + (%lvlMP * %curLvl);
		%maxHP = %defHP + (%lvlHP * %curLvl);
	}
	
	//Update Max Magic (to match Level)
	%client.KingdomMaxMagic = %maxMP; //Store 'maxMP' value to client
	
	//Hit Points
	%newHP = %hp*(%maxHP/100); //scale bar to increased HP
	%hpC = %player.hasKingdomAero ? "\c6" : "\c2"; //if player has Aero - use color 6 (White), else - use color 2 (Green)
	%hpLabel = "<font:impact:16>" @ "  " @ %hpC @ "HP"; //Magic Points bar Label
	
	//Default Mana (Magic) Points
	%newMP = KingdomCheckManaPoints(%player,"Magic");
	%mpC = %player.isKingdomUbered ? "\c4" : "\c1"; //if player is Elixir'd - use color 4 (Cyan), else - use color 1 (Blue)
	
	//Special Mana (Magic, Focus, and Special) Points
	%mpC = %newMP == 0 ? "\c7" : %mpC; //if Magic Points = 0 - use color 7, else - keep default color
	if(%player.KingMagnetEnergy > 0) //Swap out MP bar for Magnetic Energy Bar
	{
		%newMP = %player.KingMagnetEnergy; //swap the bar to Magnet Energy (Focus)
		%mpC = "\c5"; //use color 5 (Magenta)
		%mpLabel = "<font:impact:16>" @ "  " @ %mpC @ "FP"; //Focus Points bar Label
	}
	else if(%player.KingSpecialEnergy !$= "" && !%player.isKingSpecialStarting) //Swap out MP bar for Special Magic Energy Bar
	{
		%newMP = %player.KingSpecialEnergy; //swap the bar to Special Energy
		%mpC = "\c3"; //use color 3 (Yellow)
		%mpLabel = "<font:impact:16>" @ "  " @ %mpC @ "SP"; //Special Points bar Label
	}
	else //otherwise (if MP is Magic Points)
		%mpLabel = "<font:impact:16>" @ "  " @ %mpC @ "MP"; //Magic Points bar Label

	%barHP = HataPointBar(%newHP,%maxHP,40,%hpC,"\c7"); //Health
	%barMP = HataPointBar(%newMP,%maxMP,20,%mpC,"\c7"); //Magic
	
	%alignment = "<just:right>"; //line alignment (left | right | center)
	if(%client.KingdomSlot == -1) //if inventory closed
		%invLoc = "<br>" @ "<br>" @ "<br>"; //place menu lower
	else //otherwise
		%invLoc = "<font:impact:8>" @ "<br>"; //offset it higher

	%icon = "<bitmap:add-ons/System_KingdomHearts/Head>" @ "<font:impact:2>"; //Blockhead icon (like Sora's head in KH 1-3)
	%level = "<font:impact:28>" @ "\c0" @ %curLvl; //Level display
	%mana = "<font:impact:10>" @ %barMP @ %mpLabel; //Magic (or Focus, or Special) Points bar, including label
	%life = "<font:impact:10>" @ %barHP @ %hpLabel; //Health, including label
	
	%status = %alignment @ %invLoc @ %icon @ "<br>" @ %mana @ "  " @ %level @ "<br>" @ %life;
	
	if(%status !$= %player.lastKingdomStatus)
	{
		%player.isKingBottomMessaging = true; //Allow this Bottom Print through
		%player.hasKingBottomMessage = true; //Disable external Bottom Prints
		bottomPrint(%client,%status,%time);
	}
	%player.lastKingdomStatus = %status;
}
//Points Bar (e.g. Hit Points and Magic Points)
function HataPointBar(%curPts,%maxPts,%barLen,%ptCol,%noPtCol)
{
	%curBar = mFloor(%curPts * (%barLen/%maxPts)); //current HP, converted to an integer value / max bars
	for(%b=1;%b<=%barLen;%b++)
	{
		%color = (%b == 1) ? %ptCol : ""; //if 'bar loop n' = 1 (first bar left-to-right) - use 'point Color', else - undefine 'color'
		%color = (%b == %curBar+1) ? %noPtCol : %color; //if 'bar loop n' = 'current Points Bar value' + 1 (immediately to the right of current Points value) - use 'no Point Color', else - keep previous 'color'
		%bar[%b] = %color @ "I"; //add color to the current bar (if applicable)
		%bar = %bar @ %bar[%b]; //combine individual bars into a full Points Bar
	}
	return %bar; //return full (Health / Magic / Focus / Special) Points Bar
}


//Mid-Air Check
function KingdomAirCheck(%player)
{
	%isFloor = KingdomBoxCheck(%player,0.1);
	if(%isFloor)
	{
		%player.isKingdomJump2 = false;
		%player.isKingdomHighJump = false;
	}
	if(!%player.isKingdomJumpLagged && !%player.hasKG)
		KingdomDataFix(%player);
}

//Super Jump
function KingdomHighJump(%player)
{
	%pos = %player.getPosition();
	%vel = %player.getVelocity();
	%upv = getWord(%vel,2);
	%dv = getWords(%vel,0,1);
	%isFloor = KingdomBoxCheck(%player,0.1);
	if(%isFloor && %player.isKingdomJetting && %upv < 1)
	{
		%player.playthread(0,jump);
		%player.playthread(2,shiftup);
		%player.setVelocity(%dv SPC 19);
		KingdomFX(%player,KingdomHighJumpProjectile,%pos,"0 0 1",0.8);
		serverplay3d(JumpWooshBSound,%pos);
		%player.changedatablock(PlayerKingdomNoJump);
		%player.isKingdomHighJump = true;
		%player.isKingdomJumpLagged = true;
		schedule(400,0,eval,%player@".isKingdomJumpLagged = false;");
	}
}

//Midair Jump
function KingdomSecondJump(%player)
{
	%pos = %player.getPosition();
	%vel = %player.getVelocity();
	%dv = getWords(%vel,0,1);
	%uv = getWord(%vel,2);
	if(%uv > -15 && %player.isKingdomJetting)
	{
		%player.playthread(0,jump);
		%player.playthread(2,leftrecoil);
		%player.setVelocity(%dv SPC 8+%uv);
		KingdomFX(%player,KingAgilityProjectile,%pos,"0 0 1",0.8);
		serverplay3d(JumpCartoonCSound,%pos);
		%player.changedatablock(PlayerKingdomNoJump);
		%player.isKingdomJump2 = true;
		%player.isKingdomJumpLagged = true;
		schedule(400,0,eval,%player@".isKingdomJumpLagged = false;");
	}
}

//Wall Jump
function KingdomWallJump(%player)
{
	%pos = %player.getPosition();
	%ank = vectorAdd(%pos,"0 0 0.2");
	%vel = %player.getVelocity();
	%upv = getWord(%vel,2);
	%vec0 = %player.getForwardVector();
	%vec1 = vectorScale(%vec0,-1);
	%vec2 = getRelativeX(%player,%vec0);
	%vec3 = vectorScale(%vec2,-1);
	for(%a=0;%a<4;%a++)
	{
		%dir = KingdomDirCheck(%player,%vec[%a]);
		%isWall = KingdomBeamCheck(%player,%ank,0.8,$TypeMasks::fxBrickObjectType | $TypeMasks::TerrainObjectType,%dir);
		if(%isWall)
			break;
	}
	%off = vectorAdd(%pos,"0 0" SPC -0.5);
	%isFloor = KingdomBoxCheck(%player,1,%off);
	if(!%isFloor && %isWall && %upv > -10)
	{
		%xV = getWord(%vel,0);
		%yV = getWord(%vel,1);
		%dV = vectorDot(%vel,%dir);
		if(mAbs(%xV) == mAbs(%dV))
			%dF = 0 SPC %yV SPC 0;
		if(mAbs(%yV) == mAbs(%dV))
			%dF = %xV SPC "0 0";
		%yA = vectorScale(%dir,-5);
		%dA = vectorAdd(%dF,%yA);
		%zA = "0 0" SPC 9+%upv;
		%player.setVelocity(vectorAdd(%zA,%dA));
		serverplay3d(jumpsound,%pos);
		%player.playthread(0,jump);
		%player.playthread(2,shiftdown);
		KingdomFX(%player,KingdomHighJumpProjectile,%pos,%dir,0.8);
		schedule(400,0,eval,%player@".isKingdomJumpLagged = false;");
		%player.isKingdomJumpLagged = true;
		%player.isKingdomJump2 = false;
	}
}

//Quick Run
function KingdomQuickRun(%player,%firstRun)
{
	if(!isObject(%player) || %player.getState() $= "Dead")
		return;
	%vel = %player.getVelocity();
	%vec = vectorNormalize(%vel);
	if(%player.isKingdomJetting && !%player.isPhysicsDelayed && !%player.hasKG && (%player.isKingdomRun || %firstRun))
	{
		if(%firstRun)
		{
			%time = 800; //was 600
			%player.isKingdomRun = true;
			%player.KingRunStop = schedule(%time,0,eval,%player@".isKingdomRun = false;"); //schedule QuickRun finish
			%player.changedatablock(PlayerKingdomQuickRun);
			%pos = %player.getPosition();
			KingdomFX(%player,KingAgilityProjectile,%pos,%vec,1);
			serverplay3d(GlideStartFixSound,%pos);
		}
		schedule(50,0,KingdomQuickRun,%player);
	}
	else
	{
		cancel(%player.KingRunStop);
		%player.hasKG = true;
		%player.isKingdomRun = false;
		schedule(400,0,eval,%player@".hasKG = false;");
		if(%player.getDatablock().getName() $= "PlayerKingdomQuickRun") //if running
			%player.changedatablock(PlayerKingdomNoJump); //stop running
	}
}

//Glide Actual
function KingdomGlide(%player,%firstGlide)
{
	if(!isObject(%player))
		return;
	%emote = %player.getMountedImage(2);
	%vec = %player.getForwardVector();
	%vel = %player.getVelocity();
	%upv = getWord(%vel,2);
	%dot = vectorDot(%vel,%vec);
	%pos = %player.getPosition();
	%off = vectorAdd(%pos,"0 0" SPC -0.5);
	%isFloor = KingdomBoxCheck(%player,2,%off,3);
	%noEmote = isObject(%emote) && %emote.getName() $= "KingdomCloudImage" && %dot < 1;
	if(!%isFloor && %player.isKingdomCrouching && %player.isKingdomJetting && !%noEmote && %upv > -25 && !%player.isPhysicsDelayed && %player.KingdomMagnet $= "" && %player.getState() !$= "Dead" && %player.glideNum <= 10)
	{
		%dv = getWords(%vel,0,1);
		if(%dot < 0) //If moving backwards
			%dv = "0 0"; //zero out velocity
		if(%firstGlide)
		{
			%player.isKingdomJump2 = true;
			%player.isKingdomGlide = true;
			%player.isKingdomGlideTired = true;
			%player.setVelocity(%dv SPC 0);
			%player.changedatablock(PlayerKingdomGlide0);
			%player.setActionThread(root);
			%player.setArmThread(land);
			%hack = %player.getHackPosition();
			KingdomFX(%player,KingAgilityProjectile,%hack,%vec,1);
			%player.KHCloud = %player.schedule(150,mountImage,KingdomCloudImage,2);
			serverplay3d(GlideStartFixSound,%pos);
		}
		// else if(%player.dataBlock.canKingdomGlide && !%player.glideSlowDelayed)
		// {
			// %num = %player.glideNum; //use stored num
			// %num = %num $= "" ? 0 : %num; //if num undefined, use 0, else use num
			// eval(%player@".changedatablock(PlayerKingdomGlide" @ %num @ ");"); //change datablock incrementally
			// %player.glideNum = %num++;
			// %player.glideSlowDelayed = true;
			// schedule(800,0,eval,%player@".glideSlowDelayed = false;"); //was 150
		// //	centerPrint(%player.client,"<font:impact:30><just:center>\c5Glide Slow worked<br>\c6glide Num =\c2" SPC %num @ "<br>\c6Forward Crouch Speed =\c4" SPC %player.dataBlock.maxforwardcrouchspeed,5);
			// %player.setActionThread(root);
		// }
		spawnKGlideData(%player,%pos);
		schedule(50,0,KingdomGlide,%player); //was 50
	}
	else if(%player.isKingdomGlide)
	{
		%player.glideNum = ""; //reset glide num
		cancel(%player.KHCloud);
		%player.isKingdomGlide = false;
		KGlideDataDelete(%player.client);
		if(%player.getState() !$= "Dead")
		{
			%player.hasKG = true;
			schedule(400,0,eval,%player@".hasKG = false;");
			schedule(1000,0,eval,%player@".isKingdomGlideTired = false;");
			%player.changedatablock(PlayerKingdomNoJump);
			%player.setArmThread(look);
		}
		if(isObject(%emote) && %emote.getName() $= "KingdomCloudImage")
			%player.unmountImage(2);
	}
}

//Glide Shape
function spawnKGlideData(%player,%pos)
{
	%client = %player.client;
	%off = vectorAdd(%pos,"0 0" SPC -0.13);
	%shape = new StaticShape()
	{
		datablock = KGlideData;
		position = %off;
		client = %client;
		scale = "0.2 0.2 0.1";
	};missionCleanup.add(%shape);
	KGlideDataDelete(%player.client);
	%client.hd = %shape;
}
function KGlideDataDelete(%client)
{
	if(isObject(%client.hd))
		%client.hd.delete();
}


//Set up Initial Brick Menu
function OpenKingdomMenu(%client)
{
//	echo("Open Kingdom Menu called by" SPC %client.player.getShapeName());
	%client.KHItemID[0,0] = KeybladeBrick;

	%client.KHItemID[0,1] = KingdomBrickSlot1;
	%client.KHItemID[0,2] = KingdomBrickSlot2;
	%client.KHItemID[0,3] = KingdomBrickSlot3;

	%client.KHItemID[1,0] = KingdomBrickSlot1B;
	%client.KHItemID[1,1] = KingdomBrickSlot1C;
	%client.KHItemID[1,2] = KingdomBrickSlot1D;
	%client.KHItemID[1,3] = KingdomBrickSlot1E;
	%client.KHItemID[1,4] = KingdomBrickSlot1F;
	%client.KHItemID[1,5] = KingdomBrickSlot1G;
	%client.KHItemID[1,6] = KingdomBrickSlot1H;
	
	%client.KHItemID[4,0] = KingdomBrickSlot4B;
	%client.KHItemID[4,1] = KingdomBrickSlot4C;
	%client.KHItemID[5,0] = KingdomBrickSlot5B;
	%client.KHItemID[5,1] = KingdomBrickSlot5C;

	%client.KHItemID[6,4] = KingdomBrickSlot6;

	%player = %client.player;
	if(isObject(%player))
		%player.mountImage(KingdomMenuImage,0);
	if(!%player.hasKingBricksReady)
	{
		UpdateKingdomMenu(%client);
		%player.hasKingBricksReady = true;
	}
}
//Replace Brick Inventory
function UpdateKingdomMenu(%client,%type)
{
	%player = %client.player;
	if(%type $= "")
		%type = 0;
//	if(%player.isKingSpelled && %type == 0)
//		%type = 6;
	for(%a=0;%a<10;%a++)
	{
		%inv = %client.inventory[%a];
		if(%client.oldInv[%a] $= "" && %inv != 0)
			%client.oldInv[%a] = %inv;

		%id = 0;
		%name = %client.KHItemID[%type,%a];
		if(%type == 6 && %a < 4)
			%name = %client.KHItemID[0,%a];
		if(%type == 2)
			%name = KingdomSlotMigrate(%client,%a);
		if(%name !$= "")
			%id = %name.getID();
		%client.invName[%a] = %name;
		messageClient(%client,'MsgSetInvData',"",%a,%id);
	//	echo("Update Kingdom Menu:   type =" SPC %type SPC "   name =" SPC %name SPC "   id =" SPC %id);
	}
}
//Shift Slots to the left
function KingdomSlotMigrate(%client,%a)
{
	%player = %client.player;
	%name = %player.SlotItem[%a];
	%nameB = %player.SlotItem[%a+1];
	if(%name $= "" && %nameB !$= "")
	{
	//	echo("Update Menu: changed slot item  name =" SPC %name SPC "  %nameB =" SPC %nameB);
		%name = %nameB;
		%player.SlotItem[%a+1] = "";
		%player.SlotItem[%a] = %nameB;
	}
	return %name;
}

//Restore Brick Inventory
function CloseKingdomMenu(%client)
{
	for(%a=0;%a<10;%a++)
	{
		%inv = %client.invName[%a];
		%old = %client.oldInv[%a];
		if(isObject(%old))
		{
			messageClient(%client,'MsgSetInvData',"",%a,%old);
			%client.invName[%a] = "";
			%client.oldInv[%a] = "";
		}
	}
}

//Select Gui Timeout
$KingClickTime = 50;
$KingMountTime = 300;

//Command Selecting
function KingdomInventoryCheck(%player,%force)
{
	%client = %player.client;
	%item = %client.invName[%client.KingdomSlot];
	if((%item $= "" || !%player.getMountedImage(0).canKingdom || %player.KingJustClicked) && !%force)
		return;

	schedule($KingMountTime+100,0,eval,%player@".KingJustClicked = false;");
	%player.KingJustClicked = true;

	if(%item $= "KeybladeBrick" || %force) //Keyblade
	{
		%cont = true;
		%slot = 0;
	}

	if(%item $= "KingdomBrickSlot1") //Magic
	{
		%cont = true;
		%slot = 1;
	}
	else if(%item.canKMagic)
		%use = true;

	if(%item $= "KingdomBrickSlot2") //Items
	{
		%cont = true;
		%slot = 2;
	}
	else if(%item.canKUse)
		%use = true;

	if(%item $= "KingdomBrickSlot3") //Weapons
	{
		%cont = true;
		%slot = 3;
	}

	if(%item $= "KingdomBrickSlot6") //Break
		%slot = 6;

	%time = $KingMountTime;
	%locked = %player.isKingdomStopped; //|| %player.KingdomMagnet !$= "";
	if(%player.isKingSpelled && %slot == 6)
	{
		KingdomSpellBreak(%player,%slot);
		%time = $KingClickTime;
	}
	else if(%use && !%locked)
		KingdomInvUse(%player,%item);
	else if(%cont && !%locked)
	{
		if(%slot == 0)
		{
			KingdomToolOpen(%client,0,1);
			KingdomAddInvTool(%player,0);
			%client.KUseSlot = %slot;
			%time = $KingClickTime;
			%stop = true;
		}
		else if(%slot == 2 || %slot == 3)
		{
			%hasTool = KingdomInvEmptyCheck(%client,%slot);
			if(!%hasTool)
			{
				messageClient(%client,'MsgItemPickup','',"","");
				%stop = true;
			}
			else if(%slot == 3)
			{
				%data = %player.getDatablock();
				%max = %data.maxWeapons;
				KingdomToolOpen(%client,0,%max);
				for(%a=0;%a<%max;%a++)
				{
					%weap = %player.SlotWeapon[%a];
					%weapB = %player.SlotWeapon[%a+1];
					if(%weap $= "" && %weapB !$= "")
					{
						%weap = %weapB;
						%player.SlotWeapon[%a+1] = "";
					}
					KingdomAddInvTool(%player,%a,%weap);
				}
				%client.KUseSlot = %slot;
				%time = $KingClickTime;
				%stop = true;
			}
		}
		if(!%stop) //Imitate Return
		{
			UpdateKingdomMenu(%client,%slot);
			if(%slot == 1)
				KingdomInventoryOpen(%client,0);
			if(%slot == 2)
				KingdomInventoryOpen(%client,0);
		}
	}

	%player.hasKingdomSelected = true;
	schedule(%time,0,eval,%player@".hasKingdomSelected = false;");
}

//Use Anything
function KingdomSpellBreak(%player,%slot)
{
	%client = %player.client;
	if(%slot == 6)
	{
		KingdomUnStop(%player);
		KingdomUnGravitize(%player);
		KingdomUnMagnetize(%player.KingdomMagnet);
		%player.isKingSpelled = false;
		%player.spawnExplosion(KingdomWandProjectile,1);
		%hack = %player.getHackPosition();
		serverplay3d(brickbreaksound,%hack);
	}
	else
		messageClient(%client,'MsgItemPickup','',"","");
}

//Use Anything
function KingdomInvUse(%player,%item)
{
	%client = %player.client;
	if(%item.uiName $= "Cure " || %item.uiName $= "Aero ") //Usee choice spells
	{
		%slot = 4;
		%cont = true;
		%image = KingdomMagicImage;
	}
	else if(%item.canKMagic)
		KingdomUseInvMagic(%player,%item);
	else if(%item.canKUse)
	{
		if(%item.canKPlayer)
			KingdomUseInvItem(%player,%item,true);
		else
		{
			%slot = 5;
			%cont = true;
		}
	}
	if(%cont)
	{
	//	echo("attempted to continue Inventory Use");
		%client.KUseSlot = %client.KingdomSlot;
		%client.lastInv[%client.KUseSlot] = %item;
		UpdateKingdomMenu(%client,%slot);
		KingdomInventoryOpen(%client,0);
	}
}

//Use Magic
function KingdomUseInvMagic(%player,%item)
{
//	echo("Use Magic called    ui Name =" SPC %item.uiName);
	%client = %player.client;
	if(%item.uiName $= "Friend ")
	{
		%eye = %player.getEyePoint();
		%vec = %player.getEyeVector();
		%col = KingdomRadiusSearch(%player,%eye,5,%vec,2);
		if(!isObject(%col))
		{
			messageClient(%client,'MsgItemPickup','',"","");
			return;
		}
	}
	else
		%col = %player;
	%dmg = %col.getDamageLevel();
	%magic = KingdomCheckManaPoints(%player,"Magic");
	if(%player.isKingdomUbered)
		KingdomSetManaPoints(%player,"Magic",%client.KingdomMaxMagic);
	else if(%player.isKingdomUberLagged)
		return;

	%a = %client.KUseSlot;
	%last = %client.lastInv[%a];
	if(%item.uiName $= "Magnet " && %magic >= 25 && !%player.isKMagicDelayed && !%player.isKMagicWait)
	{
		FireKingdomSpell(%player,KingdomMagnetProjectile);
	//	%lefty = %player.getMountedImage(1);
	//	if(isObject(%lefty) && %lefty.getName() $= "KingdomMagnetImage")
	//	{
			%sub = 25;
			%time = 1000;
	//		%wait = 5000; //Special Use timeout
	//		%pos = %player.getMuzzlePoint(1);
			//serverplay3d(wandhitsound,%pos);
			//if(!%player.isKingdomUbered)
			//	KingdomSetManaPoints(%player,"Magic",%magic-%sub);
	//	}
	}
	else if(%item.uiName $= "Stop " && %magic >= 15 && !%player.isKMagicDelayed && !%player.isKMagicWait)
	{
		%sub = 15;
		%time = 1000;
		%wait = 3000; //Special Use timeout
		FireKingdomSpell(%player,KingdomStopProjectile);
	}
	else if(%item.uiName $= "Gravity " && %magic >= 15 && !%player.isKMagicDelayed && !%player.isKMagicWait)
	{
		%sub = 15;
		%time = 1000;
		%wait = 3000; //Special Use timeout
		FireKingdomSpell(%player,KingdomGravityProjectile);
	}
	else if(%item.uiName $= "Fire " && !%player.isKMagicDelayed)
		KingdomMagicCharge(%player,"Fire ",true);
	else if(%item.uiName $= "Blizzard " && !%player.isKMagicDelayed)
		KingdomMagicCharge(%player,"Blizzard ",true);
	else if(%item.canKPlayer && %last.uiName $= "Aero " && isObject(%col) && %magic >= 10 && !%player.isKMagicDelayed)
	{
		%sub = 10;
		%time = 1000;
		KingdomActivateAero(%col);
	}
	else if(%item.canKPlayer && %last.uiName $= "Cure " && isObject(%col) && %magic >= 5 && %dmg > 0 && !%player.isKMagicDelayed)
	{
		%sub = 5;
		%time = 1000;
		%pos = %col.getHackPosition();
		%col.setDamageLevel(%dmg-20);
		%col.emote(loveImage);
		%col.spawnExplosion(GreenWandProjectile,1);
		serverplay3d(printfiresound,%pos);
	}
	else if(!%player.isKMagicDelayed && !%player.isKMagicWait)
		messageClient(%client,'MsgItemPickup','',"","");
	if(!%player.isKMagicWait && %wait !$= "") //Schedule Special Use timeout end
	{
		%player.isKMagicWait = true;
		schedule(%wait,0,eval,%player@".isKMagicWait = false;");
	}
	if(!%player.isKMagicDelayed && %time !$= "")
	{
		%player.isKMagicDelayed = true;
		schedule(%time,0,eval,%player@".isKMagicDelayed = false;");
	}
	if(!%player.isKingdomUbered && %sub !$= "")
		KingdomSetManaPoints(%player,"Magic",%magic-%sub);
}

//Use Aero
function KingdomActivateAero(%player)
{
	%time = 40000;
	cancel(%player.AeroFinish);
	%player.hasKingdomAero = true;
	%player.AeroFinish = schedule(%time,0,eval,%player@".hasKingdomAero = false;");
	%player.spawnExplosion(KingdomAeroProjectile,1);
	%hack = %player.getHackPosition();
	serverplay3d(lightonsound,%hack);
}

//Use Item
function KingdomUseInvItem(%player,%usee,%use)
{
//	echo("Use Item called    ui Name =" SPC %item.uiName);
	%client = %player.client;
	%a = %client.KUseSlot;
	if(%use)
		%item = %client.lastInv[%a];
	if(%usee.uiName $= "Self ")
		%col = %player;
	if(%usee.uiName $= "Friend ")
	{
		%eye = %player.getEyePoint();
		%vec = %player.getEyeVector();
		%col = KingdomRadiusSearch(%player,%eye,5,%vec,2);
		if(!isObject(%col))
		{
			messageClient(%client,'MsgItemPickup','',"","");
			return;
		}
	}
	%mp = KingdomCheckManaPoints(%col,"Magic");
	%max = %col.client.KingdomMaxMagic;
	%hurt = %col.getDamageLevel();
	if(%item.uiName $= "Potion " && %hurt > 0)
	{
		%plus = 30;
		%cont = true;
	}
	if(%item.uiName $= "Mega Potion " && %hurt > 0)
	{
		%plus = 60;
		%cont = true;
	}
	if(%item.uiName $= "Ether " && %mp < %max)
	{
		%add = 30;
		%cont = true;
	}
	if(%item.uiName $= "Mega Ether " && %mp < %max)
	{
		%add = 70;
		%cont = true;
	}
	if(%item.uiName $= "Elixir " && !%col.isKingdomUbered)
	{
		%add = 200;
		%plus = 100;
		%cont = true;
		%time = 30000;
		%col.isKingdomUbered = true;
		%col.isKingdomUberLagged = true;
		schedule(%time,0,eval,%col@".isKingdomUbered = false;");
		schedule(%time+2000,0,eval,%col@".isKingdomUberLagged = false;");
	}
	if(%cont)
	{
		%player.slotItem[%a] = "";
		%hasTool = KingdomInvEmptyCheck(%client,2);
		if(%hasTool)
			%type = 2;
		else
			%a = 2;
		UpdateKingdomMenu(%client,%type);
		KingdomInventoryOpen(%client,%a);

		if(strStr(%item.uiName,"Potion ") != -1)
		{
			%color = "<color:B2FF7F>";
			%colorWand = GreenWandProjectile;
		}
		else if(strStr(%item.uiName,"Ether ") != -1)
		{
			%color = "<color:6699FF>";	
			%colorWand = KingdomWandProjectile;
		}
		else
		{
			%color = "<color:8FFFFF>";
			%colorWand = SkyWandProjectile;
		}

		%colName = %col.getShapeName();
		if(%colName $= "")
			%colName = %col.name;
		if(%col != %player)
			%name = "<color:B2B2B2> on" SPC "<color:FF9999>" @ %colName;
		else
			%name = "";
		%message = "<font:impact:30><color:B2B2B2>Used" SPC %color @ %item.uiName @ %name;
		centerPrint(%client,%message,3);

		KingdomSetManaPoints(%col,"Magic",%mp+%add);
		%col.setDamageLevel(%hurt-%plus);
		%col.spawnExplosion(%colorWand,1);
		%pos = %col.getHackPosition();
		serverplay3d(lightoffsound,%pos);
	}
	else
		messageClient(%client,'MsgItemPickup','',"","");
}

//Change inventory or close menu if empty
function KingdomInvEmptyCheck(%client,%slot)
{
	%player = %client.player;
	%data = %player.getDatablock();
	%weapon = %slot == 3;
	if(%weapon)
		%max = %data.maxWeapons;
	else
		%max = %data.maxItems;
	for(%a=0;%a<%max;%a++)
	{
		if(%weapon)
			%tool = %player.SlotWeapon[%a];
		else
			%tool = %player.SlotItem[%a];
		if(isObject(%tool))
		{
			%hasInv = true;
			break;
		}
	}
	return %hasInv;
}

//Remove Inventory Item
function KingdomRemoveInv(%player,%slot,%drop)
{
	%client = %player.client;
	messageClient(%client,'MsgSetInvData',"",%slot,false);
	%player.slotItem[%slot] = "";
	if(!%drop)
		return;
	%player.hasKingdomSelected = true;
	schedule($KingClickTime,0,eval,%player@".hasKingdomSelected = false;");
	messageClient(%client,'MsgItemPickup','',"","");
	%hasInv = KingdomInvEmptyCheck(%client,2);
	%a = 0;
	if(%hasInv)
		%type = 2;
	else
		%a = 2;
	UpdateKingdomMenu(%client,%type);
	KingdomInventoryOpen(%client,%a);
}

//Fix Slot when closing
function KingdomSlotFix(%client)
{
	%client.KingdomSlot = -1;
}

//Add Menu Weapon
function KingdomAddInvTool(%player,%slot,%custom)
{
	if(%custom !$= "")
		%item = %custom;
	else if(%slot == 0)
		%item = KeybladeItem;
	else
	{
		KingdomRemoveInvTool(%player,%slot);
		return;
	}
	%itemID = nameToID(%item);
	if(%itemID != %player.tool[%slot])
		%canAdd = true;
	if(%canAdd)
	{
		%player.tool[%slot] = %itemID;
		%player.weaponCount++;
		messageClient(%player.client,'MsgItemPickup','',%slot,%itemID,true);
	}
}

//Remove Item
function KingdomRemoveInvTool(%player,%slot,%drop)
{
	if(!isObject(%player.tool[%slot]))
		return;
	%player.tool[%slot] = 0;
	%player.weaponCount--;
	messageClient(%player.client,'MsgItemPickup','',%slot,0,!%drop);
	if(%slot == %player.currTool)
	{
		%player.unmountImage(0);
		fixArmReady(%player);
	}
	if(!%drop)
		return;
	%player.slotWeapon[%slot] = "";
	%data = %player.getDatablock();
	%hasTool = KingdomToolEmptyCheck(%player,%data.maxWeapons);
	if(%hasTool)
		KingdomToolMigrate(%player.client,%player.currTool);
	else
		commandToClient(%player.client,'SetScrollMode',3);
}
//Shift Tools up
function KingdomToolMigrate(%client,%a)
{
	%player = %client.player;
	%name = %player.SlotWeapon[%a];
	%nameB = %player.SlotWeapon[%a+1];
	if(%name $= "" && %nameB !$= "")
	{
	//	echo("Update Menu: changed slot item  name =" SPC %name SPC "  %nameB =" SPC %nameB);
		%name = %nameB;
		%player.SlotWeapon[%a+1] = "";
		%player.SlotWeapon[%a] = %nameB;
	}
}

//Change tool or close menu if empty
function KingdomToolEmptyCheck(%player,%max)
{
	%data = %player.getDatablock();
	for(%a=0;%a<%max;%a++)
	{
		if(isObject(%player.tool[%a]))
		{
			%hasTool = true;
			break;
		}
	}
	if(%hasTool)
		commandToClient(%player.client,'SetActiveTool',%a);
	return %hasTool;
}


//Open Brick GUI
function KingdomInventoryOpen(%client,%slot)
{
	%player = %client.player;
	if(!isObject(%client.invName[%slot]))
		%slot = %slot-1;
	commandToClient(%client,'SetActiveBrick',%slot);
	%client.KingdomSlot = %slot;
}
function KingdomInventoryEquip(%client,%image)
{
	%player = %client.player; //client's player object
	if(%image $= "") //if image is not specified
		%image = KingdomMenuImage; //use default inventory image
	if(isObject(%player) && %player.currTool == -1 && (!isObject((%wep = %player.getMountedImage(0))) || %wep.getName() !$= %image)) //If player exists, no tool is equiped, and there's no weapon OR there is on and it's not %image
		%player.mountImage(%image,0); //mount the image
//	echo("Inventory equip called by" SPC %player.getShapeName() SPC "  weapon =" SPC %wep.getName() SPC "  image =" SPC %image);
}

//Open Tool GUI
function KingdomToolOpen(%client,%slot,%max)
{
	commandToClient(%client,'PlayGui_CreateToolHud',%max); //max is the number of tool slots
	commandToClient(%client,'SetActiveTool',%slot);
}


//Restore Playertype
function KingdomDataFix(%player)
{
	if(isObject(%player) && %player.getState() !$= "Dead")
		%data = %player.getDatablock();
	if(%data.getName() $= "PlayerKingdomNoJump")
		%player.changedatablock(PlayerKingdomHearts);
}

//Special FX
function KingdomFX(%player,%data,%pos,%vel,%scale)
{
	%p = new Projectile()
	{
		dataBlock = %data;
		initialPosition = %pos;
		initialVelocity = %vel;
		sourceObject = %player;
		client = %player.client;
		scale = %scale SPC %scale SPC %scale;
	};MissionCleanup.add(%p);
	%p.explode();
}


///////////////
//Mana System//
///////////////

//Check Current Mana Points
function KingdomCheckManaPoints(%player,%string)
{
	eval("%result =" SPC %player @ ".Kingdom" @ %string @ "Points;");
	return %result;
}
//Set Current Mana Points
function KingdomSetManaPoints(%player,%string,%int)
{
	eval("%max =" SPC %player.client @ ".KingdomMax" @ %string @ ";");
	%result = KingdomForceManaRange(%int,%max); //force 'int' input arg. into Mana range via the 'Check Mana Range' fcn
	eval("%player.Kingdom" @ %string @ "Points =" SPC %result @ ";");
}
//Force Mana Points value into Range (when Setting)
function KingdomForceManaRange(%int,%max)
{
	if(%int < 0) //if input arg. 'integer' is less than 0
		%int = 0; //set it to zero
	if(%int > %max) //if input arg. 'integer' is greater than input arg. 'maximum'
		%int = %max; //set it to 'maximum' value
	return %int; //return final integer (note: it could technically be a float, but I would prefer to keep Mana in whole numbers)
}


//Health Target Check
function KingdomHPTargetCheck(%player)
{
	if(%player.hasKingHPChecked)
		return;
	%player.hasKingHPChecked = true;
	schedule(50,0,eval,%player@".hasKingHPChecked = false;");
	%eye = %player.getEyePoint();
	%vec = %player.getEyeVector();
	%col = KingdomRadiusSearch(%player,%eye,50,%vec,2);
	if(isObject(%col))
	{
		%cHack = %col.getHackPosition();
		%sub = vectorSub(%cHack,%eye);
		%sNrm = vectorNormalize(%sub);
		%sLen = vectorLen(%sub);
		%hit = KingdomBeamCheck(%player,%eye,%sLen,$TypeMasks::fxBrickObjectType | $Typemasks::TerrainObjectType,%sNrm);
		if(isObject(%hit))
			%col = "";
	}
	KingdomHPBarDisplay(%player,%col);
}
//Enemy HP Bar
function KingdomHPBarDisplay(%player,%col)
{
	if(!isObject(%col))
	{
		%player.setEnergyLevel(0);
		return;
	}
	%data = %col.getDatablock();
	%dmg = %col.getDamageLevel();
	%max = %data.maxDamage;
	%ratio = %max-%dmg;
	%scale = 100/%max;
	%hp = %ratio*%scale;
	%player.setEnergyLevel(%hp);
}

//Suck in Items
function KingdomItemGravitate(%player)
{
	%hack = %player.getHackPosition();
	%exception = MysteryPotionItem;
	%item = KingdomRadiusSearch(%player,%hack,5,"","",$TypeMasks::ItemObjectType,%exception);
	if(!isObject(%item) || isObject(%item.GravPlayer))
		return;
	%iPos = %item.position;
	%sub = vectorSub(%hack,%iPos);
	%scale = vectorScale(%sub,5);
	%final = vectorAdd(%scale,"0 0 1");
	%item.setVelocity(%final);
	%item.GravPlayer = %player;
	schedule(100,0,eval,%item@".GravPlayer = \"\";");
}


//Radius Search
function KingdomRadiusSearch(%player,%pos,%len,%vec,%range,%masks,%exception)
{
	if(%masks $= "")
		%masks = $TypeMasks::PlayerObjectType;
	initContainerRadiusSearch(%pos,%len,%masks);
	while(%col = containerSearchNext())
	{
		if(%vec $= "")
		{
			if(getMinigameFromObject(%col) == %player.client.minigame && %col.getDatablock().getName() !$= %exception)
				return %col;
		}
		else if(isObject(%col) && %col != %player && miniGameCanDamage(%player,%col) && isObject(%player.client.minigame))
		{
			%cHack = %col.getHackPosition();
			%sub = vectorSub(%cHack,%pos);
			%sNrm = vectorNormalize(%sub);
			%sLen = vectorLen(%sub);
			%scale = vectorScale(%vec,%sLen);
			%pAdd = vectorAdd(%pos,%scale);
			%dist = vectorDist(%sNrm,%vec);
			%div = %dist*%sLen;
		//	centerPrint(%player.client,"<font:impact:30>\c2" SPC %col.name SPC "    distance =" SPC %dist SPC "   divided =" SPC %div,1);
			if(%div < %range)
				return %col;
		}
	}
}

//Grid Snap
function KingdomDirCheck(%player,%vec)
{
	%xa = "1 0 0";
	%ya = "0 1 0";
	%xb = "-1 0 0";
	%yb = "0 -1 0";
	%xad = vectorDist(%vec,%xa);
	%yad = vectorDist(%vec,%ya);
	%xbd = vectorDist(%vec,%xb);
	%ybd = vectorDist(%vec,%yb);
	%len = 0.75; //closest dir
	if(%yad < %len)
		%dir = %ya;
	if(%ybd < %len)
		%dir = %yb;
	if(%xad < %len)
		%dir = %xa;
	if(%xbd < %len)
		%dir = %xb;
	return %dir;
}

//Vec to Rotation
function KingdomDirFix(%dir)
{
	%yaw = mATan(getWord(%dir,1),getWord(%dir,0));
	%fix = "0 0 -1" SPC %yaw;
	%eul = axisToEuler(%fix);
	%eulA = vectorAdd(%eul,"0 0 -90");
	%grid = eulerToAxis(%eulA);
	return %grid;
}

//Beam Check
function KingdomBeamCheck(%player,%pos,%len,%masks,%vec)
{
	%beam = vectorScale(%vec,%len);
	%end = vectorAdd(%pos,%beam);
	%ray = containerRayCast(%pos,%end,%masks,%player);
	return firstWord(%ray);
}

//Box Check
function KingdomBoxCheck(%player,%z,%pos,%xy)
{
	if(%pos $= "")
		%pos = %player.getPosition();
	if(%xy $= "")
		%xy = 1.23;
	initContainerBoxSearch(%pos, %xy SPC %xy SPC %z, $TypeMasks::fxBrickObjectType | $Typemasks::TerrainObjectType);
	%col = containerSearchNext();
	return isObject(%col);
}

//Relative Vector
function getRelativeX(%player,%dir)
{
	return vectorCross(%dir,%player.getUpVector());
}

//Euler to Axis & Axis to Euler
function eulerToAxis(%euler)
{
	%euler = VectorScale(%euler,$pi / 180);
	%matrix = MatrixCreateFromEuler(%euler);
	return getWords(%matrix,3,6);
}
function axisToEuler(%axis)
{
	%angleOver2 = getWord(%axis,3) * 0.5;
	%angleOver2 = -%angleOver2;
	%sinThetaOver2 = mSin(%angleOver2);
	%cosThetaOver2 = mCos(%angleOver2);
	%q0 = %cosThetaOver2;
	%q1 = getWord(%axis,0) * %sinThetaOver2;
	%q2 = getWord(%axis,1) * %sinThetaOver2;
	%q3 = getWord(%axis,2) * %sinThetaOver2;
	%q0q0 = %q0 * %q0;
	%q1q2 = %q1 * %q2;
	%q0q3 = %q0 * %q3;
	%q1q3 = %q1 * %q3;
	%q0q2 = %q0 * %q2;
	%q2q2 = %q2 * %q2;
	%q2q3 = %q2 * %q3;
	%q0q1 = %q0 * %q1;
	%q3q3 = %q3 * %q3;
	%m13 = 2.0 * (%q1q3 - %q0q2);
	%m21 = 2.0 * (%q1q2 - %q0q3);
	%m22 = 2.0 * %q0q0 - 1.0 + 2.0 * %q2q2;
	%m23 = 2.0 * (%q2q3 + %q0q1);
	%m33 = 2.0 * %q0q0 - 1.0 + 2.0 * %q3q3;
	return mRadToDeg(mAsin(%m23)) SPC mRadToDeg(mAtan(-%m13, %m33)) SPC mRadToDeg(mAtan(-%m21, %m22));
}