//ClimbTool
datablock StaticShapeData(ClimbEmptyData)
{
	category = "Static Shapes";
	shapeFile = "./cube_col.dts";
};


//Playertypes
datablock PlayerData(PlayerClimbing : PlayerStandardArmor)
{
	canJet = 0;
	canClimb = 1;
	canClimbHang = 0;
	cameraMaxDist = 5;
	jumpForce = 800;

//	minImpactSpeed = 30;
	minImpactSpeed = 0.1;
	groundImpactShakeAmp = "0.01 0.01 0.01";

	uiName = "Climbing Player";
	showEnergyBar = false;
};

datablock PlayerData(PlayerClimb : PlayerClimbing)
{
	jumpForce = 0;
	canClimbHang = 1;
	thirdPersonOnly = true;

	maxForwardSpeed = 0.1;
	maxBackwardSpeed = 0.1;
	maxSideSpeed = 0.1;

	maxForwardCrouchSpeed = 0;
	maxBackwardCrouchSpeed = 0;
	maxSideCrouchSpeed = 0;

	uiName = "";
};
datablock PlayerData(PlayerClimbSide : PlayerClimb)
{
	maxForwardSpeed = 0;
	maxBackwardSpeed = 0;
	maxSideSpeed = 2;

	uiName = "";
};
datablock PlayerData(PlayerClimbEdge : PlayerClimbSide)
{
	maxSideSpeed = 0;

	uiName = "";
};

datablock PlayerData(PlayerClimbMelee : PlayerClimbing)
{
	cameraMaxDist = 4;

	maxForwardSpeed = 6;
	maxBackwardSpeed = 6;
	maxSideSpeed = 6;

	uiName = "";
};

datablock PlayerData(PlayerClimbGun : PlayerClimbing)
{
	runForce = 100*1000;

	minLookAngle = -1.2;
	cameraMaxDist = 1.75;

	cameraVerticalOffset = 0.9; //0.64; //1.45; //1; //0.5;
	cameraHorizontalOffset = 0.526; //0.8; //0.5245;
	cameratilt = -0.05; //3.0; //0.2;

	maxForwardSpeed = 5;
	maxBackwardSpeed = 5;
	maxSideSpeed = 5;

	airControl = 0;

	uiName = "";
};

datablock PlayerData(PlayerClimbDanger : PlayerClimbing)
{
//	boundingBox = "5 5 10.6";
	boundingBox = "5 5 4";

	maxForwardSpeed = 12;
	maxBackwardSpeed = 0;
	maxSideSpeed = 0;

	maxForwardCrouchSpeed = 12;
	maxBackwardCrouchSpeed = 0;
	maxSideCrouchSpeed = 0;

	uiName = "";
};

datablock PlayerData(PlayerClimbJog : PlayerClimbing)
{
	cameraMaxDist = 6;

	maxForwardSpeed = 8;
	maxBackwardSpeed = 5;
	maxSideSpeed = 7;

	uiName = "";
};


//Hefty Code
package ClimbAddRemove
{
	function Armor::onAdd(%data,%obj)
	{
		%obj.setActionThread(root);
		ClimbShapeRemove(%obj);
		parent::onAdd(%data,%obj);
	}
	function Armor::onNewDatablock(%data,%obj)
	{
		parent::onNewDatablock(%data,%obj);
		%wep = %obj.getMountedImage(0);
		if(%data.getName() $= "PlayerClimbing")
		{
			cancel(%obj.CSL);
			cancel(%obj.CSL2);
			%obj.CSL = schedule(10,0,ClimbSilentLoop,%obj);
		}
		if(%data.canClimbHang)
			%obj.setArmThread(land);
		else if(%data.canClimb)
			%obj.setArmThread(look);
	}
	function ClimbSilentLoop(%obj)
	{
		if(!isObject(%obj))
			return;
		%data = %obj.getDatablock();
		if(%obj.getState() !$= "Dead" && %data.canClimb)
		{
			cancel(%obj.CSL2);
			%obj.CSL2 = schedule(5,0,ClimbSilentLoop,%obj);
			if(%obj.getObjectMount() != 0)
				return;
			%posA = %obj.getHackPosition();
			%posB = %obj.getEyePoint();
			%groundA = climbBoxCheck(%obj);
			%groundB = climbBoxCheck(%obj,2);
			%groundC = climbBoxCheck(%obj,4);
			%wep = %obj.getMountedImage(0);
			if(!isObject(%groundA) && isObject(%groundC) && !%obj.isCrouching)
				ClimbVaultCheck(%obj,%posA,%posB);
			if(!isObject(%groundB) && !%obj.isCrouching) // && !%obj.noReGrab)
				ClimbLedgeGrab(%obj,%posA,%posB);
			else if(%data.canClimbHang)
				stopClimbHang(%obj,"ClimbSilentLoop");
			else if(isObject(%groundA) && !%obj.isClimbRolling)
			{
			//	if(%obj.isJetting)
			//		startJogging(%obj,%data);
				if(%obj.currTool $= "")
					%obj.currTool = -1;
				if(%obj.currTool != -1 && %wep == 0 && %data.getName() !$= "PlayerClimbJog")
					servercmdusetool(%obj.client,%obj.currtool);
				else if(%data.getName() $= "PlayerClimbDanger")
				{
					if(%obj.isMeleeToggled)
						%obj.changedatablock(PlayerClimbMelee);
					else
						%obj.changedatablock(PlayerClimbing);
					%obj.playthread(0,root);
					%obj.playthread(2,root);
				}
			}
		}
	}
	//Weapon Integration
	function WeaponImage::onMount(%this,%obj,%slot)
	{
		%data = %obj.getDatablock();
		%canUseWeapon = WeaponCheck(%obj,%this);
		if(%canUseWeapon && %data.canClimb && !%data.canClimbHang && !%obj.isClimbRolling)
		{
			%obj.changedatablock(PlayerClimbGun);
			if(%obj.getObjectMount() == 0)
				%obj.playthread(0,root);
			%obj.playthread(2,root);
		}
		else
			Parent::onMount(%this,%obj,%slot);
	}
	function WeaponCheck(%obj,%this)
	{
		if(%obj.getState() $= "Dead")
			return 0;
		//Guns	
		if(%this.getName() $= "GunImage" || (!%obj.isClimbAnim && %this.getName() $= "ShotgunImage") || %this.getName() $= "P90Image" || %this.getName() $= "SMGImage" || %this.getName() $= "P90SImage" || %this.getName() $= "Mac10Image")
			return 1;
		else
			return 0;
	}
	function WeaponImage::onUnMount(%this,%obj,%slot)
	{
		Parent::onUnMount(%this,%obj,%slot);
		%data = %obj.getDatablock();
		if(%data.getName() $= "PlayerClimbGun")
		{
			%obj.changedatablock(PlayerClimbing);
			if(%obj.getObjectMount() == 0)
				%obj.playthread(0,root);
		}
	}
};activatePackage(ClimbAddRemove);

package Climbing
{
	//Vaulting Integration
	function ClimbVaultCheck(%obj,%posA,%posB)
	{
		%add = "0 0 -0.75";
		%posA = vectorAdd(%posA,%add);
		%posB = vectorAdd(%posB,%add);
		%isLedge = ClimbLedgeSearch(%obj,%posA,%posB);
		%vec = %obj.getForwardVector();
		%pos = %obj.getHackPosition();
		%pos = vectorAdd(%pos,vectorScale(%vec,1.5));
		%pos = vectorAdd(%pos,"0 0 1");
		initContainerBoxSearch(%pos, "1.3 1.3 1", $Typemasks::fxBrickObjectType | $Typemasks::TerrainObjectType);
		%col = containerSearchNext();
		if(!isObject(%col) && %isLedge && !%obj.isClimbAnim && !%obj.isClimb)
			ClimbStep(%obj);
		//	ClimbVault(%obj);
	}
	function ClimbVault(%obj)
	{
		%vec = %obj.getForwardVector();
		%vel = %obj.getVelocity();
		%slow = vectorScale(%vel,0.25);
		%fwd = vectorScale(%vec,9);
		%obj.setVelocity("0 0 12");
		%obj.schedule(100,setVelocity,%fwd);
		%obj.schedule(300,addVelocity,"0 0 -3");
		%obj.schedule(50,playthread,0,sit);
		%obj.schedule(100,playthread,1,shiftdown);
		%obj.schedule(400,playthread,0,shiftup);
		%obj.schedule(400,setVelocity,%slow);
	}
	function ClimbStep(%obj)
	{
		if(%obj.isClimbHup)
			return;
		%vec = %obj.getForwardVector();
		%fwd = vectorScale(%vec,3);
		%obj.schedule(200,setVelocity,%fwd);
		%obj.setVelocity("0 0 10");
		%obj.playthread(0,plant);
		%obj.playthread(3,shiftUp);
		%obj.isClimbHup = 1;
		schedule(250,0,eval,%obj@".isClimbHup=0;");
	}
	//Climbing Integration
	function ClimbLedgeGrab(%obj,%posA,%posB)
	{
		%vel = %obj.getVelocity();
		%uv = getWord(%vel,2);
		%isLedgeA = ClimbLedgeSearch(%obj,%posA,%posB,0.8);
		%isLedgeB = ClimbLedgeSearch(%obj,%posA,%posB,0.89);
		%isLedgeC = ClimbLedgeSearch(%obj,%posA,%posB);
		%isLedgeD = ClimbLedgeSearch(%obj,%posA,%posB,0.91);
		%isLedgeE = ClimbLedgeSearch(%obj,%posA,%posB,1.0);
	//	echo("is ledge =" SPC %isLedgeA SPC %isLedgeB SPC %isLedgeC SPC %isLedgeD SPC %isLedgeE);
		if((%isLedgeA || %isLedgeE) && %uv > -18 && !%obj.noReGrab)
		{
			ClimbYShift(%obj,%isLedgeA,%isLedgeB,%isLedgeC,%isLedgeD,%isLedgeE);
			ClimbXShift(%obj);
			ClimbLedgeHang(%obj);
		//	echo("thinks there is ledge");
		}
		else if(!%isLedgeD && !%isLedgeE && !%obj.isClimb)
		{
			%canReach = ClimbMultiLedgeCheck(%obj,%posA,%posB,-0.5,4);
			if(%canReach)
				ClimbFallSlow(%obj,%obj.rPos,%uv);
			else if(%uv == 0 && !%obj.isLedgeTurning) //was else if
				stopClimbHang(%obj,"ClimbLedgeGrab");
		}
	}
	function ClimbLedgeSearch(%obj,%posA,%posB,%len,%vec,%type)
	{
		if(%vec $= "")
			%vec = %obj.getForwardVector();
		if(%len $= "")
			%len = 0.9;
		%startA = vectorAdd(%posA,"0 0 0.15");	//hackPosition
		%startB = vectorAdd(%posB,"0 0 -0.55");	//eyePoint
		%beam = vectorScale(%vec,%len);
		%endA = vectorAdd(%startA,%beam);
		%endB = vectorAdd(%startB,%beam);
		%rayA = containerRayCast(%startA,%endA,$TypeMasks::fxBrickObjectType | $TypeMasks::TerrainObjectType,%obj);
		%rayB = containerRayCast(%startB,%endB,$TypeMasks::fxBrickObjectType | $TypeMasks::TerrainObjectType,%obj);
		if(%type $= "surface")
			%rayBMod = isObject(firstWord(%rayB));
		else
			%rayBMod = !isObject(firstWord(%rayB));
	//	echo("rayB modification" SPC %rayBMod);
		if(isObject(firstWord(%rayA)) && %rayBMod)
			return 1;
		else
			return 0;
	}
	function ClimbWallSearch(%obj,%pos,%offset)
	{
		%vec = %obj.getForwardVector();
		if(!isObject(%pos))
		{
			%pos = %obj.getPosition();
			%pos = vectorAdd(%pos,"0 0" SPC %offset);
			%pos = vectorAdd(%pos,vectorScale(%vec,1));
		}
		initContainerBoxSearch(%pos, "1.25 1.25 1", $Typemasks::fxBrickObjectType | $Typemasks::TerrainObjectType);
		if(isObject(%col = containerSearchNext()))
			return 1;
		else
			return 0;
	}
	function ClimbMultiLedgeCheck(%obj,%posA,%posB,%sub,%lim)
	{
		if(%lim < 1)
			%lim = 5;
		for(%h=0;%h<%lim;%h++)
		{
			%add = "0 0" SPC vectorScale(%h,0.1);
			if(%sub != 0)
			{
				%sub = "0 0" SPC %sub;
				%off = vectorAdd(%sub,%add);
			}
			else
				%off = %add;
			%posA = vectorAdd(%posA,%off);
			%posB = vectorAdd(%posB,%off);
			%isLedge = ClimbLedgeSearch(%obj,%posA,%posB);
			if(%isLedge)
			{
				%canReach=1;
				break;
			}
		}
		%obj.rPos = %posA;
		return %canReach;
	}
	function ClimbYShift(%obj,%isLedgeA,%isLedgeB,%isLedgeC,%isLedgeD,%isLedgeE)
	{
		%pos = %obj.getPosition();
		%vec = %obj.getForwardVector();
		if(%isLedgeA)
			%obj.setTransform(vectorAdd(%pos,vectorScale(%vec,-0.09)));
		else if(%isLedgeB)
			%obj.setTransform(vectorAdd(%pos,vectorScale(%vec,-0.01)));
		else if(%isLedgeD && !%isLedgeC)
			%obj.setTransform(vectorAdd(%pos,vectorScale(%vec,0.01)));
		else if(%isLedgeE && !%isLedgeD)
			%obj.setTransform(vectorAdd(%pos,vectorScale(%vec,0.10)));
	}
	function ClimbXShift(%obj)
	{
		if(%obj.isXShifting)
			return;
		%vec = %obj.getForwardVector();
		%vel = ClimbVelCheck(%obj,%vec);
		%x = getWord(%vel,0);
		%y = getWord(%vel,1);
		%z = getWord(%vel,2);
		if((%x > 0.05 || %x < -0.05) && (%y < 0.05 && %y > -0.05))
			%obj.changedatablock(PlayerClimbSide);
		else
			%obj.changedatablock(PlayerClimb);
	}
	function ClimbVelCheck(%obj,%vec)
	{
		%vel = %obj.getVelocity();
		%rv = relativevelocity(%vec,%vel);
		%x = getWord(%rv,0);
		%y = getWord(%rv,1);
		%z = getWord(%vel,2);
		%vel = %x SPC %y SPC %z;
		return %vel;
	}
	function ClimbFallSlow(%obj,%posA,%uv)
	{
		if((%obj.isClimbAnim || %obj.isClimb) && !%obj.isHangJumping)
			return;
		%pos = %obj.getPosition();
		%mov = vectorAdd(%posA,"0 0 -1.325");
		%len = vectorDist(getWord(%mov,2),getWord(%pos,2));
		if(%uv < -1 && %len <= 0.5) //%len was < 1.2
		{
			if(%uv < -18)
				%obj.playthread(3,activate2);
			else if(!%obj.isHangJumping && !%obj.isClimbing)
				%obj.setTransform(%mov);
		}
	}
	function ClimbLedgeHang(%obj)
	{
		if(%obj.isHangJumping)
			return;
		%wep = %obj.getMountedImage(0);
		%vec = %obj.getForwardVector();
		%vel = %obj.getVelocity();
		%y = vectorDot(%vel,%vec);
		%pos = %obj.getPosition();
		ClimbEdgeDetection(%obj,%vec,%vel,%pos);
		ClimbDirFix(%obj,%vec);
		if(%wep != 0)
		{
			%obj.playthread(1,armreadyboth);
			%obj.unmountImage(0);
		}
		if(!%obj.isClimbFirstHang)
		{
			cancel(%obj.iCH);
			%obj.isClimbFirstHang=1;
			%obj.isClimbHangable=0;
			%obj.iCH = schedule(200,0,eval,%obj@".isClimbHangable=1;");
		}
		if(!%obj.isClimb)
			ClimbShape(%obj,%pos);
		if(!%obj.isClimbAnim)
		{
		//	echo("first climb Anim");
			%obj.isClimbAnim=1;
			%obj.setVelocity("0 0 0");
			%obj.cAS = schedule(50,0,climbAnimStart,%obj);
			%obj.changedatablock(PlayerClimb);
		}
		if((%y > 0.05 || %y < -0.05) && %obj.isClimbHangable && !%obj.isClimb && !%obj.isXShifting)
		{
			%obj.isClimb=1;
			schedule(300,0,eval,%obj@".isClimb=0;");
			cancel(%obj.ClimbClR);
			cancel(%obj.ClimbClL);
			if(%obj.isClimbClLeft)
				%obj.isClimbClLeft=0;
			else
				%obj.isClimbClLeft=1;
			if(%y > 0.05)
				ClimbUp(%obj);
			if(%y < -0.05)
				ClimbDown(%obj);
		}
	}
	function ClimbEdgeDetection(%obj,%vec,%vel,%pos)
	{
		%vel = %obj.getVelocity();
		%lvec = getLeftVector(%obj);
		%rvec = getRightVector(%obj);
		%lvel = vectorDot(%lvec,%vel);
		%posA = %obj.getHackPosition();
		%posB = %obj.getEyePoint();
		%lPosA = vectorAdd(%posA,vectorScale(%lvec,0.1));
		%lPosB = vectorAdd(%posB,vectorScale(%lvec,0.1));
		%rPosA = vectorAdd(%posA,vectorScale(%rvec,0.1));
		%rPosB = vectorAdd(%posB,vectorScale(%rvec,0.1)); //was 0.2 for all 4 of these
		%fPosA = vectorAdd(%posA,vectorScale(%vec,0.8));
		%fPosB = vectorAdd(%posB,vectorScale(%vec,0.8));
		%isLedgeL = ClimbLedgeSearch(%obj,%lPosA,%lPosB,1);
		%isLedgeR = ClimbLedgeSearch(%obj,%rPosA,%rPosB,1);
		%isLedgeLTurn = ClimbLedgeSearch(%obj,%posA,%posB,1,%lvec);
		%isLedgeRTurn = ClimbLedgeSearch(%obj,%posA,%posB,1,%rvec);
		%isLWall = ClimbLedgeSearch(%obj,%fPosA,%fPosB,0.8,%lvec,"surface");
		%isRWall = ClimbLedgeSearch(%obj,%fPosA,%fPosB,0.8,%rvec,"surface");
		if(%isLedgeLTurn && %lvel > 0.5 && !%obj.isLedgeTurning)
			Rotate5(%obj,%pos,"left");
		else if(%isLedgeRTurn && %lvel < -0.5 && !%obj.isLedgeTurning)
			Rotate5(%obj,%pos,"right");
		else if((!%isLedgeL || (%isLedgeLTurn && %lvel > 0.5) || %isLWall) && !%obj.isXShifting)
		{
		//	echo("left and ledge turn lagged =" SPC %isLedgeLTurn);
			%obj.isXShifting=1;
			schedule(10,0,eval,%obj@".isXShifting=0;");
			%ls = vectorScale(%lvec,-0.1);
			%obj.setTransform(vectorAdd(%pos,%ls));
		}
		else if((!%isLedgeR || (%isLedgeRTurn && %lvel < -0.5) || %isRWall) && !%obj.isXShifting)
		{
		//	echo("right and ledge turn lagged =" SPC %isLedgeRTurn);
			%obj.isXShifting=1;
			schedule(10,0,eval,%obj@".isXShifting=0;");
			%rs = vectorScale(%rvec,-0.1);
			%obj.setTransform(vectorAdd(%pos,%rs));
		}
	}
	//Rotate 5°
	function Rotate5(%obj,%pos,%dir,%nextTurn)
	{
		if(!%obj.isClimbAnim || %obj.isClimbing)
			return;
		%vec = %obj.getForwardVector();
		%vel = ClimbVelCheck(%obj,%vec);
		%x = getWord(%vel,0);
		if(%pos $= "")
			%pos = %obj.getPosition();
		%tra = %obj.getTransform();
		%euler = axisToEuler(getWords(%tra,3,6));
		%dFix = ClimbDirCheck(%obj,%vec,0.1);
		if(%dir $= "right" && %x > 0.5)
			%nRot = vectorAdd(%euler,"0 0 -10");
		else if(%dir $= "left" && %x < -0.5)
			%nRot = vectorAdd(%euler,"0 0 10");
		else if(%dir $= "right")
			%nRot = vectorAdd(%euler,"0 0 10");
		else if(%dir $= "left")
			%nRot = vectorAdd(%euler,"0 0 -10");
		if(%dFix $= "" || !%nextTurn)
		{
			%nextTurn=1;
			%obj.setTransform(%pos SPC eulerToAxis(%nRot));
			schedule(10,0,Rotate5,%obj,%pos,%dir,%nextTurn);
			%obj.isXShifting=1;
			cancel(%obj.isXS);
			%obj.isXS = schedule(100,0,eval,%obj@".isXShifting=0;");
			%obj.isLedgeTurning=1;
			cancel(%obj.isLT);
			%obj.isLT = schedule(9,0,eval,%obj@".isLedgeTurning=0;");
		}
	}
	function ClimbDirCheck(%obj,%vec,%len)
	{
		%xa = "1 0 0";
		%ya = "0 1 0";
		%xb = "-1 0 0";
		%yb = "0 -1 0";
		%xad = vectorDist(%vec,%xa);
		%yad = vectorDist(%vec,%ya);
		%xbd = vectorDist(%vec,%xb);
		%ybd = vectorDist(%vec,%yb);
		if(%len $= "")
			%len = 0.75;
		if(%yad < %len)
			%dir = "0 1 0";
		if(%ybd < %len)
			%dir = "0 -1 0";
		if(%xad < %len)
			%dir = "1 0 0";
		if(%xbd < %len)
			%dir = "-1 0 0";
		return %dir;
	}
	function ClimbDirFix(%obj,%vec)
	{
		%pos = %obj.getPosition();
		%dir = ClimbDirCheck(%obj,%vec);
		if(%dir $= "0 1 0")
			%eulerRot = "0 0 0";
		if(%dir $= "0 -1 0")
			%eulerRot = "0 0 180";
		if(%dir $= "1 0 0")
			%eulerRot = "0 0 -90";
		if(%dir $= "-1 0 0")
			%eulerRot = "0 0 90";
		%dist = vectorDist(%dir,%vec);
		if(%dist > 0.01) //was 0.02
		{
			%hack = %obj.getHackPosition();
			%posA = vectorAdd(%hack,"0 0 0.15");
			%ray = ClimbBeamCheck(%obj,%posA,1,$TypeMasks::fxBrickObjectType | $TypeMasks::TerrainObjectType,%vec);
			%rayHack = posFromRaycast(%ray);
			%dist = vectorDist(%posA,%rayHack);
			%mov = vectorAdd(%rayHack,vectorScale(%dir,-0.9));
			%space = climbBoxCheck(%obj,1,%mov);
			%movPos = vectorAdd(%mov,"0 0 -1.325");
			if(%dist > 0.1 && isObject(firstWord(%ray)) && !%obj.isClimbAnim && !isObject(%space))
				%obj.setTransform(%movPos SPC eulerToAxis(%eulerRot));
			else if(!isObject(%space))
				%obj.setTransform(%pos SPC eulerToAxis(%eulerRot));
		}
	}
	function ClimbBeamCheck(%obj,%pos,%len,%masks,%vec)
	{
		if(%len $= "" || %len == 0)
			%len = 0.9;
		%beam = vectorScale(%vec,%len);
		%end = vectorAdd(%pos,%beam);
		%ray = containerRayCast(%pos,%end,%masks,%obj);
		if(isObject(firstWord(%ray)))
			return %ray;
	}
	function climbAnimStart(%obj)
	{
		cancel(%obj.cAS);
		cancel(%obj.cAS2);
		if(%obj.isClimbAnim && !%obj.isHangJumping && !%obj.isClimbing && !%obj.isClimbHup)
		{
			%obj.playthread(2,root);
			%obj.playthread(1,armreadyboth);
			%obj.playthread(0,fall);
			%obj.isClimbAnimated=1;
		}
		else if(%obj.isHangJumping || %obj.isClimbing)
			%obj.cAS = schedule(50,0,climbAnimStart,%obj);
	}
	function stopClimbHang(%obj,%caller)
	{
		%data = %obj.getDatablock();
		%posA = %obj.getHackPosition();
		%posB = %obj.getEyePoint();
		%isLedgeC = ClimbLedgeSearch(%obj,%posA,%posB);
		if(%data.canClimbHang && !%isLedgeC)
		{
		//	echo("stopped climb hang via" SPC %caller);
			cancel(%obj.iCH);
			%obj.isClimbAnim=0;
			%obj.isArmThreaded=0;
			%obj.isClimbHangable=0;
			%obj.isClimbFirstHang=0;
			ClimbShapeRemove(%obj);
			if(!%obj.isMeleeToggled)
				%obj.changedatablock(PlayerClimbing);
			else
				%obj.changedatablock(PlayerClimbMelee);
			stopClimbHangAnim(%obj);
			%obj.setActionThread(root);
		}
	}
	function stopClimbHangAnim(%obj)
	{
		if(!%obj.isClimbAnim && !%obj.isClimbing)
		{
			%obj.playthread(1,root);
			if(!%obj.isHangJumping)
			{
				cancel(%obj.ClimbClR);
				cancel(%obj.ClimbClL);
				%obj.playthread(3,root);
				%obj.playthread(0,root);
				%obj.isClimbAnimated=0;
			}
		}
		else if(%obj.isClimbAnimated)
			schedule(50,0,stopClimbHangAnim,%obj);
	}
	//Climbing Up and Down
	function ClimbUp(%obj)
	{
		%posA = vectorAdd(%obj.getHackPosition(),"0 0 1.2");
		%posB = vectorAdd(%obj.getEyePoint(),"0 0 1.2");
		%isLedge = ClimbLedgeSearch(%obj,%posA,%posB);
		if(%isLedge && !%isPlayer)
		{
		//	echo("climbed up");
			%rand = ClimbRandom(1,2);
			%obj.setVelocity("0 0 8.25");
			%obj.isClimbing=1;
			schedule(300,0,eval,%obj@".isClimbing=0;");
			schedule(300,0,eval,%obj@".isClimbAnim=0;");
			if(%obj.isClimbClLeft)
				ClimbClLeft(%obj);
			else
				ClimbClRight(%obj);
			if(%rand == 1)
				%obj.playthread(0,plant);
			else
				%obj.playthread(0,jump);
		}
		else
			ClimbHup(%obj);
	}
	function ClimbDown(%obj)
	{
		%posA = vectorAdd(%obj.getPosition(),"0 0 0.1");
		%posB = vectorAdd(%obj.getHackPosition(),"0 0 0");
		%isLedge = ClimbLedgeSearch(%obj,%posA,%posB);
		if(%isLedge && !%isPlayer)
		{
		//	echo("climbed down");
			%pos = %obj.getPosition();
			%pos = vectorAdd(%pos,"0 0 -1.19");
			ClimbShape(%obj,%pos);
			%rand = ClimbRandom(1,2);
			%obj.setVelocity("0 0 -2.5");
			%obj.isClimbing=1;
			schedule(300,0,eval,%obj@".isClimbing=0;");
			schedule(300,0,eval,%obj@".isClimbAnim=0;");
			if(%obj.isClimbClLeft)
				%obj.ClimbClR = schedule(150,0,ClimbClLeft,%obj);
			else
				%obj.ClimbClL = schedule(150,0,ClimbClRight,%obj);
			if(%rand == 1)
				%obj.playthread(0,plant);
			else
				%obj.playthread(0,jump);
		}
	}
	function ClimbClLeft(%obj)
	{
		%obj.playthread(1,armreadyleft);
		%obj.playthread(2,leftrecoil);
	}
	function ClimbClRight(%obj)
	{
		%obj.playthread(1,armreadyright);
		%obj.playthread(2,shiftaway);
	}
	function ClimbRandom(%a,%b)
	{
		%random = getRandom(%a,%b);
		return %random;
	}
	function ClimbHup(%obj)
	{
		%vec = %obj.getForwardVector();
		%pos = %obj.getEyePoint();
		%pos = vectorAdd(%pos,vectorScale(%vec,0.5));
		%pos = vectorAdd(%pos,"0 0 0.5");
		initContainerBoxSearch(%pos, "1.3 1.3 1", $Typemasks::fxBrickObjectType | $Typemasks::TerrainObjectType);
		%col = containerSearchNext();
		if(isObject(%col) && !%obj.isClimbing)
			%canHup=0;
		else
			%canHup=1;
		if(%canHup)
		{
		//	echo("hupped");
			cancel(%obj.hupStop);
			%vel = %obj.getVelocity();
			%dv = getWords(%vel,0,1);
			%obj.playthread(1,crouch);
			%obj.schedule(200,setThreadDir,1,false);
			%obj.playthread(2,shiftdown);
			%obj.playthread(3,plant);
			%obj.setVelocity(%dv SPC "12");
			%obj.isClimbHup=1;
			schedule(350,0,eval,%obj@".isClimbHup=0;");
			%obj.hupStop = schedule(300,0,ClimbHupFinish,%obj,%vec,%vel);
		}
	}
	function ClimbHupFinish(%obj,%vec,%vel)
	{
		%ya = vectorScale(%vec,3);
		%obj.setVelocity(%ya);
	}
	//Climb Tool
	function ClimbShape(%obj,%pos)
	{
		%start = vectorAdd(%pos,"0 0 0.1");
		%beam = "0 0 -0.3";
		%end = vectorAdd(%start,%beam);
		%ray = containerRayCast(%start,%end,$TypeMasks::StaticShapeObjectType,%obj);
		if(isObject(%shape = firstWord(%ray)))
		{
			%shPos = %shape.getPosition();
			%plPos = getWord(%pos,2);
			%shPos = getWord(%shPos,2);
			%dist = vectorDist(%plPos,%shPos);
		//	bottomPrint(%obj.client,"<font:impact:30><br><br><br><color:FFF200><just:right>Distance to Shape =" SPC %dist,1);
			if(%dist < 0.05 && !%obj.isShapeAdjusted)
			{
				%obj.setTransform(vectorAdd(%pos,"0 0" SPC 0.11-%dist));
				%obj.isShapeAdjusted=1;
				schedule(500,0,eval,%obj@".isShapeAdjusted=0;");
			}
			else
				return;
		}

		//default Shape
		%sPos = vectorAdd(%pos,"0 0 -0.11");
		%shape = new StaticShape()
		{
			datablock = ClimbEmptyData;
			position = %sPos;
			client = %obj.client;
			scale = "0.5 0.5 0.1";
		};missionCleanup.add(%shape);
		ClimbShapeRemove(%obj);
		%obj.cShape = %shape;
	}
	function ClimbShapeRemove(%obj)
	{
		if(isObject(%obj.cShape))
			%obj.cShape.delete();
	}
	//Climb Death
	function Armor::onDisabled(%data,%obj,%enabled)
	{
		parent::onDisabled(%data,%obj,%enabled);
		if(%data.canClimb)
			ClimbShapeRemove(%obj);
	}
	function GameConnection::OnClientLeaveGame(%client)
	{
		%obj = %client.player;
		ClimbShapeRemove(%obj);
		Parent::OnClientLeaveGame(%client);
	}
};activatePackage(Climbing);

package ClimbTriggers
{
	function Player::activateStuff(%obj)
	{
		%data = %obj.getDatablock();
		if(!%obj.isClimbAnim && !%obj.isClimbing)
			Parent::activateStuff(%obj);
	}
	function Armor::onImpact(%data,%obj,%col,%pos,%speed)
	{
		if(!%data.canClimb || %data.canClimb && %speed >= 30)
			parent::onImpact(%data,%obj,%col,%pos,%speed);
		if(%data.canClimb)
		{
		//	echo("speed =" SPC %speed);
		}
	}
	function Armor::onTrigger(%data,%obj,%slot,%val)
	{
		if(!%data.canClimb)
			return Parent::onTrigger(%data,%obj,%slot,%val);
		%pos = %obj.getPosition();
		%add = vectorAdd(%pos,"0 0 0.3");
		%groundA = climbBoxCheck(%obj);
		%groundB = climbBoxCheck(%obj,"",%add);
		if(isObject(%groundA) && %groundA != %groundB)
			%isGround=1;
		if(%slot == 2)
		{
			%obj.isJumping = %val;
			if(%obj.isJumping && !%isGround)
				ClimbHangJump(%obj,%data);
		//	else if(%obj.isJumping)
		//		ClimbJump(%obj,%data);
		}
		else if(%slot == 3)
		{
			%obj.isCrouching = %val;
			if(%val)
			{
				cancel(%obj.nRG);
				%obj.noReGrab=0;
				%vel = %obj.getVelocity();
				%vec = %obj.getForwardVector();
				%y = vectorDot(%vel,%vec);
				if(!%obj.isFirstCrouched)
				{
					%obj.isFirstCrouched=1;
					schedule(300,0,eval,%obj@".isFirstCrouched=0;");
				}
				else if(%data.getName() !$= "PlayerClimbDanger" && %isGround && %y > 0.5 && !%obj.isClimbRollWaiting)
				{
					%obj.changedatablock(PlayerClimbDanger);
					%obj.unmountImage(0);
					%obj.playthread(0,sit);
					%obj.setActionThread(land);
					%obj.playthread(2,look);
					%obj.schedule(50,stopthread,2);
					%obj.isClimbRolling=1;
					schedule(400,0,eval,%obj@".isClimbRolling=0;");
					%obj.isClimbRollWaiting=1;
					schedule(800,0,eval,%obj@".isClimbRollWaiting=0;");
				}
			}
			else
			{
				if(!%isGround)
				{
					%obj.noReGrab=1;
					%obj.nRG = schedule(200,0,eval,%obj@".noReGrab=0;");
				}
			}
		}
		else if(%slot == 4)
		{
			%obj.isJetting = %val;
			if(!%data.canClimbHang && !%obj.isClimbRolling)
			{
			//	if(!%val)
			//		stopJogging(%obj,%data);
			//	else
			//		startJogging(%obj,%data);
			}
		}
		else
			Parent::onTrigger(%data,%obj,%slot,%val);
	}
	function startJogging(%obj,%data)
	{
		if(%data.getName() $= "PlayerClimbJog")
			return;
		%obj.changedatablock(PlayerClimbJog);
		%obj.unmountImage(0);
		%obj.playthread(1,root);
	}
	function stopJogging(%obj,%data)
	{
		if(%data.getName() !$= "PlayerClimbJog")
			return;
		%slot = %obj.currTool;
		%obj.changedatablock(PlayerClimbing);
		servercmdusetool(%obj.client,%slot);
	}
	function climbBoxCheck(%obj,%up,%start)
	{
		if(%up $= "")
			%up = 0.1;
		if(%start $= "")
			%start = %obj.getPosition();
		initContainerBoxSearch(%start, "1.25 1.25" SPC %up, $TypeMasks::fxBrickObjectType | $Typemasks::TerrainObjectType);
		%col = containerSearchNext();
		return %col;
	}
	function ClimbHangJump(%obj,%data)
	{
		if(!%data.canClimbHang)
			return;
		%pos = %obj.getPosition();
		%vec = %obj.getForwardVector();
		%dir = ClimbDirCheck(%obj,%vec);
		%vel = ClimbVelCheck(%obj,%dir);
		%x = getWord(%vel,0);
		%y = getWord(%vel,1);
		%z = getWord(%vel,2);
		%fX = getWord(%dir,0);
		%fY = getWord(%dir,1);
		if(%x > 1.95 && %x <= 2 && %obj.isClimbAnim)
		{
			%xA = 7;
			%zA = 5;
			%yA = 0.2;
			%obj.playthread(1,shiftaway);
			%obj.playthread(0,root);
			serverPlay3D(jumpsound,%pos);
			schedule(380,0,eval,%obj@".isHangJumping=0;");
			%obj.isHangJumping=1;
			%obj.isClimbAnim=0;
			%obj.isClimbFirstHang=0;
			%obj.changedatablock(PlayerClimbEdge);
		}
		if(%x < -1.95 && %x >= -2 && %obj.isClimbAnim)
		{
			%xA = -7;
			%zA = 5;
			%yA = 0.2;
			%obj.playthread(1,leftrecoil);
			%obj.playthread(0,root);
			serverPlay3D(jumpsound,%pos);
			schedule(380,0,eval,%obj@".isHangJumping=0;");
			%obj.isHangJumping=1;
			%obj.isClimbAnim=0;
			%obj.isClimbFirstHang=0;
			%obj.changedatablock(PlayerClimbEdge);
		}
		if(%y > 0.05 && %obj.isClimbAnim && !%obj.isClimbing && !%obj.isClimbHup)
		{
			%posA = vectorAdd(%obj.getHackPosition(),"0 0 1.5");
			%posB = vectorAdd(%obj.getEyePoint(),"0 0 1.5");
			%found = ClimbMultiLedgeCheck(%obj,%posA,%posB,0,3);
			if(%found)
			{
				%zA = 10;
				%obj.playthread(1,shiftup);
				%obj.playthread(0,jump);
				serverPlay3D(jumpsound,%pos);
				schedule(200,0,eval,%obj@".isHangJumping=0;");
				%obj.isHangJumping=1;
				%obj.isClimbAnim=0;
				%obj.isClimbFirstHang=0;
				%obj.changedatablock(PlayerClimbEdge);
			}
		}
		if((%y < -0.05 || %z < -1) && %obj.isClimbAnim)
		{
			cancel(%obj.ClimbClR);
			cancel(%obj.ClimbClL);
			%obj.playthread(1,shiftdown);
			%obj.playthread(0,plant);
			%yA = -6;
			%zA = 6;
			schedule(100,0,Rotate180,%obj);
			serverPlay3D(jumpsound,%pos);
			schedule(200,0,eval,%obj@".isHangJumping=0;");
			%obj.isHangJumping=1;
			%obj.isClimbAnim=0;
			%obj.isClimbFirstHang=0;
		//	%obj.setActionThread(root);
		}
		%av = (%xA * %fY + %yA * %fX) SPC (%yA * %fY + %xA * -%fX) SPC %zA;
		%obj.setVelocity(%av);
	}
	function ClimbJump(%obj,%data)
	{
		if(%data.canClimbHang)
			return;
		%pos = %obj.getPosition();
		%vel = %obj.getVelocity();
		%dv = getWords(%vel,0,1);
		if(%data.getName() $= "PlayerClimbGun")
			%obj.setTransform(vectorAdd(%pos,"0 0 0.05"));
	//	else
	//		%obj.changedatablock(PlayerClimbing);
		%obj.setVelocity(%dv SPC "10.5");
		serverplay3d(jumpsound,%pos);
		%obj.playthread(2,shiftup);
		%obj.playthread(0,jump);
	}
	//Rotate 180°
	function Rotate180(%obj)
	{
		%eulerRotation = axisToEuler(getWords((%transform = %obj.getTransform()),3,6));
		%eulerXY = getWords(%eulerRotation,0,1);
		%eulerZ = getWord(%eulerRotation,2);
		if(%eulerZ <= 0)
			%eulerZ += 180;
		else
			%eulerZ -= 180;
		%oppositeEulerRot = %eulerXY SPC %eulerZ;
		%obj.setTransform(getWords(%transform,0,2) SPC eulerToAxis(%oppositeEulerRot));
	}
	function returnFromRoll(%obj)
	{
		if(%obj.getDatablock().getName() $= "PlayerClimbDanger")
		{
			if(!%obj.isClimbAnim)
			{
				%obj.changedatablock(PlayerClimbing);
				servercmdusetool(%obj.client,%obj.currTool);
			}
		}
	}
};activatePackage(ClimbTriggers);

package MiscFunctions
{
	//Relative Velocity
	function relativeVelocity(%dirVec,%velVec)
	{
		%pi = 4 * mAtan(1,1);
		%horMag = VectorLen(getWords(%velVec,0,1) SPC 0);
		%dirAng = mATan(getWord(%dirVec,1), getWord(%dirVec,0));
		%velAng = mATan(getWord(%velVec,1), getWord(%velVec,0));
		%relAng = %velAng - %dirAng + %pi/2;
		%relVec = VectorAdd(VectorScale(mCos(%relAng) SPC mSin(%relAng) SPC 0,%horMag), "0 0" SPC getWord(%velVec,2));
	}
	//Relative Vector
	function getRightVector(%obj)
	{
		return vectorCross(%obj.getForwardVector(),%obj.getUpVector());
	}
	function getLeftVector(%obj)
	{
		return vectorScale(getRightVector(%obj),-1);
	}
	//Euler to Axis & Axis to Euler
	function eulerToAxis(%euler)
	{
		%euler = VectorScale(%euler,$pi / 180);
		%matrix = MatrixCreateFromEuler(%euler);
		return getWords(%matrix,3,6);
	}
	function axisToEuler(%axis)
	{
		%angleOver2 = getWord(%axis,3) * 0.5;
		%angleOver2 = -%angleOver2;
		%sinThetaOver2 = mSin(%angleOver2);
		%cosThetaOver2 = mCos(%angleOver2);
		%q0 = %cosThetaOver2;
		%q1 = getWord(%axis,0) * %sinThetaOver2;
		%q2 = getWord(%axis,1) * %sinThetaOver2;
		%q3 = getWord(%axis,2) * %sinThetaOver2;
		%q0q0 = %q0 * %q0;
		%q1q2 = %q1 * %q2;
		%q0q3 = %q0 * %q3;
		%q1q3 = %q1 * %q3;
		%q0q2 = %q0 * %q2;
		%q2q2 = %q2 * %q2;
		%q2q3 = %q2 * %q3;
		%q0q1 = %q0 * %q1;
		%q3q3 = %q3 * %q3;
		%m13 = 2.0 * (%q1q3 - %q0q2);
		%m21 = 2.0 * (%q1q2 - %q0q3);
		%m22 = 2.0 * %q0q0 - 1.0 + 2.0 * %q2q2;
		%m23 = 2.0 * (%q2q3 + %q0q1);
		%m33 = 2.0 * %q0q0 - 1.0 + 2.0 * %q3q3;
		return mRadToDeg(mAsin(%m23)) SPC mRadToDeg(mAtan(-%m13, %m33)) SPC mRadToDeg(mAtan(-%m21, %m22));
	}
};activatePackage(MiscFunctions);