//Playertype
datablock PlayerData(PlayerCollector : PlayerStandardArmor)
{
	canJet = false;
	canCollect = true;

	uiName = "Collector Player";
	showEnergyBar = false;
};

package CollectorPlayer
{
	//Activate
	function Player::ActivateStuff(%obj)
	{
		Parent::activateStuff(%obj);
		if(%obj.getDatablock().canCollect && isObject(%obj.client))
		{
			if(%obj.hasCollectorActivated) //If correct playertype
				CollectorGetFromBricks(%obj); //Get something from a brick structure
			else
			{
				%obj.hasCollectorActivated = true;
				schedule(300,0,eval,%obj@".hasCollectorActivated = false;");
			}
		}
	}
};activatePackage(CollectorPlayer);

//Collect an Item from the brick structure
function CollectorGetFromBricks(%obj)
{
	%client = %obj.client;
	%eye = %obj.getEyePoint();
	%vec = %obj.getEyeVector();
	%brick1 = CollectorBeamCheck(%obj,%eye,3,$TypeMasks::fxBrickObjectType,%vec);
	if(!isObject(%brick1))
		return;

	//Keys
	if(%brick1.dataBlock $= "brick2x2fPrintData" && (%brick1.client == %client || %client.isHost))
	{
	//	echo("brick 1 is the right datablock");
		%b1Pos = %brick1.getPosition();
		%brick2 = CollectorBeamCheck(%obj,%b1Pos,0.2,$TypeMasks::fxBrickObjectType,"0 0 -1");
		if(isObject(%brick2) && %brick2.dataBlock $= "brick2x2Data" && (%brick2.client == %client || %client.isHost))
		{
			%b2Pos = %brick2.getPosition();
			%brick3 = CollectorBeamCheck(%obj,%b2Pos,0.4,$TypeMasks::fxBrickObjectType,"0 0 -1");
			if(isObject(%brick3) && %brick3.dataBlock $= "brick2x2fData" && (%brick3.client == %client || %client.isHost))
				%type = "Red Key";
		}
		if(%type $= "Red Key")
		{
		//	echo("all bricks found for  " SPC %type);
			%b1 = %brick1.getColorID() == getClosestPaintColor("1 0 0 1") && %brick1.printID == 83;
			%b2 = %brick2.getColorID() == getClosestPaintColor("1 1 1 1");
			%b3 = %brick3.getColorID() == getClosestPaintColor("1 1 1 1");
			if(%b1 && %b2 && %b3) //Found a Red Key!
			{
			//	echo("all bricks correct");
				%finish = %type;
				%brick1.setColorFx(3);
				serverplay3d(beep_key_sound,%b1Pos);
				%total = 3; //bricks used
				for(%i=1;%i<=%total;%i++)
					%brick[%i].killbrick(); //Kill bricks
			}
		}
	}

	//Gun
	if(%brick1.dataBlock $= "brick1x2fPrintData" && (%brick1.client == %client || %client.isHost))
	{
	//	echo("brick 1 is the right datablock");
		%b1Pos = %brick1.getPosition(); //brick 1 position
		%brick2 = CollectorBeamCheck(%obj,%b1Pos,0.2,$TypeMasks::fxBrickObjectType,"0 0 -1");
		if(isObject(%brick2) && %brick2.dataBlock $= "brick1x2fData" && (%brick2.client == %client || %client.isHost)) //if next brick found
		{
			%rvec = findRelativeX(%brick1.getForwardVector()); //relative rightward vector
			%b2Pos = %brick2.getPosition(); //brick 2 position
			%b2AddL = vectorAdd(%b2Pos,vectorScale(%rvec,-0.25)); //leftward shift
			%b2AddR = vectorAdd(%b2Pos,vectorScale(%rvec,0.25)); //rightward shift
			%brick3 = CollectorBeamCheck(%obj,%b2AddR,0.2,$TypeMasks::fxBrickObjectType,"0 0 -1"); //If next brick is on the left
			if(!isObject(%brick3) || %brick3.dataBlock !$= "brick1x1fData" && (%brick3.client == %client || %client.isHost)) //otherwise
				%brick3 = CollectorBeamCheck(%obj,%b2AddL,0.2,$TypeMasks::fxBrickObjectType,"0 0 -1"); //If next brick is on the right
			if(isObject(%brick3) && %brick3.dataBlock $= "brick1x1fData" && (%brick3.client == %client || %client.isHost))
				%type = "Gun";
		}
		if(%type $= "Gun")
		{
		//	echo("all bricks found for  " SPC %type);
			%b1 = %brick1.getColorID() == getClosestPaintColor("0.3 0.3 0.3 1") && %brick1.printID == 21;
			%b2 = %brick2.getColorID() == getClosestPaintColor("0.3 0.3 0.3 1");
			%b3 = %brick3.getColorID() == getClosestPaintColor("0.3 0.3 0.3 1");
			if(%b1 && %b2 && %b3) //Found a Gun!
			{
			//	echo("all bricks correct");
				%finish = %type;
				%brick1.setColorFx(3);
				serverplay3d(beep_key_sound,%b1Pos);
				%total = 3; //bricks used
				for(%i=1;%i<=%total;%i++)
					%brick[%i].killbrick(); //Kill bricks
			}
		}
	}

	//Spear
	if(%brick1.dataBlock $= "brick1x1ConeData" && (%brick1.client == %client || %client.isHost))
	{
	//	echo("brick 1 is the right datablock");
		%b1Pos = %brick1.getPosition();
		%brick2 = CollectorBeamCheck(%obj,%b1Pos,0.4,$TypeMasks::fxBrickObjectType,"0 0 -1");
		if(isObject(%brick2) && %brick2.dataBlock $= "brick1x1fRoundData" && (%brick2.client == %client || %client.isHost))
		{
			%b2Pos = %brick2.getPosition();
			%brick3 = CollectorBeamCheck(%obj,%b2Pos,0.2,$TypeMasks::fxBrickObjectType,"0 0 -1");
			if(isObject(%brick3) && %brick3.dataBlock $= "brick1x1RoundData" && (%brick3.client == %client || %client.isHost))
			{
				%b3Pos = %brick3.getPosition();
				%brick4 = CollectorBeamCheck(%obj,%b3Pos,0.4,$TypeMasks::fxBrickObjectType,"0 0 -1");
				if(isObject(%brick4) && %brick4.dataBlock $= "brick1x1RoundData" && (%brick4.client == %client || %client.isHost))
				{
					%b4Pos = %brick4.getPosition();
					%brick5 = CollectorBeamCheck(%obj,%b4Pos,0.4,$TypeMasks::fxBrickObjectType,"0 0 -1");
					if(isObject(%brick5) && %brick5.dataBlock $= "brick1x1RoundData" && (%brick5.client == %client || %client.isHost))
					{
						%b5Pos = %brick5.getPosition();
						%brick6 = CollectorBeamCheck(%obj,%b5Pos,0.4,$TypeMasks::fxBrickObjectType,"0 0 -1");
						if(isObject(%brick6) && %brick6.dataBlock $= "brick1x1RoundData" && (%brick6.client == %client || %client.isHost))
						{
							%b6Pos = %brick6.getPosition();
							%brick7 = CollectorBeamCheck(%obj,%b6Pos,0.4,$TypeMasks::fxBrickObjectType,"0 0 -1");
							if(isObject(%brick7) && %brick7.dataBlock $= "brick1x1RoundData" && (%brick7.client == %client || %client.isHost))
								%type = "Spear";
						}
					}
				}
			}
		}
		if(%type $= "Spear")
		{
		//	echo("all bricks found for  " SPC %type);
			%b1 = %brick1.getColorID() == getClosestPaintColor("0.4 0.2 0 1");
			%b2 = %brick2.getColorID() == getClosestPaintColor("0.4 0.2 0 1");
			%b3 = %brick3.getColorID() == getClosestPaintColor("0.4 0.2 0 1");
			%b4 = %brick4.getColorID() == getClosestPaintColor("0.4 0.2 0 1");
			%b5 = %brick5.getColorID() == getClosestPaintColor("0.4 0.2 0 1");
			%b6 = %brick6.getColorID() == getClosestPaintColor("0.4 0.2 0 1");
			%b7 = %brick7.getColorID() == getClosestPaintColor("0.4 0.2 0 1");
			if(%b1 && %b2 && %b3 && %b4 && %b5 && %b6 && %b7) //Found a Spear!
			{
			//	echo("all bricks correct");
				%finish = %type;
				%brick1.setColorFx(3);
				serverplay3d(beep_key_sound,%b1Pos);
				%total = 7; //bricks used
				for(%i=1;%i<=%total;%i++)
					%brick[%i].killbrick(); //Kill bricks
			}
		}
	}
	if(%finish !$= "") //If Item found
		CollectorGetActual(%obj,%finish,%b1Pos); //Get Item!

	//Vehicles
	if(%brick1.dataBlock $= "brick8x8fData" && (%brick1.client == %client || %client.isHost))
	{
		//Jeep
		%b1Pos = %brick1.getPosition();
		%brick2 = CollectorBeamCheck(%obj,%b1Pos,0.2,$TypeMasks::fxBrickObjectType,"0 0 1");
		if(isObject(%brick2) && %brick2.dataBlock $= "brick4x6Data" && (%brick2.client == %client || %client.isHost))
		{
		//	echo("brick 2 is the right datablock");
			%b2Pos = %brick2.getPosition(); //brick 2 position
			%fvec = %brick2.getForwardVector(); //forward vector
			%rvec = findRelativeX(%fvec); //relative rightward vector
			%b2AddD = vectorAdd(%b2Pos,"0 0" SPC -0.1); //leftward shift
			%b2AddDF = vectorAdd(%b2AddD,vectorScale(%fvec,1)); //down forward shift
			%b2AddDB = vectorAdd(%b2AddD,vectorScale(%fvec,-1)); //down backward shift
			%b2AddFs = vectorAdd(%b2Pos,vectorScale(%fvec,0.3)); //slight forward shift
			%b2AddBs = vectorAdd(%b2Pos,vectorScale(%fvec,-0.3)); //slight backward shift
			%b2AddUp = vectorAdd(%b2AddFs,"0 0" SPC 0.4); //upward shift

			%brick3 = CollectorBeamCheck(%obj,%b2AddDF,-1.2,$TypeMasks::fxBrickObjectType,%rvec); //left front wheel
			%brick4 = CollectorBeamCheck(%obj,%b2AddDF,1.2,$TypeMasks::fxBrickObjectType,%rvec); //right front wheel
			%brick5 = CollectorBeamCheck(%obj,%b2AddDB,-1.2,$TypeMasks::fxBrickObjectType,%rvec); //left back wheel
			%brick6 = CollectorBeamCheck(%obj,%b2AddDB,1.2,$TypeMasks::fxBrickObjectType,%rvec); //right back wheel

			%brick9 = CollectorBeamCheck(%obj,%b2AddFs,1,$TypeMasks::fxBrickObjectType,"0 0 1"); //top of window if forward
			if(!isObject(%brick9) || %brick9.dataBlock !$= "brick1x4fData" && (%brick9.client == %client || %client.isHost)) //otherwise
			{
				%brick9 = CollectorBeamCheck(%obj,%b2AddBs,1,$TypeMasks::fxBrickObjectType,"0 0 1"); //top of window if backward
				%b2AddUp = vectorAdd(%b2AddBs,"0 0" SPC 0.4); //upward shift
				%fvec = vectorScale(%fvec,-1); //use backward vector
			}
			%brick7 = CollectorBeamCheck(%obj,%b2AddUp,-0.6,$TypeMasks::fxBrickObjectType,%rvec); //left side of window
			%brick8 = CollectorBeamCheck(%obj,%b2AddUp,0.6,$TypeMasks::fxBrickObjectType,%rvec); //right side of window

			%isBFL = isObject(%brick3) && %brick3.dataBlock $= "brick1x2crestLowData" && (%brick3.client == %client || %client.isHost); //If forward left wheel
			%isBFR = isObject(%brick4) && %brick4.dataBlock $= "brick1x2crestLowData" && (%brick4.client == %client || %client.isHost); //If forward right wheel
			%isBBL = isObject(%brick5) && %brick5.dataBlock $= "brick1x2crestLowData" && (%brick5.client == %client || %client.isHost); //If back left wheel
			%isBBR = isObject(%brick6) && %brick6.dataBlock $= "brick1x2crestLowData" && (%brick6.client == %client || %client.isHost); //If back right wheel

			%isWT = isObject(%brick9) && %brick9.dataBlock $= "brick1x4fData" && (%brick9.client == %client || %client.isHost); //If window's top
			%isWL = isObject(%brick7) && %brick7.dataBlock $= "brick1x1Data" && (%brick7.client == %client || %client.isHost); //If window's left side
			%isWR = isObject(%brick8) && %brick8.dataBlock $= "brick1x1Data" && (%brick8.client == %client || %client.isHost); //If window's right side
			if(%isBFL && %isBFR && %isBBL && %isBBR && %isWT && %isWL && %isWR)
				%type = "Jeep";
		}
		if(%type $= "Jeep")
		{
		//	echo("all bricks found for  " SPC %type);
			%b1 = %brick1.getColorID() == getClosestPaintColor("1 1 1 1");
			%b2 = %brick2.getColorID() == getClosestPaintColor("0 0.5 0 1");
			%b3 = %brick3.getColorID() == getClosestPaintColor("0.3 0.3 0.3 1");
			%b4 = %brick4.getColorID() == getClosestPaintColor("0.3 0.3 0.3 1");
			%b5 = %brick5.getColorID() == getClosestPaintColor("0.3 0.3 0.3 1");
			%b6 = %brick6.getColorID() == getClosestPaintColor("0.3 0.3 0.3 1");
			%b7 = %brick7.getColorID() == getClosestPaintColor("0 0.5 0 1");
			%b8 = %brick8.getColorID() == getClosestPaintColor("0 0.5 0 1");
			%b9 = %brick9.getColorID() == getClosestPaintColor("0 0.5 0 1");
			if(%b1 && %b2 && %b3 && %b4 && %b5 && %b6 && %b7 && %b8 && %b9) //Found a Jeep!
			{
				%vehicle = %type;
				serverplay3d(beep_key_sound,%b1Pos); //beep sound
				%total = 9; //bricks used
				%rot = rotFromVec(%fvec); //fvec rotation
				for(%i=1;%i<=%total;%i++)
					%brick[%i].killbrick(); //Kill bricks
			}
		}

		//Horse
		%fvec = %brick1.getForwardVector(); //forward vector
		%rvec = findRelativeX(%fvec); //relative rightward vector
		%b1AddF = vectorAdd(%b1Pos,vectorScale(%fvec,0.6)); //forward shift
		%b1AddB = vectorAdd(%b1Pos,vectorScale(%fvec,-0.6)); //backward shift
		%b1AddL = vectorAdd(%b1Pos,vectorScale(%rvec,-0.6)); //left shift
		%b1AddR = vectorAdd(%b1Pos,vectorScale(%rvec,0.6)); //right shift
		%brick2 = CollectorBeamCheck(%obj,%b1AddF,0.2,$TypeMasks::fxBrickObjectType,"0 0 1"); //front legs if forward
		if(!isObject(%brick2) || %brick2.dataBlock !$= "brick1x2fData" && (%brick2.client == %client || %client.isHost)) //otherwise
		{
			%brick2 = CollectorBeamCheck(%obj,%b1AddB,0.2,$TypeMasks::fxBrickObjectType,"0 0 1"); //front legs if backward
			%fvec = vectorScale(%fvec,-1); //set fvec to be backward
		}
		if(!isObject(%brick2) || %brick2.dataBlock !$= "brick1x2fData" && (%brick2.client == %client || %client.isHost)) //otherwise
		{
			%brick2 = CollectorBeamCheck(%obj,%b1AddL,0.2,$TypeMasks::fxBrickObjectType,"0 0 1"); //front legs if leftward
			%fvec = vectorScale(%rvec,-1); //set fvec to be leftward
		}
		if(!isObject(%brick2) || %brick2.dataBlock !$= "brick1x2fData" && (%brick2.client == %client || %client.isHost)) //otherwise
		{
			%brick2 = CollectorBeamCheck(%obj,%b1AddR,0.2,$TypeMasks::fxBrickObjectType,"0 0 1"); //front legs if rightward
			%fvec = %rvec; //set fvec to be rightward
		}
		if(isObject(%brick2) && %brick2.dataBlock $= "brick1x2fData" && (%brick2.client == %client || %client.isHost)) //front feet
		{
			%b2Pos = %brick2.getPosition();
			%brick3 = CollectorBeamCheck(%obj,%b2Pos,0.2,$TypeMasks::fxBrickObjectType,"0 0 1");
			if(isObject(%brick3) && %brick3.dataBlock $= "brick1x2Data" && (%brick3.client == %client || %client.isHost)) //front legs
			{
				%b3Pos = %brick3.getPosition();
				%brick4 = CollectorBeamCheck(%obj,%b3Pos,0.4,$TypeMasks::fxBrickObjectType,"0 0 1");
				if(isObject(%brick4) && %brick4.dataBlock $= "brick2x4fData" && (%brick4.client == %client || %client.isHost)) //lower body
				{
					%b4Pos = %brick4.getPosition();
					%brick5 = CollectorBeamCheck(%obj,%b4Pos,0.2,$TypeMasks::fxBrickObjectType,"0 0 1");
					if(isObject(%brick5) && %brick5.dataBlock $= "brick2x4fData" && (%brick5.client == %client || %client.isHost)) //upper body
					{
						%b5Add = getWords(%b3Pos,0,1) SPC getWord(%brick5.getPosition(),2);
						%brick6 = CollectorBeamCheck(%obj,%b5Add,0.2,$TypeMasks::fxBrickObjectType,"0 0 1");
						if(isObject(%brick6) && %brick6.dataBlock $= "brick1x2fData" && (%brick6.client == %client || %client.isHost)) //neck
						{
							%b6Pos = %brick6.getPosition();
							%brick7 = CollectorBeamCheck(%obj,%b6Pos,0.2,$TypeMasks::fxBrickObjectType,"0 0 1");
							if(isObject(%brick7) && %brick7.dataBlock $= "brick2x2RampData" && (%brick7.client == %client || %client.isHost)) //Head
								%head = true;
						}
					}
				}
			}
		}
		if(%head)
		{
			%rvec = findRelativeX(%fvec); //relative rightward vector
			%b2AddL = vectorAdd(%b2Pos,vectorScale(%rvec,-0.3)); //slight leftward front feet add
			%b2AddR = vectorAdd(%b2Pos,vectorScale(%rvec,0.3)); //slight rightward front feet add
			%brick8 = CollectorBeamCheck(%obj,%b2AddL,-2.1,$TypeMasks::fxBrickObjectType,%fvec); //back left leg
			%brick9 = CollectorBeamCheck(%obj,%b2AddR,-1.6,$TypeMasks::fxBrickObjectType,%fvec); //back right leg

			if(isObject(%brick8) && %brick8.dataBlock $= "brick1x1fData" && (%brick8.client == %client || %client.isHost)) //If back left foot
			{
				%b8Pos = %brick8.getPosition();
				%brick10 = CollectorBeamCheck(%obj,%b8Pos,0.2,$TypeMasks::fxBrickObjectType,"0 0 1");
			}
			if(isObject(%brick9) && %brick9.dataBlock $= "brick1x1fData" && (%brick9.client == %client || %client.isHost)) //If back left leg
			{
				%b9Pos = %brick9.getPosition();
				%brick11 = CollectorBeamCheck(%obj,%b9Pos,0.2,$TypeMasks::fxBrickObjectType,"0 0 1");
			}

			%isBLL = isObject(%brick10) && %brick10.dataBlock $= "brick1x2RampUpData" && (%brick10.client == %client || %client.isHost); //If backward left leg
			%isBLR = isObject(%brick11) && %brick11.dataBlock $= "brick1x2RampUpData" && (%brick11.client == %client || %client.isHost); //If backward right leg
			if(%isBLL && %isBLR)
				%type = "Horse";
		}
		if(%type $= "Horse")
		{
		//	echo("all bricks found for  " SPC %type);
			%b1 = %brick1.getColorID() == getClosestPaintColor("1 1 1 1");
			%b2 = %brick2.getColorID() == getClosestPaintColor("0.4 0.2 0 1");
			%b3 = %brick3.getColorID() == getClosestPaintColor("0.4 0.2 0 1");
			%b4 = %brick4.getColorID() == getClosestPaintColor("0.4 0.2 0 1");
			%b5 = %brick5.getColorID() == getClosestPaintColor("0.4 0.2 0 1");
			%b6 = %brick6.getColorID() == getClosestPaintColor("0.4 0.2 0 1");
			%b7 = %brick7.getColorID() == getClosestPaintColor("0.4 0.2 0 1");
			%b8 = %brick8.getColorID() == getClosestPaintColor("0.4 0.2 0 1");
			%b9 = %brick9.getColorID() == getClosestPaintColor("0.4 0.2 0 1");
			%b10 = %brick10.getColorID() == getClosestPaintColor("0.4 0.2 0 1");
			%b11 = %brick11.getColorID() == getClosestPaintColor("0.4 0.2 0 1");
			if(%b1 && %b2 && %b3 && %b4 && %b5 && %b6 && %b7 && %b8 && %b9 && %b10 && %b11) //Found a Horse!
			{
				%vehicle = %type;
				serverplay3d(beep_key_sound,%b1Pos); //beep sound
				%total = 11; //bricks used
				%rot = rotFromVec(%fvec); //fvec rotation
				for(%i=1;%i<=%total;%i++)
					%brick[%i].killbrick(); //Kill bricks
			}
		}

		//Stunt Plane
		%brick2 = CollectorBeamCheck(%obj,%b1Pos,0.4,$TypeMasks::fxBrickObjectType,"0 0 1"); //plane's body
		if(isObject(%brick2) && %brick2.dataBlock $= "brick2x8fData" && (%brick2.client == %client || %client.isHost)) //If plane's body
		{
		//	echo("plane body found");
			%b2Pos = %brick2.getPosition();
			%fvec = %brick2.getForwardVector(); //forward vector
			%rvec = findRelativeX(%fvec); //relative rightward vector
			%b2AddFs = vectorAdd(%b2Pos,vectorScale(%fvec,0.3)); //slight forward shift
			%b2AddBs = vectorAdd(%b2Pos,vectorScale(%fvec,-0.3)); //slight backward shift
			%brick3 = CollectorBeamCheck(%obj,%b2AddFs,0.2,$TypeMasks::fxBrickObjectType,"0 0 1"); //cockpit front if forward
			if(!isObject(%brick3) || %brick3.dataBlock !$= "Brick1x2CrestHighEndData" && (%brick3.client == %client || %client.isHost)) //otherwise
			{
			//	echo("front inverted");
				%brick3 = CollectorBeamCheck(%obj,%b2AddBs,0.2,$TypeMasks::fxBrickObjectType,"0 0 1"); //cockpit front if backward
				%fvec = vectorScale(%fvec,-1); //use backward vector
				%rvec = findRelativeX(%fvec); //relative rightward vector
			}
			if(isObject(%brick3) && %brick3.dataBlock $= "brick1x2CrestHighEndData" && (%brick3.client == %client || %client.isHost)) //cockpit front
			{
			//	echo("cockpit front found");
				%b2AddF = vectorAdd(%b2Pos,vectorScale(%fvec,0.6)); //forward shift
				%b2AddFf = vectorAdd(%b2Pos,vectorScale(%fvec,1.2)); //far forward shift
				%b2AddFfd = vectorAdd(%b2AddFf,vectorScale("0 0 -1",0.1)); //far forward down shift
				%b2AddB = vectorAdd(%b2Pos,vectorScale(%fvec,-0.6)); //backward shift
				%b2AddBf = vectorAdd(%b2Pos,vectorScale(%fvec,-1.2)); //far backward shift
				%brick4 = CollectorBeamCheck(%obj,%b2AddF,0.2,$TypeMasks::fxBrickObjectType,"0 0 1");
				if(isObject(%brick4) && %brick4.dataBlock $= "brick2x8fData" && (%brick4.client == %client || %client.isHost)) //front wings
				{
					%b4Pos = %brick4.getPosition();
					%brick5 = CollectorBeamCheck(%obj,%b4Pos,0.6,$TypeMasks::fxBrickObjectType,%fvec);
					%brick6 = CollectorBeamCheck(%obj,%b4Pos,0.2,$TypeMasks::fxBrickObjectType,"0 0 1");
					%brick7 = CollectorBeamCheck(%obj,%b2AddB,0.2,$TypeMasks::fxBrickObjectType,"0 0 1");
					%brick8 = CollectorBeamCheck(%obj,%b2AddBf,0.2,$TypeMasks::fxBrickObjectType,"0 0 -1");
					%brick9 = CollectorBeamCheck(%obj,%b2AddFfd,-0.6,$TypeMasks::fxBrickObjectType,%rvec);
					%brick10 = CollectorBeamCheck(%obj,%b2AddFfd,0.6,$TypeMasks::fxBrickObjectType,%rvec);
					%isFH = isObject(%brick5) && %brick5.dataBlock $= "brick1x2CrestLowData" && (%brick5.client == %client || %client.isHost); //front hood
					%isFT = isObject(%brick6) && %brick6.dataBlock $= "brick2x2crestLowData" && (%brick6.client == %client || %client.isHost); //front top (above wings)
					%isBW = isObject(%brick8) && %brick8.dataBlock $= "brick1x2fData" && (%brick8.client == %client || %client.isHost); //back wheel
					%isFWL = isObject(%brick9) && %brick9.dataBlock $= "brick1x2CrestLowData" && (%brick9.client == %client || %client.isHost); //front left wheel
					%isFWR = isObject(%brick10) && %brick10.dataBlock $= "brick1x2CrestLowData" && (%brick10.client == %client || %client.isHost); //front right wheel

					if(isObject(%brick7) && %brick7.dataBlock $= "brick2x2crestLowData" && (%brick7.client == %client || %client.isHost)) //back top (behind cockpit)
					{
					//	echo("top behind cockpit found");
						%b7Pos = %brick7.getPosition();
						%brick11 = CollectorBeamCheck(%obj,%b7Pos,-0.6,$TypeMasks::fxBrickObjectType,%fvec);
						if(isObject(%brick11) && %brick11.dataBlock $= "brick1x2CrestHighEndData" && (%brick11.client == %client || %client.isHost)) //If back wing
						{
						//	echo("back vertical wing found");
							%b11Pos = %brick11.getPosition();
							%brick12 = CollectorBeamCheck(%obj,%b11Pos,0.4,$TypeMasks::fxBrickObjectType,"0 0 -1"); //back horizontal wing
							%isBVW = isObject(%brick12) && %brick12.dataBlock $= "brick1x4fData" && (%brick12.client == %client || %client.isHost);
						}
					}
				//	echo("Plane pieces found    Front Hood =" SPC %isFH SPC "  Front Top =" SPC %isFT SPC "  Back Wheel =" SPC %isBW SPC "  Front Wheel Left =" SPC %isFWL SPC "  Front Wheel Right =" SPC %isFWR SPC "  Back Wings =" SPC %isBVW);
					if(%isFH && %isFT && %isBW && %isFWL && %isFWR && %isBVW)
						%type = "Stunt Plane";
				}
			}
		}
		if(%type $= "Stunt Plane")
		{
		//	echo("all bricks found for  " SPC %type);
			%b1 = %brick1.getColorID() == getClosestPaintColor("1 1 1 1");
			%b2 = %brick2.getColorID() == getClosestPaintColor("0 0.1 0.3 1");
			%b3 = %brick3.getColorID() == getClosestPaintColor("0 0.1 0.3 1");
			%b4 = %brick4.getColorID() == getClosestPaintColor("0 0.1 0.3 1");
			%b5 = %brick5.getColorID() == getClosestPaintColor("0 0.1 0.3 1");
			%b6 = %brick6.getColorID() == getClosestPaintColor("0 0.1 0.3 1");
			%b7 = %brick7.getColorID() == getClosestPaintColor("0 0.1 0.3 1");
			%b8 = %brick8.getColorID() == getClosestPaintColor("0.3 0.3 0.3 1");
			%b9 = %brick9.getColorID() == getClosestPaintColor("0.3 0.3 0.3 1");
			%b10 = %brick10.getColorID() == getClosestPaintColor("0.3 0.3 0.3 1");
			%b11 = %brick11.getColorID() == getClosestPaintColor("0 0.1 0.3 1");
			%b12 = %brick12.getColorID() == getClosestPaintColor("0 0.1 0.3 1");
			if(%b1 && %b2 && %b3 && %b4 && %b5 && %b6 && %b7 && %b8 && %b9 && %b10 && %b11 && %b12) //Found a Stunt Plane!
			{
				%vehicle = %type;
				serverplay3d(beep_key_sound,%b1Pos); //beep sound
				%total = 12; //bricks used
				%rot = rotFromVec(%fvec); //fvec rotation
				for(%i=1;%i<=%total;%i++)
					%brick[%i].killbrick(); //Kill bricks
			}
		}
	}
	if(%vehicle !$= "")
		schedule(5,0,CollectorSpawnVehicle,%obj,%vehicle,%b1Pos,%rot);
}

//Get the Item
function CollectorGetActual(%obj,%type,%pos)
{
	if(%type $= "Red Key") //Red Key
	{
		%item = RedKeyItem;
	}
	if(%type $= "Spear") //Spear
	{
		%item = SpearItem;
	}
	if(%type $= "Gun") //Gun
	{
		%item = GunItem;
	}
	if(%item $= "")
		return;
	%item = new item()
	{
		datablock = %item;
	};

	%item.schedulePop();
	%hack = %obj.getHackPosition();
	%sub = vectorSub(%hack,%pos);

	%item.setTransform(%pos);
	%item.setVelocity(vectorAdd(vectorScale(%sub,5),"0 0 5"));
	%item.miniGame = getMiniGameFromObject(%obj);
	CollectorGetMessage(%obj.client,%type);
}

//Get the Vehicle
function CollectorSpawnVehicle(%obj,%type,%pos,%rot)
{
	%client = %obj.client;
	if(%type $= "Jeep") //Jeep
	{
		%brick = brickVehicleSpawnData; //brick data
		%vehicle = JeepVehicle; //vehicle data
		%colID = getClosestPaintColor("1 0 0 1"); //Green
	}
	if(%type $= "Horse") //Horse
	{
		%brick = brickVehicleSpawnData; //brick data
		%vehicle = HorseArmor; //vehicle data
		%colID = getClosestPaintColor("1 0 0 1"); //Green
	}
	if(%type $= "Stunt Plane") //Stunt Plane
	{
		%brick = brickVehicleSpawnData; //brick data
		%vehicle = StuntPlaneVehicle; //vehicle data
		%colID = getClosestPaintColor("1 0 0 1"); //Green
	}
	if(%brick $= "")
		return;
	%spawn = new fxDTSBrick()
	{
		datablock = %brick;
		position = %pos;
		rotation = %rot;
		colorID = %colID;
		angleID = 0;
		scale = "1 1 1";
		colorfxID = 0;
		shapefxID = 0;
		stackBLID = %client.bl_ID;
		client = %client;
		isPlanted = true;
	};
	%client.undoStack.push(%spawn TAB "PLANT"); //Make brick undoable
	%client.brickGroup.add(%spawn); //add to brick group
	%spawn.setTrusted(3);
	%spawn.plant(); //actually plant the brick
	%spawn.setVehicle(nameToID(%vehicle),%client); //spawn the vehicle
	%spawn.setRecolorVehicle(false); //make it colorable
//	%spawn.respawnVehicle(); //respawn it
	%spawn.setRendering(false); //hide
	%spawn.setRaycasting(false); //
	%spawn.setColliding(false); //
	%vePos = %spawn.vehicle.getPosition(); //vehicle position
	%spawn.vehicle.setTransform(%vePos SPC %rot); //rotate vehicle
	if(%type $= "Jeep")
		%spawn.vehicle.setNodeColor("ALL","0 0.5 0 1"); //Make Jeep green
	if(%type $= "Horse")
		%spawn.vehicle.setNodeColor("ALL","0.4 0.2 0 1"); //Make Horse brown
	if(%type $= "Stunt Plane")
		%spawn.vehicle.setNodeColor("ALL","0 0.2 0.3 1"); //Make Stunt Plane blue
	CollectorGetMessage(%client,%type);
}

//Message
function CollectorGetMessage(%client,%type)
{
	centerPrint(%client,"<font:impact:30>\c6You created a<color:FFCC00>" SPC %type @ "\c6!",5);
}


//Rotation From Vector
function RotFromVec(%vec)
{
	%yaw = mAtan(getWord(%vec,1),getWord(%vec,0));
	%fix = "0 0 -1" SPC %yaw;
	%eul = axisToEuler(%fix);
	%eulA = vectorAdd(%eul,"0 0 -90");
	%axis = eulerToAxis(%eulA);
	return %axis;
}

//Vector Code
function findRelativeX(%vec)
{
	%dir = getWords(%vec,0,1) SPC 0; //Make horizontal
	%nrm = vectorNormalize(%dir); //normalize
	return vectorCross(%dir,"0 0 1"); //rightward vector
}

//Beam Check
function CollectorBeamCheck(%obj,%pos,%len,%masks,%vec)
{
	%beam = vectorScale(%vec,%len);
	%end = vectorAdd(%pos,%beam);
	%ray = containerRayCast(%pos,%end,%masks,%obj);
	return firstWord(%ray);
}

//Credit to Space Guy for this
function getClosestPaintColor(%rgba)
{
	%prevdist = 100000;
	%colorMatch = 0;
	for(%i = 0;%i < 64;%i++)
	{
		%color = getColorIDTable(%i);
		if(vectorDist(%rgba,getWords(%color,0,2)) < %prevdist && getWord(%rgba,3) - getWord(%color,3) < 0.3 && getWord(%rgba,3) - getWord(%color,3) > -0.3)
		{
			%prevdist = vectorDist(%rgba,%color);
			%colormatch = %i;
		}
	}
	return %colormatch;
}