//By Hata
datablock PlayerData(PlayerComplexity : PlayerStandardArmor)
{
	canJet = 0;
	canPhysFlip = 1;
	canComplex = 1;
	maxDamage = 250;
//	pickupRadius = 1.25;

	uiName = "Complex Player";
	showEnergyBar = true;
	rechargeRate = 0;
};


//Complex Tool Menu Icons
datablock itemData(CompexQItemA : printGun)
{
	uiName = "";
	iconName = "add-ons/weapon_sword/icon_sword";

	doColorShift = true;
	colorShiftColor = "1 0.3 0.3 1";

	image = ComplexQImage;
	canDrop = false;
};
datablock itemData(CompexQItemB : printGun)
{
	uiName = "";
	iconName = "add-ons/weapon_gun/icon_gun";

	doColorShift = true;
	colorShiftColor = "1 1 0.4 1";

	image = ComplexQImage;
	canDrop = false;
};
datablock itemData(CompexQItemC : printGun)
{
	uiName = "";
	iconName = "./icon_P90";

	doColorShift = true;
	colorShiftColor = "0.3 1 0.45 1";

	image = ComplexQImage;
	canDrop = false;
};
datablock itemData(CompexQItemD : printGun)
{
	uiName = "";
	iconName = "add-ons/weapon_rocket_launcher/icon_rocketlauncher";

	doColorShift = true;
	colorShiftColor = "0.1 0.5 1 1";

	image = ComplexQImage;
	canDrop = false;
};
datablock ShapeBaseImageData(ComplexQImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;
	mountPoint = 0;
	className = "WeaponImage";
	canComplexQ = 1;

	stateName[0] = "Ready";
};


//Complex Menu Emote
datablock ParticleData(ComplexMenuParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 400;
	lifetimeVarianceMS   = 200;
	textureName          = "base/data/particles/star1";
	spinSpeed			= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.8 0.0 0.4 0.2";
	colors[1]     = "0.8 0.0 0.4 0.1";
	sizes[0]      = 0.2;
	sizes[1]      = 0.1;

	useInvAlpha = true;
};
datablock ParticleEmitterData(ComplexMenuEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ComplexMenuParticle";
};
datablock ShapeBaseImageData(ComplexMenuLeftImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;
	mountPoint = 1;
	className = "WeaponImage";
	canComplex = 1;

	stateName[0]					= "Ready";
	stateTransitionOnTimeout[0]		= "FireA";
	stateTimeoutValue[0]			= 0.1;

	stateName[1]					= "FireA";
	stateTransitionOnTimeout[1]		= "Ready";
	stateWaitForTimeout[1]			= true;
	stateTimeoutValue[1]			= 0.1;
	stateEmitter[1]					= ComplexMenuEmitter;
	stateEmitterTime[1]				= 0.5;
};

datablock ShapeBaseImageData(ComplexMenuImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;
	mountPoint = 0;
	className = "WeaponImage";
	canComplex = 1;

	stateName[0] = "Ready";
};

function ComplexMenuImage::onMount(%this,%obj,%slot)
{
	Parent::onMount(%this,%obj,%slot);
	%obj.mountImage(ComplexMenuLeftImage,1);
	%obj.playthread(1,root);
}
function ComplexMenuImage::onUnMount(%this,%obj,%slot)
{
	Parent::onUnMount(%this,%obj,%slot);
	schedule(10,0,closeComplexMenu,%obj);
	%obj.unmountImage(1);
}



//Bulk Code
package ComplexCMDs
{
	function ItemData::onAdd(%this,%obj)
	{
		Parent::onAdd(%this,%obj);
	}
	function WeaponImage::onMount(%this,%obj,%slot)
	{
		Parent::onMount(%this,%obj,%slot);
		if(%this.canComplexQ)
			%obj.playthread(1,root);
	}
	function Armor::onAdd(%data,%obj)
	{
		Parent::onAdd(%data,%obj);
		%obj.isSpawnLingered=1;
		schedule(100,0,eval,%obj@".isSpawnLingered=0;");
	}
	function Armor::onDamage(%data,%obj,%damage)
	{
		%hurt = %obj.getDamageLevel();
		%max = %data.maxDamage;
		if(%data.canComplex)
		{
			%scale = 100/%max;
			%hp = (%max-%hurt)*%scale;
			%obj.setEnergyLevel(%hp);
		}
		Parent::onDamage(%data,%obj,%damage);
	}
	function Armor::onNewDatablock(%data,%obj)
	{
		%client = %obj.client;
		if(!%data.canComplex)
		{
			if(%obj.lastData.canComplex)
			{
				unHideComplexInventory(%client);
				bottomprint(%client,"",1);
				%mini = %client.minigame;
				if(%obj.cannotPaint $= "Complexity")
				{
					commandToClient(%client,'SetPaintingDisabled',!%mini.enablePainting);
					%obj.cannotPaint = "";
				}
			}
			saveComplexInventory(%client);
		}
		else
		{
			hideComplexInventory(%client);
			if(!%obj.lastData.canComplex)
			{
				schedule(100,0,complexReplaceTools,%obj);
				commandToClient(%client,'SetPaintingDisabled',true);
				if(%obj.cannotPaint $= "")
					%obj.cannotPaint = "Complexity";
			}
		}
		Parent::onNewDatablock(%data,%obj);
		%obj.lastData = %data;
	}
	//Triggers
	function Armor::onTrigger(%data,%obj,%slot,%val)
	{
		if(%slot == 0 && %val)
		{
			if(%obj.isComplexChoosing)
				ComplexMenuSelect(%obj);
		}
		if(%slot == 4 && %val)
		{
			if(%data.canComplex)
				%wep = %obj.getMountedImage(0);
			if(%wep != 0 && (%obj.currTool $= "" || %obj.currTool == -1))
				%obj.CTH = schedule(300,0,ComplexToolHide,%obj);
		}
		else if(%slot == 4)
		{
			cancel(%obj.CTH);
			if(%obj.isComplexChoosing)
				ComplexMenuInvSelect(%obj);
		}
		Parent::onTrigger(%data,%obj,%slot,%val);
	}
	function ComplexToolHide(%obj)
	{
		if(%obj.currTool $= "" || %obj.currTool == -1)
			servercmdUnUseTool(%obj.client);
	}
	//Tools
	function servercmdUseTool(%client,%slot)
	{
		%obj = %client.player;
		%data = %obj.getDatablock();
		Parent::servercmdUseTool(%client,%slot);
		if(%data.canComplex)
			ComplexReplaceTools(%obj);
	}
	//Bricks
	function servercmdUseInventory(%client,%slot)
	{
		%obj = %client.player;
		if(!isObject(%obj))
			return;
		%data = %obj.getDatablock();
		if(!%data.canComplex)
			return Parent::servercmdUseInventory(%client,%slot);
		%wep = %obj.getMountedImage(0);
		if(%wep == 0 || !%wep.canComplex)
			openComplexMenu(%obj);
		else if(%wep.canComplex)
			cycleComplexScroll(%obj,%slot);
	}
	function servercmdInstantUseBrick(%client,%brickdata)
	{
		%obj = %client.player;
		if(isObject(%obj))
			%data = %obj.getDatablock();
		if(%data.canComplex)
		{
			if(!%obj.isComplexChoosing)
				closeBrickBox(%obj);
			hideComplexInventory(%obj.client);
			commandtoclient(%client,'repurposekeybinds',1);
			return;
		}
		Parent::servercmdInstantUseBrick(%client,%brickdata);
	}
	function servercmdBuyBrick(%client,%i,%id)
	{
		%obj = %client.player;
		%data = %obj.getDatablock();
		if(!%data.canComplex)
			Parent::serverCmdBuyBrick(%client,%i,%id);
		else if(%data != 0)
			hideComplexInventory(%obj.client);
	}
	function closeBrickBox(%obj)
	{
		commandToClient(%obj.client,'setBuildingDisabled',true);
		%mini = %obj.client.minigame;
		if(!isObject(%mini))
			%mini.enableBuilding = true;
		if(%obj.cannotBuild $= "")
			commandToClient(%obj.client,'SetBuildingDisabled',!%mini.enableBuilding);
	}
	function openComplexMenu(%obj)
	{
		if(%obj.isComplexLingered || %obj.isSpawnLingered)
			return;
		schedule(10,0,eval,%obj@".isComplexChoosing=1;");
		for(%i=0;%i<10;%i++)
		{
			if(%obj.client.lvl[%i] > 1)
				%upMenu=1;
			if(%obj.client.lvl[%i] > 2)
				%obj.client.lvl[%i] = 2;
		}
		for(%i=0;%i<10;%i++)
		{
			if(!%upMenu && %obj.client.lvl[%i] < 1)
				%obj.client.lvl[%i] = 1;
		}
		hideComplexInventory(%obj.client);
		%obj.mountImage(ComplexMenuImage,0);
		schedule(50,0,eval,%obj@".isScrollReady=1;");
		%obj.isScrollReady=0;
		
	}
	function closeComplexMenu(%obj)
	{
		if(!%obj.isComplexChoosing)
			return;
		%wep = %obj.getMountedImage(0);
		%obj.isComplexChoosing=0;
		closeBrickBox(%obj);
		bottomPrint(%obj.client,"",1);
		%obj.isComplexLingered=1;
		%obj.isScrollReady=0;
		schedule(100,0,eval,%obj@".isComplexLingered=0;");
	}
	function saveComplexInventory(%client)
	{
		for(%a=0;%a<10;%a++)
		{	
			%inv = %client.inventory[%a];
			%client.defInv[%a] = %inv;
		}
	}
	function hideComplexInventory(%client)
	{
		%mode = %client.mode;
		if(%mode $= "")
			%mode = 0;
		%lvl = %client.lvl[%mode];
		%menus = 4; //was 5
	//	echo("Hide Complex Inventory:" SPC "mode =" SPC %mode SPC "lvl =" SPC %lvl);
		if(%mode == 0 && %lvl == 2)
			%menus = 3;
		if(%mode == 1 && %lvl == 2)
		{
			%menus = 5;
			%start = 1;
		}
		if(%mode == 2 && %lvl == 2)
		{
			%menus = 7;
			%start = 2;
		}
		if(%mode == 3 && %lvl == 2)
		{
			%menus = 6;
			%start = 3;
		}
		%client.start = %start;

		if(%lvl == 1)
			%idp = 200;
		if(%lvl == 2)
			%idp = 201;
		if(%lvl == 3)
			%idp = 202;
		if(%lvl == 4)
			%idp = 203;
		if(%lvl == 5)
			%idp = 204;
		for(%a=0;%a<10;%a++)
		{
		//	echo("a =" SPC %a SPC "start =" SPC %start SPC "menus =" SPC %menus);
			%inv = %client.inventory[%a];
			%idf = complexFlatCheck(%client,%idp);
			if((%start $= "" && %a >= %menus) || %a >= %menus || %a < %start)
				%id = 0;
			else if(%a == %client.slot)
				%id = %idp;
			else if(%idf !$= "")
				%id = %idf;
			else
				%id = 240;
			%client.inventory[%a] = %id;
			messageclient(%client,'MsgSetInvData',"",%a,%id);
		}
	}
	function complexFlatCheck(%client,%inv)
	{
		if(%inv == 200)
			%idf = 240;
		if(%inv == 201)
			%idf = 241;
		if(%inv == 202)
			%idf = 242;
		if(%inv == 203)
			%idf = 243;
		if(%inv == 204)
			%idf = 244;
		if(%inv == 240 || %inv == 241 || %inv == 242 || %inv == 243 || %inv == 244)
			return %inv;
		else
			return %idf;
	}
	function unHideComplexInventory(%client)
	{
		%obj = %client.player;
		if(isObject(%obj))
			%wep = %obj.getMountedImage(0);
		if(%wep.canComplex)
			%obj.unmountImage(0);
		for(%a=0;%a<10;%a++)
		{
			%inv = %client.defInv[%a];
			if(isObject(%inv))
			{
				%client.inventory[%a] = %inv;
				messageclient(%client,'MsgSetInvData',"",%a,%inv);
				%client.defInv[%a] = "";
			}
		}
	}
	function cycleComplexScroll(%obj,%slot,%naClicked)
	{
		%client = %obj.client;
		if(!%obj.isComplexChoosing)
			return;
		if(%slot $= "")
			%slot = %client.slot;
		if(%client.slot !$= "" && %slot == %client.slot && %obj.isScrollReady)
			return;
		%lvl = %client.lvl[%slot];

		//Melee
		if(%slot == 0 && %client.lvl[0] == 1)
			%mode = 0;
		if(%slot == 0 && %client.lvl[0] == 2)
		{
			%menu = "Action Melee";
			%mode = 0;
		}
		if(%slot == 1 && %client.lvl[0] == 2)
		{
			%menu = "Swingable Sword";
			%mode = 0;
		}
		if(%slot == 2 && %client.lvl[0] == 2)
		{
			%menu = "Sword";
			%mode = 0;
		}

		//Sidearm
		if(%slot == 1 && %client.lvl[1] == 1)
			%mode = 1;
		if(%slot == 1 && %client.lvl[1] == 2)
		{
			%menu = "Gun";
			%mode = 1;
		}
		if(%slot == 2 && %client.lvl[1] == 2)
		{
			%menu = "Revolver";
			%mode = 1;
		}
		if(%slot == 3 && %client.lvl[1] == 2)
		{
			%menu = "SMG";
			%mode = 1;
		}
		if(%slot == 4 && %client.lvl[1] == 2)
		{
			%menu = "Mac10";
			%mode = 1;
		}

		//Primary
		if(%slot == 2 && %client.lvl[2] == 1)
			%mode = 2;
		if(%slot == 2 && %client.lvl[2] == 2)
		{
			%menu = "Guns Akimbo";
			%mode = 2;
		}
		if(%slot == 3 && %client.lvl[2] == 2)
		{
			%menu = "Shotgun";
			%mode = 2;
		}
		if(%slot == 4 && %client.lvl[2] == 2)
		{
			%menu = "P90";
			%mode = 2;
		}
		if(%slot == 5 && %client.lvl[2] == 2)
		{
			%menu = "P90 Silenced";
			%mode = 2;
		}
		if(%slot == 6 && %client.lvl[2] == 2)
		{
			%menu = "Assault Rifle";
			%mode = 2;
		}

		//Heavy
		if(%slot == 3 && %client.lvl[3] == 1)
			%mode = 3;
		if(%slot == 3 && %client.lvl[3] == 2)
		{
			%menu = "Rocket Launcher";
			%mode = 3;
		}
		if(%slot == 4 && %client.lvl[3] == 2)
		{
			%menu = "Grenade Launcher";
			%mode = 3;
		}
		if(%slot == 5 && %client.lvl[3] == 2)
		{
			%menu = "Sniper Rifle";
			%mode = 3;
		}

		%client.menuTot = 2;
		if(%mode == 0)
			%color = "<color:FF4C4C>Melee";
		if(%mode == 1)
			%color = "<color:FFFF66>Sidearm";
		if(%mode == 2)
			%color = "<color:4CFF72>Primary";
		if(%mode == 3)
			%color = "<color:197DFF>Heavy";

		if(%menu $= "")
			%main = "Main";
		if(%menu !$= "")
			%client.menu[%mode] = %menu;
	//	echo("Complex Scroll" SPC "menu =" SPC %menu SPC "slot =" SPC %slot SPC "mode =" SPC %mode);
		%client.slot = %slot;
		%client.mode = %mode;
		%client.color[%mode] = %color;
		%item = ComplexMenuFetchCheck(%client,%menu);
		%itemID = nameToID(%item);
		if(!%obj.hasItem[%itemID] && %menu !$= "")
			%invCol = "<color:666666>";
		%na = "<color:CCCCCC>(not found)";
		%added = "<color:E57F66>added!";
		%size = "<just:right><font:Impact:22>";
		%sys = "<color:FF7F99>Complex Menu ";
		%cmpBtm = "<font:Impact:30><br><just:left>" @ %color @ "+" SPC "<font:Impact:26><color:CCCCCC>" @ %invCol @ %menu @ %main;
		%endBtm = %size @ %sys;
		bottomPrint(%client,%cmpBtm SPC %endBtm,-1);
		if(!%naClicked)
			hideComplexInventory(%client);
		%client.cmpBtm = %cmpBtm SPC %na SPC %endBtm;
		%client.smpBtm = %cmpBtm SPC %added SPC %endBtm;
	}
	function ComplexMenuSelect(%obj)
	{
		%client = %obj.client;
		%menu = %client.menu[%client.mode];
		%lvl = %client.lvl[%client.mode];
		%item = ComplexMenuFetchCheck(%client,%menu);
		%itemID = nameToID(%item);
		if(%lvl >= %client.menuTot)
		{
			if(%obj.hasComplexSelectedItem)
				return;
			if(!%obj.hasItem[%itemID])
				bottomPrint(%client,%client.cmpBtm,2);
			else
			{
				bottomPrint(%client,%client.smpBtm,2);
				ComplexAddTool(%obj,%menu);
			}
			schedule(699,0,eval,%obj@".isScrollReady=0;");
			schedule(700,0,cycleComplexScroll,%obj,"",1);
			schedule(701,0,eval,%obj@".isScrollReady=1;");
			%obj.hasComplexSelectedItem=1;
			schedule(700,0,eval,%obj@".hasComplexSelectedItem=0;");
			return;
		}
		for(%i=0;%i<10;%i++)
			%client.lvl[%i] = 0;
		%client.lvl[%client.slot] = %lvl+1;
		hideComplexInventory(%client);
		schedule(50,0,eval,%obj@".isScrollReady=1;");
		%obj.isScrollReady=0;
	}
	function ComplexMenuInvSelect(%obj)
	{
		%client = %obj.client;
		%mode = %client.mode;
		%slot = %client.slot;
		%lvl = %client.lvl[%mode];
	//	echo("Complex Menu Inverse Select:" SPC "mode =" SPC %mode SPC "lvl =" SPC %lvl SPC "slot =" SPC %slot);
		if(%lvl > 1)
		{
			if(%mode == %slot)
				%client.lvl[%slot] = %lvl-1;
			else
		//		return;
				%client.lvl[%mode] = %lvl-1;
		}
		for(%i=0;%i<10;%i++)
		{
			if(%client.lvl[%i] == 0)
				%client.lvl[%i] = 1;
		}
		hideComplexInventory(%client);
		schedule(50,0,eval,%obj@".isScrollReady=1;");
		%obj.isScrollReady=0;
	}
	function ComplexMenuFetchCheck(%client,%menu)
	{
		//Melee
		if(%menu $= "Action Melee")
			%item = ActionMeleeItem;
		if(%menu $= "Swingable Sword")
			%item = SwingableSwordItem;
		if(%menu $= "Sword")
			%item = SwordItem;

		//Sidearm
		if(%menu $= "Gun")
			%item = GunItem;
		if(%menu $= "Revolver")
			%item = SFRevolverItem;
		if(%menu $= "SMG")
			%item = SMGItem;
		if(%menu $= "Mac10")
			%item = Mac10Item;

		//Primary
		if(%menu $= "Guns Akimbo")
			%item = AkimboGunItem;
		if(%menu $= "Shotgun")
			%item = ShotgunItem;
		if(%menu $= "P90")
			%item = P90Item;
		if(%menu $= "P90 Silenced")
			%item = P90SItem;
		if(%menu $= "Assault Rifle")
			%item = AssaultRifleItem;

		//Heavy
		if(%menu $= "Rocket Launcher")
			%item = RocketLauncherItem;
		if(%menu $= "Grenade Launcher")
			%item = GLPipeItem;
		if(%menu $= "Sniper Rifle")
			%item = RemmingtonItem;
		return %item;
	}
	function ComplexAddTool(%obj,%menu)
	{
		%client = %obj.client;
		%slot = %client.mode;
		%item = ComplexMenuFetchCheck(%client,%menu);
		%itemID = nameToID(%item);
		%obj.tool[%slot] = %itemID;
		%obj.weaponCount++;
		messageClient(%obj.client,'MsgItemPickup','',%slot,%itemID);
	}	
	function ComplexReplaceTools(%obj)
	{
		for(%a=0;%a<4;%a++)
		{
			if(%a == 0)
				%itemID = nameToID(CompexQItemA);
			if(%a == 1)
				%itemID = nameToID(CompexQItemB);
			if(%a == 2)
				%itemID = nameToID(CompexQItemC);
			if(%a == 3)
				%itemID = nameToID(CompexQItemD);
			%tool = %obj.tool[%a];
			%oldT = %obj.oldTool[%obj.currTool];
			%curT = %obj.tool[%obj.currTool];
			if((%obj.currTool != %a || !%obj.hasItem[%tool]) && %tool != %itemID)
			{
			//	echo("tool =" SPC %tool SPC "  item ID =" SPC %itemID);
				%obj.oldTool[%a] = %tool;
				%obj.tool[%a] = %itemID;
				%obj.weaponCount++;
				messageClient(%obj.client,'MsgItemPickup','',%a,%itemID,true);
			}
			else if(!%obj.hasItem[%curT] && %obj.hasItem[%oldT] && %oldT != %curT)
			{
				%obj.tool[%obj.currTool] = %oldT;
				%obj.weaponCount++;
				messageClient(%obj.client,'MsgItemPickup','',%obj.currTool,%oldT,true);
			}
		}
	}
	function ComplexClearTool(%obj,%a,%itemID,%wipe)
	{
		%tool = %obj.tool[%a];
	//	echo("tool =" SPC %tool);
		if(%wipe || (%tool !$= "" && (%itemID $= "" || %itemID == %tool)))
		{
			%obj.tool[%a] = "";
			%obj.weaponCount--;
			messageClient(%obj.client,'MsgItemPickup','',%a,"");
		}
	}
	function ComplexPickUpCheck(%obj,%itemID)
	{
		for(%a=0;%a<5;%a++)
		{
			%tool = %obj.tool[%a];
			if(%itemID == %tool)
				%hasItem = 1;
		}
		if(%hasItem)
			return 1;
		else
			return 0;
	}
	function Weapon::onPickup(%this,%item,%col)
	{
		%data = %col.getDatablock();
		if(!%data.canComplex)
			Parent::onPickup(%this,%item,%col);
		else if(%item.canPickup)
		{
			if(!%col.hasItem[%this])
			{
				Parent::onPickup(%this,%item,%col);
				%pickUp = ComplexPickUpCheck(%col,%this);
				if(!%pickUp)
					return;
				%col.hasItem[%this] = 1;
				ComplexClearTool(%col,4,"",1);
				%wep = %col.getMountedImage(0);
				if(%wep.canComplex)
				{
					schedule(50,0,eval,%col@".isScrollReady=1;");
					%col.isScrollReady=0;
					if(%wep.canComplex)
						cycleComplexScroll(%col,%col.client.slot);
				}
			}
		}
	}
	function servercmdDropTool(%client,%slot)
	{
		%obj = %client.player;
		%data = %obj.getDatablock();
		%wep = %obj.getMountedImage(0);
		if(%wep != 0 && %wep.canComplex || %wep == 0)
			return;
		if(%data.canComplex)
		{
			%tool = %obj.tool[%slot];
			%obj.hasItem[%tool] = 0;
		}
		Parent::servercmdDropTool(%client,%slot);
	}
	function Armor::onDisabled(%data,%obj,%enabled)
	{
		Parent::onDisabled(%data,%obj,%enabled);
		if(%data.canComplex)
			bottomprint(%obj.client,"",1);
	}
};activatePackage(ComplexCMDs);