//By Hata & Marble Man helped a bit
datablock PlayerData(PlayerCrafting : PlayerStandardArmor)
{
	canJet = 0;
	canCraft = 1;

	uiName = "Crafting Player";
	showEnergyBar = true;
	rechargeRate = 0;
};
datablock PlayerData(PlayerCraftingArmor : PlayerCrafting)
{
	maxDamage = 200;

	uiName = "";
};
datablock PlayerData(PlayerCraftingArmor2 : PlayerCrafting)
{
	maxDamage = 300;

	uiName = "";
};
datablock PlayerData(PlayerCraftingArmor3 : PlayerCrafting)
{
	maxDamage = 400;

	uiName = "";
};
datablock PlayerData(PlayerCraftingWork : PlayerCrafting)
{
	jumpForce = 0;

	maxLookAngle = 0.7;
	minLookAngle = 0;

	maxForwardSpeed = 0;
	maxBackwardSpeed = 0;
	maxSideSpeed = 0;
	
	maxForwardCrouchSpeed = 0;
	maxBackwardCrouchSpeed = 0;
	maxSideCrouchSpeed = 0;

	uiName = "";
};

package CraftAdd
{
	function Armor::onAdd(%data,%obj)
	{
		parent::onAdd(%data,%obj);
		if(%data.canCraft)
		{
		//	talk("found Crafting Player");
			%obj.setActionThread(root);
		}
	}
	function Player::showAnger(%obj)
	{
		%obj.isAngry=1;
		%obj.setFaceName("smileyCreepy");
	//	%obj.mountImage(alarmProjectile,5);
	}
	function Player::hideAnger(%obj)
	{
		%obj.isAngry=0;
		%obj.setFaceName("none");
	}
	function Player::hideArmorLocs(%obj)
	{
		//Pack
		%obj.hideNode("cape");
		%obj.hideNode("quiver");
		%obj.hideNode("tank");
		%obj.hideNode("bucket");
		%obj.hideNode("armor");
		
		%obj.unHideNode("pack");
		%obj.setNodeColor("pack","0.2 0.2 0.2 1");
		%obj.setHeadUp(true);

		//Shoulders
		%obj.hideNode("epaulets");
		%obj.hideNode("epauletsRankA");
		%obj.hideNode("epauletsRankB");
		%obj.hideNode("epauletsRankC");
		%obj.hideNode("epauletsRankD");
		%obj.hideNode("ShoulderPads");

		//Head & Accent
		%obj.hideNode("helmet");
		%obj.hideNode("flareHelmet");
		%obj.hideNode("pointyHelmet");
		
		%obj.hideNode("visor");
		%obj.setFaceName("none");
		if(%obj.isAngry)
			%obj.setFaceName("smileyCreepy");
	}
	function Player::unHideArmorLocs(%obj)
	{
		%data = %obj.getDatablock();
		if(isObject(%data) && %data.getName() $= "PlayerCraftingWork")
		{
			%obj.playthread(0,sit);
		}
		else
		{
			%obj.playthread(0,root);
			if(%obj.hasArmor)
			{
				%obj.unHideNode("armor");
				%obj.setNodeColor("armor","0.1 0.2 0.2 1");
				%obj.setHeadUp(true);
			}
			if(%obj.hasArmor2)
			{
				%obj.unHideNode("shoulderpads");
				%obj.setNodeColor("shoulderpads","0.1 0.2 0.2 1");
			}
			if(%obj.hasArmor3)
			{
				%obj.hideNode("plume");
				%obj.hideNode("triplume");
				%obj.hideNode("septplume");
				%obj.hideNode("scoutHat");
				%obj.hideNode("bicorn");
				%obj.hideNode("copHat");
				%obj.hideNode("knitHat");
				%obj.unHideNode("helmet");
				%obj.setNodeColor("helmet","0.1 0.2 0.2 1");
			}
		}
	}
	function gameConnection::ApplyBodyParts(%client)
	{
		%obj = %client.player;
		if(isObject(%obj))
		{
			%data = %obj.getDatablock();
			parent::ApplyBodyParts(%client);
			if(%data.canCraft)
			{
				%obj.hideArmorLocs();
				%obj.unHideArmorLocs();
			//	talk("parented via server CMD");
			}
		}
	}
	function gameConnection::ApplyBodyColors(%client)
	{
		%obj = %client.player;
		if(isObject(%obj))
		{
			%data = %obj.getDatablock();
			parent::ApplyBodyColors(%client);
			if(%data.canCraft)
			{
				%obj.hideArmorLocs();
				%obj.unHideArmorLocs();
			//	talk("parented via server CMD");
			}
		}
	}
};activatePackage(CraftAdd);


package CraftRemove
{
	function armor::onDisabled(%data,%obj,%enabled)
	{
		parent::onDisabled(%data,%obj,%enabled);
		if(%data.canCraft)
		{
		//	talk("canCraft onDeath");
			%obj.client.defCraftSlot = "";
			bottomprint(%obj.client,"",1);
		}
	}
};activatePackage(CraftRemove);

package CraftDamage
{
	function Armor::onDamage(%this,%obj,%damage)
	{
		Parent::onDamage(%this,%obj,%damage);
		if(%this.canCraft)
		{
			%hp = %this.maxDamage - %obj.getDamageLevel();
			%obj.setEnergyLevel(%hp);
		}
	}
};activatePackage(CraftDamage);

package CraftCMDs
{
	//Sit
	function servercmdSit(%client)
	{
		%obj = %client.player;
		if(!isObject(%obj))
			return;
		%data = %obj.getDatablock();
		if(%data.canCraft)
		{
			if(%data.getName() $= "PlayerCraftingWork")
			{
				%obj.craftReturn();
				%obj.isSitting=0;
			}
			else
			{
				%obj.craftHammerActivate();
				%obj.isSitting=1;
			}
		}
		else
			Parent::servercmdSit(%client);
	}
	//Bricks
	function servercmdUseInventory(%client,%slot)
	{
		%obj = %client.player;
		if(!isObject(%obj))
			return;
		%data = %obj.getDatablock();
		%client.defCraftSlot = %slot;
	//	talk("def Slot =" SPC %client.defCraftSlot);
		if(%data.canCraft && %data.getName() $= "PlayerCraftingWork")
		{
			cycleCraftsScroll(%obj,%slot);
		}
		else
			Parent::servercmdUseInventory(%client,%slot);
	}
	function unHideInventory(%client)
	{
		for(%a=0;%a<10;%a++)
		{
			%inv = %client.defInv[%a];
			if(isObject(%inv))
			{
				%client.inventory[%a] = %inv;
				messageclient(%client,'MsgSetInvData',"",%a,%inv);
				%client.defInv[%a] = 0;
			}
		}
	}
	function hideInventory(%client)
	{
		for(%a=0;%a<10;%a++)
		{
			%inv = %client.inventory[%a];
			%client.defInv[%a] = %inv;
			if(%a == 0)
				%inv = 273;
			if(%a == 1)
				%inv = 241;
			if(%a == 2)
				%inv = 241;
			if(%a == 3)
				%inv = 241;
			if(%a == 4)
				%inv = 240;
			if(%a == 5)
				%inv = 242;
			if(%a == 6)
				%inv = 243;
			if(%a == 7)
				%inv = 0;
			if(%a == 8)
				%inv = 0;
			if(%a == 9)
				%inv = 0;
			%client.inventory[%a] = %inv;
			messageclient(%client,'MsgSetInvData',"",%a,%inv);
		}
	}
	function defaultCraftSlot(%client)
	{
		servercmdUseInventory(%client,0);
		talk("attempted to default the craft slot");
	}
	function cycleCraftsScroll(%obj,%slot)
	{
		%obj.isCraftA=0;
		%obj.isCraftB=0;
		%obj.isCraftC=0;
		%obj.isCraftD=0;
		%obj.isCraftE=0;
		%obj.isCraftF=0;
		%obj.isCraftG=0;

		if(%obj.hasWheat)
			%wheat = "<color:FFFFFF>Wheat";
		else
			%wheat = "<color:FF9999>Wheat";

		if(%obj.hasWood)
			%wood = "<color:FFFFFF>Wood";
		else
			%wood = "<color:FF9999>Wood";

		if(%obj.hasRubber)
			%rubber = "<color:FFFFFF>Rubber";
		else
			%rubber = "<color:FF9999>Rubber";

		if(%obj.hasMetal)
			%metal = "<color:FFFFFF>Metal";
		else
			%metal = "<color:FF9999>Metal";

		if(%obj.hasCeramic)
			%ceramic = "<color:FFFFFF>Ceramic";
		else
			%ceramic = "<color:FF9999>Ceramic";

		if(%obj.hasLeather)
			%leather = "<color:FFFFFF>Leather";
		else
			%leather = "<color:FF9999>Leather";

		if(%slot == 0)
		{
			%obj.isCraftA=1;
			bottomPrint(%obj.client,"<font:impact:30><br><color:FFFFCC><just:left>make Bread?" SPC "<font:impact:20><color:CCCCCC>using" SPC %wheat SPC "",-1);
		}
		if(%slot == 1)
		{
			%obj.isCraftB=1;
			%weapon = checkForCraftItem(%obj,BowItem.getID());
			if(isObject(%weapon))
				%craftItem = "Spear";
			else
				%craftItem = "Bow";
			bottomPrint(%obj.client,"<font:impact:30><br><color:FFCCCC><just:left>make" SPC %craftItem @ "?" SPC "<font:impact:20><color:CCCCCC>using" SPC %wood SPC "<color:FFFFFF>and" SPC %rubber SPC "",-1);
		}
		if(%slot == 2)
		{
			%obj.isCraftC=1;
			%weapon = checkForCraftItem(%obj,GunItem.getID());
			if(isObject(%weapon))
				%craftItem = "Guns Akimbo";
			else
			{
				%weapon = checkForCraftItem(%obj,AkimboGunItem.getID());
				if(isObject(%weapon))
				{
					%craftItem = "Grenade Launcher";
					%addCeramic = "," SPC %ceramic;
				}
				else
				{
					%craftItem = "Gun";
					%addCeramic = "";
				}
			}
			bottomPrint(%obj.client,"<font:impact:30><br><color:FFCCCC><just:left>make" SPC %craftItem @ "?" SPC "<font:impact:20><color:CCCCCC>using" SPC %metal @ %addCeramic SPC "<color:FFFFFF>and" SPC %rubber SPC "",-1);
		}
		if(%slot == 3)
		{
			%obj.isCraftD=1;
			bottomPrint(%obj.client,"<font:impact:30><br><color:FFCCCC><just:left>make Grenade?" SPC "<font:impact:20><color:CCCCCC>using" SPC %metal @ "," SPC %ceramic SPC "<color:FFFFFF>and" SPC %rubber SPC "",-1);
		}
		if(%slot == 4)
		{
			%obj.isCraftE=1;
			bottomPrint(%obj.client,"<font:impact:30><br><color:CCFFCC><just:left>make Armor?" SPC "<font:impact:20><color:CCCCCC>using" SPC %ceramic SPC "<color:FFFFFF>and" SPC %leather SPC "",-1);
		}
		if(%slot == 5)
		{
			%obj.isCraftF=1;
			bottomPrint(%obj.client,"<font:impact:30><br><color:B2CCFF><just:left>make Craft Hammer?" SPC "<font:impact:20><color:CCCCCC>using" SPC %metal SPC "<color:FFFFFF>and" SPC %ceramic SPC "",-1);
		}
		if(%slot == 6)
		{
			%obj.isCraftG=1;
			bottomPrint(%obj.client,"<font:impact:30><br><color:FFCCFF><just:left>make Melee?" SPC "<font:impact:20><color:CCCCCC>using" SPC %wood SPC "",-1);
		}
		//	bottomPrint(%obj.client,"<font:impact:30><br><br><br><color:999999><just:left>stop Crafting? ",-1);
	}
	function checkForCraftItem(%obj,%item)
	{
		for(%i=0;%i<5;%i++)
		{
			%tool = %obj.tool[%i];
			if(%tool == %item)
			{
				%weapon = %tool;
				break;
			}
		}
		return %weapon;
	}
};activatePackage(CraftCMDs);


package CraftHands
{
	function WeaponImage::onMount(%this,%obj,%slot)
	{
		Parent::onMount(%this,%obj,%slot);
		%data = %obj.getDatablock();
		if(%data.canCraft)
		{
		//	talk("mounted" SPC %this.getName());
			%defCSlot = %obj.client.defCraftSlot;
			if(%this.getName() $= "CraftHammerImage" || %this.getName() $= "CraftHammerRedImage")
			{
				if(%defCSlot !$= "")
					%QC = "<color:FFFFFF>" @ %defCSlot+1;
				else
					%QC = "<color:FF9999>None";
				bottomPrint(%obj.client,"<font:impact:30><br><br><br><color:FFF200><just:left>Crafting Menu" SPC "<font:impact:20><color:CCCCCC>Quick Craft" SPC %QC,-1);
				hideInventory(%obj.client);
			}
			%obj.showAnger();
		}
	}
	function WeaponImage::onFire(%this,%obj,%slot)
	{
		%data = %obj.getDatablock();
		Parent::onFire(%this,%obj,%slot);
		if(%data.canCraft)
		{
		//	talk("fired" SPC %this.getName());
		}
	}
	function WeaponImage::onUnMount(%this,%obj,%slot)
	{
		Parent::onUnMount(%this,%obj,%slot);
		%data = %obj.getDatablock();
		if(%data.canCraft)
		{
		//	talk("unmounted" SPC %this.getName());
			if(%this.getName() $= "CraftHammerImage" || %this.getName() $= "CraftHammerRedImage")
				unHideInventory(%obj.client);
			%obj.schedule(10,craftAnimFix);
			%obj.craftReturn();
			%obj.hideAnger();
		}
	}
	function Armor::onTrigger(%data,%obj,%slot,%val)
	{
		if(%slot == 0)
		{
			%obj.isActivating = %val;
			%image = %obj.getMountedImage(0);
			if(%data.canCraft && %val)
				%obj.craftReturn(%image);
			Parent::onTrigger(%data,%obj,%slot,%val);
		}
		if(%slot == 0 && %data.canCraft)
		{
			%obj.isActivating = %val;
			if(%obj.isActivating)
			{
			//	talk("Craft Click Left");
				if(%obj.getMountedImage(0) == 0)
				{
					cancel(%obj.ccl);
					%obj.ccl = %obj.schedule(50,craftLeft);
				//	%obj.playthread(0,leftRecoil);
					%obj.isActivLeft=1;
				}
			}
			else
			{
				%obj.craftLoopFinished();
				if(!%obj.isActivLeft && %obj.getMountedImage(1) == 0)
					%obj.playthread(2,root);
			}
		}
		if(!%data.canCraft)
			Parent::onTrigger(%data,%obj,%slot,%val);
	}
	function Player::craftAnimFix(%obj)
	{
		if(%obj.getMountedImage(0) == 0)
			%obj.playthread(1,root);
	}
	function Player::craftStop(%obj)
	{
		%righty = %obj.getMountedImage(0);
		if(!isObject(%righty))
			return;
		if(%righty.getName() $= "CraftHammerImage" || %righty.getName() $= "CraftHammerRedImage")
			%obj.unMountImage(0);
	}
	function Player::craftReturn(%obj,%image)
	{
		%data = %obj.getDatablock();
		%defCSlot = %obj.client.defCraftSlot;
		if(isObject(%data) && %data.getName() $= "PlayerCraftingWork")
		{
			if(%obj.hasArmor3)
				%obj.changedatablock(playercraftingarmor3);
			else if(%obj.hasArmor2)
				%obj.changedatablock(playercraftingarmor2);
			else if(%obj.hasArmor)
				%obj.changedatablock(playercraftingarmor);
			else
				%obj.changedatablock(playercrafting);

		//	talk("image =" SPC %image);
			if(isObject(%image) || %obj.isSitting)
			{
				%obj.schedule(10,craftStop);
				commandToClient(%obj.client,'setBuildingDisabled',1);
				%mini = %obj.client.minigame;
				if(isObject(%mini))
					%build = !%mini.enableBuilding;
				commandToClient(%obj.client,'SetBuildingDisabled',%build);
			}
			if(isObject(%image) && %defCSlot !$= "")
			{
				if(%image.getName() $= "CraftHammerImage" || %image.getName() $= "CraftHammerRedImage")
					%obj.craftSelectedItem();	
				else
					bottomPrint(%obj.client,"",-1);
			}
			else
			{
				%obj.unMountImage(0);
				bottomPrint(%obj.client,"",-1);
			}
		}
	}
	function Player::craftLoopFinished(%obj)
	{
		brickColorRestore(%obj);
		matColorRestore(%obj);
	}
	function Player::craftSelectedItem(%obj)
	{
		if(%obj.isCraftA)
		{	
			if(%obj.hasWheat)
			{
				%dmg = %obj.getDamageLevel();
				if(%dmg > 0)
				{
				//	talk("crafted Bread");
					bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:FFF200><just:left>full Health ",1);
					%obj.setDamageLevel(0);
					%obj.hasWheat=0;
				}
				else
					bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:CC9900><just:left>max Health ",1);
			}
			else
				bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:CC9900><just:left>Wheat needed ",1);
		}
		else if(%obj.isCraftB)
		{	
			if(%obj.hasWood && %obj.hasRubber)
			{
			//	talk("crafted Bow");
				%item = bowItem;
				%upItem = spearItem;
				%obj.checkForItem(%item,%upItem);
				if(%obj.item $= %item || %obj.item $= %upItem)
				{
					if(%obj.hasFreeSlot || %obj.item $= %upItem)
					{
						if(%obj.item $= %upItem)
							%craftItem = "Spear";
						else
							%craftItem = "Bow";
						bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:FFF200><just:left>crafted" SPC %craftItem SPC "",1);
						%obj.spawnCraftedItem(%obj.item);
						%obj.hasWood=0;
						%obj.hasRubber=0;
					}
					else
						bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:CC9900><just:left>Inventory full ",1);
				}
				else
					bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:CC9900><just:left>max Arrow ",1);
			}
			else
				bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:CC9900><just:left>Materials needed ",1);
		}
		else if(%obj.isCraftC)
		{
			if(%obj.hasMetal && %obj.hasRubber)
			{
			//	talk("crafted Gun");
				%item = gunItem;
				%upItem = akimbogunItem;
				%ubItem = GLPipeItem;
				%obj.checkForItem(%item,%upItem,%ubItem);
				if(%obj.item $= %ubItem && %obj.hasCeramic)
					%obj.hasCeramic=0;
				else if(%obj.item $= %ubItem)
					%obj.item = "max";
				if(%obj.item !$= "max")
				{
					if(%obj.hasFreeSlot || %obj.item $= %upItem || %obj.item $= %ubItem)
					{
						if(%obj.item $= %upItem)
							%craftItem = "Guns Akimbo";
						else
						{
							if(%obj.item $= %ubItem)
								%craftItem = "Grenade Launcher";
							else
								%craftItem = "Gun";
						}
						bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:FFF200><just:left>crafted" SPC %craftItem SPC "",1);
						%obj.spawnCraftedItem(%obj.item);
						%obj.hasMetal=0;
						%obj.hasRubber=0;
					}
					else
						bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:CC9900><just:left>Inventory full ",1);
				}
				else if(!%obj.hasCeramic)
					bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:CC9900><just:left>Ceramic needed ",1);	
				else
					bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:CC9900><just:left>max Firearm ",1);					
			}
			else
				bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:CC9900><just:left>Materials needed ",1);
		}
		else if(%obj.isCraftD)
		{
			if(%obj.hasMetal && %obj.hasRubber && %obj.hasCeramic)
			{
			//	talk("crafted Grenade");
				%item = hegrenadeItem;
				%obj.checkForItem(%item);
				%obj.itemOld = "";
				if(%obj.hasFreeSlot)
				{
					bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:FFF200><just:left>crafted Grenade ",1);
					%obj.spawnCraftedItem(%item);
					if(%obj.hasCraftHammerRed)
						%obj.spawnCraftedItem(%item);
					%obj.hasMetal=0;
					%obj.hasRubber=0;
					%obj.hasCeramic=0;
				}
				else
					bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:CC9900><just:left>Inventory full ",1);
			}
			else
				bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:CC9900><just:left>Materials needed ",1);
		}
		else if(%obj.isCraftE)
		{
			if(%obj.hasCeramic && %obj.hasLeather)
			{
			//	talk("crafted Armor");
				if(!%obj.hasArmor3)
				{
					bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:FFF200><just:left>crafted Armor ",1);
					%obj.hasCeramic=0;
					%obj.hasLeather=0;
				}
				if(!%obj.hasArmor3 && %obj.hasCraftHammerRed)
				{
					%obj.hasArmor2=1;
					%obj.hasArmor=1;
				}
				if(%obj.hasArmor3)
					bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:CC9900><just:left>max Armor ",1);
				else if(%obj.hasArmor2)
				{
					%obj.hasArmor3=1;
					%obj.changedatablock(playercraftingarmor3);
				}
				else if(%obj.hasArmor)
				{
					%obj.hasArmor2=1;
					%obj.changedatablock(playercraftingarmor2);
				}
				else
				{
					%obj.hasArmor=1;
					%obj.changedatablock(playercraftingarmor);
				}
			}
			else
				bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:CC9900><just:left>Materials needed ",1);
		}
		else if(%obj.isCraftF)
		{
			if(%obj.hasCeramic && %obj.hasMetal)
			{
			//	talk("crafted Craft Hammer");
				if(!%obj.hasCraftHammerRed)
				{
					bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:FFF200><just:left>crafted Craft Hammer ",1);
					%obj.hasCeramic=0;
					%obj.hasMetal=0;
					%obj.hasCraftHammerRed=1;
				}
				if(%obj.hasCraftHammerRed)
					bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:FFF200><just:left>Uber Craft Hammer ",1);
			}
			else
				bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:CC9900><just:left>Materials needed ",1);
		}
		else if(%obj.isCraftG)
		{
			if(%obj.hasWood)
			{
			//	talk("crafted Melee");
				%item = swordItem;
				%obj.checkForItem(%item);
				if(%obj.hasFreeSlot)
				{
					bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:FFF200><just:left>crafted Melee ",1);
					%obj.spawnCraftedItem(%item);
					%obj.hasWood=0;
				}
				else
					bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:CC9900><just:left>Inventory full ",1);
			}
			else
				bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:CC9900><just:left>Materials needed ",1);
		}
	}
	function Player::checkForItem(%obj,%item,%upItem,%ubItem)
	{
		if(isObject(%obj))
		{
			for(%i=0;%i<5;%i++)
			{
				%obj.hasFreeSlot=0;
				%tool = %obj.tool[%i];
				if(%tool $= 0 || %tool $= "")
				{
					%obj.hasFreeSlot=1;
					break;
				}
			}

			for(%i=0;%i<5;%i++)
			{
				%obj.itemOld = "";
				%obj.item = %item;
				%tool = %obj.tool[%i];
			//	centerPrint(%obj.client,"<color:FFF200><just:right>" SPC %tool SPC "",1);
				if(%obj.hasCraftHammerRed && isObject(%tool) && %tool.getName() $= "gunItem")
				{
					%obj.itemOld = %item;
					%obj.item = %ubItem;
					return;
				}
				else if(%obj.hasCraftHammerRed && !isObject(%tool))
				{
					%obj.item = %upItem;
					return;
				}
				else if(isObject(%item) && %tool == %item.getID())
				{
					%obj.itemOld = %item;
					%obj.item = %upItem;
					return;
				}
				else if(isObject(%upItem) && %tool == %upItem.getID())
				{
					%obj.itemOld = %upItem;
					%obj.item = %ubItem;
					return;
				}
				else if(isObject(%ubItem) && %tool == %ubItem.getID())
				{
				//	talk("thinks it found Uber Item");
					%obj.item = "max";
					return;
				}
			}
		}
	}
	function Player::spawnCraftedItem(%obj,%datablock)
	{
		if(!isObject(%datablock))
			return;

	//	talk(%obj.item);
		for(%i=0;%i<5;%i++)
		{
			%tool = %obj.tool[%i];
		//	centerPrint(%obj.client,"<color:FFF200><just:right>" SPC %tool SPC "",1);
			if(isObject(%obj.itemOld) && %tool == %obj.itemOld.getID())
			{
				%obj.tool[%i] = 0;
				messageClient(%obj.client,'MsgItemPickup','',%i,0);
			}
		}

		%item = new item()
		{
			datablock = %datablock;
		};
		if(isObject(%item))
		{
			%item.schedulePop();
			%pos = %obj.getPosition();
			%rot = getWords(%obj.getTransform(),3,6);
			%pos = vectorAdd(%pos,"0 0 0.5");

			%item.setTransform(%pos SPC %rot);
			%item.miniGame = getMiniGameFromObject(%obj);
		}
	}
	function Player::craftLeft(%obj)
	{
			%obj.isActivLeft=0;
			%obj.isBoxChecking=0;
			%obj.playthread(2,armreadyright);
			%obj.craftBothLoop();
			%pos = %obj.getHackPosition();
			initContainerRadiusSearch(%pos,5,$TypeMasks::fxBrickObjectType);
			while(%mat = containerSearchNext())
			{		
				if(isObject(%mat))
					%found++;
				if(%found <= 20)
					materialHilight(%obj,%mat,%match);
			}
	}
	function Player::craftBothLoop(%obj)
	{
		if(%obj.isActivating)
		{
			%obj.schedule(50,craftBothLoop);
			if(%obj.getMountedImage(0) == 0 && %obj.getState() !$= "Dead")
			{
				%start = %obj.getEyePoint();			
				%beam = vectorScale(%obj.getEyeVector(),5);
				%end = vectorAdd(%start,%beam);
				%ray = containerRayCast(%start,%end,$TypeMasks::fxBrickObjectType,%obj);
				%brick = firstWord(%ray);
				if(isObject(%brick))
					AmmoBoxCheck(%obj,%brick);
				else
					%obj.isBoxChecking=0;
				if(isObject(%brick) && %brick.getName() $= "_Wood")
				{
					%matColor = "0.39 0.19 0 1";
					%match = matCheck(%obj,%brick,%matColor);
					if(!%obj.hasWood && %match == true)
					{
					//	talk("found Wood");
						bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:CCCCCC><just:left>collected <color:FFFFFF>Wood ",1);
						brickMaterialize(%obj,%brick);
						%obj.hasWood=1;
					}
					else if(%match == true)
						bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:999999><just:left>full <color:CCCCCC>Wood ",1);
				}
				else if(isObject(%brick) && %brick.getName() $= "_Wheat")
				{
					%matColor = "0.86 0.65 0.12 1";
					%match = matCheck(%obj,%brick,%matColor);
					if(!%obj.hasWheat && %match == true)
					{
					//	talk("found Wheat");
						bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:CCCCCC><just:left>collected <color:FFFFFF>Wheat ",1);
						brickMaterialize(%obj,%brick);
						%obj.hasWheat=1;
					}
					else if(%match == true)
						bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:999999><just:left>full <color:CCCCCC>Wheat ",1);
				}
				else if(isObject(%brick) && %brick.getName() $= "_Metal")
				{
					%matColor = "0 0.14 0.33 1";
					%match = matCheck(%obj,%brick,%matColor);
					if(!%obj.hasMetal && %match == true)
					{
					//	talk("found Metal");
						bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:CCCCCC><just:left>collected <color:FFFFFF>Metal ",1);
						brickMaterialize(%obj,%brick);
						%obj.hasMetal=1;
					}
					else if(%match == true)
						bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:999999><just:left>full <color:CCCCCC>Metal ",1);
				}
				else if(isObject(%brick) && %brick.getName() $= "_Rubber")
				{
					%matColor = "0.53 0.51 0.49 1";
					%match = matCheck(%obj,%brick,%matColor);
					if(!%obj.hasRubber && %match == true)
					{
					//	talk("found Rubber");
						bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:CCCCCC><just:left>collected <color:FFFFFF>Rubber ",1);
						brickMaterialize(%obj,%brick);
						%obj.hasRubber=1;
					}
					else if(%match == true)
						bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:999999><just:left>full <color:CCCCCC>Rubber ",1);
				}
				else if(isObject(%brick) && %brick.getName() $= "_Ceramic")
				{
					%matColor = "0.13 0.27 0.27 1";
					%match = matCheck(%obj,%brick,%matColor);
					if(!%obj.hasCeramic && %match == true)
					{
					//	talk("found Ceramic");
						bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:CCCCCC><just:left>collected <color:FFFFFF>Ceramic ",1);
						brickMaterialize(%obj,%brick);
						%obj.hasCeramic=1;
					}
					else if(%match == true)
						bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:999999><just:left>full <color:CCCCCC>Ceramic ",1);
				}
				else if(isObject(%brick) && %brick.getName() $= "_Leather")
				{
					%matColor = "0.26 0.25 0.24 1";
					%match = matCheck(%obj,%brick,%matColor);
					if(!%obj.hasLeather && %match == true)
					{
					//	talk("found Leather");
						bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:CCCCCC><just:left>collected <color:FFFFFF>Leather ",1);
						brickMaterialize(%obj,%brick);
						%obj.hasLeather=1;
					}
					else if(%match == true)
						bottomPrint(%obj.client,"<font:impact:20><br><br><br><br><br><color:999999><just:left>full <color:CCCCCC>Leather ",1);
				}
				brickHilight(%obj,%brick,%match);
			}
		}
	}
	function AmmoBoxCheck(%obj,%brick)
	{
		%pos = %brick.getPosition();
		initContainerRadiusSearch(%pos,0.5,$TypeMasks::fxBrickObjectType);
		while(%boxPart = containerSearchNext())
		{
			if(isObject(%boxPart))
				%found++;
			if(%found <= 5)
				boxPartSearch(%obj,%boxPart);
		}
	}
	function boxPartSearch(%obj,%boxPart)
	{
		if(isObject(%boxPart))
		{
		//	talk("found potential box part");
			%bData = %boxPart.getDatablock();
			%bSize = %bData.brickSizeX * %bData.brickSizeY * %bData.brickSizeZ;

			%color = "0.53 0.51 0.49 1";
			%match = matCheck(%obj,%boxPart,%color);
			if(%match == true && %boxPart.getName() $= "_AmmoBox" && %bSize == 12)
			{
				%boxPartA = %boxPart;
				checkBoxConstruction(%obj,%boxPartA);
			//	talk("found A");
			}
		}
	}
	function checkBoxConstruction(%obj,%boxPartA)
	{
	//	talk("box construction check called");
		if(%obj.isBoxChecking)
			return;
	//	talk("player not box checking");
		%obj.isAmmoBoxFull=1;
		%obj.isBoxChecking=1;
		%start = %boxPartA.getPosition();			
		%beamB = "0 0 0.5";
		%beamC = "0 0 -0.5";
	//	talk("position =" SPC %start);
		%endB = vectorAdd(%start,%beamB);
		%endC = vectorAdd(%start,%beamC);
		%rayB = containerRayCast(%start,%endB,$TypeMasks::fxBrickObjectType,%obj);
		%rayC = containerRayCast(%start,%endC,$TypeMasks::fxBrickObjectType,%obj);
		%brickB = firstWord(%rayB);
		%brickC = firstWord(%rayC);
	//	talk("brick B =" SPC %brickB);
	//	talk("brick C =" SPC %brickC);

		if(isObject(%brickB) && isObject(%brickC))
		{
		//	talk("brick B and brick C found");
			%color = "0.73 0.72 0.7 1";
			%match = matCheck(%obj,%brickB,%color);
			if(%match == true && %brickB.getName() $= "_AmmoBox" && %brickB.getDatablock() == 328)
			{
				%boxPartB = %brickB;
			//	talk("found B");
			//	talk("AmmoBox top data =" SPC %boxPartB.getDatablock());
			//	talk("AmmoBox top data name =" SPC %boxPartB.getDatablock().getName());
			}
			%color = "0.53 0.51 0.49 1";
			%match = matCheck(%obj,%brickC,%color);
			if(%match == true && %brickC.getName() $= "_AmmoBox" && %brickC.getDatablock() == 249)
			{
				%boxPartC = %brickC;
			//	talk("found C");
			}
			if(isObject(%boxPartA) && isObject(%boxPartB) && isObject(%boxPartC))
			{
				pickUpBoxAmmo(%obj,%boxPartA,%boxPartB,%boxPartC);
			}
		}
	}
	function pickUpBoxAmmo(%obj,%brickA,%brickB,%brickC)
	{
		centerPrint(%obj.client,"<font:impact:30><color:FFF200>Ammo Box ",1);
		for(%i=0;%i<5;%i++)
		{
			%tool = %obj.tool[%i];
			%ammoWep = checkForAmmoWep(%obj,%tool);
			if(isObject(%tool) && %ammoWep == true)
			{
				%weapon = %tool;
				%isAmmoBox=1;
				pickUpBoxAmmo2(%obj,%weapon,%brickA,%brickB,%brickC,%isAmmoBox);
			}
		}
	}
	function pickUpBoxAmmo2(%obj,%weapon,%brickA,%brickB,%brickC,%isAmmoBox)
	{
		for(%p=0;%p<3;%p++)
		{
			if(!%obj.isFull[%weapon])
			{
				%item = new item()
				{
					datablock = %weapon;
				};
				if(isObject(%item))
				{
					%item.schedulePop();
					%pos = %obj.getPosition();
					%rot = getWords(%obj.getTransform(),3,6);
					%pos = vectorAdd(%pos,"0 0 0.5");

					%item.setTransform(%pos SPC %rot);
					%item.miniGame = getMiniGameFromObject(%obj);
					%item.schedule(50,delete);

					brickMaterialize(%obj,%brickA,0,%isAmmoBox);
					brickMaterialize(%obj,%brickB,0,%isAmmoBox);
					brickMaterialize(%obj,%brickC,%brickC,%isAmmoBox);
				//	talk("Ammo created");
				}
			}
		}
	}
	function materialHilight(%obj,%mat)
	{
		if(isObject(%mat))
		{
			%matColor = "0.39 0.19 0 1";
			%match = matCheck(%obj,%mat,%matColor);
			if(%match == true && %mat.getName() $= "_Wood")
				%isHilightable=1;

			%matColor = "0.86 0.65 0.12 1";
			%match = matCheck(%obj,%mat,%matColor);
			if(%match == true && %mat.getName() $= "_Wheat")
				%isHilightable=1;

			%matColor = "0 0.14 0.33 1";
			%match = matCheck(%obj,%mat,%matColor);
			if(%match == true && %mat.getName() $= "_Metal")
				%isHilightable=1;

			%matColor = "0.53 0.51 0.49 1";
			%match = matCheck(%obj,%mat,%matColor);
			if(%match == true && %mat.getName() $= "_Rubber")
				%isHilightable=1;

			%matColor = "0.13 0.27 0.27 1";
			%match = matCheck(%obj,%mat,%matColor);
			if(%match == true && %mat.getName() $= "_Ceramic")
				%isHilightable=1;

			%matColor = "0.26 0.25 0.24 1";
			%match = matCheck(%obj,%mat,%matColor);
			if(%match == true && %mat.getName() $= "_Leather")
				%isHilightable=1;

			if(%isHilightable)
			{
				//Materials
				if(!%obj.hasMatCol)
				{
					%obj.hasMatCol=1;
				//	%obj.emote(wtfImage);
					if(!%obj.isMatFlashed)
					{
						%obj.isMatFlashing=1;
						%obj.schedule(10,matFlashFix);
					}
				}
				if(!%mat.isHilighted && %obj.isMatFlashing)
				{
					%matCol = %mat.getColorID();
				//	%matColFx = %mat.getColorFxID();
					%mat.setColor(45);
					%mat.setColorFx(3);
					%mat.isHilighted=1;
					%mat.schedule(150,setColor,%matCol);
					%mat.schedule(150,setColorFx,0);
					schedule(150,0,eval,%mat@".isHilighted=0;");
				}
			}
		}
		else
		{
			matColorRestore(%obj);
		}
	}
	function brickHilight(%obj,%brick,%match)
	{
		if(isObject(%brick) && !%obj.hasBrickCol && !%mat.isHilighted && %match == true)
		{
			%brick.setColorFx(3);
			%brick.setShapeFx(1);
			%obj.brick = %brick;
			%obj.hasBrickCol=1;
		}
		else if(%obj.hasBrickCol && %obj.brick !$= %brick)
		{
			brickColorRestore(%obj);
		}
	}
	function brickColorRestore(%obj)
	{
		%brick = %obj.brick;
		if(isObject(%brick))
		{
			%brick.setColorFx(0);
			%brick.setShapeFx(0);
			%obj.hasBrickCol=0;
		}
	}
	function brickMaterialize(%obj,%brick,%brickC,%isAmmoBox)
	{
		if(!isObject(%brick))
			return;
		if(!%obj.isAmmoBoxFull && %isAmmoBox)
			return;
		if(%brick == %brickC)
			%obj.isAmmoBoxFull=0;
	//	talk("brick materialized");
		%brick.fakeKillBrick("0 0 5",1.5);
		%brick.schedule(150,setRendering,0);
		%brick.schedule(150,setRaycasting,0);
		%brick.schedule(150,setColliding,0);
		%brick.schedule(30000,setRendering,1);
		%brick.schedule(30000,setRaycasting,1);
		%brick.schedule(30000,setColliding,1);
	}
	function matColorRestore(%obj)
	{
		%obj.hasMatCol=0;
	}
	function Player::matFlashFix(%obj)
	{
		%obj.isMatFlashing=0;
		if(!%obj.isMatFlashed)
		{
			%obj.isMatFlashed=1;
			schedule(1000,0,eval,%obj@".isMatFlashed=0;");
		}
	}

	function Player::craftMeleeFix(%obj)
	{
		%obj.hasCraftMeleed=0;
	}
	function Player::craftHammerActivate(%obj)
	{
		if(%obj.getMountedImage(0) == 0)
		{
			if(!%obj.hasCraftHammerRed)
			{
				%obj.mountImage(craftHammerImage,0);
			}
			else
			{
				%obj.mountImage(craftHammerRedImage,0);
			}
			commandToClient(%obj.client,'setBuildingDisabled',0);
			%obj.changedatablock(playercraftingwork);
		}
	}
	//Color Detection
	function RGBtoHSV(%r, %g, %b)
	{
		%min = getMin(%r, getMin(%g, %b));
		%max = getMax(%r, getMax(%g, %b));

		%delta = %max - %min;
		%v = %max;

		if(%max != 0)
		{
			%s = %delta / %max;

		if(%delta == 0)
		{
			%h = -12;
		}
		else
		{
			if(%r == %max)
				%h = (%g - %b) / %delta;
			else if(%g == %max)
				%h = 2 + ( %b - %r ) / %delta;
			else        
				%h = 4 + ( %r - %g ) / %delta;
		}
			%h *= 60;
			if(%h < 0)
				%h += 360;
		}
		else
		{
			%s = 0;
			%h = 0;
			%v = 0;
		}
		%h = %h / 360;
		return (%h SPC %s SPC %v);                
	}
	function matCheck(%obj,%brick,%matColor)
	{
		if(%brick.getType() & $TypeMasks::FxBrickAlwaysObjectType)
		{
			//determine if color matches or not via hue comparison

			//get brick color
			%brickRGBA = getColorIDTable(%brick.getColorId());
			%r = getWord(%brickRGBA, 0);
			%g = getWord(%brickRGBA, 1);
			%b = getWord(%brickRGBA, 2);
			//echo("brick rgb = " @ %r SPC %g SPC %b);
			//echo("brick hsv " @ RGBtoHSV(%r,%g,%b));
			%brickH = getWord(RGBtoHSV(%r,%g,%b), 0);

			%brickRGB = %r SPC %g SPC %b;
			%brickRGB = vectorNormalize(%brickRGB);

			//get mat color
			%matRGBA = %matColor;
			%r = getWord(%matRGBA, 0);
			%g = getWord(%matRGBA, 1);
			%b = getWord(%matRGBA, 2);
			//echo("mat rgb = " @ %r SPC %g SPC %b);
			//echo("mat hsv " @ RGBtoHSV(%r,%g,%b));
			%matH = getWord(RGBtoHSV(%r,%g,%b), 0);

			%matRGB = %r SPC %g SPC %b;
			%matRGB = vectorNormalize(%matRGB);

			//compare
			%hDiff = mAbs(%matH - %brickH);
			if(%hDiff > 0.5)
			//	%hDiff = 1 - %hDiff;
			if(%hDiff < 0)
				%hDiff = vectorScale(%hDiff,-1);

			//echo("hDiff = " @ %hDiff);
		//	bottomPrint(%obj.client,"<font:impact:30><br><br><br><color:FFF200><just:left>hDiff = " @ %hDiff SPC "",1);

			%obj.isBright=0;
			if(%brickRGB $= "1 0 0" || %brickRGB $= "1 0 1" || %brickRGB $= "1 1 1" || %brickRGB $= "0 1 0" || %brickRGB $= "0 1 1" || %brickRGB $= "0 0 1" || %brickRGB $= "0 0 0" || %brickRGB $= "0.59655 0.59655 0.536896")
			{
			//	echo("isBright");
				%obj.isBright=1;
			}

			if(%hDiff > 0.1 || (%matH <= 0 && %brickH > 0) && (%matH > 0 && %brickH <= 0))
			{
			//	echo("NO MATCH");
			}
			else if(!%obj.isBright)
			{
			//	echo("MATCH");
				return true;
			}
		}
	}
};activatePackage(CraftHands);