/////////////////
//Ledge Step-up//
/////////////////

//Step-up (onto Ledge)
function AdventureStepUp(%player)
{
	if(%player.isAdventureHanging || %player.isAdventureClimbing || %player.isAdventurePullup || !$Pref::Adventure::StepUp || %player.client.KeyActionCrouch) //if Hanging, or Climbing, or Pulling-up, or Pref: 'Adventure Step-up' off, or client Crouching
		return; //stop here

	%vel = %player.getVelocity();
	%upv = getWord(%vel,2);
	%xyv = getWords(%vel,0,1);
	%pos = %player.getPosition();
	%vec = %player.getForwardVector();

	%syncVec = MoveInputCamSync(%player.client,"vector",%vec);
	%dir = HataDirCheck(%syncVec);

	%posC = vectorAdd(%pos,"0 0" SPC 0.5); //Starting Point offset
//	%len = $Adventure::LedgeHangLen+0.6; //Ideal ledge length (global var.)
	%mPosA = AdventureMultiLedgeCheck(%player,%posC,%dir,false,4,1); //Check for ledge within a 4-plate range //was 1
//	talk("Step Up:  PosC =" SPC %posC);
//	talk("Step Up:  mPosA =" SPC %mPosA);
	if(%mPosA $= "" || %upv < 0) //if ledge not found, or z velocity less than 6.5, or an object is in the way of the final step-up position //%upv < 6.5
		return; //stop here
	
	%mov = vectorAdd(%mPosA,vectorScale(%dir,0.5)); //Equals 0.3 if Ideal length is 0.7
	%mov = vectorAdd(%mov,"0 0" SPC (2*0.6)+0.4);
	%block = AdventureBoxCheck(%player,false,2.5,%mov,"","Step Up","1 0.5 0.3"); //2.6 is the height of 5 bricks
	if(isObject(%block)) //if there is space above the ledge
		return; //stop here
	
//	talk("Step Up   up vel =" SPC %upv);
//	%len = vectorLen(%xyv SPC 0); //xy speed
//	%fwd = %len < 4 ? vectorScale(%dir,4) : 0; //if xy speed < 4 - add 4 speed, else - add no speed //was 3
//	%fwd = vectorScale(%dir,1); //if xy speed < 4 - add 4 speed, else - add no speed //was 3
//	%total = vectorAdd(%fwd,%xyv SPC 0);
	%total = vectorScale(%dir,2+(vectorLen(%xyv)/2)); //if xy speed < 4 - add 4 speed, else - add no speed //was 3

	%time = 100;
	%player.setTransform(vectorAdd(%mPosA,"0 0" SPC 0.3));
//	%player.schedule(50,setVelocity,%total);
//	%player.setVelocity("0 0 13"); //was 13
	%player.setVelocity(%total); //was 13
//	%player.playthread(0,walk);
	%player.playthread(2,plant);
//	%player.schedule(%time,playthread,0,root);
	%player.isAdventurePullup = true;
	schedule(%time,0,eval,%player@".isAdventurePullup = false;");
	%player.changedatablock(PlayerAdventureNoJump);
//	schedule(35,0,AdventureRestoreMainDatablock,%player);
}


//////////////
//Smart Drop//
//////////////

//Drop-to-Hang (from top of ledge)
function AdventureSmartDrop(%player,%isGroundD)
{
	if(%player.isAdventurePullup || %player.isAdventureSmartDropTired || !$Pref::Adventure::SmartDrop) //if Pulling-up, or Smart Drop timed-out, or Pref: Smart-Drop off
		return; //stop here

	%pos = %player.getPosition(); //player position
	%lastPos = %player.AdvLastPos; //player's stored last position
//	centerPrint(findclientbyname(),"<font:impact:30><just:center>\c3Adventure SmartDrop  \c6Distance =" SPC vectorDist(%pos,%lastPos) @ "<br>\c6Pos =" SPC %pos @ "<br>\c6last Pos = " SPC %lastPos,5);
	if(vectorDist(%pos,%lastPos) > 0.3) //if player's current position and last position are too far apart
		return; //stop here

	%vel = %player.getVelocity(); //player vel
	%upv = getWord(%vel,2);
	%vec = %player.getForwardVector(); //player forward vec
	%dot = vectorDot(%vel,%vec); //compare vel to dir
	%front = %dot > 0.4; //if moving forward (was 0.2)

	%time = 400; //timeout value
	
	//Smart Drop (tap Crouch after walking off a ledge, or hold Crouch while walking off)
	%eVec = %player.getEyeVector();
	if(%upv <= 0 && ((!%player.wasCrouched && (%z = getWord(%eVec,2)) < $Adventure::SmartDropZ) || (%isGroundD && %player.wasCrouched))) //if (player 'was Crouched' bool false, and looking very far downward), or ('Ground D' exists, and 'was Crouched' bool true
	{
	//	%player.changedatablock(PlayerAdventureNoAirCtrl);
		%player.changedatablock(PlayerAdventureNoMove);
		%player.setVelocity("0 0 -5");
		%player.playthread(2,shiftDown);
		%player.playthread(0,plant);
		
		%player.isAdventureSmartDropTired = true; //note: Smart Drop timeout
		cancel(%player.AdvSmartDropTired); //cancel Smart Drop timeout (prevent duplicate schedules)
		%player.AdvSmartDropTired = schedule(%time,0,eval,%player@".isAdventureSmartDropTired = false;"); //Smart Drop timeout  //was 500
	}
	if(!%player.wasCrouched) //if player 'wasCrouched' bool = false (true if still Holding, or Released Crouch less than 400 ms ago)
		return; //stop here
	if(%isGroundD) //if too low for for Smart Drop
		return; //stop here

	%xVel = getWord(%vel,0) SPC "0 0"; //new vector made from isolated x component of player vel
	%xvNrm = vectorNormalize(%xVel); //normalized x component of player vel
	%yVel = "0" SPC getWord(%vel,1) SPC "0"; //vector made from isolated y component of player vel
	%yvNrm = vectorNormalize(%yVel); //normalized y component of player vel

	%xPos = vectorAdd(%pos,vectorScale(%xvNrm,-1)); //x offset'd position (for checking for last terra firma)
	%yPos = vectorAdd(%pos,vectorScale(%yvNrm,-1)); //y offset'd position (for checking for last terra firma)

	%xGroundA = isObject(AdventureBoxCheck(%player,false,"",%xPos,"","Smart Drop X","0 1 0")); //x adjusted ground check
	%yGroundA = isObject(AdventureBoxCheck(%player,false,"",%yPos,"","Smart Drop Y","0 1 1")); //y adjusted ground check

	%dir = HataDirCheck(%vel); //find closest matching cardinal directional vector for this velocity vector
	if(!(%xGroundA && %yGroundA)) //if the following is false: (x ground A exists, AND y ground A exists)
	{
		%dir = %xGroundA ? %xVel : %dir; //if x ground A exists, use xVel (East/West-facing cardinal directional vector)
		%dir = %yGroundA ? %yVel : %dir; //if y ground A exists, use yVel (North/South-facing cardinal directional vector)
	}

	%player.isAdventureSmartDropTired = true; //note: Smart Drop timeout
	cancel(%player.AdvSmartDropTired); //cancel Smart Drop timeout (prevent duplicate schedules)
	%player.AdvSmartDropTired = schedule(%time,0,eval,%player@".isAdventureSmartDropTired = false;"); //Smart Drop timeout  //was 500
	
	%player.isAdventureClimbTired = true;
	cancel(%player.AdvClimbTired);
	%player.AdvClimbTired = schedule(200,0,eval,%player@".isAdventureClimbTired = false;");
	
	%player.wasCrouched = false; //manually reset was-Crouched bool
	%player.client.KeyActionCrouch = false;  //manually reset Crouching bool
//	%player.isCrouching = false; //manually reset Crouching bool

	AdventureSmartDropCam(%player,%front,%dir); //do fancy Smart Drop cam
//	%vInv = vectorScale(vectorNormalize(%vel),-1); //backwards vel add
//	%player.setVelocity(vectorAdd(%vInv,"0 0 -2")); //impulse downward
	%player.setVelocity("0 0" SPC -2); //impulse downward

	%dInv = vectorScale(%dir,-1); //inverted dir vec
	%mRot = vectorToAxis(%dInv); //new player rotation

	%player.setTransform(%pos SPC %mRot); //apply new transform
	%player.playthread(2,shiftdown); //animate
	%player.playthread(0,jump); //..
}
//Smart-Drop Camera
function AdventureSmartDropCam(%player,%front,%dir)
{
	%data = %player.getDatablock(); //player datablock
	%camera = %player.client.camera; //player client's camera
	%dist = %data.cameraMaxDist; //data's defined third person cam distance

	%pos = %player.getPosition(); //player pos
	%vec = %player.getForwardVector(); //player forward vec

	%vRot = vectorToAxis(%vec); //rotation from forward vector
	%pitch = %front ? -80 : -40;
	%eul = vectorAdd(axisToEuler(%vRot),%pitch SPC "0 0"); //diagonally down titled camera offset
//	%nRot = %front ? eulerToAxis(%eul) : %vRot; //if front - use v-Rot, else - use euler adjusted rot
	%nRot = eulerToAxis(%eul); //if front - use v-Rot, else - use euler adjusted rot

	%camera.setOrbitMode(%player,"",0,%dist,%dist,true); //set proper orbit mode
	%camera.setTransform(%pos SPC %nRot); //apply camera transform
	%camera.mode = "Climb"; //label "Climb" mode
	%camera.player = %player; //assign the player object
	%camera.isDescentMode = true; //note its in Descent Mode

	if(%player.client.getControlObject() != %camera) //if client not controlling the camera
		%player.client.setControlObject(%camera); //make client control the camera
}


///////////////
//Go to Ledge//
///////////////

//Go-to-Ledge (Air Dive) Check
function AdventureGoToLedge(%player,%data)
{
	if(%player.isAdventureSmartDropTired || %data.canAdventureHang) //if 'Smart Drop Tired' = true, or data 'can Hang'
		return; //stop here
	%isGroundA = isObject(AdventureBoxCheck(%player,false,"","","","Climb Check Floor","1 0 1")); //flat on the ground
	if(!%isGroundA) //if ground not found
		return; //stop here

	%max = $Pref::Adventure::ClimbMax*1.5; //use Pref: Climb-Reach * n (n = 2 by default)
//	%vel = %player.getVelocity();
	%vec = %player.getEyeVector();
//	%len = vectorLen(%vel); //speed (magnitude of velocity vector)
//	%nrm = vectorNormalize(%vel);
//	%nZ = getWord(%nrm,2); //vertical velocity component
//	if(%nz > 5)
//	{
//		%nrm = getWords(%nrm,0,1) SPC %nz*0.4;
//		%nrm = vectorNormalize(%nrm);
//	}
	%scl = vectorScale(%vec,%max);
	%xyV = getWords(%vec,0,1) SPC 0;
	%xyV = vectorNormalize(%xyV);
	%dirA = HataDirCheck(%xyV);
//	%dst = vectorDist(%xyV,%vec); //distance between player's normalized horizontal velocity vector and player's forward vector

	%posA = %player.getEyePoint();
	%end = vectorAdd(%posA,%scl);
//	%ray = containerRayCast(%posA,%end,$TypeMasks::fxBrickObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType,%player);
//	if((%dst < 0.75 && %len > 3 && %len < %max && %nZ > -0.7 && %nZ < 0) && !%data.canAdventureHang && !%player.isAdventureAirDive)

	%fcn = "AdventureFinishGoToLedge("@ %player @",\"%ray\",\""@ %vec @"\",\""@ %posA @"\",\""@ %dirA @"\");"; //function to call if Arc Search successful
	%masks = $TypeMasks::fxBrickObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType;
	AdventureArcSearch(%player,%posA,%vec,%max,%masks,10,0.25,%fcn); //Search in an Arc shape for objects
}

function AdventureFinishGoToLedge(%player,%ray,%vec,%posA,%dirA)
{
	%data = %player.getDatablock();
	if(!%player.isAdventureAirDive)
	{
		%col = firstWord(%ray);
		if(isObject(%col) && (%type = %col.getType() & $TypeMasks::fxBrickObjectType | $TypeMasks::TerrainObjectType))
		{
		//	centerPrint(%player.client,"<font:impact:30><just:center>\c3Air Dive   <color:CCCCCC>nrm z =" SPC %nz,2);
		//	centerPrint(%player.client,"<font:impact:30><just:center>\c3Air Dive   <color:CCCCCC>vel =" SPC %vel SPC "  vec =" SPC %vec SPC "  nrm =" SPC %nrm SPC "  dirA =" SPC %dirA @ "\c6<br>dist =" SPC %dst SPC "  len" SPC %len SPC "  max =" SPC %max SPC "  nrm z =" SPC %nz,-1);
			%inv = vectorScale(%dirA,-0.8); //ledge search offset
			%hit = posFromRaycast(%ray);
			%loc = vectorAdd(%hit,%inv);
		//	%sub = vectorSub(%hit,%posA);
		//	%dif = vectorLen(%sub);
		//	%tlt = mAbs(%nZ)/%dif;
			%mPosA = AdventureMultiLedgeCheck(%player,%loc,%dirA,true,4); //Check for ledge (within a range of 4-plates)
			if(%mPosA !$= "") //&& %len > %dif && %dif > 3 && %tlt > 0.1)
				AdventureDoAirDive(%player,%data,%mPosA,%posA,%dirA);
			else //otherwise, if ledge not found
			{
			//	talk("Attempt 2 Dive");
				//Try again with Dir B
				%xDir = vectorNormalize(getWord(%vec,0) SPC "0 0"); //normalized x component of player vel
				%yDir = vectorNormalize("0" SPC getWord(%vec,1) SPC "0"); //normalized y component of player vel
				%dirB = %dirA $= %xDir ? %yDir : %xDir; //if 'dir A' matches 'x dir', set 'dir B' as 'y dir', otherwise - use 'x dir'
			//	talk("Dir A =" SPC %dirA);
			//	talk("Dir B =" SPC %dirB);
			//	talk("X Dir =" SPC %xDir);
			//	talk("y Dir =" SPC %yDir);
				%inv = vectorScale(%dirB,-0.8); //ledge search offset
				%hit = posFromRaycast(%ray);
				%loc = vectorAdd(%hit,%inv);
				%mPosA = AdventureMultiLedgeCheck(%player,%loc,%dirB,true,4); //Check for ledge (within a range of 4-plates)
				if(%mPosA !$= "") //&& %len > %dif && %dif > 3 && %tlt > 0.1)
					AdventureDoAirDive(%player,%data,%mPosA,%posA,%dirB);
			}
		}

		if(!isObject(%col)) //if ray hit something
			%hit = %end; //use raycast endpoint
		RaycastDebugUpdate(%player,%posA,%hit,"Air Dive"); //Show Raycast Debugger

	//	if(%mPosA !$= "")
	//		centerPrint(%player.client,"<font:impact:30><just:center>\c3Air Dive   <color:CCCCCC>vel =" SPC %vel SPC "  sub = " SPC %sub SPC "  len" SPC %len SPC "  dif =" SPC %dif SPC "  max =" SPC %max SPC "  tilt =" SPC %tlt,5);
	}
	if(%mPosA $= "" && !%data.canAdventureHang)
		AdventureAirDiveEnd(%player);
}


////////////
//Air Dive//
////////////

//Dive-to-Ledge (Air Dive) Check
function AdventureAirDiveCheck(%player,%posA)
{
	if(!$Pref::Adventure::DiveToLedge || %player.isAdventureSmartDropTired) //if Pref: 'Dive to Ledge' off, or 'Smart Drop Tired' = true
		return; //stop here
//	%isGroundD = isObject(AdventureBoxCheck(%player,true,2,"","","Air Dive Check","1 1 0")); //high enough for Air Dive
//	if(%isGroundD) //if ground found
//		return; //stop here

//	%max = 5;
	%max = $Pref::Adventure::ClimbMax*2; //use Pref: Climb-Reach * n (n = 2 by default)
	%vel = %player.getVelocity();
	%vec = %player.getForwardVector();
	%len = vectorLen(%vel); //speed (magnitude of velocity vector)
	%nrm = vectorNormalize(%vel);
	%nZ = getWord(%nrm,2); //vertical velocity component
	if(%nz > 5)
	{
		%nrm = getWords(%nrm,0,1) SPC %nz*0.4;
		%nrm = vectorNormalize(%nrm);
	}
	%scl = vectorScale(%nrm,%max);
	%xyN = getWords(%nrm,0,1) SPC 0;
	%xyN = vectorNormalize(%xyN);
	%dir = HataDirCheck(%xyN);
	%dst = vectorDist(%xyN,%vec); //distance between player's normalized horizontal velocity vector and player's forward vector

	%data = %player.getDatablock();
	%end = vectorAdd(%posA,%scl);
	%ray = containerRayCast(%posA,%end,$TypeMasks::fxBrickObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType,%player);
	%col = firstWord(%ray);
//	if((%dst < 0.75 && %len > 3 && %len < %max && %nZ > -0.7 && %nZ < 0) && !%data.canAdventureHang && !%player.isAdventureAirDive)
	if((%len > 3 && %len < %max && %nZ > -0.7) && !%data.canAdventureHang && !%player.isAdventureAirDive)
	{
		if(isObject(%col) && (%type = %col.getType() & $TypeMasks::fxBrickObjectType | $TypeMasks::TerrainObjectType))
		{
		//	centerPrint(%player.client,"<font:impact:30><just:center>\c3Air Dive   <color:CCCCCC>nrm z =" SPC %nz,2);
		//	centerPrint(%player.client,"<font:impact:30><just:center>\c3Air Dive   <color:CCCCCC>vel =" SPC %vel SPC "  vec =" SPC %vec SPC "  nrm =" SPC %nrm SPC "  dir =" SPC %dir @ "\c6<br>dist =" SPC %dst SPC "  len" SPC %len SPC "  max =" SPC %max SPC "  nrm z =" SPC %nz,-1);
			%inv = vectorScale(%dir,-0.8); //ledge search offset
			%hit = posFromRaycast(%ray);
			%loc = vectorAdd(%hit,%inv);
			%sub = vectorSub(%hit,%posA);
			%dif = vectorLen(%sub);
			%tlt = mAbs(%nZ)/%dif;
			%mPosA = AdventureMultiLedgeCheck(%player,%loc,%dir,true,4); //Check for ledge (within a range of 4-plates)
			if(%mPosA !$= "") //&& %len > %dif && %dif > 3 && %tlt > 0.1)
				AdventureDoAirDive(%player,%data,%mPosA,%posA);
		}

		if(!isObject(%col)) //if ray hit something
			%hit = %end; //use raycast endpoint
		RaycastDebugUpdate(%player,%posA,%hit,"Air Dive"); //Show Raycast Debugger

	//	if(%mPosA !$= "")
	//		centerPrint(%player.client,"<font:impact:30><just:center>\c3Air Dive   <color:CCCCCC>vel =" SPC %vel SPC "  sub = " SPC %sub SPC "  len" SPC %len SPC "  dif =" SPC %dif SPC "  max =" SPC %max SPC "  tilt =" SPC %tlt,5);
	}
	if(%mPosA $= "" && !%data.canAdventureHang)
		AdventureAirDiveEnd(%player);
}
//Air-Dive Actual
function AdventureDoAirDive(%player,%data,%mPosA,%oPosA,%dir)
{
	%camera = %player.client.camera;
//	%ground = AdventureBoxCheck(%player,false,2.1,%mPosA,"","Air Dive Actual","1 0.5 0"); //Min grab height for Vel Cam
//	if(isObject(%ground) || %camera.mode !$= "Observer")
//	if(%camera.mode !$= "Observer")
//		return; //stop here

	//Find Add with SUVAT
	%m = 24; //gravity multiplier
	%sub = vectorSub(%mPosA,%oPosA); //sub vector between Multi-Ledge-Search returned hack position, and original hack position.
	%sLen = vectorLen(%sub); //length of sub input vector
	%sNrm = vectorNormalize(%sub); //normalizes sub input vector
	%sMov = mSqrt(2*%m*%sLen); //use a SUVAT equation to calculate new vel
//	%sMov = mCeil(%sMov*10)*0.1; //round up to nearest tenth (0.x)
	%add = vectorScale(%sNrm,%sMov); //correct velocity add
	%subZ = getWord(%sub,2); //vertical component of new sub vector
//	%vOff = %subZ < 0 ? -%subZ : %sLen;
	%vOff = %subZ < 0 ? -%subZ : %subZ*1.5;
	if(%subZ < 2)
		%vOff = %subZ*5;
	if(%subZ < 1)
		%vOff = %subZ*10;
	if(%subZ < 0.8)
		%vOff = %subZ*15;
//	%vOff = %subZ < 0.8 ? %vOff : %subZ*20;
//	%final = %add;
//	%final = vectorAdd(%add,"0 0" SPC %vOff*2.5); //final velocity add
	%final = vectorAdd(%add,"0 0" SPC %vOff); //final velocity add
//	talk("Air Dive:  Final Vel. =" SPC %final);
//	talk("Air Dive:  z of Sub =" SPC %subZ);
//	talk("Air Dive:  Sub Len =" SPC %sLen);

	%vec = %player.getForwardVector();
//	if(vectorDot(%final,%vec) < 0)
//		%final = "0 0 " SPC getWord(%final,2);
	%pos = %player.getPosition();
	%tra = %player.getEyeTransform();
//	%rot = vectorToAxis(%sub);
	%rot = vectorToAxis(%dir);

	AdventureDoAirDiveCam(%player,%camera,%data,%tra);
	%player.isAdventureAirDive = true;
	schedule(600,0,eval,%player@".isAdventureAirDive = false;");

	%player.setVelocity(%final);
	%player.setTransform(%pos SPC %rot);
//	%player.schedule(1,playthread,0,plant);
//	%player.schedule(1,setActionThread,crouch);
	%player.schedule(1,playthread,0,jump);
	serverplay3d(jumpsound,%pos);
	if(%data !$= "PlayerAdventureDive")
		%player.changedatablock(PlayerAdventureDive);
}
//Air-Dive Orbit Cam
function AdventureDoAirDiveCam(%player,%camera,%data,%tra)
{
	%dist = %data.cameraMaxDist;
	%camera.setOrbitMode(%player,%tra,0,%dist,%dist,true);
	%camera.setTransform(%tra);
	%camera.mode = "Climb";
	%camera.player = %player;
	if(%player.client.getControlObject() != %camera)
		%player.client.setControlObject(%camera);
}

//Air-Dive Restore Control (from camera to player)
function AdventureAirDiveEnd(%player)
{
	%camera = %player.client.camera; //player client's camera
	if(%player.isAdventureAirDive) //if player still Air Diving
		return; //stop here
//	echo("Air Dive Camera restored");
	AdventureCamRestore(%player);
	%player.changedatablock(PlayerAdventureNoJump);
//	AdventureRestoreMainDatablock(%player); //restore PlayerAdventure datablock
}


///////////////////
//Fluid Traversal//
///////////////////

//Adventure Fluid Traversal
function AdventureFluidTraversal(%player,%camera,%canMove)
{
	if(!$Pref::Adventure::FluidTraverse || %player.isAdventureHangJumpingTired || %player.isAdventureClimbing) //if Pref: Fluid-Traversal off, or player just hang jumped, or is Climbing
		return; //stop here

	//Basics
	%cvec = %camera.getForwardVector(); //camera's look vector (Note: I modified the default camera 'getForwardVector' fcn)
	%hack = %player.getHackPosition(); //torso position
	%client = %player.client; //object's client

	//Move-Inputs & Vectors
	%syncVec = MoveInputCamSync(%client,"vector",%cvec);
	%ang = getWords(%syncVec,0,1) SPC getWord(%cvec,2);
	%anrm = vectorNormalize(%ang);
	%hvec = %syncVec; //normalize it (horizontal vector)

	//Vector Dot
	%vec = %player.getForwardVector(); //player's forward vector (ledge-facing, in this context)
	%svec = findRelativeX(%vec); //player's rightward vector
	%dot = vectorDot(%hvec,%svec); //dot product of horizontal vec and rightward vec

	//Fancy Hands Integration
	%range = 0.5; //min distance to show Left/Right reaching hand (was 0.5)
	if(%dot < -0.1) //if look vector is leftward
	{
		//Left side
		%side = "L"; //..
		%svec = vectorScale(%svec,-1); //invert %rvec into an %lvec
		%off = %dot < -%range ? vectorScale(%svec,0.4) : ""; //if dot is left of range - define side offset, else - null
	}
	else if(%dot > 0.1) //if look vector is rightward
	{
		//Right side
		%side = "R"; //..
		%off = %dot > %range ? vectorScale(%svec,0.4) : ""; //if dot is right of range - define side offset, else - null
	}
	//Do Precise Fancy Hand
	if(%off !$= "" && !%canMove) //if offset defined, and canMove is false
	{
		%uPos = vectorAdd(%hack,"0 0" SPC 0.2+$Adventure::PosA_offset); //hand pos, with upward offset
		%fPos = vectorAdd(%off,%uPos); //final starting position
		%time = $Adventure::HandTime; //global Hand-Time variable
		AdventureDoFancyHand(%player,%side,%fPos,%anrm,0.7,%time); //Move hands (was 0.7)
		%didFancyHand = true; //note: fancy hand shown
	}

//	centerPrint(%client,"<font:impact:30><just:center>\c3Fluid Traversal   <color:CCCCCC>Dot =" SPC %dot SPC "  Range =" SPC %range,5);

	//Facing wall
	%diff = vectorDist(%hvec,%vec); //difference between horizontal angle and hanging forward vector
	if(%diff < 1.4) //if the ledge angle is too similar (%diff < 1.4)
		return; //stop here

	//Arc Ledge Search
	%fcn = "AdventureFinishTraversal("@ %player @",\"%ray\",\""@ %hvec @"\");"; //function to call if Arc Search successful
	%len = $Pref::Adventure::ClimbMax*0.55; //use Pref: Climb-Reach * n (n = 0.55 by default)
	%start = vectorAdd(%hack,"0 0" SPC $Adventure::PosA_offset); //Arc Search vertical start offset (was 0.6)
	%masks = $TypeMasks::fxBrickObjectType | $TypeMasks::TerrainObjectType; //ledge objects
	AdventureArcSearch(%player,%start,%anrm,%len,%masks,10,0.25,%fcn); //Search in an Arc shape for objects
	
	return %didFancyHand; //return whether Fancy Hand successfully displayed
}
//Fluid Traverse Finish
function AdventureFinishTraversal(%player,%ray,%hvec)
{
	//Raycast Hit Position
	if(isObject(firstWord(%ray))) //if raycast hit something
		%hPos = posFromRaycast(%ray); //hit position
	else //otherwise
		return; //stop here

	//Basics
	%client = %player.client; //define client
	%camera = %client.camera; //define camera
	%hack = %player.getHackPosition(); //torso position
	%vec = %player.getForwardVector(); //forward vector (ledge-facing, in this context)

	//New Hang Position
	%dir = HataDirCheck(%hvec); //calculate cardinal dir. from %hvec
	%inv = vectorScale(%dir,-0.8); //ledge search offset //was -0.9
	%mPos = vectorAdd(%hPos,%inv); //..
	%nPos = vectorAdd(%mPos,"0 0" SPC -$Adventure::PosA_offset); //adjust to relative Hack

	//Vector info
	%tilt = vectorDist(%dir,%hvec); //difference between %hvec and %dir
	%dist = vectorDist(%hPos,%hack); //distance between hit position and torso

	//Multi Ledge Check
	%mPosA = AdventureMultiLedgeCheck(%player,%nPos,%dir,true); //Check for ledge (Vertical Brick Grid-adjusted)
	%reach = mAbs(getWord(%hPos,2)-getWord(%hack,2)); //height distance between current ledge and found ledge
	%lim = $Pref::Adventure::ClimbMax*1; //max distance //multiplier was 0.6

//	centerPrint(%client,"<font:impact:30><just:center>\c6Fluid Traversal  \c6lim =" SPC %lim SPC "  reach =" SPC %reach @ "<br>\c6diff =" @ "<br><color:CCCCCC>dist =" SPC %dist @ "<br>\c6hit pos =" SPC %hPos SPC "<br>Multi-PosA =" SPC %mPosA,5);

	//Acceptable Vector Calculation
	if(%mPosA $= "" || %dist < 0.2 || %reach > %lim) //if ledge not found, or the ledge angle is too obtuse, or the ledge is too close, or the ledge is too high (%tilt was 0.64)
		return; //stop here

	//Velocity Add Scaling
	%sub = vectorSub(%hPos,%hack); //vector from torso to hit position
	%sNrm = vectorNormalize(%sub);
	%sLen = vectorLen(%sub); //magnitude of %sub

	//Find Add with SUVAT
	%m = 28; //gravity multiplier
	%sMov = mSqrt(2*%m*%sLen); //use a SUVAT equation to calculate new vel
	%sMov = mCeil(%sMov*10)*0.1; //round up to nearest tenth (0.x)
	%time = mAbs(%sLen)*50; //scale time to match traversal distance
	%add = vectorScale(%sNrm,%sMov); //correct velocity add
	%final = vectorAdd(%add,"0 0" SPC %sLen*1); //final velocity add (was 0.2)
	
//	bottomPrint(%client,"<font:impact:30><just:center>\c3Fluid Traversal  \c6time =" SPC %time SPC "  sub length =" SPC %sLen @ "<br><color:CCCCCC>add =" SPC %add,5);

	//Traversal Jump Anims
	if(%sLen > 4) //if length to ledge is greater than a few bricks
		%player.playthread(2,shiftup,true); //anim (and override a slot 2 animation in while climbing)
	else if(%sLen > 3) //if length to ledge is greater than a few bricks
		%player.playthread(2,shiftdown,true); //anim (and override a slot 2 animation in while climbing)

	if(%sLen > 3)
		%player.playthread(0,jump); //anim
	else //otherwise
		%player.playthread(0,plant); //anim

	//Camera Orbit Mode restore
	%rot = vectorToAxis(%dir); //rot from vector
	%pos = %player.getPosition(); //player position
	if(%player.isCamPointMode) //if free looking
	{
		%tra = %camera.getTransform(); //camera's current transform
		%player.hasCamSetup = false; //reset orbit cam
		%camera.setOrbitMode(%player,%tra,0,PlayerAdventureHang.cameraMaxDist,0,true); //Normal climb cam
		%camera.setTransform(%tra); //rotate orbit cam to match old view
	}

	//Rotate Player
	%player.setTransform(%pos SPC %rot); //rotate the player to face the correct direction

	//Set exclusive bools
	%player.isAdventureHanging = false;
	%player.isAdventureFirstHang = false;

	//Force Restore hands
	AdventureHandHideCheck(%player,"Force"); //Force restore hands (since we traversed)
	HataShapeDelete(%client.AdvTool); //delete hang shape
	HataShapeDelete(%client.AdvShow); //delete hang show shape

	//Velocity & Shape Kill
	%player.setVelocity(%final); //set new velocity

	//Climbing bool Adjustments
	%player.isAdventureClimbing = true;
	%player.AdvClimbing = schedule(%time,0,eval,%player@".isAdventureClimbing = false;");
	
	%player.isAdventureClimbTired = true;
	cancel(%player.AdvClimbTired);
	%player.AdvClimbTired = schedule(%time*2,0,eval,%player@".isAdventureClimbTired = false;");
//	%player.lastSimTime = getSimTime();
}