///////////////
//Fancy Hands//
///////////////

//Adventure Hand Hide
function AdventureHandHideCheck(%player,%type)
{
	%data = %player.getDatablock(); //player datablock
	if(!%data.canAdventureHang || %type $= "Force") //if data cannot Hang, or Force
	{
		//Show Default hands & Kill Fancy ones
		%player.client.applyBodyParts(); //restore hands
		HataShapeDelete(%player.client.AdvFancyHand["L"]); //kill both hand shapes
		HataShapeDelete(%player.client.AdvFancyHand["R"]); //..
		%player.AdvHangAnimSide = ""; //clear 'Adventure Hang Animation Side' string value
	}
	else if(%data.canAdventureHang && $Pref::Adventure::FancyHands) //otherwise, if datablock can Hang, and Pref: 'Fancy Hands' on
	{
		//Hide left hand
		%player.hideNode("LHand"); //hand
		%player.hideNode("LHook"); //hook

		//Hide right hand
		%player.hideNode("RHand"); //hand
		%player.hideNode("RHook"); //hook
	//	talk("Fancy Hand node hide");
	}
	
	if(!$Pref::Adventure::FancyHands) //if Pref: 'Fancy Hands' off
		return; //stop here
	
	//Swap out Left hand
	if(%type $= "ClLeft" || %player.AdvHangAnimSide $= "left") //if input 'type' = "ClLeft", or 'HangAnimSide' = "left"
	{
		%player.unhideNode("RHand"); //show right hand
		HataShapeDelete(%player.client.AdvFancyHand["R"]); //delete right Fancy Hand
		return "R"; //stop here
	}
	//Swap out Right hand
	if(%type $= "ClRight" || %player.AdvHangAnimSide $= "right") //if input 'type' = "ClRight", or 'HangAnimSide' = "right"
	{
		%player.unhideNode("LHand"); //show left hand
		HataShapeDelete(%player.client.AdvFancyHand["L"]); //delete left Fancy Hand
		return "L"; //stop here
	}

	return "";
}

//Fancy Hand Check (includes on/off toggling)
function AdventureFancyHandCheck(%player,%type)
{
	//Define client
	%client = %player.client; //player's client
	
	%hasFancyHand = (isObject(%client.AdvFancyHand["L"]) || isObject(%client.AdvFancyHand["R"])); //Does left fancy hand shape, or right fancy hand shape exists?
	if((!%player.isAdventureHanging && !%player.isAdventureClimbTired) || %player.isAdventurePullup || (!$Pref::Adventure::FancyHands && %hasFancyHand)) //if player is (not 'Hanging', and not 'Climb Tired'), or player is 'Pulling-up', or (Pref: 'Fancy-Hands' off, and a fancy hand exists)
	{
	//	talk("has fancy hands? =" SPC %hasFancyHand);
		AdventureHandHideCheck(%player,"Force"); //Force restore hands
		return; //stop here
	}
	else if(!%player.isAdventureClimbing) //otherwise, if not climbing
		%hideSide = AdventureHandHideCheck(%player); //hide default hands if applicable

	//Player vectors
	%fvec = %player.getForwardVector(); //ledge-facing vector
	%rvec = findRelativeX(%fvec); //rightward vector
	%lvec = vectorScale(%rvec,-1); //leftward vector

	//Camera vectors
	%camVec = %client.camera.getForwardVector(); //cam vector
	%camRVec = findRelativeX(%camVec); //rightward vector
	%camLVec = vectorScale(%camRvec,-1); //leftward vector

	//Keyboard inputs
	%syncVec = MoveInputCamSync(%client,"vector",%camVec); //get Input vector
	if(%syncVec !$= "")
	{
		%goRight = vectorDist(%syncVec,%rvec) < 1;
		%goLeft = vectorDist(%syncVec,%lvec) < 1;
	}	
	if(%goRight || %goLeft) //if can go Left, or can go Right
		%svec = %goLeft ? %lvec : %rvec; //if goLeft is true - svec = lvec, else (if goRight is true) - svec = rvec

	//Show Fancy Hands
	if(!%player.FancyHandOn["L"] && %hideSide !$= "L") //if Left hand is not fancy timed out
		AdventurePreFancyHand(%player,"L",%type,%svec); //do Fancy Hand left
	if(!%player.FancyHandOn["R"] && %hideSide !$= "R") //if right hand is not fancy timed out
		AdventurePreFancyHand(%player,"R",%type,%svec); //do Fancy Hand right
}
//Start Fancy Hand (while Hanging / Climbing)
function AdventurePreFancyHand(%player,%side,%type,%svec,%rPos)
{
	if(!$Pref::Adventure::FancyHands) //if Pref: Fancy-Hands off
		return; //stop here

	//General variables
	%dir = %player.getForwardVector(); //ledge-facing vector (in this case the same as player's Forward Vector)
	%posA = %player.getHackPosition(); //torso

	//Side-ward vectors
	%rvec = findRelativeX(%dir); //rightward vector
	%lvec = vectorScale(%rvec,-1); //leftward vector
	
	//Fancy Hand types
	if(%type $= "Climb") //if type is "Climb"
	{
		%player.AdvLrPos = %rPos; //store last rPos to player object
		%player.AdvLfHand = %side; //store last side to player object
	}
	if(%player.isAdventureClimbing) //if player is Climbing
	{
		%side = %player.AdvLfHand; //use last Fancy Hand side ("L" or "R")
		%rPos = %player.AdvLrPos; //use last rPos (relative position of new ledge)
		%shft = vectorScale(%dir,$Adventure::LedgeHangLen); //approximate location where hand rests on current ledge
		%fPos = vectorAdd(%rPos,%shft); //approximate location where hand would rest on next ledge
		%sub = vectorSub(%fPos,%posA); //vector from torso position to predicted ledge hand-hold
		%beam = vectorScale(%sub,4); //scale 'sub' to widen the hand angles
	//	talk("Pre Fancy Hand:  \"is Climbing\" Type");
		%value = 0.7; //rightward / leftward offset value (for hands)
	}
	else if(%player.isAdventureHanging) //otherwise, if player is Hanging
	{
		%player.AdvLrPos = ""; //nulify last rPos
		%player.AdvLfHand = ""; //nulify last side
		%reach = vectorScale(%svec,1); //scaled side vector (for left/right movement, holding A/D)

	//	talk("Pre Fancy Hand:  \"Silent\" Type   Side vector =" SPC %svec);
		%length = 5; //define angle calculation length
		if(%svec !$= "") //if side vector defined (climbing sideways or diagonally)
		{
			%length = 3.5; //change angle for directional climbing
			%mov["L"] = vectorDot(%lvec,%svec) > 0.99; //if 'lvec' ~ 'svec' (if they're approximately equal)
			%mov["R"] = vectorDot(%rvec,%svec) > 0.99; //if 'rvec' ~ 'svec' (if they're approximately equal)
			%both["L"] = strStr(%player.AdvHangAnimSide,"L") != -1; //if both ledges found, and a wall is to the left
			%both["R"] = strStr(%player.AdvHangAnimSide,"R") != -1; //if both ledges found, and a wall is to the right
			%hangMov = %mov[%side] && !%both[%side]; //true if moving in the same direction as the hand (e.g. moving left, and L hand), and neither ('bothL' nor 'bothR') are true
			%beam = vectorScale(%dir,3.5); //lengthened forward vector (for hand angle calculation)
		//	talk("Pre Fancy Hand:  Hang Anim Side =" SPC %player.AdvHangSide);
		//	talk("Pre Fancy Hand:  move[L] =" SPC vectorDot(%lvec,%svec));
		//	talk("Pre Fancy Hand:  move[R] =" SPC vectorDot(%rvec,%svec));
		}

		%beam = vectorScale(%dir,%length); //lengthened forward vector (for hand angle calculation)
		
		//Adjust Animation if no Ledge to the Left / Right
		%sideL = (strStr(%player.AdvHangAnimSide,"left") != -1 && %side $= "L"); //if left hand active (not Hidden)
		%sideR = (strStr(%player.AdvHangAnimSide,"right") != -1 && %side $= "R"); //if right hand active (not Hidden)
		%value = (%sideL || %sideR) ? 0.5 : 0.7; //if ((left hand Hidden) or (right hand Hidden)) - use 0.2, else - use 0.7, for the side offset value
	}
	else //otherwise (if not 'Hanging' or 'Climbing')
		return; //stop here
	
	%dvec = %side $= "L" ? %lvec : %rvec; //choose leftward or rightward vector based on the defined %side
	%off = vectorScale(%dvec,%value); //side offset (for left / right hand)
	%uPos = vectorAdd(%posA,"0 0" SPC 0.14); //hand position, with upward offset
	%fPos = vectorAdd(%off,%uPos); //final position
	%bEnd = vectorAdd(%posA,%beam); //endpoint of beam
	%nvec = vectorSub(%bEnd,%fPos); //new vector (for hand to angle towards)
	%nvec = %hangMov ? vectorNormalize(vectorAdd(%reach,%nvec)) : vectorNormalize(%nvec); //if side vector exists - tilt hand towards the direction of movement, else - point hand forward (both)

	AdventureDoFancyHand(%player,%side,%fPos,%nvec,$Adventure::LedgeHangLen); //Set the Fancy Hand, args. - L/R side, initial position, hand offset vector, hand offset distance
//	centerPrint(findclientbyname(),"<font:impact:30><just:center>\c3Fancy Hand Start called  \c5" SPC %type SPC "\c6  side =" SPC %side @ "<br>\c5is Climb = " SPC %player.isAdventureClimbing,0.2);
}
//Fancy Hand Actual
function AdventureDoFancyHand(%player,%side,%hpos,%vec,%len,%time)
{
	%client = %player.client; //define client from player
	if(%side $= "" || !%player.getDatablock().canAdventureHang || !$Pref::Adventure::FancyHands) //if %side undefined, or not in climbing playertype, or Pref: Fancy-Hands off
		return; //stop here

	%hand = %client.AdvFancyHand[%side]; //define hand object
	if(!isObject(%hand)) //if no hand object exists
	{
		%data = "AdventureHand" @ %side; //datablock name
		%color = %side $= "L" ? %client.lHandColor : %client.rHandColor; //color was ("1 0.2 1 1")
		%hand = HataMovableShapeCreate(%data,%color); //create object
		%client.AdvFancyHand[%side] = %hand; //save hand object to client
	}

//	centerPrint(%player.client,"<font:impact:30><just:center>\c3Fancy Hands   \c6side =" SPC %side SPC "  time =" SPC %time @ "<br>\c5Hand =" SPC %hand,5);

	%off = vectorScale(%vec,%len); //offset
	%vEul = vectorToEuler(%vec); //hand rotation (based on %vec)
	%roll = %side $= "L" ? 90 : -90; //if side = "L" - use 90, else - use -90
	%nRot = eulerToAxis(vectorAdd(%vEul,0 SPC %roll SPC 0)); //make new adjusted rotation
	%hand.setTransform(vectorAdd(%hPos,%off) SPC %nRot); //update hand position and rotation

	cancel(%client.justFanciedHand[%side]); //cancel Debug Object kill
	if(%time >= 1) //if time is at least 1
	{
		%client.justFanciedHand[%side] = schedule(%time,0,eval,%player@".FancyHandOn\["@ %side @"\] = false;"); //schedule "FancyHandOn" bool toggle
		%player.FancyHandOn[%side] = true; //use "FancyHandOn[%side]" to prevent hands from reseting
	}
	else //otherwise (if time is less than 1, or time undefined)
		%player.FancyHandOn[%side] = false; //don't use a timeout at all
}


////////////////
//Arm Flailing//
////////////////

function AdventureArmFlailAnim(%player,%speed,%minDamSpeed,%minDeathSpeed)
{
	if(!$Pref::Adventure::Flailing || %player.isAdvFlailing) //if Pref: Flailing off, or Flailing timeout in progress
		return; //stop here

	%player.isAdvFlailing = true; //start timeout for Arm Flailing (so it doesn't spam every 1ms)
	%timeScale = 10*(%minDeathSpeed-mCeil(%speed-%minDamSpeed)); //Scale down the time between animations, as the falling speed increases
	%timeScale = %timeScale < 150 ? 150 : %timeScale; //if timeScale value is less than 50 - set it to 50, else - keep it
	schedule(%timeScale,0,eval,%player@".isAdvFlailing = false;"); //wait 'timeScale' ms, then disable the Flailing timeout
//	talk("Flailing active:  Time Scale =" SPC %timeScale);

	if((%atMinDeathSpeed = %speed >= %minDeathSpeed)) //if 'at minimum Fall-Death Speed' = true
	{
	//	talk("Flailing Active:  At Min Death Speed = 1");
	//	talk("Flailing Active:  Speed =" SPC %speed);
		%pos = %player.getPosition();
		HataDoProjectile(%player,true,AdventureAlarmProjectile,%pos,"0 0 1",1); //spawn exclamation emote
		if(!isObject(%player.tool[%player.currTool])) //if player has no tool in hand
			%player.playthread(2,activate2); //play 'Activate Spam' animation
		%player.playthread(0,plant); //play 'Brick Planting' animation
	}
	else if((%atMinDamSpeed = %speed >= %minDamSpeed)) //otherwise, if 'at minimum Fall-Damage Speed' = true
	{
		if(!isObject(%player.tool[%player.currTool])) //if player has no tool in hand
			%player.playthread(2,shiftdown); //play 'Shift Down' animation
		%player.playthread(0,jump); //do 'Jump' animation
	}
}


///////////////////
//Hang Animations//
///////////////////

//Start Hang Animation
function AdventureUpdateHangAnim(%player,%start,%canL,%canR,%blockL,%blockR,%fancy)
{
	if(!%player.isAdventureHanging || %player.isAdventureClimbing || %player.isAdventurePullup) //if not Anim, or climbing, or Pulling-up
		return; //stop here

	if(%start) //if first Animating
	{
	//	talk("Hang Anim:  Start called");
		%player.isAdventureHangAnimReady = false; //set 'Hang Anim Ready' bool to false (only play the starting animation once)
		%player.isAdventureHangAnim = true; //set 'Hang Anim' bool to true
		%player.playthread(0,fall); //feet up animation
		%player.setActionThread(root); //clear movement thread animation
		%player.AdvHangAnimSide = ""; //clear 'Adventure Hang Animation Side' string value
	}

	if(!%player.isAdventureHangAnim) //if 'Hang Anim' bool is false (i.e. hang Anim not started)
		return; //stop here

	if(%fancy) //if 'Hang Anim Side' = "fancy" (i.e. Fluid Traversal active)
	{
		%player.AdvHangAnimSide = %player.AdvHangAnimSide @ "Fancy"; //set 'Adventure Hang Animation Side' string value to "fancy"
		if(strStr(%player.AdvLastHangAnimSide,"Fancy") == -1) //if last 'Hang Anim Side' = "fancy"
			%player.playthread(2,armreadyboth,true); //both arms up (and override a slot 2 animation in while climbing)
	}
	else //otherwise (if 'Hang Anim Side' is anything but "fancy")
	{
		if(%blockL) //if perpendicular non-ledge wall exists to the left
			%wallL = "L"; //define 'wallL' string as "L"
		if(%blockR) //if perpendicular non-ledge wall exists to the left
			%wallR = "R"; //define 'wallR' string as "R"

		if((%canL && %canR) && %player.AdvHangAnimSide !$= ("both" @ %wallL @ %wallR)) //if both (can climb left, and can climb right), and 'HangAnimSide' string is not a variant of "both"
		{
		//	talk("Hang Anim:  Both called");
			if(strStr(%player.AdvHangAnimSide,"both") == -1) //if 'HangAnimSide' string string does not contain "both"
				%player.playthread(2,armreadyboth,true); //both arms up (and override a slot 2 animation in while climbing)
			
			%player.AdvHangAnimSide = "both" @ %wallL @ %wallR; //set 'Adventure Hang Animation Side' string value to "both" + wall statuses (e.g. "bothL", "bothR", or "bothLR")
		//	talk("Hang Anim:  Side Change =" SPC %player.AdvHangAnimSide);
		}
		
		if((%canL && !%canR) && %player.AdvHangAnimSide !$= "left") //if both (can climb left, and cannot climb right), and 'HangAnimSide' is not "left"
		{
		//	talk("Hang Anim:  Left called");
			%player.playthread(2,armreadyleft,true); //left arm up (and override a slot 2 animation in while climbing)
			%player.AdvHangAnimSide = "left"; //set 'Adventure Hang Animation Side' string value to "left"
		}

		if((%canR && !%canL) && %player.AdvHangAnimSide !$= "right") //if both (can climb right, and cannot climb left), and 'HangAnimSide' is not "right"
		{
		//	talk("Hang Anim:  Right called");
			%player.playthread(2,armreadyright,true); //right arm up (and override a slot 2 animation in while climbing)
			%player.AdvHangAnimSide = "right"; //set 'Adventure Hang Animation Side' string value to "right"
		}
	}
	//Save last 'Hang Anim Side'
	%player.AdvLastHangAnimSide = %player.AdvHangAnimSide; //save previous 'Hang Anim Side' to player object
}

//Stop Hang Animation
function AdventureStopHangAnim(%player,%mount)
{
//	%player.AdvHangAnimSide = ""; //clear 'Adventure Hang Animation Side' string value
	%player.playthread(2,root); //clear slot 2 thread
	if(!%player.isAdventureHangJumping && !%mount) //if player is not 'Hang Jumping', and is not mounted to an object/vehicle
	{
		cancel(%player.AdventureCl); //cancel climb down animation
		%player.playthread(3,root); //clear slot 3 thread
		%player.playthread(0,root); //clear slot 0 thread
	}
	fixArmReady(%player); //update 'Arm Ready' to match current equipped Weapon's preferences
}


////////////////////
//Climb Animations//
////////////////////

//Climb Animation Check
function AdventureClimbAnimCheck(%player,%time,%rPos,%svec,%down)
{
	if(%time < 100) //if climb time less than 100 (brick distance less than 1)
	{
		//Use smaller animation
		%player.playthread(2,root,true); //override a slot 2 animation in while climbing
		%player.playthread(3,activate,true); //click anim
	}
	else
	{
		//Use Anim + Fancy Hands
		%ClLeft = %player.isAdventureClLeft; //left/right climb toggle bool

		//Direction Checks
		%upL = !%down && %ClLeft; //ready to climb up (left)
		%upR = !%down && !%ClLeft; //ready to climb up (right)
		%downL = %down && %ClLeft; //ready to climb down (left)
		%downR = %down && !%ClLeft; //ready to climb down (right)

		//Player Anim
		if(%upL || %downR) //if upward - with left hand, or downward - with right hand
			AdventureDoClimbAnim(%player,true,%time,%down); //Do left arm player anim
		if(%upR || %downL) //if upward - with right hand, or downward - with left hand
			AdventureDoClimbAnim(%player,false,%time,%down); //Do right arm player anim
		//	AdventureClRight(%player,%time,%down); //Do right arm player anim

		//Fancy Hands
		if(%ClLeft) //if Climb Left bool true
			AdventurePreFancyHand(%player,"L","Climb",%svec,%rPos); //Update left Fancy Hand
		else //otherwise
			AdventurePreFancyHand(%player,"R","Climb",%svec,%rPos); //Update right Fancy Hand
	}
	AdventureClimbRandom(%player); //random forward/backward leaning
}

//Animation - Alternating Left/Right hands
function AdventureDoClimbAnim(%player,%left,%time,%down)
{
	if(%left) //if left arg. = true
	{
		%thread0 = "leftrecoil"; //left-hand shiftaway anim
		%thread1 = "armreadyleft"; //left arm up anim
		%type = %down ? "ClRight" : "ClLeft"; //switch hand hide type if %down
	}
	else //else (if 'right')
	{
		%thread0 = "shiftaway"; //right-hand recoil anim
		%thread1 = "armreadyright"; //right arm up anim
		%type = %down ? "ClLeft" : "ClRight"; //switch hand hide type if %down
	}
	
	//Player Animation
	if(!%down) //if Climbing Up
		%player.playthread(3,%thread0,true); //Anim - left shift away
	else //otherwise (if Climbing Down)
		%player.AdventureCl = %player.schedule(%time/2,playthread,3,%thread0,true); //Anim - left shift away (delayed)
	%player.playthread(2,%thread1,true); //Anim - left hand up (and override a slot 2 animation in while climbing)

	//Hide Fancy Hand
	AdventureHandHideCheck(%player,%type); //Hide selected hand

	//Toggle Climb Left
	%player.isAdventureClLeft = !%player.isAdventureClLeft; //toggle Climb Left
}

//Animation - Leaning back/forward randomly
function AdventureClimbRandom(%player)
{
	%rand = getRandom(); //generate random float between 0 and 1
	if(%rand >= 0.5) //if float greater than or equal to 5
		%player.playthread(0,plant); //play plant brick anim
	else //otherwise (if float less than 50)
		%player.playthread(0,jump); //play jump anim
}


/////////////////////
//Default Functions//
/////////////////////

package AdventureAesthetics
{
	//Player on Animate (Protect climbing animations)
	function Player::Playthread(%player,%slot,%thread,%override)
	{
		if((%slot == 2 || %slot == 3) && %player.isAdventureHanging && !%override) //if (animation slot = 2 or 3), and player is Hanging, and player is not climbing, and override = false // && !%player.isAdventureClimbing
			return; //stop here (ignore animation call)
		Parent::Playthread(%player,%slot,%thread); //Do regular animating
	//	echo(%player.getShapeName() @ "'s Thread parented  slot =" SPC %slot SPC "  thread =" SPC %thread);	
	}
	//Player on Sit (Disable Sit emote, when hanging)
	function serverCmdSit(%client)
	{
		if(!isObject(%client.player) || !%client.player.getDatablock().canAdventureHang) //if player DNE, or player data. cannot Hanging
			Parent::serverCmdSit(%client); //Parent default fcn
	}
};activatePackage(AdventureAesthetics);