//////////////////////
//Debug Server CMD's//
//////////////////////

//Toggle Debug CMD
function serverCmdAdventureDebug(%client,%word1,%word2,%word3,%word4,%word5,%word6,%word7)
{
	if(!%client.isSuperAdmin) //if client is not Super Admin
		return; //Stop here (Prevent non-Super Admins from using this)

	for(%n=1;%n<=7;%n++) //get words 1-7
		%words = %words SPC %word[%n]; //combine all input words into one string, and make it lower-case (not case-sensitive)
	%words = strTrim(strLwr(%words)); //trim any spaces from the left / right, and force lowercase

	%ray = strStr(%words,"ray") != -1 || strStr(%words,"cast") != -1; //if client mentioned "ray" or "cast" (i.e. raycast)
	%box = strStr(%words,"box") != -1 || strStr(%words,"square") != -1; //if client mentioned "box" or "square"
	%print = strStr(%words,"center") != -1 || strStr(%words,"print") != -1; //if client mentioned "center" or "print"
	%ledge = strStr(%words,"ledge") != -1 || strStr(%words,"high") != -1; //if client mentioned "ledge" or "high" - short for highlight
	%tool = strStr(%words,"tool") != -1 || strStr(%words,"plate") != -1; //if client mentioned "tool" or "plate" (climb tool / plate)
	%aim = strStr(%words,"aim") != -1 || strStr(%words,"cross") != -1; //if client mentioned "aim" or "cross" - short for crosshair

	$Adventure::DebugRay = false; //disable Debug raycast by default
	$Adventure::DebugBox = false; //disable Debug Box by default
	$Adventure::DebugCenter = false; //disable Debug centerprint by default
	$Adventure::DebugHiBrick = false; //disable Debug Highlight by default
	$Adventure::DebugTool = false; //disable Debug Tool show
	$Adventure::DebugCrosshair = false; //disable Debug Crosshair raycast display
	
	if((!%ray && !%box && !%print && !%ledge && !%tool && !%aim)) //if no keywords mentioned in the /cmd
		%on = "<color:CD6666>Disabled"; //say disabled (toggling off)
	else //if at least one keyword was mentioned in the /cmd
	{
		%on = "<color:B2FF7F>enabled"; //say enabled by default
		if(%ray) //if print keywords used
		{
			%rNote = "\c6 + \c6raycast"; //add to status 
			$Adventure::DebugRay = true; //enable Debug centerprint
		}
		if(%box) //if print keywords used
		{
			%bNote = "\c6 + \c6box search"; //add to status 
			$Adventure::DebugBox = true; //enable Debug centerprint
		}
		if(%print) //if print keywords used
		{
			%pNote = "\c6 + \c6centerprint info"; //add to status 
			$Adventure::DebugCenter = true; //enable Debug centerprint
		}
		if(%ledge) //if highlight keywords used
		{
			%hNote = "\c6 + \c6ledge highlighting"; //add to status
			$Adventure::DebugHiBrick = true; //enable Debug centerprint
		}
		if(%tool) //if tool keywords used
		{
			%tNote = "\c6 + \c6climb tool display"; //add to status
			$Adventure::DebugTool = true; //enable Debug Tool show
		}
		if(%aim) //if crosshair keywords used
		{
			%aNote = "\c6 + \c6crosshair raycast display"; //add to status
			$Adventure::DebugCrosshair = true; //enable Debug Tool show
		}
	}
	%status = rTrim(%on @ %rNote @ %bNote @ %pNote @ %hNote @ %tNote @ %aNote); //trim extra space from the right side (if %message undefined it removes a " ")
	%client.chatMessage("\c5Adventure Player <color:FFE599>Debug" SPC %status); //Send chat message to client
}

//Set Debug Shape Time CMD
function serverCmdAdventureSetTime(%client,%type,%time)
{
	if(!%client.isSuperAdmin) //if client is not Super Admin
		return; //Stop here (Prevent regular players from using this)

	%ray = strStr(strLwr(%type),"ray") != -1 || strStr(strLwr(%type),"cast") != -1; //if client mentioned "ray" or "cast"
	%box = strStr(strLwr(%type),"box") != -1 || strStr(strLwr(%type),"square") != -1; //if client mentioned "box" or "square"
	%ledge = strStr(strLwr(%type),"ledge") != -1 || strStr(strLwr(%type),"high") != -1; //if client mentioned "ledge" or "high" - short for highlight
	%fancy = strStr(strLwr(%type),"fancy") != -1 || strStr(strLwr(%type),"hand") != -1; //if client mentioned "fancy" or "hand"
	if(%ray) //if %ray keyword mentioned
		%message = "\c5Adventure Player <color:FFE599>Raycast Debug"; //message
	else if(%box) //otherwise, if %ray keyword mentioned
		%message = "\c5Adventure Player <color:FFE599>Box Check Debug"; //message
	else if(%ledge) //otherwise, if a %ledge keyword is mentioned
		%message = "\c5Adventure Player <color:FFE599>Ledge Indicator"; //message
	else if(%fancy) //otherwise, if a %fancy keyword is mentioned
		%message = "\c5Adventure Player <color:FFE599>Fancy Hand"; //message
	else //otherwise
	{
		%client.chatMessage("\c5Adventure Player <color:FFE599>Debug<color:CCCCCC> type undefined. Try \"ray\", \"ledge\", or \"fancy\"."); //Send chat message to client
		return; //stop here
	}

	if(%time >= 1 && %message !$= "") //if entered time is greater than 1, and %message is defined
	{
		if(%ray) //if Raycast type
		{
			%oldTime = $Adventure::RayDelTime; //current timeout before Raycast Debugging shape gets deleted
			$Adventure::RayDelTime = %time; //set new timeout (from input %time)
		}
		if(%box) //if Box Check type
		{
			%oldTime = $Adventure::BoxDelTime; //current timeout before Box Check Debugging shape gets deleted
			$Adventure::BoxDelTime = %time; //set new timeout (from input %time)
		}
		if(%ledge) //if Ledge Indicator type
		{
			%oldTime = $Adventure::HiBrickTime; //current timeout before Ledge Indicator brick ghost gets deleted
			$Adventure::HiBrickTime = %time; //set new timeout (from input %time)
		}
		if(%fancy) //if Fancy Hand type
		{
			%oldTime = $Adventure::HandTime; //current timeout before Fancy Hands reset (it defaults to 1, via the FancyHandActual function)
			$Adventure::HandTime = %time; //set new timeout (from input %time)
		}
		%client.chatMessage(%message SPC "time \c6was\c3" SPC %oldTime @ "\c6."); //Send chat message to client (old time)
		%client.chatMessage(%message SPC "time \c6set to\c3" SPC %time @ "\c6."); //.. (new time)
	}
	else //otherwise
	{
		%client.chatMessage(%message @ "<color:CCCCCC>: The value you entered is less than the minimum of\c3 1<color:CCCCCC>."); //Send chat message to client
		if(%ray && $Adventure::RayDelTime !$= "") //if saved pref time is defined
			%client.chatMessage(%message SPC "time \c6is currently \c3" @ $Adventure::RayDelTime @ "\c6."); //..
		if(%box && $Adventure::BoxDelTime !$= "") //if saved pref time is defined
			%client.chatMessage(%message SPC "time \c6is currently \c3" @ $Adventure::BoxDelTime @ "\c6."); //..
		if(%ledge && $Adventure::HiBrickTime !$= "") //if saved pref time is defined
			%client.chatMessage(%message SPC "time \c6is currently \c3" @ $Adventure::HiBrickTime @ "\c6."); //..
		if(%fancy && $Adventure::HandTime !$= "") //if saved pref time is defined
			%client.chatMessage(%message SPC "time \c6is currently \c3" @ $Adventure::HandTime @ "\c6."); //..
	}
}


/////////////////////////
//Ledge Search Debugger//
/////////////////////////

//Viable Ledge Indicator
function AdventureLedgeIndicate(%player,%pos,%vec,%ID)
{
	if(!$Adventure::DebugHiBrick) //if Pref: Debug-enabled off, or Pref: Debug-Highlight off
		return; //Stop here

	%client = %player.client; //define client
	%clHiBr = %client.AdvHiBrick[%ID]; //check for old highlight brick
	if(isObject(%clHiBr)) //if old highlighter brick exists
		%dist = vectorDist(%clHiBr.oldPos,%pos); //the distance between the old and new brick position
//	centerPrint(%client,"<font:impact:30><just:center>\c3Ledge Highlight   <color:FFFFFF>dist =" SPC %dist,10);
	if((!isObject(%clHiBr) || %dist > 0.6) && !%client.justAdvHigh) //if (old brick DNE, or its too dist too far) and did not just update brick position
	{
		%client.justAdvHigh = true; //prevent brick spam updating
		schedule(50,0,eval,%client@".justAdvHigh = false;"); //set timeout before next brick update

		HataShapeDelete(%clHiBr); //delete the old highlight brick
		AdventureLedgeIndicatorSpawn(%client,%pos,%vec,%ID); //Spawn highlight new brick
	}

	%time = $Adventure::HiBrickTime; //use global Highlight Brick Time variable's value
	cancel(%client.DelHiBrick[%ID]); //cancel Highlight Brick kill
	%client.DelHiBrick[%ID] = schedule(%time,0,HataShapeDelete,%client.AdvHiBrick[%ID],%client@".DelHiBrick\["@ %ID @"\]"); //schedule Highlight brick delete (so it deletes itself automatically when unused)

}
//Spawn Ledge Indicator
function AdventureLedgeIndicatorSpawn(%client,%pos,%vec,%ID)
{
	%off = vectorScale(%vec,0.4); //forward adjustment
	%add = vectorAdd(%pos,%off); //forward adjusted position
	%sub = vectorAdd(%add,"0 0" SPC -0.07); //downward adjusted position
	%rot = vectorToAxis(%vec); //new rotation
	%data = brick1x2fPrintData; //brick data
	%colID = getClosestPaintColor("0.22 0.5 0.67 0.5"); //translucent white

	%brick = new fxDTSBrick()
	{
		datablock = %data;
		position = %sub;
		rotation = %rot;
		colorID = %colID;
		printID = 20; //caution arrow
		scale = "1 1 1";
		colorfxID = 4; //flashing
		client = %client;
		isPlanted = true;
	};
	%brick.setRaycasting(false); //
	%brick.setColliding(false); //
	
	%brick.setTransform(%brick.position SPC %brick.rotation);
	%brick.oldPos = %pos; //save brick's position
	%client.AdvHiBrick[%ID] = %brick; //save brick to player object
}


////////////////////
//Raycast Debugger//
////////////////////

//Raycast Debug Update
function RaycastDebugUpdate(%player,%start,%end,%name)
{
	%client = %player.client; //define client from player
	if(!$Adventure::DebugRay || (%name $= "Beam Check Aim Check" && !$Adventure::DebugCrosshair)) //if Pref: Debug off, or (Crosshair debugging Raycast, and Debug-Crosshair off)
		return; //Stop here

	%data = strReplace(%name," ",""); //delete spaces for proper datablock name
	%data = strReplace(%data,"[","I"); //replace brackets with I's
	%data = strReplace(%data,"]","I"); //..

	if(%client.DebugRay[%data]) //if ray just updated
		return; //stop here

	%timeout = 25; //timeout value for ray debug update
	%client.DebugRay[%data] = true; //note we just spawned a raycast
	schedule(%timeout,0,eval,%client@".DebugRay\["@ %data @"\] = false;"); //timeout before ray can be updated

	%color = %name $= "Beam Check Aim Check" ? "0 0.7 1 1" : "1 0.1 1 1";
	%clDbg = %client.RayDebug[%data]; //Raycast Debugger object
	if(!isObject(%clDbg)) //if Debug object DNE
	{
		%clDbg = HataMovableShapeCreate(HataDebugRayData,%color); //create object
		%client.RayDebug[%data] = %clDbg; //Store shape to client
	}
	%size = 0.1; //scale of Debug Object

	%sub = vectorSub(%end,%start); //vec from %start to %end
	%vector = vectorNormalize(%sub); //normalized sub
	%relative = "0 1 0";

	%xyz = vectorNormalize(vectorCross(%relative,%vector));
	%u = mACos(vectorDot(%relative,%vector)) * -1;

	%scale = vectorScale(%sub,0.5); //sub vector with half the magnitude
	%clDbg.setTransform(vectorAdd(%start,%scale) SPC %xyz SPC %u);
	%clDbg.setScale(%size SPC vectorDist(%start,%end) * 2 SPC %size);

	%time = $Adventure::RayDelTime; //use global Raycast Delete Time variable's value
	cancel(%client.DelDebug[%data]); //cancel Debug Object kill
	%client.DelDebug[%data] = schedule(%time,0,HataShapeDelete,%clDbg,%client@".DelDebug\["@ %data @"\]"); //schedule Debug Object kill (so it deletes itself if something goes wrong)

	%message = "<font:impact:30><just:center>\c5Debug Raycast: \c3" SPC %name @ "<br><color:CCCCCC>" @ %start @ "<br>\c6" @ %end; //Centerprint Message
	if(%message !$= %client.lastPrint && !%client.justUpdatedPrint) //if message is new, and message was not just updated
	{
		if($Adventure::DebugCenter) //if Pref: Centerprint on
			centerPrint(%client,%message,5); //update centerPrint
		%client.justUpdatedPrint = true; //prevent centerprint spam updating
		schedule(50,0,eval,%client@".justUpdatedPrint = false;"); //allow centerprint again timeout
	}
	%client.lastPrint = %message; //save last message
}


//////////////////////
//Box Check Debugger//
//////////////////////

//Box Check Debug Update
function BoxCheckDebugUpdate(%player,%start,%width,%height,%name,%color)
{
	%client = %player.client; //define client from player
	if(!$Adventure::DebugBox) //if Pref: Debug off
		return; //Stop here

	%name = %name $= "" ? "basic" : %name; //if name undefined - set it "basic", else - keep it as defined
	
	%data = strReplace(%name," ",""); //delete spaces for proper datablock name
	%data = strReplace(%data,"[","I"); //replace brackets with I's
	%data = strReplace(%data,"]","I"); //..

//	talk("box debug called");
	if(%client.DebugBox[%data]) //if Box just updated
		return; //stop here

	// %timeout = 25; //timeout value for Box debug update
	// %client.DebugBox[%data] = true; //note we just spawned a Box
	// schedule(%timeout,0,eval,%client@".DebugBox\["@ %data @"\] = false;"); //timeout before Box can be updated

//	talk("Debug Box:  Name =" SPC %name);
//	talk("Debug Box:  Color =" SPC %color);
	%color = getWord(%color,3) $= "" ? %color SPC 0.5 : %color; //make color solid (not translucent)
//	%color = "1 0 0 1"; //make color solid (not translucent
	%clDbg = %client.BoxDebug[%data]; //Box Check Debugger object
	if(!isObject(%clDbg)) //if Debug object DNE
	{
		%clDbg = HataMovableShapeCreate(HataDebugPlateData); //create object
		%client.BoxDebug[%data] = %clDbg; //Store shape to client
	}
//	talk("Debug Box Data =" SPC %data);

	%clDbg.setNodeColor("ALL",%color); //set shape's color
	%clDbg.setTransform(%start); //move it to the correct position, and rotate it
	%clDbg.setScale(%width*20 SPC %width*20 SPC %height);
//	talk("Debug Box pos =" SPC %clDbg.getPosition());
//	talk("Player pos =" SPC %player.getPosition());
	
	%time = strStr(%data,"ClimbCheck") == -1 ? $Adventure::BoxDelTime : 2; //use global Raycast Delete Time variable's value
	cancel(%client.DelDebug[%data]); //cancel Debug Object kill
	%client.DelDebug[%data] = schedule(%time,0,HataShapeDelete,%clDbg,%client@".DelDebug\["@ %data @"\]"); //schedule Debug Object kill (so it deletes itself if something goes wrong)
}