/////////////////
//Miscellaneous//
/////////////////

//Restore Main Datablock
function AdventureRestoreMainDatablock(%player,%onRelease)
{
	if(%player.getState() $= "Dead") //if player is dead
		return; //stop here
	%data = %player.getDatablock();
	if((%data.canNoJump || %data.canNoMove) && %data.getName() !$= "PlayerAdventureSmartDrop") //if (player data 'can No-Jump', or player data 'can No-Move'), and 'data' is not 'Smart Drop'
	{
		if(%player.client.KeyActionJump) //if player is holding the Jump key
			%player.AdvRestoreOnRelease = true; //set 'RestoreOnRelease' bool to true ('RestoreMainDatablock' will be called again on-Release of the Jump key)
		else //otherwise
		{
			if(%onRelease && %player.AdvRestoreOnRelease) //if called onRelease (arg. is a bool), and 'Restore On Release' = true
				%player.AdvRestoreOnRelease = false; //reset 'RestoreOnRelease' bool to false
			%player.changedatablock(PlayerAdventure); //change to main datablock
		}
	}
}

//Spawn Camera Reset
function AdventureSetCamLocation(%player,%camera)
{
	if(!isObject(%player) || !isObject(%camera)) //if player DNE, or camera DNE
		return; //stop here
	%hack = %player.getHackPosition(); //player's torso position
	%rot = vectorToAxis(%player.getMuzzleVector(0,true)); //get rotation from player's muzzle vector (Free Look impervious eye vector)
	%camera.AdvLastTrans = %hack SPC %rot; //save last camera transform
}

//Restore Camera & Control (from camera to player)
function AdventureCamRestore(%player,%lookVec)
{
	%client = %player.client; //player's client
	%camera = %client.camera; //client's camera
	if(!isObject(%camera) || %camera.mode !$= "Climb") //if camera DNE, or camera mode is not "Climb"
		return; //stop here
	
//	echo("Camera Restored");
//	%camVec = %camera.getForwardVector(); //camera's look vector (Note: I modified the default camera 'getForwardVector' fcn)
	%fwdVec = %player.getForwardVector(); //player's muzzle vector, args. - slot, 'override' = true 
//	%muzVec = %player.getMuzzleVector(0,true); //player's muzzle vector, args. - slot, 'override' = true 
	
	%camera.isDescentMode = false; //reset 'is Descent Mode' bool to false
	
	%client.setControlObject(%player); //set client in control of player (was Camera)
	%camera.mode = "Observer"; //change mode name to "Observer" (was "Climb")
	%camera.setFlyMode(); //set camera to Observer Mode (Fly Mode)
	
	if(%lookVec !$= "") //if 'look Vector' defined
	// {
	// //	talk("fancy true");
		commandToClient(%client,'hataForceAim',%lookVec,%fwdVec); //set player look vector to match camera look vector
	// }
}


//////////////
//Climb Tool//
//////////////

//Adventure Pre-Climb Tool
function AdventurePreSpawnClimbTool(%player,%pos,%dir,%time,%suffix)
{
	//Define Client
	%client = %player.client; //player's client

	//Position Calculations
	%rot = vectorToAxis(%dir); //Shape rotation (from vector)
	
	%z = -0.11; //under player offset ('pos' must = 'player.getPosition()') //was -0.11
	%z = %suffix $= "up" ? (1.325 + 0.15) : %z; //if suffix = "up" - use above player 'z' value ('pos' must = 'posA'), else - keep last 'z'
	%zAd = vectorAdd(%pos,"0 0" SPC %z);  //downward offset
	%fwd = vectorScale(%dir,0.4); //forward offset
	%off = vectorAdd(%fwd,%zAd); //combined offset

	%toolScl = "0.4 0.2 0.1"; //Climb tool scale
	%toolScl = %suffix $= "up" ? "0.01 0.01 0.1" : %toolScl; //if suffix = "up" - use a tiny shape scale, else - keep last scale
	%showScl = (40*getWord(%toolScl,0)) SPC (40*getWord(%toolScl,1)) SPC (1*getWord(%toolScl,2)); //Climb tool display scale (calculated)
	AdventureSpawnClimbTool(%client,"%client.AdvTool" @ %suffix,HataHiddenCubeData,%off SPC %rot,%toolScl,%time); //spawn hidden Climb Tool static shape
	if($Adventure::DebugTool) //if Pref: Debug-Tool on
		AdventureSpawnClimbTool(%client,"%client.AdvShow" @ %suffix,HataDebugPlateData,%off SPC %rot,%showScl,%time,"0 1 1 1"); //spawn Visible Climb Tool static shape
}
//Adventure Climb Tool Actual
function AdventureSpawnClimbTool(%client,%name,%data,%tra,%scale,%time,%color)
{
	%fname = strReplace(%name,"%client",%client); //fixed name (with working client)
	eval("%shape = "@%fname@";"); //e.g. "%shape = %client.AdvTool;"
	if(!isObject(%shape)) //if shape DNE
	{
		//Make new shape
		%shape = HataMovableShapeCreate(%data,%color); //spawn Climb Tool shape
		%shape.setScale(%scale); //set its scale (looks like a 1x2x1 Plate)
		eval(strReplace(%name,"%client",%client)@" = "@%shape@";"); //e.g. "%client.AdvTool = %shape;"
	}

	%shape.setTransform(%tra); //move it to the correct position, and rotate it

	%delName = strReplace(%name,"%client.","");
	cancel(%client.Del[%delName]); //cancel Climb Tool delete
	if(%time > 0) //if type undefined
		eval(%client @ ".Del\[" @ %delName @ "\] = schedule(" @ %time @ ",0,HataShapeDelete," @ %shape @ ",\"" @ %client @ ".Del\[" @ %delName @ "\]\");"); //schedule Climb Tool delete (so it deletes itself if something goes wrong)
}

//Spawn Static Shape
function HataMovableShapeCreate(%data,%color)
{
	%shape = new StaticShape() //create Debug Object object
	{
		dataBlock = %data; //shape file
		type = ClimbHelper; //a note for easy exemption from StaticShapeObjectType searches
	};MissionCleanup.add(%shape); //Mission Editor hook
	
	if(%color !$= "") //if color is defined
		%shape.setNodeColor("ALL",%color); //set shape's color
	return %shape; //return shape object
}
//Delete Static Shape
function HataShapeDelete(%shape,%name)
{
	if(%name !$= "") //if name defined
		eval(%name @ " = \"\";"); //undefine it (remove schedule from client)
	if(isObject(%shape)) //if shape exists
		%shape.delete(); //delete it
}