//by munk & Hata

//Regular Footsteps
datablock AudioProfile(foot_boot1)
{
	fileName = "./sounds/sn_walk_conc_4.wav";
	description = AudioClosest3d;
	preload = false;
};
datablock AudioProfile(foot_boot2)
{
	fileName = "./sounds/sn_walk_conc_3.wav";
	description = AudioClosest3d;
	preload = false;
};
datablock AudioProfile(foot_boot3)
{
	fileName = "./sounds/sn_walk_conc_2.wav";
	description = AudioClosest3d;
	preload = false;
};
datablock AudioProfile(foot_boot4)
{
	fileName = "./sounds/sn_walk_conc_1.wav";
	description = AudioClosest3d;
	preload = false;
};

//Quiet Footsteps
datablock AudioProfile(foot_quiet1)
{
	fileName = "./sounds/walkQuiet1.wav";
	description = AudioClosest3d;
	preload = false;
};
datablock AudioProfile(foot_quiet2)
{
	fileName = "./sounds/walkQuiet2.wav";
	description = AudioClosest3d;
	preload = false;
};
datablock AudioProfile(foot_quiet3)
{
	fileName = "./sounds/walkQuiet3.wav";
	description = AudioClosest3d;
	preload = false;
};
datablock AudioProfile(foot_quiet4)
{
	fileName = "./sounds/walkQuiet4.wav";
	description = AudioClosest3d;
	preload = false;
};

//Underwater Check
package Swimming
{
	function Armor::onEnterLiquid(%data,%obj,%coverage,%type)
	{
		Parent::onEnterLiquid(%data,%obj,%coverage,%type);
		%obj.isSwimming = true; //note when underwater
	}
	function Armor::onLeaveLiquid(%data,%obj,%coverage,%type)
	{
		Parent::onLeaveLiquid(%data,%obj,%coverage,%type);
		%obj.isSwimming = false; //note when out of water
	}
};activatepackage(Swimming);

package Footsteps
{
	function Armor::onAdd(%data,%obj)
	{
		Parent::onAdd(%data,%obj);
		HataFootstepLoop(%obj); //start on first spawn
	}
	function Armor::onTrigger(%data,%obj,%slot,%val)
	{
		Parent::onTrigger(%data,%obj,%slot,%val);
		if(%slot == 3)
			%obj.isStepProning = %val; //crouching
		if(%slot == 4 && %data.canJet)
			%obj.isStepJetting = %val; //jetting
	}
};activatepackage(Footsteps);


function HataFootstepLoop(%obj)
{
	if(!isObject(%obj)) //if no player object
		return;
	%data = %obj.getDatablock();
	%model = fileName(%data.shapeFile);
	if(%model !$= "m.dts" || %obj.getState() $= "Dead") //if dead or not a Blockhead model
		return;
	cancel(%obj.HFsL); //don't double schedule
	%obj.HFsL = schedule(320,0,HataFootstepLoop,%obj); //schedule next footstep

	%pos = %obj.getPosition();
	%xyP = getWords(%pos,0,1); //horizontal position
	%vel = %obj.getVelocity();
	%isGround = FootPlaceCheck(%obj); //check for solid ground
	if(%obj.lastXY $= %xyP || %obj.isStepProning || !%isGround || %obj.isSwimming || %obj.isStepJetting) //if hasn't moved, or is crouching, or is midair, or is swimming, or is jetting
	{
		cancel(%obj.HFsL); //don't double schedule
		%obj.HFsL = schedule(50,0,HataFootstepLoop,%obj); //schedule another movement check, with less timeout
	}
	else if(!isObject(%obj.getObjectMount())) //otherwise, if not in a vehicle
	{
		//echo("diff position");
		if(mAbs(getWord(%vel,0)) < 3 && mAbs(getWord(%vel,1)) < 3) //if moving slowly
			playHataFootstep(%obj,1); //play quiet footstep sfx
		else //otherwise
			playHataFootstep(%obj,2); //play regular footstep sfx
		%obj.lastXY = %xyP; //set last horizontal position
	}
}
function playHataFootstep(%obj,%type)
{
	%pos = %obj.getPosition();
	%random = getRandom(0,3);
	if(%type == 1)
		%sound = "foot_quiet"@%random+1;
	else
		%sound = "foot_boot"@%random+1;
	serverplay3d(%sound,%pos);
}

function FootPlaceCheck(%obj)
{
	%pos0 = %obj.getPosition();
	%pos1 = vectorAdd(%pos0,"0 0 0.5");
	for(%a=0;%a<2;%a++) //ensure he's not stuck in the ground, with 2 checks
	{
		initContainerBoxSearch(%pos[%a], "1.25 1.25 0.1", $TypeMasks::fxBrickObjectType|$Typemasks::TerrainObjectType);
		%col[%a] = containerSearchNext();
	}
	return isObject(%col0) && %col0 != %col1; //if on the ground, and ground is not overlapping him
}