//Command Menu Image
datablock ShapeBaseImageData(KingdomMenuImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;
	mountPoint = 0;
	className = "WeaponImage";
	canKingdom = true;

	stateName[0] = "Ready";
};
function KingdomMenuImage::onMount(%this,%obj,%slot)
{
	Parent::onMount(%this,%obj,%slot);
	%obj.playthread(1,root);
}


//Magic Emitter
datablock ParticleData(KingdomMagicParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -1;
	inheritedVelFactor   = 0.2;
	lifetimeMS           = 400;
	lifetimeVarianceMS   = 200;
	textureName          = "base/data/particles/cloud";
	spinSpeed			= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0 0.1 1 0.4";
	colors[1]     = "0 1 1 0";
	sizes[0]      = 0.2;
	sizes[1]      = 0.1;

	useInvAlpha = true;
};
datablock ParticleEmitterData(KingdomMagicEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 1;
   velocityVariance = 1;
   overrideAdvance = false;
   particles = "KingdomMagicParticle";
};

//Magic Image
datablock ShapeBaseImageData(KingdomMagicImage : KingdomMenuImage)
{
//	armReady = true;

	stateName[0]                    = "Ready";
	stateTransitionOnTimeout[0]		= "Ready";
	stateTimeoutValue[0]			= 0.2;
	stateEmitter[0]					= KingdomMagicEmitter;
	stateEmitterTime[0]				= 0.3;
};
function KingdomMagicImage::onMount(%this,%obj,%slot)
{
	Parent::onMount(%this,%obj,%slot);
	%obj.playthread(1,armreadyright);
}





//Command Menu Bricks - Main
datablock fxDTSBrickData(KingdomBrickSlot1 : brick1x1Data) //Magic
{
	category = "";
	subCategory = "";
	uiName = "Magic ";
	iconName = "base/client/ui/itemicons/wand";
	canKingdom = true;
	isMain = true;
};
datablock fxDTSBrickData(KingdomBrickSlot2 : KingdomBrickSlot1) //Items
{
	uiName = "Items ";
	iconName = "add-ons/system_kingdomhearts/potion";
};
datablock fxDTSBrickData(KingdomBrickSlot3 : KingdomBrickSlot1) //Weapons
{
	uiName = "Weapons ";
	iconName = "add-ons/weapon_gun/icon_gun";
};
datablock fxDTSBrickData(KingdomBrickSlot6 : KingdomBrickSlot1) //Break
{
	uiName = "Break ";
	iconName = "add-ons/system_kingdomhearts/break5";
};

//Command Menu Bricks - Magic
datablock fxDTSBrickData(KingdomBrickSlot1B : KingdomBrickSlot1)
{
	uiName = "Fire ";
	canKMagic = true;
	isMain = false;
};
datablock fxDTSBrickData(KingdomBrickSlot1C : KingdomBrickSlot1B)
{
	uiName = "Blizzard ";
};
datablock fxDTSBrickData(KingdomBrickSlot1D : KingdomBrickSlot1B)
{
	uiName = "Gravity ";
};
datablock fxDTSBrickData(KingdomBrickSlot1E : KingdomBrickSlot1B)
{
	uiName = "Stop ";
};
datablock fxDTSBrickData(KingdomBrickSlot1F : KingdomBrickSlot1B)
{
	uiName = "Magnet ";
};
datablock fxDTSBrickData(KingdomBrickSlot1G : KingdomBrickSlot1B)
{
	uiName = "Aero ";
};
datablock fxDTSBrickData(KingdomBrickSlot1H : KingdomBrickSlot1B)
{
	uiName = "Cure ";
};

//Command Menu Bricks - Items
datablock fxDTSBrickData(KingdomBrickSlot2B : KingdomBrickSlot2)
{
	uiName = "Potion ";
	canKUse = true;
	isMain = false;
};
datablock fxDTSBrickData(KingdomBrickSlot2C : KingdomBrickSlot2B)
{
	uiName = "Mega Potion ";
};
datablock fxDTSBrickData(KingdomBrickSlot2D : KingdomBrickSlot2B)
{
	uiName = "Elixir ";
};
datablock fxDTSBrickData(KingdomBrickSlot2E : KingdomBrickSlot2B)
{
	uiName = "Ether ";
};
datablock fxDTSBrickData(KingdomBrickSlot2F : KingdomBrickSlot2B)
{
	uiName = "Mega Ether ";
};

//Command Menu Bricks - Players
datablock fxDTSBrickData(KingdomBrickSlot4B : KingdomBrickSlot1B) //Magic
{
	uiName = "Self ";
	canKPlayer = true;
};
datablock fxDTSBrickData(KingdomBrickSlot4C : KingdomBrickSlot4B)
{
	uiName = "Friend ";
};
datablock fxDTSBrickData(KingdomBrickSlot5B : KingdomBrickSlot2B) //Items
{
	uiName = "Self ";
	canKPlayer = true;
};
datablock fxDTSBrickData(KingdomBrickSlot5C : KingdomBrickSlot5B)
{
	uiName = "Friend ";
};

//Command Menu Keyblade
datablock fxDTSBrickData(KeybladeBrick : KingdomBrickSlot1) //Keyblade
{
	uiName = "Keyblade ";
	iconName = "add-ons/weapon_keyblade/icon_keyblade";
};