//Sounds
datablock AudioProfile(GrapReelPartA)
{
	fileName = "./ReelPartA.wav";
	description = AudioClosest3d;
	preload = true;
};
datablock AudioProfile(GrapReelPartB)
{
	fileName = "./ReelPartB.wav";
	description = AudioClosest3d;
	preload = true;
};
datablock AudioProfile(GrapReelPartC)
{
	fileName = "./ReelPartC.wav";
	description = AudioClosest3d;
	preload = true;
};
datablock AudioProfile(GrapReelPartD)
{
	fileName = "./ReelPartD.wav";
	description = AudioClosest3d;
	preload = true;
};
datablock AudioProfile(GrapReelPartE)
{
	fileName = "./ReelPartE.wav";
	description = AudioClosest3d;
	preload = true;
};


//Rope shape
datablock StaticShapeData(HataCylinder2Shape)
{
	shapeFile = "./hatacyl2.dts";
};


//Hand Emitter - Pull
datablock ParticleData(GrapHookPullParticle)
{
	dragCoefficient      = 20;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	lifetimeMS           = 400;
	lifetimeVarianceMS   = 200;
	textureName          = "base/data/particles/thinring";
	spinSpeed			= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "1 0.3 0.2 0.5";
	colors[1]     = "1 0 0 0";
	sizes[0]      = 0.3;
	sizes[1]      = 0.5;

	useInvAlpha = true;
};
datablock ParticleEmitterData(GrapHookPullEmitter)
{
	ejectionPeriodMS = 20;
	periodVarianceMS = 0;
	ejectionVelocity = 2;
	velocityVariance = 1;
	overrideAdvance = false;
	particles = "GrapHookPullParticle";
};

//Hand Emitter - Hang
datablock ParticleData(GrapHookHangParticle : GrapHookPullParticle)
{
	colors[0]     = "0 0.7 1 0.5";
	colors[1]     = "0 1 1 0";
};
datablock ParticleEmitterData(GrapHookHangEmitter : GrapHookPullEmitter)
{
	particles = "GrapHookHangParticle";
};

//Hooked Emitter
datablock ParticleData(GrapHookedParticle)
{
	dragCoefficient      = 20;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0;
	lifetimeMS           = 400;
	lifetimeVarianceMS   = 200;
	textureName          = "base/data/particles/thinring";
	spinSpeed			= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "1 0.7 0.3 0.5";
	colors[1]     = "1 1 1 0";
	sizes[0]      = 0.2;
	sizes[1]      = 0;

};
datablock ParticleEmitterData(GrapHookedEmitter)
{
	ejectionPeriodMS = 20;
	periodVarianceMS = 0;
	ejectionVelocity = 0;
	velocityVariance = 0;
	overrideAdvance = false;
	particles = "GrapHookedParticle";
};


//Hook Trail Particle
datablock ParticleData(GrapplingHookTrailParticle)
{
	dragCoefficient      = 10;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 800;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/ring";
	spinSpeed			 = 0;
	colors[0]     = "1 0 0 1";
	colors[1]     = "0 1 1 0";
	sizes[0]      = 0.3;
	sizes[1]      = 0.3;
	times[0] = 0;
	times[1] = 1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(GrapplingHookTrailEmitter)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 1;
	velocityVariance = 1;
	particles = "GrapplingHookTrailParticle";

	uiName = "";
};
//Hook Pull Trail
datablock ParticleData(GrapplingHookPullTrailParticle : GrapplingHookTrailParticle)
{
	colors[0]     = "0 1 1 0";
	colors[1]     = "1 0 0 1";
};
datablock ParticleEmitterData(GrapplingHookPullTrailEmitter : GrapplingHookTrailEmitter)
{
	particles = "GrapplingHookPullTrailParticle";
};

//Hit Explosion
datablock ExplosionData(GrapplingHookExplosion : HammerExplosion)
{
	soundProfile = hammerhitsound;
};
//Hit Explosion Projectile
datablock ProjectileData(GrapplingHookHitProjectile)
{
	explosion     = GrapplingHookExplosion;
};

//Hook Projectile
datablock ProjectileData(GrapplingHookProjectile)
{
	projectileShapeName = "add-ons/weapon_bow/arrow.dts";
	directDamage        = 0;
	particleEmitter     = GrapplingHookTrailEmitter;
	explodeOnDeath		= true;

	muzzleVelocity      = 200; //was 100
	velInheritFactor    = 0;

	armingDelay         = 0;
	lifetime            = 300;
	fadeDelay           = 300;
	gravityMod 			= 0.0;
	isBallistic         = false;

	isGrapplingHook		= true;
	uiName = "";
};
//Hook Pull Projectile
datablock ProjectileData(GrapplingHookPullProjectile : GrapplingHookProjectile)
{
	particleEmitter     = GrapplingHookPullTrailEmitter;
};



//Item
datablock ItemData(GrapplingHookItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	//Basic Item Properties
	shapeFile = "add-ons/weapon_bow/bow.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//Gui stuff
	uiName = "Grapple Hook";
	iconName = "add-ons/weapon_bow/icon_bow";
	doColorShift = true;
	colorShiftColor = "1 0.3 0.2 1";

	image = GrapplingHookSwitchImage;
	canDrop = true;
};


//Switch Image
datablock ShapeBaseImageData(GrapplingHookSwitchImage)
{
	shapeFile = "add-ons/weapon_gun/pistol.dts"; //weapon model
	offset = "-0.2 -0.7 0.1"; //3D offset
	rotation = eulerToMatrix("0 90 0"); //3D Rotation
	eyeOffset = "0.6 0.7 -0.4"; //First person offset
	eyeRotation = eulerToMatrix("0 0 0"); //First person rotation

	colorShiftColor = "0.2 0.2 0.2 1"; //define color
	doColorShift = true; //set color

	mountPoint = 0; //hold in right hand
	emap = true;

	className = "WeaponImage";
	item = GrapplingHookItem;
	isGrapplingHook = true;

	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.4;
};

//Ready Image (cannot shoot)
datablock ShapeBaseImageData(GrapplingHookReadyImage : GrapplingHookSwitchImage)
{
	stateTransitionOnTimeout[0]     = "Ready";
	
	stateName[1]                    = "Ready";
	stateScript[1]					= "onReady";
	stateTransitionOnTimeout[1]		= "Ready";
	stateTimeoutValue[1]			= 0.2;
	stateWaitForTimeout[1]			= false;
	stateEmitterTime[1]				= 0.3;
};
//Main Image (hang)
datablock ShapeBaseImageData(GrapplingHookImage : GrapplingHookReadyImage)
{
	stateTransitionOnTriggerDown[1] = "Fire";
	stateEmitter[1]					= GrapHookHangEmitter; //emitter

	stateName[2]                    = "Fire";
	statetimeoutValue[2]			= 1.0;
	stateScript[2]					= "onFire";
	stateTransitionOnTimeout[2]		= "Ready";
	stateWaitForTimeout[2]			= false;
	stateEmitterTime[2]				= 1.1;
	stateEmitter[2]					= GrapHookHangEmitter; //emitter
};
//Main Image (pull)
datablock ShapeBaseImageData(GrapplingHookPullImage : GrapplingHookImage)
{
	stateEmitter[1]	= GrapHookPullEmitter; //emitters
	stateEmitter[2]	= GrapHookPullEmitter; //
};

//Pull Image - Grappling
datablock ShapeBaseImageData(GrapHookPullImage : GrapplingHookReadyImage)
{
	colorShiftColor = "1 0 0 1"; //define color
	stateEmitter[1]	= GrapHookedEmitter; //emitters
};
//Left-handed Pull
datablock ShapeBaseImageData(GrapHookPullLeftImage : GrapHookPullImage)
{
	mountPoint = 1; //hold in left hand
	shapeFile = "add-ons/weapon_gun/pistol.dts"; //weapon model
	offset = "0.2 -0.7 0.1"; //3D offset
	rotation = eulerToMatrix("0 -90 0"); //3D Rotation
	eyeOffset = "-0.6 0.7 -0.4"; //First person offset
	eyeRotation = eulerToMatrix("0 0 0"); //First person rotation
	isGrapplingHook = false; //Do not apply "isGrapplingHook" properties
	isGrapHookLeft = true; //is left-handed Grapple
};

//Hang Image - Grappling
datablock ShapeBaseImageData(GrapHookHangImage : GrapplingHookReadyImage)
{
	colorShiftColor = "0 0.5 1 1"; //define color
	stateEmitter[1]	= GrapHookedEmitter; //emitters
};
//Left-handed Hang
datablock ShapeBaseImageData(GrapHookHangLeftImage : GrapHookPullLeftImage)
{
	colorShiftColor = "0 0.5 1 1"; //define color
	stateEmitter[1]	= GrapHookedEmitter; //emitters
};

//Mounting
function GrapplingHookSwitchImage::onMount(%this,%obj,%slot)
{
	Parent::onMount(%this,%obj,%slot);
	if(!%obj.isHookGrappling) //if not already Grappling
		%obj.playthread(1,armreadyright); //raise right hand
	schedule(1,0,GrapplingHookMode,%obj,%this); //set correct mode
	GrapplingHookPaintToggle(%obj,true); //disable paint (true means force it)
}


//Throw the Hook
function GrapplingHookImage::onFire(%this,%obj,%slot)
{
	GrapplingHookToggle(%obj,%this,true); //true means onFire
}
function GrapplingHookPullImage::onFire(%this,%obj,%slot)
{
	GrapplingHookToggle(%obj,%this,true); //true means onFire
}



//Grappling Hook Global Silent Loop
function GrapplingHookGlobalSilentLoop()
{
	cancel($GrapplingHook::SilentSchedule); //don't multi-schedule
	for(%i=0;%i<$GrappleList.getCount();%i++)
	{
		%obj = $GrappleList.getObject(%i); //search within GrappleList
		if(!isObject(%obj) || %obj.getState() $= "Dead") //if nonexistent or dead
			continue; //skip
		%wep = %obj.getMountedImage(0); //right hand weapon
		if((!isObject(%wep) || !%wep.isGrapplingHook) && !%obj.isHookGrappling) //if no weapon, wrong weapon, and not Grappling
		{
			$GrappleList.remove(%obj); //Remove Player/Bot
			continue; //skip
		}
		if(%obj.isHookGrappling && (!%obj.isGrapClicking || !%wep.isGrapplingHook) && !$Pref::GrapplingHook::canToggle) //if Grappling, and not clicking/wrong wep, and Pref: Toggle off
			GrapplingHookRelease(%obj); //unhook
		else if(%obj.isGrapDualTethering) //if tethering, run alternate loop
			GrapplingHookTetherLoop(%obj); //run Tether loop
		else //otherwise
			GrapplingHookHangLoop(%obj); //run normal Grapple loop
		%isGrapplingHooker = true; //there is at least 1 Grappler
	}

	if(%isGrapplingHooker) //if there is a Grappler
	{
		$GrapplingHook::SilentSchedule = scheduleNoQuota(10,0,GrapplingHookGlobalSilentLoop); //continue loop
		$GrapplingHook::SilentStarted = true; //note that the loop is running
	}
	else //if no Grappler, loop will not repeat
		$GrapplingHook::SilentStarted = false; //note that the loop is stopped
}


//Check Grapple Mode (Pull or Hang)
function GrapplingHookMode(%obj,%image)
{
	%client = %obj.client; //define %client
	%newIm = GrapplingHookImage; //use Main Image
	%wep = %obj.getMountedImage(0); //right hand weapon
	if(%obj.isHookGrappling) //if Grappling
	{
		if(GrapplePullModeCheck(%obj)) //If Pull mode verified
			%newIm = GrapHookPullImage; //switch to Pull image
		else 
			%newIm = GrapHookHangImage; //new Image, Hang mode by default
	}
	else if(GrapplePullModeCheck(%obj)) //if not Grappling, and Pull mode verified
		%newIm = GrapplingHookPullImage; //use Main Image (Pull version)
	if(isObject(%wep) && %wep == %image) //if right hand weapon exists, and it is the right Image
		%obj.mountImage(%newIm,0); //do the switch
}

//Toggle the Grapple (Hook or Release)
function GrapplingHookToggle(%obj,%image,%onFire)
{
	if($Pref::GrapplingHook::canToggle) //if toggling enabled
	{
		if(%obj.hasGrapplingHookFired || %onFire) //if just fired, or onFire
			return; //stop
		%client = %obj.client; //define %client
		%time = 400; //E Fire timeout (Activate-Stuff via Paint key)
		if(GrapplePullModeCheck(%obj)) //If Pull mode verified
			%time = 1000; //longer timeout when in Pull mode
		%obj.hasGrapplingHookFired = true; //note that we just threw the hook
		schedule(%time,0,eval,%obj@".hasGrapplingHookFired = false;"); //set timeout for next throw
	}
	else if(!$Pref::GrapplingHook::canToggle && !%onFire) //if Pref: Toggle off, and not onFire (pressed E)
		return; //stop
	if(!%obj.isHookGrappling) //if not Grappling (not hooked to anything)
		GrapplingHookFire(%obj,%image,GrapplePullModeCheck(%obj)); //Throw out Grappling Hook
	else if($Pref::GrapplingHook::canToggle) //if Grappling, and Pref: Toggle on
		GrapplingHookRelease(%obj); //unhook
}

//Throw initial Grappling Hook
function GrapplingHookFire(%obj,%image,%PullMode)
{
	%obj.playthread(2,shiftright); //anim
	%projectile = GrapplingHookProjectile; //use Hang projectile
	if(%PullMode) //if in Pull mode
		%projectile = GrapplingHookPullProjectile; //use Pull projectile (inverted trail color pattern)
	%speed = %projectile.muzzleVelocity; //muzzle vel
	%muzzle = %obj.getMuzzlePoint(0); //muzzle point
	%vector = %obj.getMuzzleVector(0); //muzzle vector
	%velocity = vectorScale(%vector,%speed); //calculated initial projectile vel
	%p = new (Projectile)() //create new projectile object
	{
		dataBlock = %projectile; //set projectile
		initialVelocity = %velocity; //set velocity
		initialPosition = %muzzle; //set position
		sourceObject = %obj;
		client = %obj.client;
	};MissionCleanup.add(%p); //Mission Editor hook
	%obj.isHookGrappling = false; //set Grappling to off
	%obj.hasGrapHookFired = true; //note that we fired the hook
}

//Return Grappling Hook
function GrapplingHookRelease(%obj,%silent)
{
	%wep = %obj.getMountedImage(0); //right hand Image
	%left = %obj.getMountedImage(1); //left hand Image
	if(isObject(%wep) && (%wep.getName() $= "GrapHookPullImage" || %wep.getName() $= "GrapHookHangImage")) //if Image exists, and is Pull or Hang Image
		%obj.mountImage(GrapplingHookSwitchImage,0); //restore normal Grappling Hook Image (after unhook, or missed throw)
	if(%obj.isHookGrappling && !%silent) //if Grappling, and silent release is off
		serverPlay3D(wrenchmisssound,%obj.getMuzzlePoint(0)); //play sound
	%obj.hasGrapHookFired = false; //note that hook is returned
	%obj.isHookGrappling = false; //set Grappling to off 
	%obj.isGrapDualTethering = false; //set dual-tethering to off
	%obj.isGrapSuperReeling = false; //reset Super Reeling to off
	%obj.GrapplingHookPos = ""; //remove saved pos
	if(isObject(%left) && %left.isGrapHookLeft) //if Image in left hand, and it is the left-handed Grapple Hook
		%obj.unmountImage(1); //unmount it
	if((%col = %obj.GrapplingHookTarget).GrapplingHookedBy $= %obj) //if we are the hooker
		%col.GrapplingHookedBy = ""; //remove saved hooker
	%obj.GrapplingHookTarget = 0; //remove saved target
	%obj.GrapplingHookTether = 0; //remove saved tether
	GrapplingHookAnim(%obj,false); //stop left hand anim
	GrapplingHookRopeKill(%obj.GHRope); //instakill rope
	cancel(%obj.GHRopeKill); //cancel rope kill schedule
	if(!isObject(%wep) || !%wep.isGrapplingHook) //if no weapon or wrong weapon
		%obj.playthread(3,root); //drop left hand
}

//Latch onto object
function GrapplingHookLatchOn(%obj,%col,%pos)
{
	%client = %obj.client; //define %client
	%obj.GrapplingHookPos = ""; //reset
	%obj.GrapplingHookTarget = 0; //reset
	%obj.GrapplingHookTether = 0; //reset
	%cGrap = %col.GrapplingHookedBy; //Player that is Grappling %col
	if(GrapplePullModeCheck(%obj) && isObject(%cGrap) && GrapplePullModeCheck(%cGrap) && %cGrap != %obj) //if our Pull mode is verified, and col is Grappled by someone, and their Pull mode is verified, and "someone" is not us
		return;
	if(%col.getType() & $Typemasks::PlayerObjectType || %col.getType() & $Typemasks::VehicleObjectType) //if %col is a Player/Bot or Vehicle
	{
		if((!miniGameCanDamage(%obj,%col) || !isObject(%client.minigame)) && $Pref::GrapplingHook::Minigame) //if (%obj can't damage %col, or minigame doesn't exist), and Pref: Minigame on
			return; //stop
		//Save grappling offset
		%sub = vectorSub(%pos,%obj.getHackPosition()); //vector from %obj's torso to the hit position
		%nrm = vectorNormalize(%sub); //make sub's magnitude equal to 1
		%vec = vectorScale(%nrm,0.1); //scale normalized sub to desired length
		%pos = vectorAdd(%pos,%vec); //add %vec adjustment to hit position
		%tra = %col.getTransform(); //col transform
		%mat = setWord(%tra,6, -getWord(%tra,6)); //Zeblote matrix math
		%col.GrappedOffset[%obj] = matrixMulVector(%mat,vectorSub(%pos,%col.getPosition()));
		%obj.GrapplingHookTarget = %col; //save %col
		if(!isObject(%col.GrapplingHookedBy)) //if there is no saved hooker
			%col.GrapplingHookedBy = %obj; //set us as the hooker
	}
	else if(GrapplePullModeCheck(%obj)) //otherwise if Pull Mode verified
		return; //stop
	else //hang from stationary object
		%obj.GrapplingHookPos = %pos; //set hook point
	%obj.isHookGrappling = true; //set Grappling to true
	%obj.isHookGrappleStart = true; //set first grapple to true
	%obj.isGrapDualTethering = false; //set dual-tethering to false
	schedule(30,0,eval,%obj@".isHookGrappleStart = false;"); //timeout Grapple start
	$GrappleList.add(%obj); //Grappled players list
	if(!$GrapplingHook::SilentStarted) //if not Silent Looping
		schedule(10,0,GrapplingHookGlobalSilentLoop); //start loop
	GrapplingHookMode(%obj,%obj.getMountedImage(0)); //switch to correct Image
	serverPlay3D(hammerhitsound,%obj.getMuzzlePoint(0)); //latch on sound
}

//Dual-tethering
function GrapplingHookTetherCheck(%obj)
{
	%wep = %obj.getMountedImage(0); //right hand weapon
	if(!isObject(%wep) || !%wep.isGrapplingHook) //if no weapon, or wrong weapon, or no client
		return; //stop
	if(GrapplePullModeCheck(%obj) && %obj.isHookGrappling) //if Pull mode verified, and Grappling
	{
		if(!%obj.isGrapDualTethering) //if not dual-tethering
			GrapplingHookTetherShoot(%obj,%wep); //Shoot second tether
	}
}
//Shoot out second Tether
function GrapplingHookTetherShoot(%obj,%wep)
{
	if(%obj.hasGrapTetherFired) //if just fired tether
		return; //stop

	%obj.playthread(2,shiftleft); //anim

	%len = $Pref::GrapplingHook::TetherMax; //max length of Raycast (30 by default)
	%eye = %obj.getMuzzlePoint(0); //eye point
	%vec = %obj.getMuzzleVector(0); //eye vector
	%col = GrapplingHookRaycast(%obj,%len,%eye,%vec); //fire raycast to second object
	if(%col != 0) //if col found (Raycast function returns 0 if nothing found)
	{
		if(%col.getType() & $Typemasks::PlayerObjectType && (!miniGameCanDamage(%obj,%col) || !isObject(%obj.client.minigame)) && $Pref::GrapplingHook::Minigame) //if (%obj can't damage %col, or minigame doesn't exist), and Pref: Minigame on
			return; //stop
		%obj.GrapplingHookTether = %col; //save Tether object
		%obj.lastColAType = %obj.GrapplingHookTarget.getType(); //set lastColAType to Target's the first time
		%obj.lastColBType = %col.getType(); //set lastColBType to %col's the first time
		%obj.isGrapDualTethering = true; //set dual-tethering to true
		%pos = %col.GrapTetherPos; //pull hit pos from %col object
		GrapplingHookFX(%obj,GrapplingHookHitProjectile,%pos,%vec,1); //fake hit explosion
		serverPlay3D(hammerhitsound,%obj.getMuzzlePoint(0)); //latch on sound
		return; //stop
	}

	%time = 400; //Tether miss timeout
	%obj.hasGrapTetherFired = true; //disable tethering until timeout ends
	schedule(%time,0,eval,%obj@".hasGrapTetherFired = false;"); //timeout tether
}

//Slam tethered objects together
function GrapTetherSlam(%obj,%colA,%colB,%hack,%pos)
{
	if(isObject(%colB) && (%colB.getType() & $Typemasks::PlayerObjectType || %colB.getType() & $Typemasks::VehicleObjectType)) //if colB found
	{
		if(isObject(%mountB = %colB.getObjectMount())) //If colB is in a vehicle
			%colB = %mountB; //use vehicle object
		%both = true; //retract both colA and colB (colB is not stationary)
	}
	if(isObject(%mountA = %colA.getObjectMount())) //If colA is in a vehicle
		%colA = %mountA; //use vehicle object

	%min = 4; //extend min length (to prevent glitching)
	if(%obj.HookGrappleLength < %min) //if rope length shorter than safe length
	{
		GrapplingHookRelease(%obj); //do tether release
		return; //stop
	}
	%sub = vectorSub(%pos,%hack); //vec from colA to colB
	%nrm = vectorNormalize(%sub); //direction
	%add = vectorScale(%nrm,40); //make pull stronger
	%inv = vectorScale(%add,-1); //vec from colB to colA
	%colA.setVelocity(%add); //slam colB and colA together
	if(%both) //if colB is movable
		%colB.setVelocity(%inv); //slam it too
	GrappleHookReelAudio(%obj,true); //do Reeling sound effects (force max speed sound)
}


//Hang/Pull loop
function GrapplingHookHangLoop(%obj)
{
	%col = %obj.GrapplingHookTarget; //define col
	%pos = %obj.GrapplingHookPos; //define pos
	if(isObject(%col)) //if col exists, and is not dead (not a brick, or other stationary object)
	{
		if(%col.getType() & $Typemasks::PlayerObjectType && $Pref::GrapplingHook::onPlayers && %col.getState() !$= "Dead") //if col is a Player/Bot, and Pref: Player-Grappling on
		{
			%moving = true; //note nonstatic
			if(isObject(%vehicle = %col.getObjectMount())) //if col is in a vehicle
				%col = %vehicle; //use vehicle for calculations
		}
		if(%col.getType() & $Typemasks::VehicleObjectType && $Pref::GrapplingHook::onVehicles) //if col is a vehicle, and Pref: Vehicle-Grappling on
			%moving = true; //note nonstatic
		if(%moving) //if movable object
		{
			%loc = %col.getPosition(); //col's position
			%pos = vectorAdd(%loc, matrixMulVector(%col.getTransform(),%col.GrappedOffset[%obj])); //Zeblote's fancy math for finding exact hook point
		}
		if(isObject(%ride = %obj.getObjectMount()) && %ride == %col || !%moving) //if %obj is in a vehicle and Grappling to it, or Pref: Players/Vehicle-Grappling off
		{
			GrapplingHookRelease(%obj,true); //do tether release
			return; //stop
		}
	}
	else if(%pos $= "" || !%obj.isHookGrappling) //If pos undefined, or obj is not Grappling
		return; //stop
	if(%col.isHookGrappling && GrapplePullModeCheck(%obj) && !GrapplePullModeCheck(%col) || %col.GrapplingHookTarget == %obj) //if (col is Grappling, and our Pull mode verified, and %col is in Hang mode), or col is Grappling us
	{
		if(%col.GrapplingHookTarget == %obj) //if grappling each other
			GrapplingHookRelease(%col); //release col's tether
		GrapplingHookRelease(%obj); //release tether
		return; //stop
	}
	%hack = %obj.getHackPosition(); //torso
	%sub = vectorSub(%hack,%pos); //vector from torso to col
	if(%obj.isHookGrappleStart) //first time
	{
		%obj.isHookGrappleStart = false; //end Grapple Start timer immediately
		%obj.HookGrappleLength = vectorLen(%sub); //maintain rope length
		%obj.HookGrapOriginalLen = %obj.HookGrappleLength; //save inital length
		if(%obj.HookGrapOriginalLen < 8) //if too short
			%obj.HookGrapOriginalLen = 8; //save longer initial rope length
		%start = true; //first time
	}
	%wep = %obj.getMountedImage(0); //right hand weapon
	%sReel = %obj.isGrapSuperReeling && $Pref::GrapplingHook::SuperReel; //Super Reeling and Pref: Super-Reel on
	%canReel = %obj.isGrapReeling && $Pref::GrapplingHook::canReel; //Reeling and Pref: Reel on
	if((%canReel && %obj.HookGrappleLength > 2 || %sReel) && $Pref::GrapplingHook::canToggle && !%isBot && isObject(%wep) && %wep.isGrapplingHook) //if (Reeling & Pref: Reeling on & rope is not too short, or Super Reeling & Pref: Super-Reel on), and Pref: Toggle on, and %obj not a Bot, and weapon exists, and right weapon, and rope is not too short
	{
		%reelSpeed = 0.05; //Standard Reeling speed
		if($Pref::GrapplingHook::ReelAccel) //if Pref: Reel Acceration on
			%reelSpeed = 0.02*%obj.GrapReelRepeats; //multiply by number of audio loops
		if(%sReel) //if Pref: Super Reel on, and we're Super Reeling
			%reelSpeed = 0.5; //Straight Reeling speed
		%obj.HookGrappleLength = %obj.HookGrappleLength-%reelSpeed; //shorten the rope (scale it faster as you hold)
		GrappleHookReelAudio(%obj,%obj.isGrapSuperReeling); //do Reeling sound effect (force max speed sound if Super Reeling)
	}

	GrapplingHookAnim(%obj,true); //raise left hand
	GrapplingHookRopeActual(%obj,%col,%sub,%pos,%hack,GrapplePullModeCheck(%obj),%start); //Do rope
}

//Tether objects together
function GrapplingHookTetherLoop(%obj)
{
	%colA = %obj.GrapplingHookTarget; //define col A
	%colB = %obj.GrapplingHookTether; //define col B
	if(isObject(%colB)) //if colB found and is an object
	{
		if(%colB.getType() & $Typemasks::PlayerObjectType) //if colB is a Player/Bot
		{
			if($Pref::GrapplingHook::onPlayers && %colB.getState() !$= "Dead") //if Pref: Player-Grappling on, and not Dead
			{
				%pos = %colB.getHackPosition(); //use torso
				if(isObject(%vehicle = %colB.getObjectMount())) //if colB is riding
					%colB = %vehicle; //use vehicle for calculations
			}
		}
		else if(%colB.getType() & $Typemasks::VehicleObjectType) //if colB is a Vehicle
		{
			if($Pref::GrapplingHook::onVehicles) //if Pref: Vehicle-Grappling on
				%pos = %colB.getWorldBoxCenter(); //use center of vehicle
		}
		else //otherwise we have a brick, or other stationary object
			%pos = %colB.GrapTetherPos; //use point of contact from raycast
		if(%colB.isHookGrappling || isObject(%colB.GrapplingHookedBy) || %pos $= "") //if col B is Grappling, or Grappled, or pos is undefined
		{
			GrapplingHookRelease(%obj); //release tether
			return; //stop here
		}
	}
	if(!isObject(%colB) || !isObject(%colA) || %colA.getType() != %obj.lastColAType || %colB.getType() != %obj.lastColBType || %colA.isHookGrappling || !%obj.isHookGrappling) //colB is invalid, or colA is invalid, or we are not Grappling
	{
		GrapplingHookRelease(%obj); //do tether release
		return; //stop here
	}
//	bottomPrint(%obj.client,"<font:impact:30><color:FFF200><just:center>Grapple Tether Loop<color:CCCCCC><br>" @ "Col A =" SPC %colA.getType() SPC "  ID =" SPC %colA @ "<br>Col B =" SPC %colB.getType() SPC "  ID =" SPC %colB @ "<br>Pos =" SPC %pos,10);
	%hack = %colA.getWorldBoxCenter(); //center of vehicle
	if(%colA.getType() & $Typemasks::PlayerObjectType) //if Player/Bot
		%hack = %colA.getHackPosition(); //torso
	%sub = vectorSub(%hack,%pos); //vector from torso to colB
	%obj.HookGrappleLength = vectorLen(%sub); //set rope length
	%obj.HookGrapOriginalLen = %obj.HookGrappleLength; //save inital length
	%obj.lastColAType = %colA.getType(); //store last col A's Type
	%obj.lastColBType = %colB.getType(); //store last col B's Type

	GrapplingHookAnim(%obj,true); //raise left hand
	GrapplingHookRopeActual(%colA,%colB,%sub,%pos,%hack,GrapplePullModeCheck(%obj),false,%obj); //Do rope
}

//Simulate actual Rope
function GrapplingHookRopeActual(%colA,%colB,%sub,%pos,%hack,%pull,%start,%obj)
{
	if(%obj $= "") //if tetherer undefined
		%obj = %colA; //we're the grappler
	%speed = 2; //how fast to correct hang position
	%length = %obj.HookGrappleLength; //length of the rope
	%nrm = vectorNormalize(%sub); //normalized %sub
	%inv = vectorScale(%nrm,-1); //invert normalized vector
	%scale = vectorScale(%nrm,%length); //ideal vector to player
	%point = vectorAdd(%scale,%pos); //ideal player position

	%vel = %colA.getVelocity(); //player velocity
	%dif = vectorSub(%point,%hack); //vector from torso to ideal hang position
	if(isObject(%colB) && (%colB.getType() & $Typemasks::PlayerObjectType || %colB.getType() & $Typemasks::VehicleObjectType)) //if colB exists, and is Player/Bot or Vehicle
	{
		%vAdd = %colB.getVelocity(); //Add col's velocity
		if(%pull) //if in Pull mode
		{
			%vel = %colB.getVelocity(); //colB velocity
			%vAdd = %colA.getVelocity(); //player velocity
			%scale = vectorScale(%inv,%length); //ideal vector to colB
			%point = vectorAdd(%scale,%hack); //ideal colB position
			%dif = vectorSub(%point,%pos); //vector from torso to ideal hang position
			%inv = %nrm; //flip %inv to match colB's eye vector
		}
	}
	else //otherwise
		%pull = false; //do not set the velocity of a stationary object (e.g. brick or terrain)

	%mov = vectorScale(%dif,%speed); //new position fixing velocity
	%mov = vectorAdd(%mov,%vAdd); //new position + colB's velocity
	%len = vectorLen(%sub); //length from colB to player

	%iHor = getWords(%inv,0,1) SPC 0; //get %inv's horizontal component
	%iFwd = vectorNormalize(%iHor); //find %inv's forward vector

	%rvec = vectorCross(%iFwd,"0 0 1"); //relative x vector
	%uvec = vectorCross(%rvec,%inv); //relative z vector
	%dotX = vectorDot(%vel,%rvec); //relative x velocity
	%dotZ = vectorDot(%vel,%uvec); //relative z velocity
	%dotY = vectorDot(%vel,%inv); //relative y velocity

	%min = 3; //minimum rope length
	%wep = %obj.getMountedImage(0); //right hand weapon
	%sReel = %obj.isGrapSuperReeling && $Pref::GrapplingHook::SuperReel; //Super Reeling and Pref: Super-Reel on
	if(%len < %obj.HookGrapOriginalLen && (!%canReel && !%sReel && $Pref::GrapplingHook::canToggle || !$Pref::GrapplingHook::canToggle)) //if rope is shorter than ideal, and we are not reeling
	{
		if(%length < %obj.HookGrapOriginalLen) //if length is less than the ideal, extend the rope
		{
			%obj.HookGrappleLength = %length+0.05; //extend the rope
			%fixY = vectorDot(%mov,%inv); //y add
			if(%dotY < %fixY) //if y vel is faster than y add (only use %fixY if the Y vel is faster)
				%dotY = %fixY; //substitute with y add
		//	centerPrint(%client,"<font:impact:30><color:FFF200><just:center>Grapple Hang Loop<color:CCCCCC><br>" @ "Rel Vel Y =" SPC %dotY @ "<br>Rel Fix Y =" SPC %fixY,10);
		}
	}
	else if(%len < %min && !%obj.isGrapDualTethering && isObject(%wep) && %wep.isGrapplingHook) //if len is too short, and not dual-tethering, and right weapon
		%release = true; //note to break rope
	else if(%len > $Pref::GrapplingHook::RopeMax) //stretching too far (only applies to buggy situations like using F8 while Grappling)
		%release = true; //note to break rope
	else if(%len > %length) //if rope is too long
		%dotY = vectorDot(%mov,%inv)*(%len-%length); //substitute y add for velocity (scale it by the distance, for smoothness)
	else if(%len >= %min) //length suitable
		%obj.HookGrappleLength = %len; //set new ideal rope length to %len

	if(%sReel) //Super Reeling and Pref: Super-Reel on
	{
		%dotX = 0; //reel straight to object, don't swing
		%dotZ = 0; //
	}
	if(%release) //if noted
	{
		if(%sReel) //Super Reeling and Pref: Super-Reel on, or len is longer than the original length
		{
			%obj.isGrapSuperReelDelayed = true; //Impact safety timeout on
			schedule(200,0,eval,%obj@".isGrapSuperReelDelayed = false;"); //safety timeout over
		}
		GrapplingHookRelease(%obj); //do tether release
		return; //stop
	}

	%rAdd = %dotX SPC %dotY SPC %dotZ; //relative velocity to set
	%final = vectorRotateVector(%rAdd,%inv); //rotate relative velocity to match rope vector

	GrapplingHookRopeCheck(%colA,%hack,%pos,%start,%obj); //Do rope FX
	if(%obj.isGrapDualTethering && %obj.isGrapReeling && $Pref::GrapplingHook::canReel) //if Tethering, and Reeling, and Reeling enabled
		GrapTetherSlam(%obj,%colA,%colB,%hack,%pos); //Slam them
	else if(%pull) //pull object
		%colB.setVelocity(%final); //set colB's velocity
	else if(isObject(%mount = %colA.getObjectMount())) //If colA is in a vehicle
		%mount.setVelocity(%final); //set vehicle's final velocity
	else //otherwise
		%colA.setVelocity(%final); //set colA's velocity
//	centerPrint(%client,"<font:impact:30><color:FFF200><just:center>Grapple Hang Loop<color:CCCCCC><br>" @ "velocity =" SPC %vel @ "<br>fix =" SPC %fix @ "<br>final =" SPC %final,10);
}

//On Hook Contact (Hang)
function GrapplingHookProjectile::onCollision(%this,%proj,%col,%fade,%pos,%vec)
{
	%obj = %proj.sourceObject; //define %obj
	GrapplingHookLatchOn(%obj,%col,%pos); //latch Grappling Hook
	GrapplingHookFX(%obj,GrapplingHookHitProjectile,%pos,%vec,1); //fake hit explosion
	Parent::onCollision(%this,%proj,%col,%fade,%pos,%vec);
}
//On Hook Contact (Pull)
function GrapplingHookPullProjectile::onCollision(%this,%proj,%col,%fade,%pos,%vec)
{
	%obj = %proj.sourceObject; //define %obj
	GrapplingHookLatchOn(%obj,%col,%pos); //latch Grappling Hook
	GrapplingHookFX(%obj,GrapplingHookHitProjectile,%pos,%vec,1); //fake hit explosion
	Parent::onCollision(%this,%proj,%col,%fade,%pos,%vec);
}

package GrappleHook
{
	//on Hook miss (hits nothing at all)
	function ProjectileData::onExplode(%this,%proj,%pos)
	{
		%obj = %proj.sourceObject; //define %obj
		if(%this.isGrapplingHook && isObject(%obj) && !%obj.isHookGrappling) //if Grapple Projectile, and Player/Bot exists, and not Grappling
			GrapplingHookRelease(%obj,true); //return Grappling Hook
		Parent::onExplode(%this,%proj,%pos);
	}
	//on Mount/Unmount
	function WeaponImage::onMount(%this,%obj,%slot)
	{
		Parent::onMount(%this,%obj,%slot);
	}
	function WeaponImage::onUnmount(%this,%obj,%slot)
	{
		Parent::onUnmount(%this,%obj,%slot);
		if(%slot != 0) //if not right hand
			return; //stop here
		GrapplingHookAnim(%obj,false,true); //reset Anim
		schedule(5,0,GrapplingHookPaintToggle,%obj); //Restore Paint setting (if applicable)
	}
	//Activate (Paint key)
	function Player::ActivateStuff(%obj)
	{
		%wep = %obj.getMountedImage(0);
		if((isObject(%wep) && %wep.isGrapplingHook || %obj.isHookGrappling) && $Pref::GrapplingHook::canToggle) //if (right weapon, or Grappling), and Pref: Toggle on (allow unhooking while Grapple Hook is not equiped)
			GrapplingHookToggle(%obj,%wep); //fire or release hook
		else //otherwise
			Parent::ActivateStuff(%obj); //do normal function
	}
	//on Death
	function Armor::onDisabled(%data,%obj,%enabled)
	{
		GrapplingHookRopeKill(%obj.GHRope); //kill rope on Death
		Parent::onDisabled(%data,%obj,%enabled);
	}
	//on Leave
	function GameConnection::OnClientLeaveGame(%client)
	{
		if(isObject(%client.player)) //if player object exists onLeave
			GrapplingHookRopeKill(%client.player.GHRope); //kill its rope
		Parent::OnClientLeaveGame(%client);
	}
	//Triggers
	function Armor::onTrigger(%data,%obj,%slot,%val)
	{
		if(%slot == 0) //Left click
		{
			%obj.isGrapClicking = %val; //store click bool
			if(%obj.isGrapClicking) //if holding click
			{
				%obj.isGrapSuperReeling = false; //reset Super Reel on click
				if(GrapplePullModeCheck(%obj) && $Pref::GrapplingHook::canTether || $Pref::GrapplingHook::SuperReel) //if (Pull mode verfied, and Pref: Tether on), or Pref: Super Reel
					%obj.GrapReel = schedule(300,0,eval,%obj@".isGrapReeling = true;"); //click-hold delay before Reeling (since you can also dual-tether)
				else //if Hang mode, or Pref: Tether off
					%obj.isGrapReeling = true; //no delay
				if(%obj.hasFirstTapped && !%obj.client.GrapModePull) //if double tapped, and not Pull Mode
					%obj.isGrapSuperReeling = true; //set Super Reel mode
				%obj.hasFirstTapped = true; //tapped click
				schedule(300,0,eval,%obj@".hasFirstTapped = false;"); //timeout for double click
			}
			else //on release
			{
				if(!%obj.isGrapReeling && $Pref::GrapplingHook::canTether) //if tapped click, and Pref: Tether on
					GrapplingHookTetherCheck(%obj); //Do dual-tether
				%obj.isGrapReeling = false; //set Reeling to off
				%obj.initGrapReelAudio = false; //reset Reel Audio to off
				cancel(%obj.GrapReel); //cancel Reel delay schedule, since we already released click
			}
			%wep = %obj.getMountedImage(0); //right hand gun
			if($Pref::GrapplingHook::canToggle && %obj.isHookGrappling && (!isObject(%wep) || !%wep.isGrapplingHook)) //if Pref: Toggle, and Grappling, and wrong or no weapon
				return; //stop (prevent unlatching via left click)
		}
		Parent::onTrigger(%data,%obj,%slot,%val);
	}
	//Toggle
	function serverCmdLight(%client)
	{
		%obj = %client.player; //define %obj
		if(!isObject(%obj) || !isObject(%wep = %obj.getMountedImage(0)) || !%wep.isGrapplingHook) //if no Player/Bot, or no weapon, or wrong weapon
			return Parent::serverCmdLight(%client); //do normal function
		if($Pref::GrapplingHook::canSwitch && $Pref::GrapplingHook::canToggle) //if Pref: Pull on, and Pref: Toggle on
		{
			%client.GrapModePull = !%client.GrapModePull; //toggle Pull/Hang mode
			GrapplingHookMode(%obj,%wep); //instant switch modes
			GrapplingHookRelease(%obj); //release rope if already Grappling
		}
		else
			%client.GrapModePull = false; //default to false always, if Pull is disabled
	}
	//Item Drop
	function serverCmdDropTool(%client,%slot)
	{
		%obj = %client.player; //define %obj
		%tool = %obj.tool[%slot]; //Item in Tool inventory
		Parent::serverCmdDropTool(%client,%slot);
		if(isObject(%obj) && isObject(%tool) && %tool.uiName $= "Grapple Hook") //if Player/Bot exists, and Item exists, and Item is the Grappling Hook
		{
			%obj.unmountImage(0); //unequip weapon Image
			%obj.playthread(1,root); //put hand down
		}
	}
	//Info
	function serverCmdWtf(%client)
	{
		Parent::serverCmdWtf(%client);
		%obj = %client.player; //define %obj
		if(!isObject(%obj) || !isObject(%wep = %obj.getMountedImage(0)) || !%wep.isGrapplingHook) //if no %obj, or no weapon, or wrong weapon
			return; //stop
		if($Pref::GrapplingHook::onPlayers) //Pref: Player-Grappling on
			%enemy = "<color:CCCCCC>Players\c6";
		else //otherwise
			%enemy = "\c7Players\c6"; //grey it out

		if($Pref::GrapplingHook::onVehicles) //Pref: Vehicle-Grappling on
			%car = "<color:CCCCCC>Vehicles";
		else //otherwise
			%car = "\c7Vehicles"; //grey it out

		if($Pref::GrapplingHook::canToggle) //Toggle mode
		{
			%toggle1 = "\c6- To shoot the Grappling Hook, Press the Paint key (<color:FFE599>E\c6 by default)";
			%toggle2 = "\c6- To release your tether, press the Paint key (<color:FFE599>E\c6 by default) again";
			if($Pref::GrapplingHook::canReel) //if climbing is enabled
			{
				%toggle3 = "\c6- To reel in, hold <color:FFE599>Left Click"; //tell how to reel in
				%toggle4 = "\c6- To reel back out, release <color:FFE599>Left Click"; //tell how to unreal out
			}
		}
		else //Hold mode
		{
			%toggle1 = "\c6- To shoot the Grappling Hook, hold <color:FFE599>Left Click";
			%toggle2 = "\c6- To release your tether, release <color:FFE599>Left Click";
		}
		if(GrapplePullModeCheck(%obj)) //Pull mode verified
		{
			%mode = "\c0Pull Mode";
			%toggle5 = "\c6- Use this mode to drag" SPC %enemy SPC "and" SPC %car;
			%toggle6 = "\c6- To toggle back to \c4Hang mode\c6, press the Light key (<color:FFE599>R\c6 by default)";
		}
		else //Hang mode
		{
			%mode = "\c4Hang Mode";
			%toggle5 = "\c6- Use this mode to swing from objects or latch onto" SPC %enemy SPC "and" SPC %car;
			if($Pref::GrapplingHook::canToggle)
				%toggle6 = "\c6- To toggle to \c0Pull mode\c6, press the Light key (<color:FFE599>R\c6 by default)";
		}
		%intro = "<color:CCCCCC>Grappling Hook: " @ %mode; //intro text
		messageClient(%client,"",%intro); //show intro text
		for(%a=1;%a<=6;%a++) //loop all info possibilities
		{
			if(%toggle[%a] !$= "") //if info exists (not empty)
				messageClient(%client,"",%toggle[%a]); //send that message as well
		}
	}
	//on Animate (override)
	function Player::Playthread(%obj,%slot,%thread)
	{
		if(%thread !$= "root") //if Anim is not "root"
			%obj.GrapLastThread[%slot] = %thread; //store last Anim
		else if(%obj.GrapLastThread[%slot] $= "") //If last Anim in %slot is undefined
			%obj.GrapLastThread[%slot] = root; //set it to "root"

		%wep = %obj.getMountedImage(0); //right hand weapon
		if(%obj.isHookGrappling && (%slot == 3 && %thread $= "armreadyleft" || (%slot == 3 || %slot == 1) && isObject(%wep) && %wep.isGrapplingHook)) //if Grappling, and (slot 3 and Anim-left), or (slot 3 or 1, and right weapon)
		{
			if(%obj.GrapLastThread[%slot] !$= %thread || %obj.GrapHookAnimStart) //if current Anim is not the same, or first starting Anim
				%play = true; //note to play Anim
		}
		else if(%slot != 3) //&& (!isObject(%wep) || !%wep.isGrapplingHook)) //if slot not 3, and (no weapon, or wrong weapon)
			%play = true; //note to play anim
		else if(!%obj.isHookGrappling) //otherwise if not Grappling
			%play = true; //note to play Anim
	//	bottomPrint(%obj.client,"<font:impact:30><color:FFF200><just:center>onPlaythread<color:CCCCCC><br>" @ "Thread =" SPC %thread SPC "  Slot =" SPC %slot @ "<br>Last Thread =" SPC %obj.GrapLastThread[%slot] SPC "  Slot =" SPC %slot @ "<br>Play =" SPC %play,1);
		if(%play) //if noted, play the animation (otherwise do nothing)
			Parent::Playthread(%obj,%slot,%thread); //Do regular animating
	}
	//On Impact
	function Armor::onImpact(%data,%obj,%col,%pos,%speed)
	{
		%client = %obj.client; //define %client
		%canReel = %obj.isGrapReeling && $Pref::GrapplingHook::canReel || %obj.isGrapSuperReeling && $Pref::GrapplingHook::SuperReel; //if Reeling and Pref: Reel on
		if(%obj.isHookGrappling || %obj.isGrapSuperReelDelayed) //if Grappling, don't take fall damage
			return; //stop (was going to add an Animation/sound here)
		Parent::onImpact(%data,%obj,%col,%pos,%speed); //
	}
};activatePackage(GrappleHook);



//Reeling Audio
function GrappleHookReelAudio(%obj,%force)
{
	if(!%obj.initGrapReelAudio) //if first play
	{
		%obj.GrapReelRepeats = 0; //reset Reeling count
		%obj.initGrapReelAudio = true; //do not repeat
	}
	if(!%obj.GrapReelAudioOn) //Audio not playing
	{
		%numReels = %obj.GrapReelRepeats; //recorded Reel repeats
		%obj.GrapReelAudioOn = true; //timeout the next Audio play
		schedule(200,0,eval,%obj@".GrapReelAudioOn = false;"); //
		%pos = %obj.getMuzzlePoint(0); //right hand
		if(%numReels > 12 || %force) //different sounds for different time lengths (use highest if not %force)
			%sound = GrapReelPartE;
		else if(%numReels > 9)
			%sound = GrapReelPartD;
		else if(%numReels > 6)
			%sound = GrapReelPartC;
		else if(%numReels > 2)
			%sound = GrapReelPartB;
		else
			%sound = GrapReelPartA;
		serverPlay3D(%sound,%pos); //play actual sound
		if(%numReels < 30) //limit max count (for Reel speed scaling) //was 30
			%obj.GrapReelRepeats++; //count Reels
	}
}

//Left hand animation
function GrapplingHookAnim(%obj,%on,%unmount)
{
	%wep = %obj.getMountedImage(0); //right hand weapon
	%left = %obj.getMountedImage(1); //left hand weapon
	if(isObject(%wep) && %wep.isGrapplingHook) //if righty
	{
		%thread = "armreadyright"; //use right hand anim
		if(isObject(%left) && %left.isGrapHookLeft && !%unmount) //if Image in left hand, and it is the Grappling Hook, and not onUnmount (redundant for safety)
			%obj.unmountImage(1); //unmount it
	}
	else if(isObject(%left) && !%left.isGrapHookLeft) //if Image in left hand, and it's not Grapple
		return; //stop (do no animation changes)
	else //if not
	{
		%thread = "armreadyleft"; //use left hand anim
		%image = GrapHookHangLeftImage; //use Hang Image on left hand
		if(GrapplePullModeCheck(%obj)) //if Pull mode verified
			%image = GrapHookPullLeftImage; //use Hang Image on left hand
		if((!isObject(%left) || !%left.isGrapHookLeft) && %obj.isHookGrappling) //if (left hand empty, or wrong Image), and Grappling
			%obj.mountImage(%image,1); //mount left Grapple Hook
	}

	if(%on) //Do Anim
	{
		if(!%obj.isGrapHookAnim) //if not Animating
		{
			%obj.isGrapHookAnim = true; //note that we are Animating
			%obj.GrapHookAnimStart = true; //note that we just started the Anim
			schedule(10,0,eval,%obj@".GrapHookAnimStart = false;"); //set timeout for next throw
		}
		if(%thread $= "armreadyleft") //if left hand anim
			%obj.playthread(3,%thread); //lift left hand
		else if(%thread $= "armreadyright") //if left hand anim
		{
			%obj.playthread(1,%thread); //lift right hand
			%obj.playthread(3,root); //fix right hand
		}
	//	centerPrint(%obj.client,"<font:impact:30><color:FFF200><just:center>Grapple Anim<color:CCCCCC><br>" @ "Thread =" SPC %thread @ "<br>Unmount =" SPC %unmount,3);
	}
	else if(!%unmount || %thread $= "armreadyright") //Stop Anim
		%obj.isGrapHookAnim = false; //set Anim off
}

//Group support (includes Bots not just Players)
if(!isObject($GrappleList))
{
	$GrappleList = new SimGroup()
	{
		class = "GrappleList";
	};
}

//Rope FX Check
function GrapplingHookRopeCheck(%colA,%hack,%pos,%start,%obj)
{
	if(%obj $= "") //if tetherer undefined
		%obj = %colA; //we're the grappler
	if(%start || !isObject(%obj.GHRope)) //if start override, or rope object does not exist
		GrapplingHookRopeCreate(%obj); //make rope object
	GrapplingHookRopeUpdate(%colA,%hack,%pos,%obj); //adjust rope object
}
//Create Rope
function GrapplingHookRopeCreate(%obj)
{
	%obj.GHRope = new StaticShape() //create rope object
	{
		dataBlock = HataCylinder2Shape; //shape file
	};MissionCleanup.add(%obj.GHRope); //Mission Editor hook
	%obj.GHRope.setNodeColor("ALL","0.5 0.3 0.2 1"); //set its color to brown (like Bow arrows)
}
//Manipulate Rope
function GrapplingHookRopeUpdate(%colA,%hack,%pos,%obj)
{
	%hand = %hack; //use center of colA
	if(%colA == %obj) //if we're grappling
	{
		%hand = %colA.getMuzzlePoint(0); //use right hand
		%left = %colA.getMountedImage(1); //left hand Image
		if(isObject(%left) && %left.isGrapHookLeft) //if left Grapple is mounted
			%hand = %colA.getMuzzlePoint(1); //use left hand
		else if(isObject(%left)) //if wrong Image in left hand
			%hand = %colA.getHackPosition(); //use torso for dual-weilded weapons
	}
	%size = 0.2; //scale of rope

	%vector = vectorNormalize(vectorSub(%pos,%hand));
	%relative = "0 1 0";

	%xyz = vectorNormalize(vectorCross(%relative,%vector));
	%u = mACos(vectorDot(%relative,%vector)) * -1;

	%obj.GHRope.setTransform(vectorScale(vectorAdd(%hand,%pos),0.5) SPC %xyz SPC %u);
	%obj.GHRope.setScale(%size SPC vectorDist(%hand,%pos) * 2 SPC %size);

	cancel(%obj.GHRopeKill); //cancel rope kill
	%obj.GHRopeKill = schedule(300,0,GrapplingHookRopeKill,%obj.GHRope); //schedule rope kill (so it deletes itself if something goes wrong)
}
//Kill Rope
function GrapplingHookRopeKill(%rope)
{
	if(isObject(%rope)) //if rope exists
		%rope.delete(); //delete it
}

//Check for Pull Mode
function GrapplePullModeCheck(%obj)
{
	%client = %obj.client; //define %client
	return isObject(%client) && %client.GrapModePull && $Pref::GrapplingHook::canSwitch && $Pref::GrapplingHook::canToggle; //if Pull mode, and Pref: Pull on, and Pref: Toggle on, and Grappling
}

//Disable Painting
function GrapplingHookPaintToggle(%obj,%force)
{
	%client = %obj.client; //define %client
	%wep = %obj.getMountedImage(0); //right hand weapon
	if(!%force && !%obj.isHookGrappling && (!isObject(%wep) || !%wep.isGrapplingHook)) //if not forcing, and not Grappling, and (no weapon, or wrong weapon)
	{
	//	centerPrint(%client,"<font:impact:30><color:FFF200><just:center>Paint Toggle<color:CCCCCC><br>" @ "Weapon =" SPC %wep.getName() @ "<br>Grappling =" SPC %obj.isGrappling,3);
		%mini = %client.minigame; //define minigame
		if(!isObject(%mini)) //if no minigame
			%paint = true; //paint is always enabled
		else //otherwise
			%paint = %client.minigame.enablePainting; //paint setting is determined by minigame preferences
		if(%client.cannotPaint $= "GrapplingHook") //if Grappling Hook was the first cause of noPaint (do not reenable paint if another mod disabled it)
		{
			commandToClient(%client,'SetPaintingDisabled',!%paint); //restore paint setting
			%client.cannotPaint = ""; //reset noPaint cause
		}
	}
	else //otherwise
	{
		commandToClient(%client,'SetPaintingDisabled',true); //disable Painting
		if(%client.cannotPaint $= "") //if cause of noPaint is undefined
			%client.cannotPaint = "GrapplingHook"; //Grappling Hook called it first
	}
}

//Explosion Particle FX
function GrapplingHookFX(%obj,%data,%pos,%vel,%scale)
{
	%p = new Projectile()
	{
		dataBlock = %data; //set datablock
		initialPosition = %pos; //set position
		initialVelocity = %vel; //set velocity
		sourceObject = %obj;
		client = %obj.client;
		scale = %scale SPC %scale SPC %scale; //set scale
	};MissionCleanup.add(%p); //Mission Editor hook
	%p.explode(); //explode instantly
}

//Raycast
function GrapplingHookRaycast(%obj,%len,%start,%vec)
{
	%beam = vectorScale(%vec,%len);
	%end = vectorAdd(%start,%beam); //end point of beam
	%masks = $TypeMasks::PlayerObjectType | $TypeMasks::fxBrickObjectType | $Typemasks::TerrainObjectType | $Typemasks::VehicleObjectType | $Typemasks::StaticShapeObjectType;
	%ray = containerRayCast(%start,%end,%masks,%obj); //raycast
	%col = firstWord(%ray); //collision object
	if(!isObject(%col)) //if no collision object
		return 0; //return 0
	%col.GrapTetherPos = posFromRaycast(%ray); //include position if brick, or other stationary object
	return %col; //return col
}

//Boodals Vector Manipulation
function vectorRotateVector(%vec1,%vec2)
{
	return vectorRotateAxis(%vec1,vectorToAxis(%vec2));
}
function vectorToAxis(%vec)
{
	return eulerToAxis(vectorToEuler(%vec));
}
function vectorToEuler(%vec)
{
	%vec = vectorNormalize(%vec);
	%yaw = mRadToDeg(mATan(-getWord(%vec,0),getWord(%vec,1)));
	%pitch = mRadToDeg(mASin(getWord(%vec,2)));
	return %pitch SPC 0 SPC %yaw;
}
function vectorRotateAxis(%vec,%axis)
{
	return matrixMulVector("0 0 0 " @ %axis,%vec);
}

//Trader's code
function eulerToAxis(%euler)
{
	%euler = VectorScale(%euler,$pi / 180);
	%matrix = MatrixCreateFromEuler(%euler);
	return getWords(%matrix,3,6);
}