//Sounds
datablock AudioProfile(ThrowPunchSound)
{
	fileName = "./swing3.wav";
	description = AudioClosest3d;
	preload = false;
};
datablock AudioProfile(JabHitSound)
{
	fileName = "./Jab.wav";
	description = AudioClosest3d;
	preload = true;
};
datablock AudioProfile(LeftHookHitSound)
{
	fileName = "./LeftHook.wav";
	description = AudioClosest3d;
	preload = true;
};
datablock AudioProfile(RightHookHitSound)
{
	fileName = "./RightHook.wav";
	description = AudioClosest3d;
	preload = true;
};
datablock AudioProfile(PunchHDHitSound)
{
	fileName = "./PunchHD.wav";
	description = AudioClosest3d;
	preload = true;
};


//Punch Projectile
datablock ParticleData(ActionMeleeExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	lifetimeMS           = 400;
	lifetimeVarianceMS   = 200;
	textureName          = "base/data/particles/chunk";
	spinSpeed			= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "1 1 1 0.2";
	colors[1]     = "1 1 1 0.1";
	sizes[0]      = 0.25;
	sizes[1]      = 1.0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(ActionMeleeExplosionEmitter)
{
   ejectionPeriodMS = 1;
   ejectionVelocity = 2;
   velocityVariance = 1;
   thetaMin         = 89;
   thetaMax         = 90;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ActionMeleeExplosionParticle";
};
datablock ExplosionData(ActionMeleeExplosion)
{
   lifeTimeMS = 150;
   
   soundProfile = RightHookHitSound;

   particleEmitter = ActionMeleeExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "0.25 0.25 0.25";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;
};
AddDamageType("ActionMelee",   '<bitmap:add-ons/Weapon_ActionMelee/PunchCI> %1',    '%2 <bitmap:add-ons/Weapon_ActionMelee/PunchCI> %1',0.5,1);
datablock ProjectileData(ActionMeleeProjectile)
{
	projectileShapeName = "base/data/shapes/empty.dts";
	muzzleVelocity      = 200; //Max (set to 40 for 'arrow' projectile testing)
	lifetime            = 65; //at lifetimes < 65, I have not seen the projectile appear

	// projectileShapeName = "add-ons/weapon_bow/arrow.dts";
	// muzzleVelocity      = 40; //Max (set to 40 for 'arrow' projectile testing)
	// lifetime            = 1000; //at lifetimes < 65, I have not seen the projectile appear

	directDamage        = 1;
	directDamageType    = $DamageType::ActionMelee;
	explosion           = ActionMeleeExplosion;

	velInheritFactor    = 0; //was 0

	uiName = "";
};

//Counterattack Projectile
datablock ParticleData(ActionMeleeCounterExplosionParticle)
{
	dragCoefficient      = 12;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	lifetimeMS           = 600;
	lifetimeVarianceMS   = 200;
	textureName          = "base/data/particles/thinring";
	spinSpeed			= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[1]     = "0.8 0.8 0.8 0";
	colors[0]     = "0.8 0.8 0.8 0.3";
	sizes[0]      = 0;
	sizes[1]      = 1.0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(ActionMeleeCounterExplosionEmitter)
{
   ejectionPeriodMS = 10;
   ejectionVelocity = 2;
   velocityVariance = 1;
   thetaMin         = 89;
   thetaMax         = 90;
   phiVariance      = 360;
   particles = "ActionMeleeCounterExplosionParticle";
};
datablock ExplosionData(ActionMeleeCounterExplosion)
{
   lifeTimeMS = 150;

   soundProfile = PushBroomHitSound;
   emitter[0] = ActionMeleeCounterExplosionEmitter;

   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "0.25 0.25 0.25";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;
};
datablock ProjectileData(ActionMeleeCounterProjectile)
{
   explosion = ActionMeleeCounterExplosion;
};

//Special Move Projectile
datablock ParticleData(ActionMeleePowExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	lifetimeMS           = 400;
	lifetimeVarianceMS   = 200;
	textureName          = "base/data/particles/thinring";
	spinSpeed			= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.8 0.8 0.8 0.2";
	colors[1]     = "0.8 0.8 0.8 0.1";
	sizes[0]      = 0.25;
	sizes[1]      = 1.0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(ActionMeleePowExplosionEmitter)
{
   ejectionPeriodMS = 1;
   ejectionVelocity = 5;
   velocityVariance = 1.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiVariance      = 360;
   particles = "ActionMeleePowExplosionParticle";
};
datablock ExplosionData(ActionMeleePowExplosion)
{
   lifeTimeMS = 150;

   particleEmitter = ActionMeleePowExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "0.25 0.25 0.25";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;
};
datablock ProjectileData(ActionMeleePowProjectile)
{
   explosion = ActionMeleePowExplosion;
};


//Item
datablock ItemData(ActionMeleeItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	shapeFile = "./hand.dts";

	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Action Melee";
	iconName = "./BackPunchIcon";

	doColorShift = true;
	colorShiftColor = "1 0.8 0 1";

	image = ActionMeleeImage;
	canDrop = true;
};



//Left Weapon
datablock ShapeBaseImageData(ActionMeleeLeftImage)
{
	shapeFile = "./lHand.dts";
	emap = true;

	mountPoint = 1;
	offset = "0 0.2 0";

	doColorShift = true;
	colorShiftColor = "0.3 0.3 0.3 1";

	isActionMelee = true; //shortcut - if(%weapon.isActionMelee)
};

//Main Weapon (Right Hand)
datablock ShapeBaseImageData(ActionMeleeImage : ActionMeleeLeftImage)
{
//	shapeFile = "base/data/shapes/empty.dts";
	shapeFile = "./rHand.dts";

	mountPoint = 0;
	melee = true;

	correctMuzzleVector = false;
	className = "WeaponImage";

	item = ActionMeleeItem;
	projectile = ActionMeleeProjectile;
	projectileType = Projectile;

	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.5;
	stateTransitionOnTimeout[0]     = "Ready";

	stateName[1]                    = "Ready";
	stateScript[1]					= "onReady";
	stateTransitionOnTriggerDown[1] = "PreFire";

	stateName[2] 					= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateTransitionOnTriggerUp[2]	= "Fire";
	stateTransitionOnTimeout[2]		= "Wait";
	stateTimeoutValue[2]			= 0.3;
	stateWaitForTimeout[2]			= false;

	stateName[3] 					= "Fire";
	stateScript[3]                  = "onFire";
	stateTransitionOnTimeout[3]		= "Ready";
	stateTimeoutValue[3]			= 0.4;

	stateName[4] 					= "Wait";
	stateScript[4]                  = "onWait";
	stateTransitionOnTriggerUp[4]	= "Ready";
};


//on Mount
function ActionMeleeImage::onMount(%this,%player,%slot)
{
	Parent::onMount(%this,%player,%slot);
	%client = %player.client; //player's client
	%player.playthread(1,root); //Anim - drop hands
	%player.mountImage(ActionMeleeLeftImage,1); //mount left handed image (for First Person grey hand)
}
//on Unmount
function ActionMeleeImage::onUnmount(%this,%player,%slot)
{
	Parent::onUnmount(%this,%player,%slot); //parent
	if(%slot != 0) //if not main image (i.e. not right hand)
		return; //stop here
	schedule(1,0,ActionMeleeRootAnim,%player); //schedule anim fix
	if(%player.getMountedImage(1).isActionMelee) //if Left Action Melee
		%player.unmountImage(1); //unmount it
}
//on Ready
function ActionMeleeImage::onReady(%this,%player,%slot)
{
	ActionMeleeRootAnim(%player); //reset animation
}
//on PreFire
function ActionMeleeImage::onPreFire(%this,%player,%slot)
{
	ActionMeleeTell(%player); //Hint punch (before actual swing)
}
//on Fire
function ActionMeleeImage::onFire(%this,%player,%slot)
{
	ActionMeleePunch(%player); //Start punch
}


//Pre-Punch
function ActionMeleeTell(%player)
{
	%player.playthread(2,plant); //flinch Anim
}
//Do Punch
function ActionMeleePunch(%player)
{
	%time = ActionMeleePunchAlternate(%player); //Do punch anims (alternates hands), and return its time value.
	schedule(%time,0,ActionMeleePunchProjectile,%player); //spawn the projectile mid animation
}
//Do Punch Projectile
function ActionMeleePunchProjectile(%player)
{
	if(!isObject(%player) || %player.getState() $= "Dead") //if player DNE, or player is dead
		return; //stop here
	%hand = %player.isAmPunchL ? %player.getMuzzlePoint(1) : %player.getMuzzlePoint(0); //if PunchL - use left hand pos, otherwise - use right hand pos
	serverPlay3d(throwpunchsound,%hand); //play punch throwing sound
	%eye = %player.getEyePoint(); //head
	%hand = %player.getHackPosition();
	%masks = $TypeMasks::PlayerObjectType | $TypeMasks::fxBrickObjectType | $TypeMasks::TerrainObjectType; //raycast targets
	%muzz = %player.isAmPunchL ? %player.getMuzzleVector(1) : %player.getMuzzleVector(0); //if PunchL - use left hand gun vector, otherwise - use right hand gun vector

	//Manually Correct Muzzle Vector
	%reach = 2; //Reach for detecting punches (The projectile won't spawn if the target is out of reach)
	%ray = ActionMeleeBeamCheck(%player,%eye,%reach,%masks,%muzz); //fire raycast from eye point
	if(%ray != 0) //if the raycast hit something
	{
		%hitPos = posFromRaycast(%ray); //raycast hit position
		%hSub = vectorSub(%hitPos,%hand); //vector from hand to hit position
		%muzz = vectorNormalize(%hSub); //use normalize %hSub as the new muzzle vector
	}
	else //otherwise (check again from hand point)
		%ray = ActionMeleeBeamCheck(%player,%hand,%reach,%masks,%muzz); //fire raycast from muzzle point (left / right hand, alternating)

	if(%ray == 0) //If both checks returned "0", i.e. raycasts hit nothing
		return; //stop here

	//Spawn the actual projectile
	%projData = ActionMeleeProjectile; //projectile datablock
	%plaVel = %player.getVelocity(); //player velocity
	%vector1 = VectorScale(%muzz,%projData.muzzleVelocity);
	%vector2 = VectorScale(%plaVel,%projData.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	%initVec = %player.getForwardVector(); //save original forward vector of puncher
	%projectile = new (ActionMeleeImage.projectileType)()
	{
		dataBlock = %projData;
		initialVelocity = %velocity;
		initialPosition = %hand;
		initForwardVec = %initVec;  //custom field used for Back Punch code
		sourceObject = %player;
		client = %player.client;
	};MissionCleanup.add(%projectile);
}


//Punch Alternation
function ActionMeleePunchAlternate(%player)
{
	%player.AmPunchNum++; //count punches
	%player.isAmPunchL = %player.AmPunchNum % 2 == 1 ? false : true; //if Punch number is odd (divided by 2, remainder 1) - right punch, else - left punch
	cancel(%player.AmPunchNumFix);
	%player.AmPunchNumFix = schedule(1000,0,eval,%player@".AmPunchNum = \"\";");

	if(%player.isAmPunchL) //if punch L
		%time = ActionMeleeDoAnim(%player,true); //do Left Punch anim (get timing too)
	else //otherwise
		%time = ActionMeleeDoAnim(%player,false); //do Right Punch anim (get timing too)
	return %time; //time when animation will match projectile spawn point
}
//Punch Animations
function ActionMeleeDoAnim(%player,%left)
{
	//Right hand anims
	%arm = "armreadyright";
	%anim = "shiftaway"; //right recoil

	//Left hand anims
	if(%left) //if doing left sided anim
	{
		%arm = "armreadyleft";
		%anim = "leftrecoil"; //left shiftaway
	}

	//Play anims
	%player.playthread(1,%arm);
	%player.stopthread(1); //freeze 'armready' thread immediately (for stationary hand-to-the-side)
	%player.playthread(3,%anim);

	%fireTime = 1; //75; //delay before firing
	%player.schedule(100,setThreadDir,3,false); //bring hand back down
	return %fireTime; //time when hand should spawn projectile
}

//Projectile on Damage
function ActionMeleeProjectile::Damage(%this,%proj,%col,%fade,%pos,%normal)
{
	%player = %proj.sourceObject; //attacker object
	%play = %col.getType() & $Typemasks::PlayerObjectType; //player category?
	%wrong = %play && fileName(%col.getDatablock().shapeFile) !$= "m.dts"; //correct player model?
	if(!%play || %wrong || %player.getState() $= "Dead") //if wrong player type, or wrong model, or attacker is dead
	{
		Parent::Damage(%this,%proj,%col,%fade,%pos,%normal); //Parent default functions
		return; //stop here
	}
	
	//Unused but Useful!
//	%back = getWord(ActionMeleeHitPos(%col,%pos,%proj),0); //back punch
//	%crit = getWord(ActionMeleeHitPos(%col,%pos,%proj),1); //head punch
//	%frnt = getWord(ActionMeleeHitPos(%col,%pos,%proj),2); //front punch

	%percent = 25; //100; //Manual Damage setting
	%col.AmJustHitPercent = %percent; //note multiplier for damage (based on location)

	Parent::Damage(%this,%proj,%col,%fade,%pos,%normal);
	ActionMeleeFinisherCheck(%player,%col,%pos); //Check for Finisher opportunity (Special Move Finisher)
	%col.AmJustHitPercent = 0; //reset multiplier
}

//Hit Position Check
function ActionMeleeHitPos(%col,%pos,%proj)
{
	%vec1 = %col.getForwardVector(); //col's forward facing vector
	%vec2 = %proj.initForwardVec; //initial forward vector of puncher on fire
	%vec2 = vectorNormalize(getWords(%vec2,0,1) SPC 0); //horizontalize the vector
	%vec3 = vectorScale(%vec2,-1); //invert vec2
	%back = vectorDist(%vec1,%vec2) < 0.2; //true if hit from behind
	%frnt = vectorDist(%vec1,%vec3) < 1.0; //true if hit from the front
	%head = %col.getEyePoint(); //center of head
	%neck = vectorAdd(%head,"0 0 -0.3"); //offset to neck area
	%crit = getWord(%pos,2) > getWord(%neck,2); //true if hit position above col's neck (head punch)
	%crit = %col.isAmCrouch ? %frnt : %crit; //if crouched - use front of player (simulated head), otherwise - use normal head
//	centerPrint(findclientbyname(),"<font:impact:30><just:center>\c3Action Melee Hit Check  " @ "<br>\c6back =" SPC %back SPC "  crit =" SPC %crit @ "<br><color:CCCCCC>dist =" SPC vectorDist(%vec1,%vec2),5);
	return %back SPC %crit SPC %frnt; //back punch? _ head punch? _ front punch?
}

//Finishing Move Check
function ActionMeleeFinisherCheck(%hitter,%victim,%pos)
{
	%dead = %victim.getState() $= "Dead"; //if victim dead
	if(%dead || %victim.AmJustHitPercent >= 1) //if victim is dead, or being hit
	{
		if(%victim.getState() !$= "Dead") //if victim NOT dead
			schedule(1,0,DoStunPhysics,%victim,%hitter,%imVel); //Manually Physics Stun them (like Physics Death)
		ActionMeleeDoFinisher(%hitter,%victim,%pos,%dead); //finisher animations
		return; //stop here
	}

	//on Hit Flinching Animations
	%rand = getRandom(); //generate a random float between 0 and 1
	if(%rand <= 0.5) //if float is less than or equal to 0.5
		%victim.playthread(3,plant); //plant brick anim
	else //otherwise (if float > 0.5)
		%victim.playthread(3,jump); //jump anim
}


package ActionMelee
{
	//on Damage
	function Armor::Damage(%data,%player,%sourceObject,%position,%damage,%damageType)
	{
		%percent = %player.AmJustHitPercent; //stored hit damage multiplier
		if(%percent && %damage > 0) //Just got hit by Action Melee, and damage was positive
			%damage = %damage*%percent; //%damage is set as 1 for the Action Melee projectile datablock, so we scale it
	//	echo("on Damage   damage =" SPC %damage SPC "  percent =" SPC %percent);
		Parent::Damage(%data,%player,%sourceObject,%position,%damage,%damageType); //parent (with updated damage)
	}
	//Player Triggers
	function Armor::onTrigger(%data,%player,%slot,%val)
	{
		if(%slot == 3) //if crouching
			%player.isAmCrouch = %val; //store crouch bool to player object
		Parent::onTrigger(%data,%player,%slot,%val); //parent
	}
	//Camera Spy Fix
	function SimObject::onCameraEnterOrbit(%player,%camera)
	{
		if(%camera.mode $= "ActionMelee") //if camera mode is Action Melee (called by Action Melee not /spy)
			%player.observerCount++; //keep observer count accurate, but don't parent
		else //otherwise
			Parent::onCameraEnterOrbit(%player,%camera); //parent
	}
	function SimObject::onCameraLeaveOrbit(%player,%camera)
	{
		if(%camera.mode $= "ActionMelee") //if camera mode is Action Melee (called by Action Melee not /spy)
			%player.observerCount--; //keep observer count accurate, but don't parent
		else //otherwise
			Parent::onCameraLeaveOrbit(%player,%camera); //parrent
	}
	//on Death
	function Armor::onDisabled(%data,%player,%enabled)
	{
		//Cancel schedules (prevent death glitches)
		cancel(%player.AmPunch);
		cancel(%player.AmSMove1);
		cancel(%player.AmSMove2);
		Parent::onDisabled(%data,%player,%enabled); //parent
	}
};activatePackage(ActionMelee);


//Finisher Move Effects
function ActionMeleeDoFinisher(%hitter,%victim,%pos,%isDead)
{
	//General
	%vec = %hitter.getForwardVector(); //hitter's forward vector
	%tra = %hitter.getTransform(); //hitter's transform
	%rot = getWords(%tra,3,6); //hitter's rotation

	//Select Finisher at Random
	%rand = %isDead ? getRandom() : 0; //generate a random float between 0 and 1

	//Uppercutt
	if(%rand < 0.34)
	{
		%hitter.playthread(3,armreadyright);
		%hitter.playthread(2,shiftaway);
		%hitter.playthread(1,activate);
		%hitter.playthread(0,jump);

	//	%nVel = vectorAdd(vectorScale(%vec,6),"0 0 18");
		%nVel = vectorAdd(vectorScale(%vec,12),"0 0 10");
	//	%nVel = %isDead ? %nVel : vectorAdd(vectorScale(%vec,9),"0 0 25");
		%eul = vectorAdd(axisToEuler(%rot),"10 0 60");
	}

	//Punt
	else if(%rand < 0.67)
	{
		%hitter.AmSMove1 = %hitter.schedule(350,playthread,2,root);
		%hitter.playthread(2,walk);
		%hitter.schedule(10,stopthread,2);
		%hitter.playthread(1,plant);

		%nVel = vectorAdd(vectorScale(%vec,10),"0 0 8");
	//	%nVel = vectorAdd(vectorScale(%vec,15),"0 0 12");
		%eul = vectorAdd(axisToEuler(%rot),"-20 0 40");
	}

	//Headbutt
	else if(%rand <= 1.0)
	{
		%hitter.playthread(0,plant);
		%hitter.playthread(1,crouch);
		%hitter.AmSMove1 = %hitter.schedule(100,setThreadDir,1,false);
		%hitter.AmSMove2 = %hitter.schedule(600,playthread,1,root);
		%hitter.playthread(2,shiftdown);
		%hitter.playthread(3,headup);

		%eul = vectorAdd(axisToEuler(%rot),"-30 0 30");
		%nVel = vectorAdd(vectorScale(%vec,12),"0 0 0");
	//	%nVel = vectorAdd(vectorScale(%vec,15),"0 0 5");
	}

	%victim.setVelocity(%nVel); //set death velocity
	ActionMeleeFX(%hitter,ActionMeleePowProjectile,%pos,1); //spawn special projectile explosion
	if (false) //if($Pref::ActionMelee::FancyCam) //if Pref: Fancy-Cam On
	{
		%nRot = eulerToAxis(%eul); //new rotation (dependant on which Finisher anim was played)
		%dist = 6; //4.5; //camera offset distance
		%time = 900; //1200; //delay before camera restore
		ActionMeleeSpecialCam(%hitter,%hitter,%nRot,%dist,%time,false); //true glitches the climbing animation (client-side)
		ActionMeleeSpecialCam(%victim,%victim,eulerToAxis(vectorAdd(axisToEuler(%rot),"-30 0 150")),8,-1,false); //true glitches the climbing animation (client-side)
	}
}



//Fix Animations
function ActionMeleeRootAnim(%player)
{
	if(!isObject(%player) || %player.getState() $= "Dead") //if player DNE, or player is dead
		return; //stop here

	cancel(%player.AmSMove1);
	cancel(%player.AmSMove2);

	%wep = %player.getMountedImage(0); //mounted weapon
	if(%wep.isActionMelee) //if Action Melee is mounted
	{
		%player.playthread(1,root); //reset anim
		%player.playthread(2,root); //reset anim
		%player.playthread(3,root); //reset anim
	}
	else if(%wep == 0) //if no weapon is mounted
		%player.playthread(1,root); //reset anim
}

//Explosion Effects
function ActionMeleeFX(%player,%data,%pos,%scale,%vec)
{
	if(%pos $= "")
		%pos = %player.getHackPosition();
	if(%vec $= "")
		%vec = %player.getForwardVector();
	%p = new Projectile()
	{
		dataBlock = %data;
		initialPosition = %pos;
		initialVelocity = %vec;
		sourceObject = %player;
		client = %player.client;
	};MissionCleanup.add(%p);
	%p.setScale(%scale SPC %scale SPC %scale);
	%p.explode();
}

//Special Camera
function ActionMeleeSpecialCam(%player,%target,%rot,%dist,%time)
{
	%cam = isObject(%client = %player.client) && isObject(%camera = %client.camera); //cam exists? (define client and camera too)
	if(!%cam || !isObject(%target)) //if cam mode is not default
		return; //stop here
	%self = %player == %target; //if player is the target
	%camera.mode = "ActionMelee"; //set cam mode to Action Melee
	%camera.setOrbitMode(%target,"",0,%dist,%dist,%self);
	%camera.setTransform("0 0 0" SPC %rot);
	%camera.player = %player; //store player to camera

	%client.setControlObject(%camera); //have client take control of camera
	if(%time > 0)
		%client.AmCamRestr = schedule(%time,0,ActionMeleeCamRestore,%client,"by Special Cam"); //schedule camera restore
	schedule(200,0,eval,%client@".isAmCamRestDelayed = false;"); //Set a timeout for cam restore (to avoid a glitchy looking cam switch)
	%client.isAmCamRestDelayed = true; //..
}

//Restore Camera
function ActionMeleeCamRestore(%client,%caller)
{
//	talk("cam Restore called" SPC %caller);
	%camera = %client.camera; //client's camera
	if(!isObject(%client) || %client.isAmCamRestDelayed || !isObject(%camera) || %camera.mode !$= "ActionMelee" || !isObject(%player = %camera.player) || %player.getState() $= "Dead") //if client DNE, or client is cam restore delayed, or camera DNE, or camera mode not Action Melee, or player DNE, or player is dead
		return; //stop here
	cancel(%client.AmCamRestr); //cancel any duplicate schedules
	%client.setControlObject(%player); //restore player control
	%camera.mode = "Observer"; //reset cam mode
	%camera.setFlyMode(); //stop orbit cam
}

//Beam Check
function ActionMeleeBeamCheck(%player,%pos,%len,%masks,%vec)
{
	%beam = vectorScale(%vec,%len); //lengthened vector (for calculating the raycast's endpoint)
	%end = vectorAdd(%pos,%beam); //calculated endpoint for raycast
	%ray = containerRayCast(%pos,%end,%masks,%player); //fire raycast
	%ray = isObject(firstWord(%ray)) ? %ray : 0; //if raycast hit - keep ray, else set it to zero
	return %ray; //return the raycast
}


//Euler to Axis & Axis to Euler
function eulerToAxis(%euler)
{
	%euler = VectorScale(%euler,$pi / 180);
	%matrix = MatrixCreateFromEuler(%euler);
	return getWords(%matrix,3,6);
}
function axisToEuler(%axis)
{
	%angleOver2 = getWord(%axis,3) * 0.5;
	%angleOver2 = -%angleOver2;
	%sinThetaOver2 = mSin(%angleOver2);
	%cosThetaOver2 = mCos(%angleOver2);
	%q0 = %cosThetaOver2;
	%q1 = getWord(%axis,0) * %sinThetaOver2;
	%q2 = getWord(%axis,1) * %sinThetaOver2;
	%q3 = getWord(%axis,2) * %sinThetaOver2;
	%q0q0 = %q0 * %q0;
	%q1q2 = %q1 * %q2;
	%q0q3 = %q0 * %q3;
	%q1q3 = %q1 * %q3;
	%q0q2 = %q0 * %q2;
	%q2q2 = %q2 * %q2;
	%q2q3 = %q2 * %q3;
	%q0q1 = %q0 * %q1;
	%q3q3 = %q3 * %q3;
	%m13 = 2.0 * (%q1q3 - %q0q2);
	%m21 = 2.0 * (%q1q2 - %q0q3);
	%m22 = 2.0 * %q0q0 - 1.0 + 2.0 * %q2q2;
	%m23 = 2.0 * (%q2q3 + %q0q1);
	%m33 = 2.0 * %q0q0 - 1.0 + 2.0 * %q3q3;
	return mRadToDeg(mAsin(%m23)) SPC mRadToDeg(mAtan(-%m13, %m33)) SPC mRadToDeg(mAtan(-%m21, %m22));
}