//Sound
datablock AudioProfile(HomingLaserFireSound)
{
	fileName = "./LaserFire.wav";
	description = AudioClosest3d;
	preload = true;
};

//Explosion
datablock ParticleData(HomingLaserExplosionParticle : swordExplosionParticle)
{
   lifetimeMS           = 200;
   lifetimeVarianceMS   = 0;
   gravityCoefficient   = 0;
   spinRandomMin = -200;
   spinRandomMax = 200;
   textureName   = "base/data/particles/star1";
   colors[0]     = "0.2 0.8 0.5 1";
   colors[1]     = "0 0 1 0";
   sizes[0]      = 0.5;
   sizes[1]      = 1.5;
};
datablock ParticleEmitterData(HomingLaserExplosionEmitter : swordExplosionEmitter)
{
   ejectionVelocity = 0;
   particles = "HomingLaserExplosionParticle";
   uiName = "";
};

datablock ExplosionData(HomingLaserExplosion)
{
   lifeTimeMS = 5;

   soundProfile = "";

   particleEmitter = HomingLaserExplosionEmitter;
   particleDensity = 1;
   particleRadius = 0;

   faceViewer     = true;
   explosionScale = "1 1 1";

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 0;
   lightStartColor = "0.5 0.5 0.5";
   lightEndColor = "0.5 0.8 0";
};
datablock ProjectileData(HomingLaserExplosionProjectile)
{
   explosion = HomingLaserExplosion;
   uiName = "";
};

//Trail Emitter
datablock ParticleData(HomingLaserTrailParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 600;
	lifetimeVarianceMS   = 405;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -150.0;
	spinRandomMax		= 150.0;
	colors[0]     = "0.2 0.8 0.5 0.4";
	colors[1]     = "0.5 0.5 1 1";
	colors[2]     = "0.2 0.2 1 0.7";
	colors[3]     = "0.2 0.8 0.5 0";

	sizes[0]      = 0.2;
	sizes[1]      = 0.2;
    sizes[2]      = 0.2;
 	sizes[3]      = 0.2;

	times[0] = 0.0;
	times[1] = 0.05;
	times[2] = 0.3;
	times[3] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(HomingLaserTrailEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 1;
   ejectionVelocity = 1;
   velocityVariance = 1;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
	overrideAdvance = false;
	particles = "HomingLaserTrailParticle";

	uiName = "";
};

//Muzzle Emote
datablock ParticleData(HomingLaserMuzzleParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 1;
	lifetimeMS           = 400;
	lifetimeVarianceMS   = 200;
	textureName          = "base/data/particles/dot";
	spinSpeed			= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.4 1 0.7 0.5";
	colors[1]     = "0.7 0.9 1 0";
	sizes[0]      = 0.1;
	sizes[1]      = 0.1;

	useInvAlpha = true;
};
datablock ParticleEmitterData(HomingLaserMuzzleEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 1;
   velocityVariance = 1;
   overrideAdvance = false;
   particles = "HomingLaserMuzzleParticle";
};

//Projectiles
datablock ProjectileData(HomingLaserProjectile)
{
   directDamage        = 15;
   directDamageType    = $DamageType::Gun;
   radiusDamageType    = $DamageType::Gun;
   particleEmitter     = HomingLaserTrailEmitter;
   explosion		   = HomingLaserExplosion;

   muzzleVelocity      = 100;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 100;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   canLaserHome = true;
   uiName = "";
};

//Item
datablock ItemData(HomingLaserItem : gunItem)
{
	shapeFile = "add-ons/weapon_gun/pistol.dts";
	uiName = "Homing Laser";
	colorShiftColor = "0.2 0.8 0.5 1";
	image = HomingLaserImage;
};

//Image
datablock ShapeBaseImageData(HomingLaserImage)
{
	// Basic Item properties
	shapeFile = "add-ons/weapon_gun/pistol.dts";
	emap = true;
	mountPoint = 0;

	eyeOffset = 0;
	offset = "0 0 0";
	rotation = eulerToMatrix("0 0 0");
	correctMuzzleVector = true;
	className = "WeaponImage";

	item = HomingLaserItem;
	projectile = HomingLaserProjectile;
	projectileType = Projectile;

	armReady = true;
	doRetraction = false;

	doColorShift = true;
	colorShiftColor = HomingLaserItem.colorShiftColor;

	// Initial start up state
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.4;
	stateTransitionOnTimeout[0]     = "Ready";
	stateSound[0]                   = WeaponSwitchSound;

	stateName[1]                    = "Ready";
	stateScript[1]					= "onReady";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateTransitionOnTimeout[1]		= "Ready";
	stateTimeoutValue[1]			= 0.2;
	stateEmitter[1]					= HomingLaserMuzzleEmitter;
	stateEmitterTime[1]				= 0.5;
	stateWaitForTimeout[1]			= false;

	stateName[2]                    = "Fire";
	stateTransitionOnTriggerUp[2]	= "Ready";
	stateTimeoutValue[2]            = 0.4;
	stateFire[2]                    = true;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateSound[2]                   = HomingLaserFireSound;
	stateWaitForTimeout[2]			= true;
};

//Projectile
function HomingLaserImage::onFire(%this,%obj,%slot)
{
	%obj.num = 0;
	cancel(%obj.p.HLRepeat);
	%projectile = %this.projectile;
	%vector = %obj.getMuzzleVector(0);
	%objectVelocity = %obj.getVelocity();
	%vector1 = vectorScale(%vector,%projectile.muzzleVelocity);
	%vector2 = vectorScale(%objectVelocity,%projectile.velInheritFactor);
	%velocity = vectorAdd(%vector1,%vector2);
	%position = %obj.getMuzzlePoint(0);
	spawnHomingProjectile(%projectile,%velocity,%position,%obj);
}
function HomingLaserProjectile::onCollision(%this,%proj,%col,%fade,%pos,%normal)
{
	cancel(%proj.HLRepeat);
	Parent::onCollision(%this,%proj,%col,%fade,%pos,%normal);
}

//Projectile Data
package HomingLaser
{
	function Projectile::onAdd(%proj,%a,%b)
	{
		Parent::onAdd(%proj,%a,%b);
		%this = %proj.dataBlock;
		if(%this.canLaserHome)
		{
			%obj = %proj.sourceObject;
			%num = %obj.num;
			if(%num < 25)
			{
				%proj.HLRepeat = schedule(40,0,HomingLaserFireLoop,%obj,%proj);
				%obj.num++;
			}
			else
				%obj.num = 0;
		}
	}
};activatePackage(HomingLaser);

//Special Fcns
function spawnHomingProjectile(%data,%vel,%pos,%obj,%p)
{
	if(isObject(%p))
		%p.delete();
	%p = new (Projectile)()
	{
		dataBlock = %data;
		initialVelocity = %vel;
		initialPosition = %pos;
		sourceObject = %obj;
		client = %obj.client;
	};MissionCleanup.add(%p);
	%obj.p = %p;
}
function HomingLaserFireLoop(%obj,%proj)
{
	if(!isObject(%obj) || %obj.getState() $= "Dead" || !isObject(%proj))
		return;
//	echo("homing laser fire loop");
	%this = %proj.dataBlock;
	%posA = %proj.getPosition();
	%pVel = %proj.getVelocity();
	%hit = HomingLaserRadiusSearch(%proj,%posA,%obj);
	if(isObject(%hit))
	{
	//	echo("blah laser found player");
		%posB = %hit.getHackPosition();
		%nVel = vectorSub(%posB,%posA);
		%nVel = vectorNormalize(%nVel);
		%pNrm = vectorNormalize(%pVel);
		%pNrm = vectorScale(%pNrm,1.5);
		%cVel = vectorAdd(%nVel,%pNrm);
		%cVel = vectorNormalize(%cVel);
		%vel = vectorScale(%cVel,%this.muzzleVelocity);
	}
	else
		%vel = %pVel;
	spawnHomingProjectile(%this,%vel,%posA,%obj,%obj.p);
}
function HomingLaserRadiusSearch(%proj,%posA,%obj)
{
	initContainerRadiusSearch(%posA,100,$TypeMasks::PlayerObjectType);
	while(%col = containerSearchNext())
	{
		if(isObject(%col) && %found <= 20)
		{
			%vec = vectorSub(%col.getHackPosition(),%posA);
			%nVec = vectorNormalize(%vec);
			%vel = %proj.getVelocity();
			%nVel = vectorNormalize(%vel);
			%dist = vectorDist(%nVel,%nVec);
			if(%obj != %col && %dist < 0.1 && miniGameCanDamage(%obj,%col))
				return %col;
			%found++;
		}
	}
}