//Sounds
datablock AudioProfile(ThrowPunchSound)
{
	fileName = "base/data/sound/northToss.wav";
	description = AudioClosest3d;
	preload = false;
};
datablock AudioProfile(JabHitSound)
{
	fileName = "./Jab.wav";
	description = AudioClosest3d;
	preload = true;
};
datablock AudioProfile(LeftHookHitSound)
{
	fileName = "./LeftHook.wav";
	description = AudioClosest3d;
	preload = true;
};
datablock AudioProfile(RightHookHitSound)
{
	fileName = "./RightHook.wav";
	description = AudioClosest3d;
	preload = true;
};
datablock AudioProfile(PunchHDHitSound)
{
	fileName = "./PunchHD.wav";
	description = AudioClosest3d;
	preload = true;
};


//Punch Explosion
datablock ParticleData(JudoMeleeExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	lifetimeMS           = 400;
	lifetimeVarianceMS   = 200;
	textureName          = "base/data/particles/chunk";
	spinSpeed			= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "1 1 1 0.2";
	colors[1]     = "1 1 1 0.1";
	sizes[0]      = 0.25;
	sizes[1]      = 1.0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(JudoMeleeExplosionEmitter)
{
   ejectionPeriodMS = 1;
   ejectionVelocity = 5;
   velocityVariance = 1.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "JudoMeleeExplosionParticle";
};
datablock ExplosionData(JudoMeleeExplosion)
{
   lifeTimeMS = 150;
   
   soundProfile = RightHookHitSound;

   particleEmitter = JudoMeleeExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "0.25 0.25 0.25";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;
};

//Special Move Explosion
datablock ParticleData(JudoPowExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	lifetimeMS           = 400;
	lifetimeVarianceMS   = 200;
	textureName          = "base/data/particles/thinring";
	spinSpeed			= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.8 0.8 0.8 0.2";
	colors[1]     = "0.8 0.8 0.8 0.1";
	sizes[0]      = 0.25;
	sizes[1]      = 1.0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(JudoPowExplosionEmitter)
{
   ejectionPeriodMS = 1;
   ejectionVelocity = 5;
   velocityVariance = 1.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiVariance      = 360;
   particles = "JudoPowExplosionParticle";
};
datablock ExplosionData(JudoPowExplosion)
{
   lifeTimeMS = 150;
   
   soundProfile = LeftHookHitSound;

   particleEmitter = JudoPowExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "0.25 0.25 0.25";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;
};


//Primary Punch
AddDamageType("JudoMelee",   '<bitmap:add-ons/Weapon_JudoMelee/PunchCI> %1',    '%2 <bitmap:add-ons/Weapon_JudoMelee/PunchCI> %1',0.5,1);
datablock ProjectileData(JudoMeleeProjectile)
{
	canJudo = 1;
	projectileShapeName = "base/data/shapes/empty.dts";
	directDamage        = 10;
	directDamageType    = $DamageType::JudoMelee;
	radiusDamageType    = $DamageType::JudoMelee;
	explosion           = JudoMeleeExplosion;

	muzzleVelocity      = 20;
	velInheritFactor    = 1.0;

	lifetime            = 150;
	fadeDelay           = 3500;

	uiName = "";
};

//Secondary Moves
datablock ProjectileData(JudoUppercuttProjectile : JudoMeleeProjectile)
{
	directDamage	= 30;
	impactImpulse	= 250;
	verticalImpulse	= 1000;
	explosion		= JudoPowExplosion;
};
datablock ProjectileData(JudoHeadbuttProjectile : JudoMeleeProjectile)
{
	directDamage	= 30;
	impactImpulse	= 1000;
	verticalImpulse	= 250;
	explosion		= JudoPowExplosion;
};
datablock ProjectileData(JudoKickProjectile : JudoMeleeProjectile)
{
	directDamage	= 30;
	impactImpulse	= 500;
	verticalImpulse	= 500;
	explosion		= JudoMeleeExplosion;
};


//Item
datablock ItemData(JudoMeleeItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	shapeFile = "./hand2.dts";

	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Judo Melee";
	iconName = "./BackPunchIcon";

	image = JudoMeleeImage;
	canDrop = false;
};


//Weapon
datablock ShapeBaseImageData(JudoMeleeImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = true;

	mountPoint = 0;
	correctMuzzleVector = true;
	className = "WeaponImage";
	isJudoMelee = 1;

	item = JudoMeleeItem;
	projectile = "";
	projectileType = Projectile;

	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.5;
	stateTransitionOnTimeout[0]     = "Ready";

	stateName[1]                    = "Ready";
	stateScript[1]					= "onReady";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateTransitionOnNoAmmo[1]  	= "NoAmmo";

	stateName[2] 					= "Fire";
	stateScript[2]                  = "onFire";
	stateTimeoutValue[2]            = 0.2;
	stateWaitForTimeout[2]			= true;
	stateTransitionOnTriggerUp[2]	= "Ready";

	stateName[3]   = "NoAmmo";
	stateTransitionOnAmmo[3] = "Ready";
};

function JudoMeleeImage::onMount(%this,%obj,%slot)
{
	Parent::onMount(%this,%obj,%slot);
	commandToClient(%obj.client,'setPaintingDisabled',1);
	%obj.isPaintDisabled[1] = 1;
	%obj.hasJudoMounted=1;
	%obj.playthread(1,root);
	%obj.JPN = 1;
}
function JudoMeleeImage::onUnMount(%this,%obj,%slot)
{
	Parent::onUnMount(%this,%obj,%slot);
	schedule(10,0,JudoRootAnim,%obj);
	%client = %obj.client;
	%mini = %client.minigame;
	if(isObject(%mini))
		%paint = !%mini.enablePainting;
	else
		%paint = 0;
	if(%obj.isPaintDisabled[1] && !%obj.isPaintDisabled[0])
		commandToClient(%client,'SetPaintingDisabled',%paint);
	%obj.hasJudoMounted=0;
	cancel(%obj.iJS);
	cancel(%obj.JUA);
	cancel(%obj.JCR);
}

function JudoMeleeImage::onReady(%this,%obj,%slot)
{
	cancel(%obj.JSCs);
	if(!%obj.isJudoSpecial)
		JudoRootAnim(%obj);
	if(%obj.isJudoPunching)
		%obj.JCR = schedule(600,0,eval,%obj@".JPN = 1;");
	%obj.isJudoPunching=0;
	if(%obj.JPN > 5 && %obj.getImageState(0) !$= "NoAmmo")
	{
		%obj.setImageAmmo(0,0);
		%obj.schedule(600,setImageAmmo,0,1);
		%obj.JPN = 1;
	}
}
function JudoMeleeImage::onFire(%this,%obj,%slot)
{
	cancel(%obj.JCR);
	JudoPunch(%obj,%this);
	%obj.JSCs = schedule(600,0,JudoSpecialCombo,%obj,%obj.JPN);
	%obj.JPN = %obj.JPN++;
}

function JudoRootAnim(%obj)
{
	if(%obj.getState() $= "Dead")
		return;
	cancel(%obj.JSBA);
	%wep = %obj.getMountedImage(0);
	if(%obj.hasJudoMounted)
	{
		%obj.playthread(1,root);
		%obj.playthread(2,root);
		%obj.playthread(3,root);
	}
	else if(%wep != 0)
		%obj.updateArm(%wep);
	else
		%obj.playthread(1,root);
}

function JudoPunch(%obj,%this)
{
//	echo("Judo Punch Number =" SPC %obj.JPN SPC "Image Ammo =" SPC %obj.getImageAmmo(0));
	%obj.isJudoPunching=1;
	%obj.isJudoBlocking=0;
	cancel(%col.iJB);
	cancel(%obj.JSBA);
	JudoPunchAlternate(%obj);
	%hack = %obj.getHackPosition();
	%posA = vectorAdd(%hack,"0 0 0.5");
	serverPlay3d(throwpunchsound,%posA);
	JudoProjectileSpawn(%obj,JudoMeleeProjectile,%posA);
}

function JudoSpecialCombo(%obj,%JPN)
{
	if(!%obj.hasJudoMounted || %obj.getState() $= "Dead")
		return;
	%obj.isJudoSpecial=1;
	schedule(400,0,eval,%obj@".isJudoSpecial=0;");
	%obj.playthread(1,root);
	if(%JPN == 1)
		JudoKick(%obj);
	if(%JPN == 2)
		JudoUppercutt(%obj);
	if(%JPN == 3)
		JudoHeadbutt(%obj);
	%obj.JPN = 6;
}
function JudoKick(%obj)
{
	%obj.JUA = %obj.schedule(350,playthread,2,root);
	%obj.playthread(2,walk);
	%obj.schedule(50,stopthread,2);
	%obj.playthread(1,plant);

	%pos = %obj.getPosition();
	%posA = vectorAdd(%pos,"0 0 1");
	serverPlay3d(throwpunchsound,%posA);
	JudoProjectileSpawn(%obj,JudoKickProjectile,%posA);
}
function JudoHeadbutt(%obj)
{
	%obj.playthread(3,plant);
	%obj.playthread(1,crouch);
	%obj.schedule(100,setThreadDir,1,false);
	%obj.JUA = %obj.schedule(600,playthread,1,root);
	%obj.playthread(2,shiftdown);

	%eye = %obj.getEyePoint();
	serverPlay3d(throwpunchsound,%eye);
	JudoProjectileSpawn(%obj,JudoHeadbuttProjectile,%eye);
}
function JudoUppercutt(%obj)
{
	%obj.JUA = %obj.schedule(350,playthread,3,root);
	%obj.playthread(3,armreadyright);
	%obj.playthread(2,shiftaway);
	%obj.playthread(1,activate);

	%hack = %obj.getHackPosition();
	%posA = vectorAdd(%hack,"0 0 0.5");
	serverPlay3d(throwpunchsound,%posA);
	JudoProjectileSpawn(%obj,JudoUppercuttProjectile,%posA);
}

function JudoPunchAlternate(%obj)
{
	if(%obj.JPN == 2 || %obj.JPN == 4)
		JudoDoAnimRight(%obj);
	if(%obj.JPN == 1 || %obj.JPN == 3 || %obj.JPN == 5)
		JudoDoAnimLeft(%obj);
}
function JudoDoAnimRight(%obj)
{
	%obj.playthread(3,shiftaway);
	%obj.schedule(50,stopthread,1);
	%obj.playthread(1,armreadyright);
}
function JudoDoAnimLeft(%obj)
{
	%obj.playthread(3,leftrecoil);
	%obj.schedule(50,stopthread,1);
	%obj.playthread(1,armreadyleft);
}


//Secondary Projectile Spawning
function JudoProjectileSpawn(%obj,%data,%pos)
{
	%muzz = %obj.getMuzzleVector(0);
	%mVel = vectorScale(%muzz,%data.muzzleVelocity);
	%p = new Projectile()
	{
		dataBlock = %data;
		initialPosition = %pos;
		initialVelocity = %mVel;
		sourceObject = %obj;
		client = %obj.client;
	};
	MissionCleanup.add(%p);
}


//Euler to Axis & Axis to Euler
function eulerToAxis(%euler)
{
	%euler = VectorScale(%euler,$pi / 180);
	%matrix = MatrixCreateFromEuler(%euler);
	return getWords(%matrix,3,6);
}
function axisToEuler(%axis)
{
	%angleOver2 = getWord(%axis,3) * 0.5;
	%angleOver2 = -%angleOver2;
	%sinThetaOver2 = mSin(%angleOver2);
	%cosThetaOver2 = mCos(%angleOver2);
	%q0 = %cosThetaOver2;
	%q1 = getWord(%axis,0) * %sinThetaOver2;
	%q2 = getWord(%axis,1) * %sinThetaOver2;
	%q3 = getWord(%axis,2) * %sinThetaOver2;
	%q0q0 = %q0 * %q0;
	%q1q2 = %q1 * %q2;
	%q0q3 = %q0 * %q3;
	%q1q3 = %q1 * %q3;
	%q0q2 = %q0 * %q2;
	%q2q2 = %q2 * %q2;
	%q2q3 = %q2 * %q3;
	%q0q1 = %q0 * %q1;
	%q3q3 = %q3 * %q3;
	%m13 = 2.0 * (%q1q3 - %q0q2);
	%m21 = 2.0 * (%q1q2 - %q0q3);
	%m22 = 2.0 * %q0q0 - 1.0 + 2.0 * %q2q2;
	%m23 = 2.0 * (%q2q3 + %q0q1);
	%m33 = 2.0 * %q0q0 - 1.0 + 2.0 * %q3q3;
	return mRadToDeg(mAsin(%m23)) SPC mRadToDeg(mAtan(-%m13, %m33)) SPC mRadToDeg(mAtan(-%m21, %m22));
}


package JudoPunch
{
	function ProjectileData::Damage(%this,%proj,%col,%fade,%pos,%normal)
	{
		if(!%this.canJudo)
			return Parent::damage(%this,%proj,%col,%fade,%pos,%normal);
		%obj = %proj.sourceObject;
		if(%col.getType() & $Typemasks::PlayerObjectType && %obj.getState() !$= "Dead")
		{
			if(%col.isJudoBlocking)
			{
				%col.isJudoBlocking=0;
				%vec1 = %col.getForwardVector();
				%vec2 = vectorNormalize(%proj.initialVelocity);
				%damloc = (vectorDot(%vec1,%vec2) > -0.5);
				%scale = getWord(%col.getScale(),2);
				if(getword(%pos,2) > getword(%col.getWorldBoxCenter(),2) - 3.3*%scale)
				{
					//front Headshot
					if(%damLoc == 0)
						%hasGuarded=1;
				}
				else if(getword(%pos,2) > getword(%col.getWorldBoxCenter(),2) - 4.5*%scale)
				{
					//front Torso shot
					if(%damLoc == 0)
						%hasGuarded=1;
				}
				else
				{
					//front Leg shot
					if(%damLoc == 0)
						%hasGuarded=1;
				}
			}
		}
		if(%hasGuarded)
		{
			%col.playthread(1,plant);
			%col.playthread(2,leftrecoil);
			%obj.damage(%col.client,"",40,$DamageType::JudoMelee);
			cancel(%col.iJB);
			cancel(%col.iJBD);
			cancel(%col.JSBA);
			%col.iJBD = schedule(350,0,eval,%col@".isJudoBlockDelayed=0;");
		}
		else
		{
			%rand = getRandom(1,2);
			if(%rand == 1)
				%col.playthread(3,plant);
			else
				%col.playthread(3,jump);
			Parent::damage(%this,%proj,%col,%fade,%pos,%normal);
		}
	}
};activatePackage(JudoPunch);

//Counter
package JudoCounter
{
	function Player::ActivateStuff(%obj)
	{
		if(!%obj.isJudoPunching && !%obj.isJudoBlockDelayed)
			Parent::activateStuff(%obj);
		%wep = %obj.getMountedImage(0);
		if(!%obj.isJudoBlockDelayed && %wep.isJudoMelee && !%obj.isJudoPunching)
		{
			%obj.isJudoBlocking=1;
			%obj.isJudoBlockDelayed=1;
			%obj.iJB = schedule(500,0,eval,%obj@".isJudoBlocking=0;");
			%obj.iJBD = schedule(1000,0,eval,%obj@".isJudoBlockDelayed=0;");
			%obj.JSBA = %obj.schedule(500,playthread,1,root);
			%obj.playthread(1,armreadyboth);

			%obj.setImageAmmo(0,0);
			%obj.schedule(500,setImageAmmo,0,1);
		}
	}
	function Armor::onDisabled(%data,%obj,%enabled)
	{
		cancel(%obj.JSBA);
		cancel(%obj.iJB);
		cancel(%obj.iJBD);
		Parent::onDisabled(%data,%obj,%enabled);
	}
};activatePackage(JudoCounter);