//Animations
datablock TSShapeConstructor(KeybladeEDts)
{
	baseShape = "./keyblade/keybladeE.dts";
	sequence0 = "./keyblade/guard.dsq guard";
	sequence1 = "./keyblade/returnGuard.dsq returnGuard";
	sequence2 = "./keyblade/returnLeft.dsq returnLeft";
	sequence3 = "./keyblade/returnRight.dsq returnRight";
	sequence4 = "./keyblade/slash.dsq slash";
	sequence5 = "./keyblade/slashLeft.dsq slashLeft"; 
	sequence6 = "./keyblade/slashReturn.dsq slashReturn";
	sequence7 = "./keyblade/slashRight.dsq slashRight";
	sequence8 = "./keyblade/throw.dsq throw";
	sequence9 = "./keyblade/upwardReturn.dsq upwardReturn";
	sequence10 = "./keyblade/upwardSlash.dsq upwardSlash";
};


//Counterattack Emitter B
datablock ParticleData(KeybladeCounterBParticle)
{
	dragCoefficient      = 6;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.1;
	constantAcceleration = 0.0;
	lifetimeMS           = 800;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/star1";
	spinSpeed			 = 10;
	colors[0]     = "1 0 0 0.6";
	colors[1]     = "1 0.7 0.4 0";
	sizes[0]      = 0;
	sizes[1]      = 0.6;
	times[0] = 0;
	times[1] = 1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(KeybladeCounterBEmitter)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 10;
	velocityVariance = 0;
	ejectionOffset   = 0;
	thetaMin         = 90;
	thetaMax         = 90.1;
	phiReferenceVel  = 4000;
	phiVariance		 = 0;
	particles = "KeybladeCounterBParticle";
};
//Counterattack Explosion
datablock ExplosionData(KeybladeCounterExplosion)
{
	particleDensity = 5;
	particleRadius  = 5;

	emitter[0] = "";
	emitter[1] = KeybladeCounterBEmitter;

	lifeTimeMS 	   = 150;
	faceViewer     = true;
	explosionScale = "1 1 1";

	//Dynamic light
	lightStartRadius = 0;
	lightEndRadius = 10;
	lightStartColor = "1 0.6 0.4";
	lightEndColor = "1 0 0";
};
datablock ProjectileData(KeybladeCounterProjectile)
{
	explosion = KeybladeCounterExplosion;
};

//Guard FX (Direct)
datablock ParticleData(KeybladeGuardParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.1;
	constantAcceleration = 0.0;
	lifetimeMS           = 300;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/thinring";
	spinSpeed			 = 10.0;
	colors[0]     = "1 0.6 0.4 0.4";
	colors[1]     = "0.8 0.8 0.8 0";
	sizes[0]      = 1;
	sizes[1]      = 1;
	times[0] = 0;
	times[1] = 1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(KeybladeGuardEmitter)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 2;
	velocityVariance = 1;
	ejectionOffset   = 0;
	thetaMin         = 0;
	thetaMax         = 90;
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance = false;
	particles = "KeybladeGuardParticle";
};
datablock ExplosionData(KeybladeGuardExplosion)
{
	soundProfile = hammerhitsound;
	particleEmitter = KeybladeGuardEmitter;
	particleDensity = 10;
	particleRadius = 0.1;

	lifeTimeMS = 100;
	faceViewer     = true;
	explosionScale = "1 1 1";
};
datablock ProjectileData(KeybladeGuardProjectile)
{
	explosion = KeybladeGuardExplosion;
};

//Repel FX (Actual)
datablock ParticleData(KeybladeRepelParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.1;
	constantAcceleration = 0.0;
	lifetimeMS           = 300;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/thinring";
	spinSpeed			 = 10.0;
	colors[0]     = "1 0.6 0.4 0.2";
	colors[1]     = "0.8 0.8 0.8 0";
	sizes[0]      = 20;
	sizes[1]      = 20;
	times[0] = 0;
	times[1] = 1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(KeybladeRepelEmitter)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 0;
	velocityVariance = 0;
	particles = "KeybladeRepelParticle";
};
datablock ExplosionData(KeybladeRepelExplosion)
{
	explosionShape = "Add-Ons/Weapon_Rocket Launcher/explosionSphere1.dts";
	particleEmitter = KeybladeRepelEmitter;
	particleDensity = 10;
	particleRadius = 1;

	lifeTimeMS = 150;
	faceViewer     = true;
	explosionScale = "0.5 0.5 0.5";

	//Dynamic light
	lightStartRadius = 0;
	lightEndRadius = 10;
	lightStartColor = "1 0.6 0.4";
	lightEndColor = "1 1 1";
};
datablock ProjectileData(KeybladeRepelProjectile)
{
	explosion = KeybladeRepelExplosion;
};


//Keyblade Hit Explosion
datablock ParticleData(KeybladeHitExplosionParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0;
	constantAcceleration = 0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 250;
	textureName          = "base/data/particles/star1";
	spinSpeed			 = 10.0;
	spinRandomMin		 = -150.0;
	spinRandomMax		 = 150.0;
	colors[0]     = "1 0.6 0.2 1";
	colors[1]     = "1 0 0 0";

	sizes[0]      = 0.0;
	sizes[1]      = 0.5;

	times[0] = 0.0;
	times[1] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(KeybladeHitExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 1;
   velocityVariance = 1;
   particles = "KeybladeHitExplosionParticle";
};
datablock ExplosionData(KeybladeHitExplosion)
{
   soundProfile 	= SwordHitSound;
   particleEmitter 	= KeybladeHitExplosionEmitter;
   particleDensity 	= 10;
   particleRadius 	= 0.1;

   lifeTimeMS 		= 100;
   faceViewer     	= true;
   explosionScale	= "1 1 1";
};

//Keyblade Trail
datablock ParticleData(KeybladeTrailParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0;
	constantAcceleration = 0;
	lifetimeMS           = 300;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/dot";
	spinSpeed			 = 10.0;
	spinRandomMin		 = -150.0;
	spinRandomMax		 = 150.0;
	colors[0]     = "1 0.4 0.1 0";
	colors[1]     = "1 0.4 0.1 1";
	colors[2]     = "1 0 0 1";
	colors[3]     = "1 0 0 0";

	sizes[0]      = 0.1;
	sizes[1]      = 0.1;
	sizes[2]      = 0.1;
	sizes[3]      = 0.1;

	times[0] = 0.0;
	times[1] = 0.1;
	times[2] = 0.9;
	times[3] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(KeybladeTrailEmitter)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 0;
	velocityVariance = 0;
	particles = "KeybladeTrailParticle";
};

//Key Chain Emitter
datablock ParticleData(KeyChainParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = 5;
	inheritedVelFactor   = 0;
	lifetimeMS           = 200;
	lifetimeVarianceMS   = 0;
	spinSpeed			 = 10;
	spinRandomMin		 = -5;
	spinRandomMax		 = 5;
	textureName          = "base/data/particles/nut";
	colors[0]     = "0.7 0.7 0.7 1";
	colors[1]     = "0.7 0.7 0.7 0";
	sizes[0]      = 0.1;
	sizes[1]      = 0.1;

	useInvAlpha = true;
};
datablock ParticleEmitterData(KeyChainEmitter)
{
   ejectionPeriodMS = 15;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0;
   overrideAdvance = false;
   particles = "KeyChainParticle";
};

//Main Projectile
datablock ProjectileData(KeybladeProjectile)
{
   directDamage        = 20;
   directDamageType    = $DamageType::Sword;
   radiusDamageType    = $DamageType::Sword;

   verticalImpulse	   = 0;
   muzzleVelocity      = 50;
   velInheritFactor    = 0;
   explodeOnDeath	   = false;
   explosion 		   = KeybladeHitExplosion;

   armingDelay         = 0;
   lifetime            = 80;
   fadeDelay           = 80;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod 		   = 0.0;
   canKeyblade = true;

   hasLight    = false;
   uiName = "";
};

//Trail Projectile
datablock ProjectileData(KeybladeTrailProjectile)
{
	particleEmitter     = KeybladeTrailEmitter;
	directDamage        = 0;
	armingDelay         = 100;
	lifetime            = 100;
	fadeDelay           = 100;
	canKeyblade = true;
};

//Throw Projectile
datablock ProjectileData(KeybladeThrowProjectile : KeybladeProjectile)
{
	projectileShapeName = "./keyblade/keyblade_projectile.dts"; 
	directDamage		= 30;
	directDamageType    = $DamageType::Sword;
	radiusDamageType    = $DamageType::Sword;
	explosion		    = wandexplosion;

	impactImpulse		= 400;
	verticalImpulse		= 400;

	muzzleVelocity      = 75;
	velInheritFactor    = 0;
	explodeOnDeath 	    = true;

	armingDelay         = 0;
	lifetime            = 500;
	fadeDelay           = 500;
};

//Item
datablock ItemData(KeybladeItem : swordItem)
{
	shapeFile = "./keyblade/keyblade_item.dts";
	uiName = "Keyblade";
	iconName = "./icon_keyblade";
	colorShiftColor = "0.2 0.2 0.2 1";
	image = KeybladeSwitchImage;
	doColorShift = false;
	canDrop = false;
};

//Base Image
datablock ShapeBaseImageData(KeybladeBaseImage)
{
	//Basic Item properties
	shapeFile = "./keyblade/keybladeE.dts";
	emap = true;
	mountPoint = 0;

	eyeOffset = 0;
	offset = "0 0 0"; //"0 0 0.1";
	rotation = eulerToMatrix("0 0 0"); //("-90 0 -16");
	correctMuzzleVector = false;
	className = "WeaponImage";

	item = KeybladeItem;
	projectile = "";
	projectileType = Projectile;

	armReady = true;
	doRetraction = false;

	doColorShift = KeybladeItem.doColorShift;
	colorShiftColor = KeybladeItem.colorShiftColor;
	canKeyblade = true;
};

//Switch Image
datablock ShapeBaseImageData(KeybladeSwitchImage : KeybladeBaseImage)
{
	//Initial start up state
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.3;
	stateTransitionOnTimeout[0]     = "Ready";
	stateSound[0]                   = swordDrawSound;
	stateEmitter[0]					= KeyChainEmitter;
	stateEmitterTime[0]				= 0.4;
	stateEmitterNode[0]				= "emitter";

	stateName[1]                    = "Ready";
	stateScript[1]					= "onReady";
};
function KeybladeSwitchImage::onMount(%this,%player,%slot)
{
	if(isObject(%player.light)) //Disable light
		%player.light.delete(); //
	%player.hideNode("RHand"); //Hide hand
	%player.hideNode("RHook"); //Hide hand
}
function KeybladeSwitchImage::onReady(%this,%player,%slot)
{
	%player.mountImage(KeybladeImage,0);
}

//Main Image
datablock ShapeBaseImageData(KeybladeImage : KeybladeBaseImage)
{
	//Initial start up state
	stateName[0]                    = "Ready";
	stateScript[0]					= "onReady";
	stateTransitionOnTriggerDown[0] = "Fire";
	stateTransitionOnTimeout[0]		= "Ready";
	stateTimeoutValue[0]			= 0.2;
	stateWaitForTimeout[0]			= false;
	stateEmitter[0]					= KeyChainEmitter;
	stateEmitterTime[0]				= 0.3;
	stateEmitterNode[0]				= "emitter";

	stateName[1]					= "Fire";
	stateScript[1]                  = "onFire";
};
function KeybladeImage::onMount(%this,%player,%slot)
{
	cancel(%player.KeyLazy);
	%player.KeyLazy = schedule(3000,0,KeybladeLazyAnim,%player);
	Parent::onMount(%this,%player,%slot);
//	centerPrint(%player.client,"<font:impact:30>\c3Keyblade Main Image Mounted by\c6" SPC %player.getShapeName(),1);
}
function KeybladeImage::onFire(%this,%player,%slot)
{
	%player.mountImage(KeybladeSlashImage,0); //Equip normal Slash image
}

//Empty Image
datablock ShapeBaseImageData(KeybladeEmptyImage : KeybladeBaseImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	stateName[0] = "ready";
};

//Horizontal Slash Image
datablock ShapeBaseImageData(KeybladeHoriSlashImage : KeybladeBaseImage)
{
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.3;
	stateTransitionOnTriggerDown[0]	= "Anim1";
	stateTransitionOnTimeout[0]		= "Return3";
	stateWaitForTimeout[0]			= false;
	stateEmitter[0]					= KeyChainEmitter;
	stateEmitterTime[0]				= 0.4;
	stateEmitterNode[0]				= "emitter";

	//Slash 1 Actual
	stateName[9]                    = "Anim1";
	stateTransitionOnTimeout[9]		= "Hold1";
	stateTimeoutValue[9]            = 0.3;
	stateSequence[9]				= "slashLeft";
	stateWaitForTimeout[9]			= true;
	stateEmitter[9]					= KeyChainEmitter;
	stateEmitterTime[9]				= 0.4;
	stateEmitterNode[9]				= "emitter";
	stateScript[9]					= "onAnim1";

	//Slash 1 Hold
	stateName[7]                    = "Hold1";
	stateTimeoutValue[7]            = 0.3;
	stateTransitionOnTriggerUp[7]	= "Check1";
	stateTransitionOnTimeout[7]		= "Hold1";
	stateWaitForTimeout[7]			= false;
	stateEmitter[7]					= KeyChainEmitter;
	stateEmitterTime[7]				= 0.4;
	stateEmitterNode[7]				= "emitter";

	//Slash 1 Return Check
	stateName[1]                    = "Check1";
	stateTimeoutValue[1]            = 0.3;
	stateTransitionOnTriggerDown[1]	= "Anim2";
	stateTransitionOnTimeout[1]		= "Return1";
	stateWaitForTimeout[1]			= false;
	stateEmitter[1]					= KeyChainEmitter;
	stateEmitterTime[1]				= 0.4;
	stateEmitterNode[1]				= "emitter";

	//Slash 2 Actual
	stateName[2]                    = "Anim2";
	stateTransitionOnTimeout[2]		= "Hold2";
	stateTimeoutValue[2]            = 0.3;
	stateSequence[2]				= "slashRight";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= KeyChainEmitter;
	stateEmitterTime[2]				= 0.4;
	stateEmitterNode[2]				= "emitter";
	stateScript[2]					= "onAnim2";

	//Slash 2 Hold
	stateName[8]                    = "Hold2";
	stateTimeoutValue[8]            = 0.3;
	stateTransitionOnTriggerUp[8]	= "Check2";
	stateTransitionOnTimeout[8]		= "Hold2";
	stateWaitForTimeout[8]			= false;
	stateEmitter[8]					= KeyChainEmitter;
	stateEmitterTime[8]				= 0.4;
	stateEmitterNode[8]				= "emitter";

	//Slash 2 Return Check
	stateName[3]                    = "Check2";
	stateTimeoutValue[3]            = 0.3;
	stateTransitionOnTriggerDown[3]	= "Anim1";
	stateTransitionOnTimeout[3]		= "Return2";
	stateWaitForTimeout[3]			= false;
	stateEmitter[3]					= KeyChainEmitter;
	stateEmitterTime[3]				= 0.4;
	stateEmitterNode[3]				= "emitter";

	//Slash 1 Return
	stateName[4]                    = "Return1";
	stateTimeoutValue[4]            = 0.1;
	stateTransitionOnTimeout[4]		= "Return3";
	stateSequence[4]				= "returnLeft";
	stateWaitForTimeout[4]			= true;
	stateEmitter[4]					= KeyChainEmitter;
	stateEmitterTime[4]				= 0.2;
	stateEmitterNode[4]				= "emitter";

	//Slash 2 Return
	stateName[5]                    = "Return2";
	stateTimeoutValue[5]            = 0.1;
	stateTransitionOnTimeout[5]		= "Return3";
	stateSequence[5]				= "returnRight";
	stateWaitForTimeout[5]			= true;
	stateEmitter[5]					= KeyChainEmitter;
	stateEmitterTime[5]				= 0.2;
	stateEmitterNode[5]				= "emitter";

	//Return Final
	stateName[6]                    = "Return3";
	stateScript[6]					= "onReturn";
};
//Fire 1
function KeybladeHoriSlashImage::onAnim1(%this,%player,%slot)
{
	KeybladeSlashCombo(%player,%this,"B1");
	%player.playthread(2,shiftleft);
}
//Fire 2
function KeybladeHoriSlashImage::onAnim2(%this,%player,%slot)
{
	KeybladeSlashCombo(%player,%this,"B2");
	%player.playthread(2,shiftright);
}
//Return to Main
function KeybladeHoriSlashImage::onReturn(%this,%player,%slot)
{
	%player.mountImage(KeybladeImage,0);
}

//Horizontal Slash Quick Image
datablock ShapeBaseImageData(KeybladeHoriQuickImage : KeybladeHoriSlashImage)
{
	//Speed up Slashes
	stateTimeoutValue[9] = 0.2;
	stateTimeoutValue[2] = 0.2;
};
//Fire 1
function KeybladeHoriQuickImage::onAnim1(%this,%player,%slot)
{
	KeybladeSlashCombo(%player,%this,"B1");
	%player.playthread(2,shiftleft);
}
//Fire 2
function KeybladeHoriQuickImage::onAnim2(%this,%player,%slot)
{
	KeybladeSlashCombo(%player,%this,"B2");
	%player.playthread(2,shiftright);
}
//Return to Main
function KeybladeHoriQuickImage::onReturn(%this,%player,%slot)
{
	%player.mountImage(KeybladeImage,0);
}

//Upward Slash Image
datablock ShapeBaseImageData(KeybladeUpwardSlashImage : KeybladeBaseImage)
{
	//Slash Actual
	stateName[0]                    = "Anim1";
	stateTransitionOnTimeout[0]		= "Hold";
	stateTimeoutValue[0]            = 0.2;
	stateSequence[0]				= "upwardSlash";
	stateWaitForTimeout[0]			= true;
	stateEmitter[0]					= KeyChainEmitter;
	stateEmitterTime[0]				= 0.3;
	stateEmitterNode[0]				= "emitter";
	stateScript[0]					= "onAnim1";

	//Slash Hold
	stateName[7]                    = "Hold";
	stateTimeoutValue[7]            = 0.3;
	stateTransitionOnTriggerUp[7]	= "Return1";
	stateTransitionOnTimeout[7]		= "Hold";
	stateWaitForTimeout[7]			= false;
	stateEmitter[7]					= KeyChainEmitter;
	stateEmitterTime[7]				= 0.4;
	stateEmitterNode[7]				= "emitter";

	//Slash Return
	stateName[4]                    = "Return1";
	stateTimeoutValue[4]            = 0.1;
	stateTransitionOnTimeout[4]		= "Return2";
	stateSequence[4]				= "upwardReturn";
	stateWaitForTimeout[4]			= true;
	stateEmitter[4]					= KeyChainEmitter;
	stateEmitterTime[4]				= 0.2;
	stateEmitterNode[4]				= "emitter";

	//Return Final
	stateName[1]                    = "Return2";
	stateScript[1]					= "onReturn";
};
//Fire
function KeybladeUpwardSlashImage::onAnim1(%this,%player,%slot)
{
	KeybladeSlashCombo(%player,%this,"A2");
	%player.playthread(2,shiftto);
}
//Return to Main
function KeybladeUpwardSlashImage::onReturn(%this,%player,%slot)
{
	%player.mountImage(KeybladeImage,0);
}

//Regular Slash Image
datablock ShapeBaseImageData(KeybladeSlashImage : KeybladeBaseImage)
{
	//Slash Actual
	stateName[0]                    = "Anim1";
	stateTransitionOnTimeout[0]		= "Hold";
	stateTimeoutValue[0]            = 0.2;
	stateSequence[0]				= "slash";
	stateWaitForTimeout[0]			= true;
	stateEmitter[0]					= KeyChainEmitter;
	stateEmitterTime[0]				= 0.3;
	stateEmitterNode[0]				= "emitter";
	stateScript[0]					= "onAnim1";

	//Slash Hold
	stateName[7]                    = "Hold";
	stateTimeoutValue[7]            = 0.3;
	stateTransitionOnTriggerUp[7]	= "Return1";
	stateTransitionOnTimeout[7]		= "Hold";
	stateWaitForTimeout[7]			= false;
	stateEmitter[7]					= KeyChainEmitter;
	stateEmitterTime[7]				= 0.4;
	stateEmitterNode[7]				= "emitter";

	//Slash Return
	stateName[4]                    = "Return1";
	stateTimeoutValue[4]            = 0.1;
	stateTransitionOnTimeout[4]		= "Return2";
	stateSequence[4]				= "slashReturn";
	stateWaitForTimeout[4]			= true;
	stateEmitter[4]					= KeyChainEmitter;
	stateEmitterTime[4]				= 0.2;
	stateEmitterNode[4]				= "emitter";

	//Return Final
	stateName[1]                    = "Return2";
	stateScript[1]					= "onReturn";
};
//Fire
function KeybladeSlashImage::onAnim1(%this,%player,%slot)
{
	KeybladeSlashCombo(%player,%this,"A1",true);
	%player.playthread(2,shiftaway);
	%player.schedule(100,playthread,2,shiftto);
}
//Return to Main
function KeybladeSlashImage::onReturn(%this,%player,%slot)
{
	KeybladeSlashCombo(%player,%this);
}

//Downward Slash Image (same as regular slash)
datablock ShapeBaseImageData(KeybladeSlashDownImage : KeybladeBaseImage)
{
	//Pre-Slash
	stateName[0]                    = "PreSlash";
	stateTimeoutValue[0]            = 0.3;
	stateTransitionOnTriggerDown[0]	= "Anim1";
	stateTransitionOnTimeout[0]		= "Return2";
	stateWaitForTimeout[0]			= false;
	stateEmitter[0]					= KeyChainEmitter;
	stateEmitterTime[0]				= 0.4;
	stateEmitterNode[0]				= "emitter";

	//Slash Actual
	stateName[2]                    = "Anim1";
	stateTransitionOnTimeout[2]		= "Hold";
	stateTimeoutValue[2]            = 0.2;
	stateSequence[2]				= "slash";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= KeyChainEmitter;
	stateEmitterTime[2]				= 0.3;
	stateEmitterNode[2]				= "emitter";
	stateScript[2]					= "onAnim1";

	//Slash Hold
	stateName[7]                    = "Hold";
	stateTimeoutValue[7]            = 0.3;
	stateTransitionOnTriggerUp[7]	= "Return1";
	stateTransitionOnTimeout[7]		= "Hold";
	stateWaitForTimeout[7]			= false;
	stateEmitter[7]					= KeyChainEmitter;
	stateEmitterTime[7]				= 0.4;
	stateEmitterNode[7]				= "emitter";

	//Slash Return
	stateName[4]                    = "Return1";
	stateTimeoutValue[4]            = 0.1;
	stateTransitionOnTimeout[4]		= "Return2";
	stateSequence[4]				= "slashReturn";
	stateWaitForTimeout[4]			= true;
	stateEmitter[4]					= KeyChainEmitter;
	stateEmitterTime[4]				= 0.2;
	stateEmitterNode[4]				= "emitter";

	//Return Final
	stateName[1]                    = "Return2";
	stateScript[1]					= "onReturn";
};
//Fire
function KeybladeSlashDownImage::onAnim1(%this,%player,%slot)
{
	KeybladeSlashCombo(%player,%this,"A1");
}
//Return to Main
function KeybladeSlashDownImage::onReturn(%this,%player,%slot)
{
	%player.mountImage(KeybladeImage,0);
}

//Guard Image
datablock ShapeBaseImageData(KeybladeGuardImage : KeybladeBaseImage)
{
	//Guard Actual
	stateName[0]                    = "Anim";
	stateTransitionOnTimeout[0]     = "Check";
	stateTimeoutValue[0]            = 0.2;
	stateSequence[0]				= "guard";
	stateEmitter[0]					= KeyChainEmitter;
	stateEmitterTime[0]				= 0.3;
	stateEmitterNode[0]				= "emitter";

	stateName[1]                    = "Check";
	stateTimeoutValue[1]            = 0.3;
	stateTransitionOnTimeout[1]		= "Check";
	stateEmitter[1]					= KeyChainEmitter;
	stateEmitterTime[1]				= 0.4;
	stateEmitterNode[1]				= "emitter";
};
function KeybladeGuardImage::onUnMount(%this,%player,%slot)
{
	KeybladeGuardToggle(%player,2); //toggle Guard - unmount end
	Parent::onUnMount(%this,%player,%slot);
}

//Throw Image
datablock ShapeBaseImageData(KeybladeThrowImage : KeybladeBaseImage)
{
	//Slash Actual
	stateName[0]                    = "Anim";
	stateTransitionOnTimeout[0]		= "Hold";
	stateTimeoutValue[0]            = 0.2;
	stateSequence[0]				= "throw";
	stateWaitForTimeout[0]			= true;
	stateEmitter[0]					= KeyChainEmitter;
	stateEmitterTime[0]				= 0.3;
	stateEmitterNode[0]				= "emitter";

	//Slash Hold
	stateName[1]                    = "Hold";
	stateTimeoutValue[1]            = 0.3;
	stateTransitionOnTriggerUp[1]	= "Throw";
	stateTransitionOnTimeout[1]		= "Hold";
	stateWaitForTimeout[1]			= false;
	stateEmitter[1]					= KeyChainEmitter;
	stateEmitterTime[1]				= 0.4;
	stateEmitterNode[1]				= "emitter";

	stateName[2]                    = "Throw";
	stateScript[2]					= "onThrow";
};
//Throw
function KeybladeThrowImage::onThrow(%this,%player,%slot)
{
	KeybladeThrow(%player);
}

//Keyblade Relaxed Animation
function KeybladeLazyAnim(%player)
{
	if(isObject(%player))
		%wep = %player.getMountedImage(0);
	if(isObject(%wep) && %wep.getName() $= "KeybladeImage")
	{
		%player.playthread(1,root);
		%player.playthread(2,activate);
	}
}

//Blade on Fire
function KeybladeSlashCombo(%player,%image,%type,%first)
{
	%min = 3; //Must match Ground Combo function
	%max = 7; //Must match Ground Combo function
	%vel = %player.getVelocity(); //velocity
	%upv = getWord(%vel,2); //upward vel
	%readyA = %player.KeyAirComboNum >= 1 && %upv > -4; //Still in the Combo
	%readyB = %player.KeyGroundComboNum >= %min && %player.KeyGroundComboNum <= %max; //Still in the Combo
	if(%readyA || %readyB)
	{
		if(%image.getName() !$= "KeybladeHoriQuickImage") //if onAnim and not quick slashing
			%weap = KeybladeHoriQuickImage;
	//	echo("Combo activated  ready =" SPC %ready SPC "  weapon =" SPC %weap SPC "  player =" SPC %player.getShapeName());
	}
	else
	{
		if(%image.getName() !$= "KeybladeHoriSlashImage") //if onAnim and not regular slashing
			%weap = KeybladeHoriSlashImage;
	}
	%proj = KeybladeProjectile; //normal projectile
	if(%upv > 5 && %player.KeyAirComboNum < 1) //Upward slash anim
		%weap = KeybladeUpwardSlashImage; //Air Combo launcher
	else if((%upv < -4 && %player.KeyAirComboNum > 3) || %player.KeyGroundComboNum == %max) //falling
		%weap = KeybladeSlashDownImage; //Air Combo finisher
	if(%first) //If first slash
		%weap = ""; //Keep image
	if(%weap !$= "" && %weap !$= %image.getName())
		%player.mountImage(%weap,0); //Equip correct animations
	else
	{
		if(%first) //only fix arm if first slashing
			fixArmReady(%player); //arm ready right
		KeybladeSlashStart(%player,%type,10,1,%proj); //Do slash
		cancel(%player.KeyLazy); //cancel idle animation
		if(%image.getName() $= "KeybladeSlashImage") //only charge if regular chopping
		{
			cancel(%player.KeyThrow); //don't double schedule
			%player.KeyThrow = schedule(750,0,KeybladeThrowPrepare,%player); //charge time
		}
	}
}
//Do Slash
function KeybladeSlashStart(%player,%type,%max,%scale,%projectile)
{
	%len = 3; //Length of raycast
	%muz = %player.getMuzzlePoint(0); //right hand
	%mvec = %player.getMuzzleVector(0); //aim vector
	%enemy = KeybladeRadiusSearch(%player,%muz,%len,%mvec,3); //enemy search
	%svec = %mvec; //if enemy not found yet
	if(isObject(%enemy)) //enemy found
		%svec = vectorSub(%enemy.getHackPosition(),%muz); //vector towards enemy
	%velocity = vectorScale(%svec,%projectile.muzzleVelocity); //projectile vel
	%p = new (Projectile)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %muz;
		sourceObject = %player;
		client = %player.client;
	};MissionCleanup.add(%p);
	%player.KeyTrailPos = ""; //reset trail pos
	for(%a=1;%a<%max;%a++)
		KeybladeSlashLoop(%player,%muz,%mvec,%type,%max,%scale,%a); //Do trail loop
}
//Slash Trail FX
function KeybladeSlashLoop(%player,%pos,%mvec,%type,%max,%scale,%num)
{
	%wep = %player.getMountedImage(0);
	if(!isObject(%player) || %player.getState() $= "Dead" || %wep == 0 || !%wep.canKeyblade)
		return;
	%len = 1.6; //Length of slash
	%rvec = findRelativeX(%mvec);
	%up = vectorCross(%rvec,%mvec);
	%shift = 0.15; //distance b/n projectiles
	%m = 0.3; //arc scale
	%addA = KeybladeTrailOffset(%type,%up,%rvec,%scale,%shift,%num);
	%nPos = KeybladeTrailDirect(%mvec,%addA,%m,%max,%num,%pos,%len);
	if(%num > 1)
	{
		%addB = KeybladeTrailOffset(%type,%up,%rvec,%scale,%shift,%num-1);
		%oPos = KeybladeTrailDirect(%mvec,%addB,%m,%max,%num-1,%pos,%len);
	}
	if(%oPos $= "") //If there is an old position
		return;
	%sub = vectorSub(%nPos,%oPos); //set velocity to match distance b/n points
	%projectile = KeybladeTrailProjectile;
	%velocity = vectorScale(%sub,20); //projectile velocity
	%p = new (Projectile)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %oPos;
		sourceObject = %player;
		client = %player.client;
	};MissionCleanup.add(%p);
}
//Trail Add
function KeybladeTrailOffset(%type,%up,%rvec,%start,%shift,%num)
{
	if(%type $= "A1")
	{
		%sub = %start-(%num*%shift);
		%add = vectorScale(%up,%sub);
	}
	if(%type $= "A2")
	{
		%sub = %start-(%num*%shift);
		%add = vectorScale(%up,-%sub);
	}
	if(%type $= "B1")
	{
		%sub = %start-(%num*%shift);
		%add = vectorScale(%rvec,%sub);
	}
	if(%type $= "B2")
	{
		%sub = %start-(%num*%shift);
		%add = vectorScale(%rvec,-%sub);
	}
	return %add;
}
//Trail Position
function KeybladeTrailDirect(%mvec,%add,%m,%max,%num,%pos,%len)
{
	%vector = vectorAdd(%mvec,%add);
	%mov = vectorScale(%vector,%num*%m);
	%pivot = mFloor(%max*0.75); //pivot point
	if(%num == %pivot)
		%mov = vectorScale(%vector,(%num-1)*%m);
	if(%num > %pivot)
		%mov = vectorScale(%vector,((2*%pivot)-%num-1)*%m);
	%off = vectorAdd(%pos,%mov); //slash start offset
	%mult = vectorScale(%add,%len); //scale vector to slash length
	%nPos = vectorAdd(%off,%mult); //projectile spawn point
	return %nPos;
}


//Keyblade Prepare Throw
function KeybladeThrowPrepare(%player)
{
	%wep = %player.getMountedImage(0);
	if(isObject(%wep) && %wep.canKeyblade)
	{
		%player.mountImage(KeybladeThrowImage,0);
		fixArmReady(%player); //arm ready right
	}
}

//Keyblade Throwing
function KeybladeThrow(%player)
{
	%wep = %player.getMountedImage(0);
	if(!isObject(%wep) || !%wep.canKeyblade || %player.hasThrownKeyblade)
		return;
	%player.hasThrownKeyblade = true;
	%player.mountImage(KeybladeEmptyImage,0);
	%player.playthread(1,activate);
	%player.client.applyBodyParts(); //Show hand

	%lifetime = 500; //must match projectileData lifetime
	%projectile = KeybladeThrowProjectile;
	%speed = %projectile.muzzleVelocity;
	%len = %speed*%lifetime/1000; //Predicted end point
	%muzzle = %player.getMuzzlePoint(0);
	%vector = %player.getMuzzleVector(0);
	%hack = %player.getEyePoint();
	%hPos = KeybladeRaycast(%player,%len,%hack,%vector); //Position from raycast
	if(%hPos !$= "")
	{
		%sub = vectorSub(%hPos,%muzzle);
		if(vectorDot(%sub,%vector) > 0.5) //Make sure Sub isn't too short
			%vector = vectorNormalize(%sub); //correct muzzle vector
	}
	%velocity = vectorScale(%vector,%speed);
	%p = new (Projectile)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %muzzle;
		sourceObject = %player;
		client = %player.client;
	};MissionCleanup.add(%p);
	schedule(%lifetime,0,ReturnKeyblade,%player); //Return Keyblade after lifetime
//	echo("len =" SPC %len SPC "  muzzle vel =" SPC %speed SPC "  vector =" SPC %vector SPC "  velocity =" SPC %velocity);
}

//Keyblade Return
function ReturnKeyblade(%player)
{
	%wep = %player.getMountedImage(0);
	if(isObject(%wep) && %wep.getName() $= "KeybladeEmptyImage" && %player.hasThrownKeyblade)
	{
		%player.mountImage(KeybladeImage,0);
		fixArmReady(%player); //arm ready right
		%player.hideNode("RHand"); //Hide hand
		%player.hideNode("RHook"); //Hide hand
	}
	%player.hasThrownKeyblade = false;
}


//Keyblade Air Combo
function KeybladeAirCombo(%player,%col)
{
	if(%col.getState() $= "Dead" || !isObject(%player) || !isObject(%wep = %player.getMountedImage(0)) || !%wep.canKeyblade || %player.isKeyAirComboHit) //if dead, nonexistent, wrong weapon, or being combo'd
		return; //stop

	%muz = %player.getMuzzleVector(0);//Check look angle
	%mZ = getWord(%muz,2); //z value of aim vector

	%vel = %player.getVelocity(); //player velocity
	%vec = %player.getForwardVector(); //player forward vector
	%rvec = findRelativeX(%vec); //relative x vec

	%upv = getWord(%vel,2); //z velocity
	%rv = vectorDot(%vel,%rvec); //right vel (x)
	%fv = vectorDot(%vel,%vec); //forward vel (y)

	%hack = %player.getHackPosition(); //player position
	%cHck = %col.getHackPosition(); //col position

	%min = 3; //Min number of hits before Combo finisher
	%time = 1000; //Combo timeout
	%inRange = %upv < 1 && %upv > -1; //In range for ground combo
	if(%mZ == -1) //Stop if looking straight down
		return;
	if(%upv > 13) //if upward vel matches High Jump
		%Air = true; //can Air combo
	else if(%player.KeyAirComboNum > 0 && %upv > -5) //if Combo started, and not falling too fast
		%Air = true; //can Air combo
	else if(%player.KeyAirComboNum >= %min) //if at least 3 hits
	{
		%add = vectorAdd("0 0" SPC -10,vectorScale(%vec,10)); //diagonally down vel
		KeybladeFX(%player,WandProjectile,%cHck,%muz,1); //particles
		%col.damage(%player,0,20,KeybladeProjectile.directDamageType); //double damage
		%col.setVelocity(%add); //Slam enemy
		%player.KeyAirComboNum = 0; //Reset combo
		cancel(%player.KeyACEnd); //Combo Timer
	}
	if(%Air || %special) //if can Air combo, or Air Combo finishing
	{
		%zA = %player.KeyAirComboNum*1.5; //Scale Combo hit number for z add
		if(%zA > 4) //If buff over 4
			%zA = 4; //Limit max vel buff
	//	centerPrint(%player.client,"<font:impact:30>\c3Keyblade Combo\c6  Up Vel =" SPC %upv SPC "  z Add =" SPC %zA SPC "  Combo Num =" SPC %player.KeyAirComboNum,5);
		if(%zA > 0 && %upv < 10)
			%z = %upv + %zA; //add adjusted velocity buff to current upward vel
		else //otherwise
			%z = %upv; //keep current up vel
		if(%z > 18) //was 18
			%z = 18; //limit velocity
		if(%fv > 0) //if moving forward
			%fv = 0; //nulify forward vel

		%rot = vectorToRotation(%vec); //forward rotation
		%cor = vectorRotateAxis(%rv SPC %fv SPC %z,%rot); //corrected vel

		%nPos = vectorAdd(%hack,%cor); //Projected col position
		%nSub = vectorSub(%nPos,%cHck); //vector from col to new pos
		%mov = vectorScale(%nSub,1.1); //new col velocity
		if(!%special)
		{
			%player.setVelocity(%cor);
			%col.setVelocity(%mov);
		}
		cancel(%player.KeyACEnd); //Combo Timer
		cancel(%player.KeyMCEnd); //Multi Combo end
		cancel(%player.KeyACHit); //Combo'd Timer
		%player.KeyACEnd = schedule(%time,0,eval,%player@".KeyAirComboNum = 0;"); //schedule reset of Air Combo hit number
		%col.KeyACHit = schedule(%time,0,eval,%col@".isKeyAirComboHit = false;"); //schedule reset of enemy's Combo'd status
		%col.isKeyAirComboHit = true; //enemy is being Combo'd
		%player.KeyAirComboNum++; //add 1 to Air Combo hit count
	}
}


//Keyblade Guard Toggle
function KeybladeGuardToggle(%player,%case)
{
	if(!isObject(%wep = %player.getMountedImage(0)) || !%wep.canKeyblade || %player.isKeybladeGuardTired) //if wrong gun, or gun is not Keyblade, and player is not Guard tired
		return; //stop here
	if(!%player.isKeybladeGuarding && %case < 1) //if Guard bool = false, and case undefined (no force end) 
	{
		%player.mountImage(KeybladeGuardImage,0); //Mount guard image
		fixArmReady(%player); //arm ready right fix
		%player.isKeybladeGuarding = true; //set Guarding bool on
	
		%tra = %player.getEyeTransform(); //player eye transform
		%rot = getWords(%tra,3,6); //player rotation
		%eul = vectorAdd(axisToEuler(%rot),"-5 0 0"); //offset rotation
		%dist = %player.getDatablock().cameraMaxDist; //Playertype camera offset
		%time = -1; //delay before camera restore (-1 = infinite)
		KeybladeSpecialCam(%player,%player,eulerToAxis(%eul),%dist,%time,true); //Do orbit cam
	}
	else if(%case != 3 || %case == 3 && %player.isKeybladeGuarding) //if case is not 3, or (case is 3, and Guard bool = true)
	{
		if(%wep.getName() $= "KeybladeGuardImage" && %case != 2) //if wep is Guard image, and not case 2 (on unmount, prevent infinite loop)
			%player.mountImage(KeybladeImage,0); //mount main Keyblade image
		KeybladeCamRestore(%player.client,false); //restore player camera - rotate = true
		%player.isKeybladeGuarding = false; //set Guarding bool off

		if(%case == 4) //if case = 4 (counterattack)
		{
			schedule(2000,0,eval,%player@".isKeybladeGuardTired = false;"); //set timeout before next Guard
			%player.isKeybladeGuardTired = true; //..
		}
	}
}

//Keyblade Guard Actual
function KeybladeGuardActual(%player,%enemy)
{
	%wep = %player.getMountedImage(0);
	if(!isObject(%wep) || %wep.getName() !$= "KeybladeGuardImage")
		return; //stop here
	%hack = %player.getHackPosition();
	KeybladeFX(%player,KeybladeRepelProjectile,%hack,"0 0 1",0.2);
}
//Keyblade Guard Direct
function KeybladeGuardDirect(%player,%enemy,%pos,%this)
{
	%wep = %player.getMountedImage(0);
	if(!isObject(%wep) || %wep.getName() !$= "KeybladeGuardImage")
		return;
	%hack = %player.getHackPosition();
	%sub = vectorSub(%pos,%hack);
	KeybladeFX(%player,KeybladeGuardProjectile,%pos,%sub,1);
	if(!isObject(%enemy) || %enemy.getType() & !$Typemasks::PlayerObjectType || !isObject(%this))
		return;
	%player.KeyGuardWord[0] = %enemy;
	%player.KeyGuardWord[1] = %pos;
	%player.KeyGuardWord[2] = %this;
	for(%a=0;%a<3;%a++) //reset saved info
	{
		cancel(%player.KeyGWReset[%a]);
		%player.KeyGWReset[%a] = schedule(300,0,eval,%player@".KeyGuardWord["@%a@"]= 0;");
	}
}
//Keyblade Guard Direct Counterattack
function KeybladeDirectCounter(%player)
{
	%enemy = %player.KeyGuardWord[0];
	%pos = %player.KeyGuardWord[1];
	%this = %player.KeyGuardWord[2];
	%wep = %player.getMountedImage(0);

	KeybladeGuardToggle(%player,4); //toggle Guard - counter end

	if(!isObject(%wep) || %wep.getName() !$= "KeybladeGuardImage") //if no weapon, or wrong weapon
		return; //stop here
	if(!isObject(%enemy) || %enemy.getType() & $Typemasks::FxBrickObjectType || !isObject(%this) || %pos $= "") //if enemy DNE, or enemy is a brick (event-made projectile), or projectile data DNE, or pos undefined
		return; //stop here

	%hack = %player.getHackPosition();
	%ePos = %enemy.getHackPosition();
	%eSub = vectorSub(%ePos,%hack);
	%eLen = vectorLen(%eSub);
	%eNrm = vectorNormalize(%eSub);
	%scale = vectorScale(%eNrm,12);
	%velocity = vectorScale(%eNrm,%this.muzzleVelocity);

	KeybladeFX(%player,WandProjectile,%pos,%eNrm,1); //Special FX
	KeybladeFX(%player,KeybladeCounterProjectile,%pos,%eNrm,1); //Special FX
	schedule(1000,0,eval,%enemy@".isKeyAirComboHit = false;");
	%enemy.isKeyAirComboHit = true;

	schedule(100,0,eval,%enemy@".isKeySafe = false;"); //schedule end of timeout
	%enemy.isKeySafe = true; //damage safety timeout

	if(%eLen < 5) //If enemy is close
		%enemy.setVelocity(vectorAdd("0 0 10",%scale)); //knock enemy back
	if(%this.getName() $= "KeybladeProjectile") //if projectile data is Keyblade data
		return; //stop here

	//Spawn a projectile (Reflection)
	%p = new (Projectile)()
	{
		dataBlock = %this;
		initialVelocity = %velocity;
		initialPosition = %pos;
		sourceObject = %player;
		client = %player.client;
	};MissionCleanup.add(%p);
}

//Fix Right hand
function KeybladeHandFix(%player)
{
	if(isObject(%player.client) && (!isObject(%wep = %player.getMountedImage(0)) || !%wep.canKeyblade)) //if not holding Keyblade
		%player.client.applyBodyParts(); //Show hand
}

package Keyblade
{
	//Guard
	function serverCmdLight(%client)
	{
		%player = %client.player;
		if(!isObject(%player) || %player.getState() $= "Dead") //if no player object, or player is dead
			return Parent::serverCmdLight(%client); //stop and parent here
		KeybladeGuardToggle(%player); //toggle Guard
	}
	//Unmounting
	function WeaponImage::onUnMount(%this,%player,%slot)
	{
		if(%this.canKeyblade)
			schedule(5,0,KeybladeHandFix,%player); //schedule hand fix
		Parent::onUnMount(%this,%player,%slot);
	}
	//on Datablock change
	function Armor::onNewDatablock(%data,%player)
	{
		Parent::onNewDatablock(%data,%player);
		if(isObject(%wep = %player.getMountedImage(0)) && %wep.canKeyblade)
		{
			%player.hideNode("RHand"); //Hide hand
			%player.hideNode("RHook"); //Hide hand
		}
	}
	//Projectile Damage
	function ProjectileData::Damage(%this,%proj,%col,%fade,%pos,%normal)
	{
		%player = %proj.sourceObject;
		if(%col.getType() & $Typemasks::PlayerObjectType && %this.canKeyblade)
		{
			if(%this.getName() $= "KeybladeProjectile") //If slash projectile
				KeybladeAirCombo(%player,%col); //Do Combo stuff
		}
		if(%col.isKeybladeGuarding && %this.getName() !$= "KeybladeTrailProjectile")
			KeybladeGuardDirect(%col,%player,%pos,%this);
		Parent::Damage(%this,%proj,%col,%fade,%pos,%normal);
	}
	//Player Damage
	function Armor::Damage(%data,%player,%sourceObject,%position,%damage,%damageType)
	{
		if(%damage > 0 && (%player.isKeybladeGuarding || %player.isKeySafe) && (%sourceObject != %player && !%player.hasJustImpacted)) //Take damage when not guarding, or on fall damage
		{
			KeybladeGuardActual(%player,%sourceObject); //Take no damage and do FX
			%damage = %damage*0.3; //take partial damage while Guarding
		}
		Parent::Damage(%data,%player,%sourceObject,%position,%damage,%damageType); //
	}
	//On Impact
	function Armor::onImpact(%data,%player,%col,%pos,%speed)
	{
		%player.hasJustImpacted = true; //override for Guard
		schedule(1,0,eval,%player@".hasJustImpacted = false;"); //
		Parent::onImpact(%data,%player,%col,%pos,%speed);
	}
	//Player Controls
	function Armor::onTrigger(%data,%player,%slot,%val)
	{
		KeybladeTriggerCheck(%player,%slot,%val); //hook for special reactions
		Parent::onTrigger(%data,%player,%slot,%val);
	}
	//Camera Controls
	function Observer::onTrigger(%data,%camera,%slot,%val)
	{
		if(isObject((%player = %camera.player))) //if player exists
			KeybladeTriggerCheck(%player,%slot,%val); //hook for special reactions
		Parent::onTrigger(%data,%camera,%slot,%val);
	}
	//Camera Spy Fix
	function SimObject::onCameraEnterOrbit(%player,%camera)
	{
		if(%camera.mode $= "Keyblade") //if camera mode is Action Melee (called by Action Melee not /spy)
			%player.observerCount++; //keep observer count accurate, but don't parent
		else //otherwise
			Parent::onCameraEnterOrbit(%player,%camera); //parent
	}
	function SimObject::onCameraLeaveOrbit(%player,%camera)
	{
		if(%camera.mode $= "Keyblade") //if camera mode is Action Melee (called by Action Melee not /spy)
			%player.observerCount--; //keep observer count accurate, but don't parent
		else //otherwise
			Parent::onCameraLeaveOrbit(%player,%camera); //parent
	}
};activatePackage(Keyblade);


//Special Camera
function KeybladeTriggerCheck(%player,%slot,%val)
{
	if(%slot == 0) //if Left Click
	{
		if(!%val) //if releasing (not holding)
			cancel(%player.KeyThrow); //cancel Keyblade throw charge
		else //if holding
			KeybladeDirectCounter(%player); //Attempt Conterattack
	}
	else if(%val) //otherwise if holding a key (e.g. crouch, jump, jet)
		KeybladeGuardToggle(%player,3); //toggle Guard - misc. end
}

//Special Camera
function KeybladeSpecialCam(%player,%target,%rot,%dist,%time,%control)
{
	%cam = isObject(%client = %player.client) && isObject(%camera = %client.camera); //cam exists? (define client and camera too)
	%camera.mode = %camera.mode $= "Corpse" ? %camera.mode = "Observer" : %camera.mode; //if camera mode is "corpse" change it to "observer", otherwise leave it
	if(!%cam || %camera.mode !$= "Observer" || !isObject(%target)) //if cam mode is not default
		return; //stop here
	%self = %player == %target; //if player is the target
	%camera.mode = "Keyblade"; //set cam mode to Action Melee
	%camera.setOrbitMode(%target,"",0,%dist,%dist,%self);
	%camera.setTransform("0 0 0" SPC %rot);
	%client.setControlObject(%camera);
	if(%control) //if %control
		%camera.setControlObject(%target); //let player control himself (or the target) while in the camera
	%camera.player = %player; //store player to camera
	if(%time > 0) //if time is positive
		schedule(%time,0,KeybladeCamRestore,%client); //schedule camera restore
}

//Restore Camera
function KeybladeCamRestore(%client,%rotate)
{
	%camera = %client.camera;
	if(!isObject(%client) || !isObject(%player = %client.player) || %player.getState() $= "Dead" || !isObject(%camera) || %camera.mode !$= "Keyblade") //if client DNE, or player DNE, or player is dead, or camera DNE, or camera mode not Action Melee
		return; //stop here
	if(%rotate)
	{
		%pos = %player.getPosition(); //player position
		%rot = getWords(%camera.getTransform(),3,6); //cam rotation
		%player.setTransform(%pos SPC %rot); //rotate player to match camera
	}
	%client.setControlObject(%player); //restore player control
	%camera.mode = "Observer"; //reset cam mode
	%camera.setFlyMode(); //stop orbit cam
}

//Raycast
function KeybladeRaycast(%player,%len,%pos,%vec)
{
	%beam = vectorScale(%vec,%len);
	%end = vectorAdd(%pos,%beam);
	%masks = $TypeMasks::PlayerObjectType | $TypeMasks::fxBrickObjectType | $Typemasks::TerrainObjectType | $Typemasks::VehicleObjectType | $Typemasks::StaticShapeObjectType;
	%ray = containerRayCast(%pos,%end,%masks,%player);
	%col = firstWord(%ray);
	if(isObject(%col))
		%hitLoc = posFromRaycast(%ray);
	return %hitLoc;
}

//Radius Search
function KeybladeRadiusSearch(%player,%pos,%len,%vec,%range)
{
	%masks = $TypeMasks::PlayerObjectType;
	initContainerRadiusSearch(%pos,%len,%masks);
	while(%col = containerSearchNext())
	{
		if(isObject(%col) && %col != %player && miniGameCanDamage(%player,%col) && isObject(%player.client.minigame))
		{
			%cHack = %col.getHackPosition();
			%sub = vectorSub(%cHack,%pos);
			%sNrm = vectorNormalize(%sub);
			%sLen = vectorLen(%sub);
			%scale = vectorScale(%vec,%sLen);
			%pAdd = vectorAdd(%pos,%scale);
			%dist = vectorDist(%sNrm,%vec);
			%div = %dist*%sLen;
			%wordsA = getWords(%vec,0,1);
			%wordsB = getWords(%sNrm,0,1);
			%dif = vectorDist(%wordsA SPC 0,%wordsB SPC 0);
		//	centerPrint(%player.client,"<font:impact:30>" SPC %col.name SPC "  \c6distance =" SPC %dist SPC "   divided =" SPC %div @ "<br>\c3type =" SPC %type SPC "  difference =" SPC %dif,5);
			if(%div < %range && %dif < 2 && %sLen <= %len)
				return %col;
		}
	}
}

//Special FX
function KeybladeFX(%player,%data,%pos,%vec,%scale)
{
	%p = new Projectile()
	{
		dataBlock = %data;
		initialPosition = %pos;
		initialVelocity = %vec;
		sourceObject = %player;
		client = %player.client;
		scale = %scale SPC %scale SPC %scale;
	};MissionCleanup.add(%p);
	%p.explode();
}

//Vector Code
function findRelativeX(%vec)
{
	%dir = getWords(%vec,0,1) SPC 0; //Make horizontal
	%nrm = vectorNormalize(%dir); //normalize
	return vectorCross(%dir,"0 0 1"); //rightward vector
}

//Vec to Rotation
function vectorToRotation(%vec)
{
	%yaw = mATan(getWord(%vec,1),getWord(%vec,0));
	%fix = "0 0 -1" SPC %yaw;
	%eul = axisToEuler(%fix);
	%eulA = vectorAdd(%eul,"0 0 -90");
	%rot = eulerToAxis(%eulA);
	return %rot;
}

//Boodals Code
function vectorRotateAxis(%vec,%axis)
{
	%u["x"] = getword(%axis,0);
	%u["y"] = getword(%axis,1);
	%u["z"] = getword(%axis,2);

	%angl = getword(%axis,3) * -1;
	%cos = mcos(%angl);
	%sin = msin(%angl);

	%a[1,1] = %cos + (%u["x"] * %u["x"] * (1 - %cos));
	%a[1,2] = (%u["x"] * %u["y"] * (1 - %cos)) - (%u["z"] * %sin);
	%a[1,3] = (%u["x"] * %u["z"] * (1 - %cos)) + (%u["y"] * %sin);

	%a[2,1] = (%u["y"] * %u["x"] * (1 - %cos)) + (%u["z"] * %sin);
	%a[2,2] = %cos + (%u["y"] * %u["y"] * (1 - %cos));
	%a[2,3] = (%u["y"] * %u["z"] * (1 - %cos)) - (%u["x"] * %sin);

	%a[3,1] = (%u["z"] * %u["x"] * (1 - %cos)) - (%u["y"] * %sin);
	%a[3,2] = (%u["z"] * %u["y"] * (1 - %cos)) + (%u["x"] * %sin);
	%a[3,3] = %cos + (%u["z"] * %u["z"] * (1 - %cos));

	%x = getWord(%vec, 0);
	%y = getWord(%vec, 1);
	%z = getWord(%vec, 2);

	%newx = (%a[1,1] * %x) + (%a[1,2] * %y) + (%a[1,3] * %z);
	%newy = (%a[2,1] * %x) + (%a[2,2] * %y) + (%a[2,3] * %z);
	%newz = (%a[3,1] * %x) + (%a[3,2] * %y) + (%a[3,3] * %z);

	%pos = %newx SPC %newy SPC %newz;
	return %pos;
}