//SFX
datablock AudioProfile(KingdomMagicFireSound)
{
   filename    = "./MagicFire.wav";
   description = AudioClose3d;
   preload = true;
};



//Magnet Trail
datablock ParticleData(KingdomMagnetTrailParticle)
{
	dragCoefficient      = 10;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.1;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 50;
	textureName          = "base/data/particles/dot";
	spinSpeed			 = 10.0;
	spinRandomMin		 = -150.0;
	spinRandomMax		 = 150.0;
	colors[0]     = "1 0 1 0.4";
	colors[1]     = "1 1 1 0";
	sizes[0]      = 1;
	sizes[1]      = 0;
	times[0] = 0;
	times[1] = 1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(KingdomMagnetTrailEmitter)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 1;
	velocityVariance = 0.5;
	ejectionOffset   = 0;
	thetaMin         = 0;
	thetaMax         = 90;
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance = false;
	particles = "KingdomMagnetTrailParticle";

	uiName = "";
};


//Magnet Explosion
datablock ParticleData(KingdomMagnetExplosionParticle)
{
	dragCoefficient      = 10;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 1;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 50;

	textureName   = "base/data/particles/ring";
	colors[0]     = "1 0 1 0.4";
	colors[1]     = "1 1 1 0";
	sizes[0]      = 3;
	sizes[1]      = 3;
};
datablock ParticleEmitterData(KingdomMagnetExplosionEmitter)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 5;
	velocityVariance = 4;
	particles = "KingdomMagnetExplosionParticle";
	uiName = "";
};
datablock ExplosionData(KingdomMagnetExplosion)
{
	particleDensity = 5;
	particleRadius = 0.2;

	emitter[0] = KingdomMagnetExplosionEmitter;
	emitter[1] = "";

	lifeTimeMS 		= 100;
	faceViewer    	= true;
	explosionScale 	= "1 1 1";
};

//Magnet Projectile
datablock ProjectileData(KingdomMagnetProjectile)
{
	projectileShapeName = "base/data/shapes/empty.dts";
	directDamage        = 0;
	particleEmitter     = KingdomMagnetTrailEmitter;
	explosion		    = KingdomMagnetExplosion;

	impactImpulse		= 0;
	verticalImpulse		= 0;
	muzzleVelocity      = 90;
	velInheritFactor    = 0;

	armingDelay         = 6000;
	lifetime            = 6000;
	fadeDelay           = 6000;
	bounceElasticity    = 0.6;
	bounceFriction      = 0.0;
	isBallistic         = true;
	gravityMod = 0.5;

	hasLight    = false;
	uiName = "";
};



//Magnet Emitter
datablock ParticleData(KingdomMagnetParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -1;
	inheritedVelFactor   = 0.2;
	lifetimeMS           = 400;
	lifetimeVarianceMS   = 200;
	textureName          = "base/data/particles/dot";
	spinSpeed			 = 1.0;
	colors[0]     = "1 0 1 0.4";
	colors[1]     = "1 1 1 0";
	sizes[0]      = 0;
	sizes[1]      = 0.5;

	useInvAlpha = false;
};
datablock ParticleEmitterData(KingdomMagnetEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 1;
   overrideAdvance = false;
   particles = "KingdomMagnetParticle";
};

//Magnet Spell Image
datablock ShapeBaseImageData(KingdomMagnetImage : KingdomMenuImage)
{
	mountPoint = 1;
	stateName[0]                    = "Ready";
	stateTransitionOnTimeout[0]		= "Ready";
	stateTimeoutValue[0]			= 0.2;
	stateEmitter[0]					= KingdomMagnetEmitter;
	stateEmitterTime[0]				= 0.3;
};
function KingdomMagnetImage::onMount(%this,%player,%slot)
{
	Parent::onMount(%this,%player,%slot);
	%player.playthread(1,armreadyleft);
}


//Frozen Image
datablock ParticleData(KingdomStoppedParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/exclamation";
	spinSpeed			= 0.0;
	colors[0]     = "1 1 1 1";
	colors[1]     = "1 1 1 0";
	sizes[0]      = 1;
	sizes[1]      = 1;

	useInvAlpha = true;
};
datablock ParticleEmitterData(KingdomStoppedEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 20;
   velocityVariance = 5;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "KingdomStoppedParticle";
};
datablock ShapeBaseImageData(KingdomStoppedImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

	mountPoint = 2;
	offset = "0 0 1.5";
	eyeOffset = "0 -1 0";

	stateName[0]					= "Ready";
	stateTransitionOnTimeout[0]		= "FireA";
	stateTimeoutValue[0]			= 0.1;

	stateName[1]					= "FireA";
	stateTransitionOnTimeout[1]		= "Ready";
	stateWaitForTimeout[1]			= true;
	stateTimeoutValue[1]			= 1.0;
	stateEmitter[1]					= KingdomStoppedEmitter;
	stateEmitterTime[1]				= 2.0;
};


//Aero Particle
datablock ParticleData(KingdomAeroParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 50;
	textureName          = "base/data/particles/thinring";
	spinSpeed			 = 2;
	colors[0]     = "1 1 1 0.2";
	colors[1]     = "1 1 1 0";
	sizes[0]      = 3;
	sizes[1]      = 3;

	useInvAlpha = true;
};
datablock ParticleEmitterData(KingdomAeroEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 1;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "KingdomAeroParticle";
};

//Aero Explosion
datablock ExplosionData(KingdomAeroExplosion)
{
	lifeTimeMS = 100;

	emitter[0] = KingdomAeroEmitter;   
	particleDensity = 1;
	particleRadius = 10;

	faceViewer     = true;
	explosionScale = "1 1 1";
};

//Aero Projectile
datablock ProjectileData(KingdomAeroProjectile)
{
	explosion = KingdomAeroExplosion;
};


//Stop Trail
datablock ParticleData(KingdomStopTrailParticle)
{
	dragCoefficient      = 10;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.1;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/thinring";
	spinSpeed			 = 10.0;
	spinRandomMin		 = -150.0;
	spinRandomMax		 = 150.0;
	colors[0]     = "0.2 0.2 0.2 0";
	colors[1]     = "1 1 1 0.3";
	sizes[0]      = 0.5;
	sizes[1]      = 0.0;
	times[0] = 0.0;
	times[1] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(KingdomStopTrailEmitter)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 2;
	velocityVariance = 1;
	ejectionOffset   = 0;
	thetaMin         = 0;
	thetaMax         = 90;
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance = false;
	particles = "KingdomStopTrailParticle";

	uiName = "";
};

//Stop Explosion
datablock ParticleData(KingdomStopExplosionParticle : swordExplosionParticle)
{
	lifetimeMS           = 200;
	lifetimeVarianceMS   = 100;
	gravityCoefficient   = 0;
	spinRandomMin = -90;
	spinRandomMax = 90;
	textureName   = "base/data/particles/star1";
	colors[0]     = "0.2 0.2 0.2 0";
	colors[1]     = "1 1 1 0.3";
	sizes[0]      = 1.5;
	sizes[1]      = 0.0;
};
datablock ParticleEmitterData(KingdomStopExplosionEmitter : swordExplosionEmitter)
{
	ejectionVelocity = 5;
	velocityVariance = 1;
	particles = "KingdomStopExplosionParticle";
	uiName = "";
};
datablock ExplosionData(KingdomStopExplosion)
{
	lifeTimeMS = 500;

	emitter[0] = KingdomStopExplosionEmitter;   
	emitter[1] = GunSmokeEmitter;
	particleDensity = 2;
	particleRadius = 0;

	faceViewer     = true;
	explosionScale = "1 1 1";
};

//Stop Projectile
datablock ProjectileData(KingdomStopProjectile)
{
	directDamage        = 0;
	particleEmitter     = KingdomStopTrailEmitter;
	explosion		    = KingdomStopExplosion;

	explodeOnDeath 		= true;
	muzzleVelocity      = 5;
	velInheritFactor    = 0;
	armingDelay         = 100;
	lifetime            = 100;

	hasLight = false;
	uiName = "";
};


//Gravity Trail
datablock ParticleData(KingdomGravityTrailParticle : KingdomStopTrailParticle)
{
	textureName   = "base/data/particles/thinring";
	colors[0]     = "0.8 0.5 0 0.4";
	colors[1]     = "1 0.7 0 1";
};
datablock ParticleEmitterData(KingdomGravityTrailEmitter : KingdomStopTrailEmitter)
{
	particles = "KingdomGravityTrailParticle";
};

//Gravity Explosion
datablock ParticleData(KingdomGravityExplosionParticle : KingdomStopExplosionParticle)
{
	textureName   = "base/data/particles/dot";
	colors[0]     = "0.8 0.5 0 0.4";
	colors[1]     = "1 0.7 0 1";
};
datablock ParticleEmitterData(KingdomGravityExplosionEmitter : KingdomStopExplosionEmitter)
{
	ejectionVelocity = 10;
	velocityVariance = 5;
	particles = "KingdomGravityExplosionParticle";
	uiName = "";
};
datablock ExplosionData(KingdomGravityExplosion : KingdomStopExplosion)
{
	emitter[0] = KingdomGravityExplosionEmitter;   
};

//Gravity Projectile
datablock ProjectileData(KingdomGravityProjectile)
{
	directDamage        = 0;
	particleEmitter     = KingdomGravityTrailEmitter;
	explosion		    = KingdomGravityExplosion;

	explodeOnDeath 		= true;
	muzzleVelocity      = 10;
	velInheritFactor    = 0;
	armingDelay         = 100;
	lifetime            = 100;

	hasLight = false;
	uiName = "";
};


//Fireball Trail
datablock ParticleData(KingdomFireTrailParticle)
{
	dragCoefficient      = 10;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.1;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 50;
	textureName          = "base/data/particles/cloud";
	spinSpeed			 = 10.0;
	spinRandomMin		 = -150.0;
	spinRandomMax		 = 150.0;
	colors[0]     = "1 0 0 0";
	colors[1]     = "1 0.5 0 1";
	sizes[0]      = 1;
	sizes[1]      = 0;
	times[0] = 0;
	times[1] = 1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(KingdomFireTrailEmitter)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 1;
	velocityVariance = 1;
	ejectionOffset   = 0;
	thetaMin         = 0;
	thetaMax         = 90;
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance = false;
	particles = "KingdomFireTrailParticle";

	uiName = "";
};

//Fireball Explosion
datablock ParticleData(KingdomFireParticle)
{
	dragCoefficient      = 10;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 1;
	lifetimeMS           = 300;
	lifetimeVarianceMS   = 100;

	textureName   = "base/data/particles/cloud";
	colors[0]     = "1 0 0 1";
	colors[1]     = "1 0.3 0 0";
	sizes[0]      = 0;
	sizes[1]      = 1;
};
datablock ParticleEmitterData(KingdomFireEmitter)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 5;
	velocityVariance = 5;
	particles = "KingdomFireParticle";
	uiName = "";
};
datablock ExplosionData(KingdomFireExplosion)
{
	particleDensity = 10;
	particleRadius = 0.2;

	emitter[0] = KingdomFireEmitter;

	lifeTimeMS 		= 100;
	faceViewer    	= true;
	explosionScale 	= "1 1 1";

	damageRadius = 1;
	radiusDamage = 1;
	playerBurnTime = 5000;
};

//Fireball Heavy Explosion
datablock ParticleData(KingdomFiragaParticle)
{
	dragCoefficient      = 10;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 1;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 100;

	textureName   = "base/data/particles/thinring";
	colors[0]     = "1 0 0 1";
	colors[1]     = "1 0.6 0.4 0";
	sizes[0]      = 3;
	sizes[1]      = 3;
};
datablock ParticleEmitterData(KingdomFiragaEmitter)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 5;
	velocityVariance = 5;
	particles = "KingdomFiragaParticle";
	uiName = "";
};
datablock ExplosionData(KingdomFiragaExplosion)
{
	particleDensity = 10;
	particleRadius = 0.2;

	emitter[0] = KingdomFiragaEmitter;
	emitter[1] = OrangeWandExplosionEmitter;

	lifeTimeMS 		= 100;
	faceViewer    	= true;
	explosionScale 	= "1 1 1";
};
datablock ProjectileData(KingdomFiragaExplosionProjectile)
{
	explosion = KingdomFiragaExplosion;
};

//Fireball Projectile
datablock ProjectileData(KingdomFireProjectile)
{
	directDamage        = 20;
	directDamageType    = $DamageType::Direct;
	radiusDamageType    = $DamageType::Direct;
	particleEmitter     = KingdomFireTrailEmitter;
	explosion		    = KingdomFireExplosion;

	impactImpulse		= 100;
	verticalImpulse		= 100;
	muzzleVelocity      = 200;
	velInheritFactor    = 0;

	armingDelay         = 0;
	lifetime            = 1000;
	fadeDelay           = 1000;
	bounceElasticity    = 0;
	bounceFriction      = 0;
	isBallistic         = false;
	gravityMod = 0.0;

	hasLight    = false;
	uiName = "";
};

//Fireball Heavy Projectile
datablock ProjectileData(KingdomFiragaProjectile : KingdomFireProjectile)
{
	directDamage        = 40;

	impactImpulse		= 400;
	verticalImpulse		= 400;
	muzzleVelocity      = 50;

	lifetime            = 500;
	fadeDelay           = 500;
	bounceElasticity    = 0;
	bounceFriction      = 0;
	isBallistic         = false;
	gravityMod = 0.0;

	hasLight    = false;
	uiName = "";
};


//Blizzard Trail
datablock ParticleData(KingdomBlizzardTrailParticle : KingdomFireTrailParticle)
{
	textureName   = "base/data/specialfx/snow";
	colors[0]     = "0 1 1 0.4";
	colors[1]     = "0.6 1 1 0";
	sizes[0]      = 0;
	sizes[1]      = 1;
};
datablock ParticleEmitterData(KingdomBlizzardTrailEmitter : KingdomFireTrailEmitter)
{
	particles = "KingdomBlizzardTrailParticle";
};

//Blizzard Explosion
datablock ParticleData(KingdomBlizzardParticle : KingdomFireParticle)
{
	textureName   = "base/data/particles/star1";
	colors[0]     = "0 1 1 0.4";
	colors[1]     = "0.8 1 1 0";
	sizes[0]      = 0;
	sizes[1]      = 0.5;
};
datablock ParticleEmitterData(KingdomBlizzardEmitter : KingdomFireEmitter)
{
	ejectionVelocity = 5;
	velocityVariance = 5;
	particles = "KingdomBlizzardParticle";
	uiName = "";
};
datablock ExplosionData(KingdomBlizzardExplosion)
{
	particleDensity = 10;
	particleRadius = 0.2;
	lifeTimeMS 		= 100;
	emitter[0] = KingdomBlizzardEmitter;   
};

//Blizzard Projectile
datablock ProjectileData(KingdomBlizzardProjectile : KingdomFireProjectile)
{
	directDamage        = 9;
	particleEmitter     = KingdomBlizzardTrailEmitter;
	explosion		    = KingdomBlizzardExplosion;
	explodeOnDeath		= false;
	impactImpulse		= 200;
	verticalImpulse		= 200;
	muzzleVelocity      = 90;
	lifetime            = 300;
	fadeDelay           = 300;
};

//Blizzard Projectile
datablock ProjectileData(KingdomBlizzardWeakProjectile : KingdomBlizzardProjectile)
{
	directDamage    = 5;
	impactImpulse	= 50;
	verticalImpulse	= 50;
};

//Heavy Blizzard Trail
datablock ParticleData(KingdomBlizzagaTrailParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.1;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 50;
	textureName          = "base/data/particles/thinring";
	spinSpeed			 = 10.0;
	colors[0]     = "0 1 1 0.4";
	colors[1]     = "0.8 1 1 0";
	sizes[0]      = 0.6;
	sizes[1]      = 0.6;
	times[0] = 0;
	times[1] = 1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(KingdomBlizzagaTrailEmitter)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 10;
	velocityVariance = 5;
	ejectionOffset   = 0;
	thetaMin         = 0;
	thetaMax         = 90;
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance = false;
	particles = "KingdomBlizzagaTrailParticle";

	uiName = "";
};

//Blizzard Heavy Projectile
datablock ProjectileData(KingdomBlizzagaProjectile : KingdomBlizzardProjectile)
{
	directDamage        = 10;
	particleEmitter     = KingdomBlizzagaTrailEmitter;

	impactImpulse		= 100;
	verticalImpulse		= 100;
	muzzleVelocity      = 8;

	lifetime            = 400;
	fadeDelay           = 400;
	bounceElasticity    = 0;
	bounceFriction      = 0;
	isBallistic         = false;
	gravityMod = 0.0;

	hasLight    = false;
	uiName = "";
};


//Cast Magic
function FireKingdomSpell(%player,%projectile)
{
	if(%projectile $= "KingdomStopProjectile") //Stop
		CastKingdomRadiusSpell(%player,"Stop ",5,5,7);
	if(%projectile $= "KingdomGravityProjectile") //Gravity
		CastKingdomRadiusSpell(%player,"Gravity ",5,5,7);
//	if(%projectile $= "KingdomMagnetProjectile") //Magnet
//	{
//		CastKingdomRadiusSpell(%player,"Magnet ",5,3,10); //was 1,1,10
//		%player.playthread(2,leftrecoil);
//	}
//	else //if not Magnet, do regular cast FX
//	{
		%pos = %player.getMuzzlePoint(0); //right hand
		%vec = %player.getMuzzleVector(0); //aim vector
		serverplay3d(kingdommagicfiresound,%pos); //play magic fire sound
		SpawnKingdomSpellProjectile(%player,%projectile,%vec); //continue to spawning projectile
//	}
}
function SpawnKingdomSpellProjectile(%player,%projectile,%vec,%shellcount,%spread,%position,%energy)
{
	if(%position $= "") //if position undefined
		%position = %player.getMuzzlePoint(0); //right hand
	if(%shellcount $= "") //if no shell count defined
		%shellcount = 1; //set shell count to 1
	%velocity = vectorScale(%vec,%projectile.muzzleVelocity); //set projectile's initial velocity
	for(%shell=0;%shell<%shellcount;%shell++)
	{
		if(%shellcount > 1) //If more than one shell, add spread
		{
			%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
			%velocity = MatrixMulVector(%mat, %velocity);
		}
		%p = new (Projectile)() //create projectile
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %position;
			sourceObject = %player;
			client = %player.client;
			KingEnergy = %energy;
		};MissionCleanup.add(%p);
	}
}

//Radius Spell
function CastKingdomRadiusSpell(%player,%spell,%max,%range,%len)
{
	%hand = %player.getMuzzlePoint(0); //right hand
	%vec = %player.getMuzzleVector(0); //aim vector
	initContainerRadiusSearch(%hand,%len,$TypeMasks::PlayerObjectType); //search only for players
	while(%col = containerSearchNext())
	{
		if(isObject(%col) && %col != %player && miniGameCanDamage(%player,%col) && isObject(%player.client.minigame)) //If col is damageable
		{
			%cHack = %col.getHackPosition(); //col hack position
			%sub = vectorSub(%cHack,%hand); //vector from hand to col hack
			%sNrm = vectorNormalize(%sub); //normalized %sub
			%sLen = vectorLen(%sub); //length of %sub
			%scale = vectorScale(%vec,%sLen); //scale aim vector to the length of %sub
			%pAdd = vectorAdd(%hand,%scale); //find the point %sLen in front of player's right hand
			%dist = vectorDist(%sNrm,%vec); //find the distance b/n the aim vector and normalized sub vector
			%div = %dist*%sLen; //scale distance difference to make a similar angle range (so the range doesn't widen the farther away you are)
		//	centerPrint(%player.client,"<font:impact:30>\c2" SPC %col.name SPC "    distance =" SPC %dist SPC "   divided =" SPC %div,5);
			if(%div < %range && %a < %max) //if scaled difference is less than the define range, and the number of col's found is less than the defined maximum
			{
				KingdomRadiusSpellActual(%col,%spell,%player); //Do radius spell
				%a++;
			}
		}
	}
}

//Cast Actual Radius Spell
function KingdomRadiusSpellActual(%player,%spell,%caster)
{
//	echo("Spell Cast Actual attempted   spell =" SPC %spell SPC "   obj Kingdom Stopped =" SPC %player.isKingdomStopped);
	%client = %player.client; //victim's client
	%item = %client.invName[%client.KingdomSlot]; //current inventory Item
	if(%spell $= "Fire ") //If Fire
	{
		%sub = vectorSub(%player.getHackPosition(),%caster.getMuzzlePoint(0)); //vector b/n player and target
		%nrm = vectorNormalize(%sub); //normalized sub vector
		SpawnKingdomSpellProjectile(%caster,KingdomFiragaProjectile,%nrm); //spawn heavy projectile
	}
	else if(%spell $= "Magnet " && %player.KingdomMagnet $= "") //If Magnet and not magnetized already
	{
	//	%cont = %item.isMain || %client.KingdomSlot == -1; //If victim is in the main menu or has no menu open
	//	%lefty = %caster.getMountedImage(1); //check victim's left hand
	//	schedule(50,0,KingdomMagnetCheck,%player,%caster); //Start Magnetized check loop
	//	if(!isObject(%lefty) || %lefty.getName() !$= "KingdomMagnetImage") //Only mount Magnet Image if not already mounted
	//	{
		//	%sub = vectorSub(%player.getHackPosition(),%caster.getMuzzlePoint(0)); //vector b/n player and target
		//	%nrm = vectorNormalize(%sub); //normalized sub vector
			%vec = %caster.getMuzzleVector(0);
			SpawnKingdomSpellProjectile(%caster,KingdomMagnetProjectile,%vec);
	//		KingdomUnMagnetize(%player); //Break victim's magnet
	//		%caster.mountImage(KingdomMagnetImage,1); //mount fancy Magnet particle image
	//		KingdomMagnetEnergyDrain(%caster,true); //start draining Magnetic Energy
	//		$KingMagnetDamage = 1; //damage divisor
	//		$KingMagnetScale = 7; //speed multiplier
	//		$KingMagnetSpeed = 40; //max swing speed
	//		$KingMagnetTime = 400; //timeout before next slam will be counted
	//		%caster.playthread(1,armreadyleft); //left hand up animation
	//	}
		//%player.isPhysJumpOverride = true; //override rolling and flipping
	//	%player.KingdomMagnet = %caster; //set victim's attacker
	//	schedule(1,0,KingSpellSet,%player); //set spell
	}
	else if(%spell $= "Stop " && !%player.isKingdomStopped) //If Stop and not Stop'd already
	{
		%time = 8000; //time Stop will last
		%cont = %item.isMain || %client.KingdomSlot == -1; //If victim is in the main menu or has no menu open
		%power = %player.hLoopActive; //victim's power status (if bot)
		%camera = %client.camera; //victim's camera
		%player.KUnStop = schedule(%time,0,KingdomUnStop,%player,%power); //schedule Stop's end
		%player.mountImage(KingdomStoppedImage,2); //mount emote
		%player.isKingdomStopped = true; //victim is Stop'd
		schedule(1,0,KingSpellSet,%player); //set spell
		if(%player.isBot) //if victim is a bot
		{
			%player.setBotPowered(false); //turn bot off
			return; // stop here
		}
		%data = %player.getDatablock(); //victim's datablock
		%dist = %data.cameraMaxDist; //victim datablock's camera distance
		if(%dist < 4) //if cam distance too close
			%dist = 4; //Make sure camera isn't too close to victim
		%tra = %player.getTransform(); //Player direction
		%camera.mode = "KingdomStopped"; //set camera mode (to prevent overlapping)
		%camera.player = %player; //link victim to camera
		%camera.setOrbitMode(%player,%tra,0,%dist,%dist,true); //orbit camera around victim
		%camera.setTransform(%tra); //rotate camera
		%client.setControlObject(%camera); //set client to control camera
	}
	else if(%spell $= "Gravity " && !%player.isKingdomGravitized) //If Gravity and not gravitized already
	{
		%time = 8000; //time Gravity will last
		%cont = %item.isMain || %client.KingdomSlot == -1; //If victim is in the main menu or has no menu open
		%player.KUnGrav = schedule(%time,0,KingdomUnGravitize,%player); //schedule Gravity's stop
		%player.isKingdomGravitized = true; //victim is now gravitized
		schedule(1,0,KingSpellSet,%player); //set spell
		if(%player.lastScale $= "") //if scale is not already changed
		{
			%player.lastScale = %player.getScale(); //save scale
			%words = getWords(%player.getScale(),0,1); //xy scale
			%word2 = getWord(%player.getScale(),2); //get z scale
			%player.setScale(%words SPC %word2*0.5); //make victim half size (scaled to their current size)
		}
		%player.damage(%caster,0,5,$DamageType::Default); //Apply mild damage
	}
//	if(%cont)
//		UpdateKingdomMenu(%client); //Add Break to menu
}

function KingSpellSet(%player)
{
	%client = %player.client; //define client
	%tool = %player.tool[%player.currTool]; //current Tool
	%item = %client.invName[%client.KingdomSlot]; //KH Item (in selected slot)
	
	if(!%player.getDatablock().canKingdom || %player.KHSpellSet) //if wrong playertype, or Spell is already set
		return; //stop here

	if(%tool.uiName $= "Keyblade") //if Keyblade equiped
		%slot = 0; //1st slot
	else if(%item.canKMagic)
		%slot = 1; //2nd slot
	else if(%item.canKUse)
		%slot = 2; //3rd slot
	else if(%tool.uiName !$= "Keyblade") //if tool equiped, but not Keyblade
		%slot = 3; //4th slot

//	%key = isObject(%tool) && %tool.uiName $= "Keyblade"; //Keyblade equiped
	UpdateKingdomMenu(%client,6);
	KingdomInventoryOpen(%client,%slot); //open main menu (if %key, %inventory arg is false)

	%time = $KingClickTime; //uniform menu open timeout
	schedule(1,0,KingSpellSet,%player); //set spell
	%player.isKingSpelled = true; //spelled is true
	%player.KHSpellSet = true; //prevent multiple sets
	%player.hasKingdomSelected = true; //delay menu changing (fixes a bug)
	schedule(%time+50,0,eval,%player@".hasKingdomSelected = false;"); //..
}

//Magic Energy Charge
function KingdomMagicCharge(%player,%type,%start)
{
	if(!isObject(%player) || %player.getState() $= "Dead") //If player does not exist or is dead
		return; //Stop here
	%client = %player.client; //player's client
	%slot = %client.KingdomSlot; //client's special inventory slot
	%max = %client.KingdomMaxMagic; //client's max magic
	%magic = KingdomCheckManaPoints(%player,"Magic"); //player's current magic level
	if(%start && %magic >= 5) //if first loop
	{
		%player.KingSpecialEnergy = 0; //Reset Special energy
		cancel(%player.isKSStart); //cancel extra schedules
		%player.isKSStart = schedule(400,0,eval,%player@".isKingSpecialStarting = false;"); //Delay changing of MP bar
		%player.isKingSpecialStarting = true; //
	}
	if((%client.invName[%slot].uiName $= %type && %player.KingSpecialEnergy < %max && %player.isKingClicking) && %magic > 20) //If correct menu item, not full energy bar and holding click, and magic > 20
		%player.KingSpecialEnergy = %player.KingSpecialEnergy+2; //Charge magic
	if(%player.KingSpecialEnergy > %max) //if special energy > max MP
		%player.KingSpecialEnergy = %max; //Cap energy at max MP value
	if(%client.invName[%slot].uiName !$= %type || !%player.isKingClicking) //if player scrolls away from menu Item or releases click
		%player.KingSpecialEnergy = ""; //Disable meter and charge
	else //otherwise continue the loop
	{
		%interval = 50; //time b/n loops
		schedule(%interval,0,KingdomMagicCharge,%player,%type); //loop
	}
}

//Cast Strong Magic
function KingdomMagicSpecial(%player)
{
	%client = %player.client; //player's client
	%slot = %client.KingdomSlot; //client's special inventory slot
	%type = %client.invName[%slot].uiName; //client's inventory Item
	%mult = %player.KingSpecialEnergy/10; //change energy from a scale of x/100 to a scale of x/10
	%magic = KingdomCheckManaPoints(%player,"Magic"); //current magic
	if(%player.isKMagicDelayed) //if just used magic
		return; //stop here
	%used = 20; //Magic used for spell
	%vec = %player.getMuzzleVector(0); //aim vector
	%hand = %player.getMuzzlePoint(0); //right hand
	if(%type $= "Fire " && %player.KingSpecialEnergy !$= "") //If Fire and charged at all
	{
		%time = 150; //Magic timeout
		if(%player.isKingSpecialStarting) //If not charged
		{
			SpawnKingdomSpellProjectile(%player,KingdomFireProjectile,%vec); //Shoot fireball
			%player.playthread(2,activate); //animate
			%sub = 5;
		}
		else if(%player.KingSpecialEnergy > 10 && %magic >= %used) //Ready for charged spell
		{
			CastKingdomRadiusSpell(%player,"Fire ",%mult,50,%mult); //Do radius spell
			%player.spawnExplosion(KingdomFiragaExplosionProjectile,%mult*0.4); //spawn fancy radius particle, scaled to charge
			%player.playthread(2,activate2); //animate
			%hand = %player.getHackPosition(); //change sound position to torso
			%sub = 20;
		}
	}
	if(%type $= "Blizzard " && %player.KingSpecialEnergy !$= "") //If Blizzard and charged at all
	{
		%time = 600; //Magic timeout
		if(%player.isKingSpecialStarting) //If not charged
		{
			SpawnKingdomSpellProjectile(%player,KingdomBlizzardProjectile,%vec,4,0.005); //shoot ice projectiles
			%player.playthread(2,activate); //animate
			%sub = 5;
		}
		else if(%player.KingSpecialEnergy > 10 && %magic >= %used) //Ready for charged spell
		{
			KingdomFX(%player,SkyWandProjectile,%hand,%vec,0.5); //hand particle FX
			SpawnKingdomSpellProjectile(%player,KingdomBlizzardWeakProjectile,%vec,4,0.005,"",%player.KingSpecialEnergy); //shoot ice projectiles
			%player.playthread(2,activate); //animate
			%sub = 20;
		}
	}
	if(%sub !$= "") //spell cast
	{
		serverPlay3d(KingdomMagicFireSound,%hand); //play magic fire sound
		%player.KingSpecialEnergy = ""; //clear special energy
	}
	if(%sub !$= "" && !%player.isKingdomUbered) //Elixr Check
		KingdomSetManaPoints(%player,"Magic",%magic-%sub); //deduct magic
	if(%time !$= "") //If a delay is defined
	{
		schedule(%time,0,eval,%player@".isKMagicDelayed = false;"); //set delay
		%player.isKMagicDelayed = true; //
	}
}

//Blizzard Snow Storm
function KingdomBlizzardStormLoop(%player,%caster,%num,%energy)
{
	if(!isObject(%player) || %player.getState() $= "Dead" || !isObject(%caster) || %caster.getState() $= "Dead") //if caster or victim is dead
		return; //stop here
	%max = mCeil(%energy/10); //max loops
	%scale = %player.getScale(); //Player scale
	%sWrd0 = getWord(%scale,0); //x
	%sWrd1 = getWord(%scale,1); //y
	%sWrd2 = getWord(%scale,2); //z
	if(%num == 0) //Start
	{
		centerPrint(%player.client,"<font:impact:30>\c4Blizzard \c6on its way! Run!",5); //warn victim
		%delay = 2000; //time before storm starts
		schedule(%delay,0,eval,%player@".isKingStormReady = true;"); //schedule storm start
		%player.spawnExplosion(SkyWandProjectile,%sWrd2); //victim spelled FX
		%player.isKingStormReady = false; //spell delay started
		%num = 1; //loop set to 1
	}
	else if(%num <= %max && %player.isKingStormReady) //If loop number > max loops, and start delay over
	{
		//Random offsets
		%word0 = getRandom(-1,1)*1.2; //x
		%word1 = getRandom(-1,1)*1.2; //y
		%word2 = getRandom(-1,1)*1.2; //z
		//Actual attack
		%hack = %player.getHackPosition(); //victim's center
		%off = vectorAdd(%hack,%word0*%sWrd0 SPC %word1*%sWrd1 SPC %word2*%sWrd2); //random offset from victim
		%sub = vectorSub(%hack,%off); //vector from offset to victim
		%vec = vectorNormalize(%sub); //normalized sub vector
		SpawnKingdomSpellProjectile(%caster,KingdomBlizzagaProjectile,%vec,1,0,%off); //shoot Blizzaga projectile
		serverplay3d(pushbroomhitsound,%off); //play pushbroom hit sound
		%num++; //increase loop number by 1
	}
	if(%num <= %max) //continue to loop until loop number reaches the defined max loops
	{
		%interval = 200; //time b/n loops
		cancel(%player.KingBlizzLoop); //prevent extra scheduling
		%player.KingBlizzLoop = schedule(%interval,0,KingdomBlizzardStormLoop,%player,%caster,%num,%energy); //schedule next loop
	}
}

//Magnet energy drain
function KingdomMagnetEnergyDrain(%player,%start)
{
	if(!isObject(%player) || %player.getState() $= "Dead") //If player does not exist or is dead
		return; //stop here
	if(%start) //if first loop
	{
		%max = %player.client.KingdomMaxMagic; //client's max MP
		%player.KingMagnetEnergy = %max; //set player's Magnet energy
	}
	if(isObject(%lefty = %player.getMountedImage(1)) && %lefty.getName() $= "KingdomMagnetImage" && %player.KingMagnetEnergy > 0) //if Magnet image mounted and player has Magnet energy
	{
		%interval = 100; //time b/n energy deductions
		%player.KingMagnetEnergy = %player.KingMagnetEnergy-1; //drain Magnet energy
		schedule(%interval,0,KingdomMagnetEnergyDrain,%player); //schedule next drain
	}
	else //otherwise disable Magnet
		KingdomUnMagnetize(%player); //
}
//Magnet loop
function KingdomMagnetCheck(%player)
{
	%caster = %player.KingdomMagnet; //saved caster
	%item = %caster.client.invName[%caster.client.KingdomSlot]; //Special Inventory slot
	if(!isObject(%player) || %player.getState() $= "Dead") //If dead or nonexistent
		KingdomUnMagnetize(%caster); //Break caster's spell
	else if(%item.uiName $= "Magnet " && isObject(%caster) && %caster.KingdomMagnet != %player && isObject(%lefty = %caster.getMountedImage(1)) && %lefty.getName() $= "KingdomMagnetImage" && %player.isKingSpelled)
	{
		%length = 5; //length away from caster of the Magnet
		schedule(50,0,KingdomMagnetCheck,%player);
		%vec = %caster.getMuzzleVector(1); //aim vector
		%scale = vectorScale(%vec,%length); //length to offset the magnet position
		%hand = %caster.getMuzzlePoint(1); //hand point
		%point = vectorAdd(%hand,%scale); //Magnet position
		%hack = %player.getHackPosition(); //victim's torso
		%dist = vectorDist(%point,%hack); //distance b/n Magnet and victim
		if(%dist > 0) //if not close enough to the Magnet
		{
			%vel = %player.getVelocity(); //victim's velocity
			%mov = %caster.getVelocity(); //caster's velocity
			%sub = vectorSub(%point,%hack); //vector from victim to Magnet
			%spd = vectorScale(%sub,$KingMagnetScale); //scale vector to magnetic pull
			%add = vectorAdd(%spd,%mov); //add caster velocity to magnetic pull velocity
			%nrm = vectorNormalize(%add); //normalize that
			%len = vectorLen(%add); //length of %add
			%vLen = vectorLen(%vel); //length of victim's velocity
			%vNrm = vectorNormalize(%vel); //normalized victim velocity
			%vMin = %vLen-%len; //victim's speed - Magnet's pull
			%vAdd = vectorScale(%vec,%vLen); //scale aim vector by victim's speed
			%vAng = vectorDist(%vec,%vNrm); //angle b/n caster's aim and victim's normalized velocity
			%dot = vectorDot(%vAdd,%nrm); //Make sure victim is moving towards the caster's aim vector
			if(%vMin > 3 && %dot > 0 && %vLen > 5 && %vAng < 0.5)
				%add = %vAdd; //use scaled aim vector instead of magnetic pull
			else if(%dist < 0.2 && %len < 10) //If victim is very close to the magnet, and magnetic pull is less than 10
				%add = "0 0 1"; //keep them in the same spot
			%aLen = vectorLen(%add); //length of new velocity
			%aNrm = vectorNormalize(%add); //normalized new velocity
			if(%aLen > $KingMagnetSpeed) //limit final velocity
				%add = vectorScale(%aNrm,$KingMagnetSpeed);
			%player.setVelocity(%add); //set final velocity
		//	centerPrint(%caster.client,"<font:impact:30><color:FFF200><just:center>Kingdom Magnet Check<color:CCCCCC><br>" @ "len =" SPC %len SPC "vel len =" SPC %vLen SPC "vel minus =" SPC %vMin @ "<br>dist =" SPC %dist SPC "dot =" SPC %dot SPC "ang =" SPC %vAng,5);
		}
	}
	else
	{
		%player.setVelocity("0 0 0"); //null victim's velocity on release
		%player.KingdomMagnet = ""; //unbind caster from victim
	//	%player.isPhysJumpOverride = false; //allow flipping again
		if(%caster.KingdomMagnet == %player || %item.uiName !$= "Magnet ") //If players Magnet each other, or caster scrolls away from Magnet
			KingdomUnMagnetize(%caster); //Break caster's spell
		if(%caster.KingdomMagnet == %player) //If players Magnet each other
			KingdomUnMagnetize(%player); //Break victim's spell
		KingdomRemoveBreak(%player.client); //Remove the Break option from menu
	}
}

//Release Magnet
function KingdomUnMagnetize(%player)
{
	if(!isObject(%player)) //If player doesn't exist
		return;
	%player.KingMagnetEnergy = 0; //Set Magnet energy to empty
	%lefty = %player.getMountedImage(1); //left-handed image
	if(isObject(%lefty) && %lefty.getName() $= "KingdomMagnetImage") //Make sure we've got the right one
	{
		%player.unmountImage(1); //unmount it
		%weap = %player.getMountedImage(0); //right-handed image
		if(isObject(%weap) && %weap.canKingdom) //if still in the menu
			%player.playthread(1,armreadyright); //put your arm back up
	}
}

//Unfreeze when Stopped
function KingdomUnStop(%player,%power)
{
	cancel(%player.KUnStop); //cancel any extra schedules
	%player.isKingdomStopped = false; //no longer stopped
	if(!isObject(%player) || %player.getState() $= "Dead") //If player is dead or does not exist
		return;
	%client = %player.client; //player's client
	%camera = %client.camera; //player's camera
	%emote = %player.getMountedImage(2); //mounted emote
	if(%player.isBot) //If bot
		%player.setBotPowered(%power); //restore bot's powered status
	if(isObject(%emote) && %emote.getName() $= "KingdomStoppedImage") //if still emoting
		%player.unmountImage(2); //stop emoting
	if(isObject(%camera) && %camera.mode $= "KingdomStopped") //If player and in stop camera
	{
		%client.setControlObject(%player); //restore player control
		%camera.mode = "Observer"; //restore original camera mode
		%camera.setFlyMode(); //release orbit cam
		KingdomRemoveBreak(%client); //remove Break option from menu
	}
}

//Restore Scale when Gravitized
function KingdomUnGravitize(%player)
{
	cancel(%player.KUnGrav); //cancel any extra schedules
	%player.isKingdomGravitized = false; //no longer gravitized
	if(!isObject(%player) || %player.getState() $= "Dead") //If player is dead or does not exist
		return;
	%client = %player.client; //player's client
	KingdomRemoveBreak(%client); //remove Break option from menu
	if(%player.lastScale !$= "") //make sure there is a last scale
	{
		%player.setScale(%player.lastScale); //restore scale
		%player.lastScale = ""; //remove last scale
	}
}

//Remove Break command
function KingdomRemoveBreak(%client)
{
	%player = %client.player; //client's player
	%slot = %client.KingdomSlot; //Special Inventory slot
	if((!%player.isKingdomGravitized && !%player.isKingdomStopped && %player.KingdomMagnet $= "")) //If not under a specific Breakable spell
	{
		%player.KHSpellSet = false; //reset SpellSet fix
		%player.isKingSpelled = false; //player is no longer Spelled
		if((%client.invName[%slot].isMain || %slot == -1)) //If client is in the main menu or has the menu closed
		{
			UpdateKingdomMenu(%client); //remove Break option
			if(%slot == 4) //if Break is selected
				KingdomInventoryOpen(%client,0); //switch to first slot
		}
	}
}


function KingdomSpellColCheck(%hitter,%victim,%data,%vel,%pos)
{
	%magnet = %victim.getType() & $Typemasks::PlayerObjectType && %data == KingdomMagnetProjectile.getId(); //if victim is not a player, or not the Magnet projectile
	if(!%magnet) //if not Magnet
		return; //stop here
	%hPos = %hitter.getHackPosition();
	%vPos = %victim.getHackPosition();
	%sub = vectorSub(%hPos,%vPos);
	%vel = %sub;
	%vec = vectorNormalize(%vel); //directional vector from velocity
	%set = vectorScale(%vel,3); //scale velocity vector
	%len = vectorLen(%set); //length of new vector
	%set = %len > 30 ? vectorScale(%vec,30) : %set; //if set's magnitude is greater than 20, limit it to 20
	%add = vectorAdd(%set,"0 0" SPC 10);
	%victim.setVelocity(%add);
}



package KingdomSpells
{
	// function ProjectileData::onCollision(%data,%proj,%col,%fade,%pos,%normal)
	// {
		// %player = %proj.sourceObject; //spell caster
		// %vel = %proj.getVelocity(); //projectile velocity
		// Parent::onCollision(%data,%proj,%col,%fade,%pos,%normal);
		// KingdomSpellColCheck(%player,%col,%data,%vel,%pos); //check for special hit effects
	// }
	//Projectile Damage
	function ProjectileData::Damage(%data,%proj,%col,%fade,%pos,%normal)
	{
		%player = %proj.sourceObject;
		if(%col.getType() & $Typemasks::PlayerObjectType && %data.getName() $= "KingdomBlizzardWeakProjectile")
			KingdomBlizzardStormLoop(%col,%player,0,%proj.KingEnergy);
		Parent::Damage(%data,%proj,%col,%fade,%pos,%normal);
	}
	//On Impact
	function Armor::onImpact(%data,%player,%col,%pos,%speed)
	{
		%caster = %player.KingdomMagnet; //player's attacker
		if(%caster !$= "") //if attacker exists
		{
			if(!%player.justKingMagnetSlammed) //If victim was not just slammed
			{
				%player.damage(%caster,0,%speed/$KingMagnetDamage,$DamageType::Impact); //Apply Magnet Damage
				schedule($KingMagnetTime,0,eval,%player@".justKingMagnetSlammed = false;"); //schedule Magnet slam timeout
				%player.justKingMagnetSlammed = true; //
			}
		}
		else //otherwise do regular onImpact stuff
			Parent::onImpact(%data,%player,%col,%pos,%speed);
	}
	//Camera Spy Fix
	function SimObject::onCameraEnterOrbit(%player,%camera)
	{
		if(%player.isKingdomStopped) //If player is Stop'd
			%player.observerCount++; //raise observer count
		else //otherwise continue normally
			Parent::onCameraEnterOrbit(%player,%camera);
	}
	function SimObject::onCameraLeaveOrbit(%player,%camera)
	{
		if(%player.isKingdomStopped) //If player is Stop'd
			%player.observerCount--; //lower observer count
		else //otherwise continue normally
			Parent::onCameraLeaveOrbit(%player,%camera);
	}
};activatePackage(KingdomSpells);