//Explosion
datablock ParticleData(MysteryBladeExplosionParticle : swordExplosionParticle)
{
   gravityCoefficient   = 0;
   spinRandomMin = -90;
   spinRandomMax = 90;
   textureName   = "base/data/particles/star1";
   colors[0]     = "1 0.6 0.1 1";
   colors[1]     = "1 0 0 0";
   sizes[0]      = 0.5;
   sizes[1]      = 1.5;
};
datablock ParticleEmitterData(MysteryBladeExplosionEmitter : swordExplosionEmitter)
{
   ejectionVelocity = 0;
   particles = "MysteryBladeExplosionParticle";
   uiName = "";
};
datablock ExplosionData(MysteryBladeExplosion)
{
   lifeTimeMS = 500;

   soundProfile = swordHitSound;

   particleEmitter = MysteryBladeExplosionEmitter;
   particleDensity = 1;
   particleRadius = 0;

   faceViewer     = true;
   explosionScale = "1 1 1";
};
datablock ProjectileData(MysteryBladeExplosionProjectile)
{
   explosion = MysteryBladeExplosion;
   uiName = "";
};

//Trail Emitter
datablock ParticleData(MysteryBladeTrailParticle)
{
	dragCoefficient      = 10;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.1;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/cloud";
	spinSpeed			 = 10.0;
	spinRandomMin		 = -150.0;
	spinRandomMax		 = 150.0;
	colors[0]     = "0.2 0.2 1 1";
	colors[1]     = "0.5 0.5 1 0.6";
	colors[2]     = "1 0.2 0.2 0";
	colors[3]     = "1 0.5 0.5 0.2";

	sizes[0]      = 0;
	sizes[1]      = 0.25;
    sizes[2]      = 0.5;
    sizes[3]      = 0.75;

	times[0] = 0.0;
	times[1] = 0.1;
	times[2] = 0.3;
	times[3] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(MysteryBladeTrailEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 1;
   velocityVariance = 1;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
	overrideAdvance = false;
	particles = "MysteryBladeTrailParticle";

	uiName = "";
};

//Blade Emote
datablock ParticleData(MysteryBladeHandParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -1;
	inheritedVelFactor   = 0.2;
	lifetimeMS           = 400;
	lifetimeVarianceMS   = 200;
	textureName          = "base/data/particles/cloud";
	spinSpeed			= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "1 0.6 0.1 0.4";
	colors[1]     = "1 0.5 0.5 0";
	sizes[0]      = 0.2;
	sizes[1]      = 0.1;

	useInvAlpha = true;
};
datablock ParticleEmitterData(MysteryBladeHandEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 1;
   velocityVariance = 1;
   overrideAdvance = false;
   particles = "MysteryBladeHandParticle";
};

//Projectiles
datablock ProjectileData(MysteryBladeProjectile)
{
   directDamage        = 10;
   directDamageType    = $DamageType::Sword;
   radiusDamageType    = $DamageType::Sword;
   particleEmitter     = MysteryBladeTrailEmitter;
   explosion		   = MysteryBladeExplosion;

   muzzleVelocity      = 30;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 100;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   uiName = "";
};

//Item
datablock ItemData(MysteryBladeItem : swordItem)
{
//	shapeFile = "add-ons/weapon_sword/sword.dts";
	shapeFile = "./mysteryblade.dts";
	uiName = "Mystery Blade";
	colorShiftColor = "0.2 0.2 0.2 1";
	image = MysteryBladeSwitchImage;
	canDrop = false;
};

//Switch Image
datablock ShapeBaseImageData(MysteryBladeBaseImage)
{
	// Basic Item properties
	shapeFile = "./mysteryblade.dts";
	emap = true;
	mountPoint = 0;

	eyeOffset = 0;
	offset = "0 0 0"; //"0 0 0.1";
	rotation = eulerToMatrix("0 0 0"); //("-90 0 -16");
	correctMuzzleVector = false;
	className = "WeaponImage";

	item = MysteryBladeItem;
	projectile = "";
	projectileType = Projectile;

	armReady = true;
	doRetraction = false;

	doColorShift = true;
	colorShiftColor = MysteryBladeItem.colorShiftColor;
	
	canMystery = 1;
};
datablock ShapeBaseImageData(MysteryBladeSwitchImage : MysteryBladeBaseImage)
{
	// Basic Item properties
	shapeFile = "./mysteryblade.dts";
	emap = true;
	mountPoint = 0;

	// Initial start up state
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.4;
	stateTransitionOnTimeout[0]     = "Ready";
	stateSound[0]                   = swordDrawSound;

	stateName[1]                    = "Ready";
	stateScript[1]					= "onReady";
};
function MysteryBladeSwitchImage::onReady(%this,%obj,%slot)
{
	%obj.mountImage(MysteryBladeImage,0);
}

//Main Image
datablock ShapeBaseImageData(MysteryBladeImage : MysteryBladeBaseImage)
{
	// Basic Item properties
	shapeFile = "./mysteryblade.dts";
	mountPoint = 0;

	// Initial start up state
	stateName[0]                    = "Ready";
	stateScript[0]					= "onReady";
	stateTransitionOnTriggerDown[0] = "PreFire";
	stateTransitionOnTimeout[0]		= "Ready";
	stateTimeoutValue[0]			= 0.2;
	stateEmitter[0]					= MysteryBladeHandEmitter;
	stateEmitterTime[0]				= 0.3;
	stateWaitForTimeout[0]			= false;

	stateName[1]					= "PreFire";
	stateScript[1]                  = "onPreFire";
	stateTimeoutValue[1]            = 0.3;
	stateEmitter[1]					= MysteryBladeHandEmitter;
	stateEmitterTime[1]				= 0.4;
	stateTransitionOnTriggerUp[1]	= "Fire";
	stateTransitionOnTimeout[1]     = "Fire2";
	stateWaitForTimeout[1]			= true;

	stateName[2]                    = "Fire";
	stateScript[2]                  = "onFire";

	stateName[3]                    = "Fire2";
	stateScript[3]                  = "onFire2";
};
function MysteryBladeImage::onReady(%this,%obj,%slot)
{
	if(%obj.isMysterySlashVert)
		%obj.playthread(3,root);
	%obj.isMysterySlashVert=0;
}
function MysteryBladeImage::onPreFire(%this,%obj,%slot)
{
//	%obj.playthread(3,activate);
	return;
}
function MysteryBladeImage::onFire(%this,%obj,%slot)
{
	MysterySlashHorizontal(%obj);
}
function MysteryBladeImage::onFire2(%this,%obj,%slot)
{
	MysterySlashVertical(%obj);
}

//Vertical Image
datablock ShapeBaseImageData(MysteryBladeVertImage : MysteryBladeBaseImage)
{
	// Basic Item properties
	shapeFile = "./mysteryblade.dts";
	mountPoint = 0;

	// Initial start up state

	stateName[0]                    = "Anim";
	stateTransitionOnTimeout[0]     = "Check";
	stateTimeoutValue[0]            = 0.2;
	stateSequence[0]				= "slashDown";
	stateWaitForTimeout[0]			= true;

	stateName[1]                    = "Check";
	stateTimeoutValue[1]            = 0.3;
	stateTransitionOnTriggerUp[1]	= "Return";
	stateWaitForTimeout[1]			= true;

	stateName[2]                    = "Return";
	stateScript[2]					= "onReturn";
};
function MysteryBladeVertImage::onReturn(%this,%obj,%slot)
{
	%obj.mountImage(MysteryBladeImage,0);
}

//Horiz Left Image
datablock ShapeBaseImageData(MysteryBladeLeftImage : MysteryBladeBaseImage)
{
	// Basic Item properties
	shapeFile = "./mysteryblade.dts";
	mountPoint = 0;

	// Initial start up state
	stateName[0]                    = "Anim";
	stateTransitionOnTimeout[0]		= "Return";
	stateTimeoutValue[0]            = 0.6;
	stateSequence[0]				= "slashLeft";
	stateWaitForTimeout[0]			= true;

	stateName[1]                    = "Return";
	stateScript[1]					= "onReturn";
};
function MysteryBladeLeftImage::onReturn(%this,%obj,%slot)
{
	%obj.mountImage(MysteryBladeImage,0);
}

//Horiz Right Image
datablock ShapeBaseImageData(MysteryBladeRightImage : MysteryBladeBaseImage)
{
	// Basic Item properties
	shapeFile = "./mysteryblade.dts";
	mountPoint = 0;

	// Initial start up state
	stateName[0]                    = "Anim";
	stateTransitionOnTimeout[0]		= "Return";
	stateTimeoutValue[0]            = 0.6;
	stateSequence[0]				= "slashRight";
	stateWaitForTimeout[0]			= true;

	stateName[1]                    = "Return";
	stateScript[1]					= "onReturn";
};
function MysteryBladeRightImage::onReturn(%this,%obj,%slot)
{
	%obj.mountImage(MysteryBladeImage,0);
}

//Blade Fcns
function MysterySlashVertical(%obj)
{
	%vel = %obj.getVelocity();
	%up = %obj.getUpVector();
	%uVel = vectorDot(%vel,%up);
	%obj.mountImage(MysteryBladeVertImage,0);
	if(%uVel > 0.5)
	{
	//	%obj.playthread(3,spearReady);
		%obj.isMysterySlashVert=1;
		%dir = 2;
	}
	else
	{
	//	%obj.playthread(3,shiftto);
		%dir = 1;
	}
	schedule(150,0,MysterySlashStart,%obj,"A",%dir);
}
function MysterySlashHorizontal(%obj)
{
	%vel = %obj.getVelocity();
	%left = getLeftVector(%obj);
	%lVel = vectorDot(%vel,%left);
	if(%lVel > 0.5)
	{
		%obj.mountImage(MysteryBladeRightImage,0);
	//	%obj.playthread(3,shiftleft);
		%dir = 2;
	}
	else
	{
		%obj.mountImage(MysteryBladeLeftImage,0);
	//	%obj.playthread(3,shiftright);
		%dir = 1;
	}
	schedule(150,0,MysterySlashStart,%obj,"B",%dir);
}
function MysterySlashStart(%obj,%type,%dir)
{
	%max = 20;
	for(%a=0;%a<%max;%a++)
		MysterySlashLoop(%obj,%type,%dir,%max,%a);
}
function MysterySlashLoop(%obj,%type,%dir,%max,%var)
{
	%wep = %obj.getMountedImage(0);
	if(!isObject(%obj) || %obj.getState() $= "Dead" || %wep == 0 || !%wep.canMystery)
		return;
	%up = %obj.getUpVector();
	%left = getLeftVector(%obj);
	%scale = 0.75;
	%shift = %scale/10;
	if(%type $= "A")
	{
		if(%dir == 2)
		{
			%start = -%scale;			
			%sub = %start+(%var*%shift);
		}
		else
		{
			%start = %scale;
			%sub = %start-(%var*%shift);
		}
		%add = vectorScale(%up,%sub);
	}
	if(%type $= "B")
	{
		if(%dir == 2)
		{
			%start = -%scale;			
			%sub = %start+(%var*%shift);
		}
		else
		{
			%start = %scale;
			%sub = %start-(%var*%shift);
		}
		%add = vectorScale(%left,%sub);
	}
	%projectile = MysteryBladeProjectile;
	%vec = %obj.getForwardVector();
	%vecA = %obj.getEyeVector();
	%vecB = %obj.getMuzzleVector(0);
	%vecC = getWords(%vec,0,1) SPC getWord(%vecA,2);
	if(getWord(%vecA,2) == getWord(%vecB,2))
		%vector = vectorAdd(%vecB,%add);
	else
		%vector = vectorAdd(%vecC,%add);
	%objectVelocity = %obj.getVelocity();
	%vector1 = vectorScale(%vector,%projectile.muzzleVelocity);
	%vector2 = vectorScale(%objectVelocity,%projectile.velInheritFactor);
	%velocity = vectorAdd(%vector1,%vector2);
	%muzzle = %obj.getMuzzlePoint(0);
	%mov = vectorScale(%vector,%var*0.05);
	if(%var > 10)
		%mov = vectorScale(%vector,(%max-%var)*0.05);
	%position = vectorAdd(%muzzle,%mov);
	%p = new (Projectile)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %position;
		sourceObject = %obj;
		client = %obj.client;
	};MissionCleanup.add(%p);
}

//Vector Code
function getLeftVector(%obj)
{
	return vectorCross(%obj.getForwardVector(),%obj.getUpVector());
}