//audio
datablock AudioProfile(paintballShotSound)
{
   filename    = "./files/paintballShot.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(paintballHit)
{
   filename    = "./files/paintballHit.wav";
   description = AudioClose3d;
   preload = true;
};


//shell
datablock DebrisData(paintballBlueDebris)
{
	shapeFile = "./blue/paintshell.dts";
	lifetime = 1;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

//muzzle flash effects
datablock ParticleData(paintballBlueFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 1;
	lifetimeVarianceMS   = 0;
	textureName          = "./blue/cloud.png";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.9 0.0 0.9";
	colors[1]     = "0.9 0.5 0.0 0.0";
	sizes[0]      = 0.5;
	sizes[1]      = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(paintballBlueFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "paintballBlueFlashParticle";

   uiName = "paintblue1";
};

//explosion FX
datablock ParticleData(paintballBlueExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "./blue/cloud.png";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	sizes[0]      = 0.25;
	sizes[1]      = 0.75;

	useInvAlpha = true;
};
datablock ParticleEmitterData(paintballBlueExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "paintballBlueExplosionParticle";

   useEmitterColors = true;
   uiName = "Paintball Gun Blue Hit Dust";
};

//gun smoke
datablock ParticleData(paintballBlueSmokeParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 1;
	lifetimeVarianceMS   = 0;
	textureName          = "./blue/cloud.png";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.9";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(paintballBlueSmokeEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "paintballBlueSmokeParticle";

   uiName = "paintblue2";
};

//Same for all Paintball guns
datablock ParticleData(paintballExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 1;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 0.0 0.9";
	colors[1]     = "0.9 0.0 0.0 0.0";
	sizes[0]      = 1;
	sizes[1]      = 0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(paintballExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "paintballExplosionRingParticle";

   useEmitterColors = true;
   uiName = "Paintball Ring Emitter";
};

//explosion
datablock ExplosionData(paintballBlueExplosion)
{
	soundProfile = paintballHit;

   lifeTimeMS = 500;

   particleEmitter = paintballBlueExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = paintballExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 0;
   lightStartColor = "0.5 0.8 0.9";
   lightEndColor = "0 0 0";
};

//Projectile
AddDamageType("PaintballGunBlue",   '<bitmap:add-ons/Weapon_PaintballGuns/blue/CI_Gun> %1',    '%2 <bitmap:add-ons/Weapon_PaintballGuns/blue/CI_gun> %1',0.2,1);
datablock ProjectileData(paintballBlueProjectile)
{
   projectileShapeName = "./blue/paintball.dts";
   directDamage        = 5;
   directDamageType    = $DamageType::Gun;
   radiusDamageType    = $DamageType::Gun;

   impactImpulse	   = 100;
   verticalImpulse	   = 100;
   explosion           = paintballBlueExplosion;

   muzzleVelocity      = 90;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 10000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   isPaintball = true;
   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Paintball Gun Blue Bullet";
};

//Item
datablock ItemData(PaintballGunBlueItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	shapeFile = "./blue/pistol.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "PB Gun Blue";
	iconName = "./blue/icon_gun";

	image = paintballBlueImage;
	canDrop = true;
};

//Image
datablock ShapeBaseImageData(paintballBlueImage)
{
   // Basic Item properties
   shapeFile = "./blue/pistol.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleVector = true;
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = paintballBlueProjectile;
   projectileType = Projectile;

	casing = paintballBlueDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   melee = false;
   armReady = true;
   isPaintballGun = true;

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.14;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= paintballBlueFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= paintballShotSound;
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= paintballBlueSmokeEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.01;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4]			= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]     = "Ready";
	stateSequence[4]	= "Ready";
};

package PaintballGuns
{
	//Paint Bricks on hit
	function ProjectileData::onCollision(%this,%proj,%col,%fade,%pos,%normal,%a,%b,%c)
	{
		%obj = %proj.sourceObject;
		if(%col.getType() & $TypeMasks::FxBrickObjectType && isObject(%obj.client))
			PaintballGunBrickPaint(%col,%this,%obj.client);
		return Parent::onCollision(%this,%proj,%col,%fade,%pos,%normal,%a,%b,%c);
	}
	//Restore Bricks on client leave
	function GameConnection::OnClientLeaveGame(%client)
	{
		ClearClientPBPaint(%client);
		Parent::OnClientLeaveGame(%client);
	}
};activatePackage(PaintballGuns);

//Clear Paint
function serverCmdClearPBPaint(%client)
{
	if(%client.isSuperAdmin)
	{
		%client.chatMessage("\c5Paintball Guns \c6Paint Cleared!");
		ClearPBPaint();
	}
	else
		%client.chatMessage("\c5Paintball Guns \c7You are not Admin.");
}

//Paint Brick
function PaintballGunBrickPaint(%brick,%this,%client)
{
	if(!%this.isPaintball || (strStr(%brick.getDatablock().getName(),"Checkpoint") != -1 || strStr(%brick.getDatablock().getName(),"Spawn") != -1))
		return;
	if(%this.getName() $= "PaintballYellowProjectile")
		%rgb = "1 1 0";
	if(%this.getName() $= "PaintballOrangeProjectile")
		%rgb = "1 0.5 0";
	if(%this.getName() $= "PaintballGreenProjectile")
		%rgb = "0 1 0";
	if(%this.getName() $= "PaintballBlueProjectile")
		%rgb = "0 0 1";
	if(%this.getName() $= "PaintballRedProjectile")
		%rgb = "1 0 0";
	if(!%brick.isPBPainted)
	{
		%brick.oldColor = %brick.getColorID(); //original brick color
		%brick.oldColFx = %brick.getColorFxID(); //original brick color fx
		%client.PBBrick[%client.PBBrickCount++] = %brick;
	}
	%colorA = %brick.getColorID(); //brick color
	%colorB = getClosestPaintColor(%rgb SPC 1); //new brick color
	%brick.setColor(%colorB);
	%brick.setColorFx(0);
	%brick.isPBPainted = true;
	if(%colorA != %colorB)
		%client.setScore(%client.score+$Pref::PaintballGun::Score);
}
//UnPaint Brick
function PaintballGunBrickUnpaint(%client,%a)
{
	%brick = %client.PBBrick[%a];
	%client.PBBrick[%a] = "";
	if(!%brick.isPBPainted) //if Painted
		return;
	%brick.setColor(%brick.oldColor); //restore brick color
	%brick.setColorFx(%brick.oldColFx); //restore brick color fx
	%brick.isPBPainted = false;
}

//Clear all paint
function ClearPBPaint()
{
	for(%i=0;%i<ClientGroup.getCount();%i++)
	{
		%client[%i] = ClientGroup.getObject(%i);
		ClearClientPBPaint(%client[%i]);
	}
}
//Clear all clients' paint
function ClearClientPBPaint(%client)
{
	if(!%client.isSuperAdmin)
		return;
	for(%a=0;%a<=%client.PBBrickCount;%a++)
		PaintBallGunBrickUnpaint(%client,%a);
	%client.PBBrickCount = 0;
}

//Credit to Space Guy for this
function getClosestPaintColor(%rgba)
{
	%prevdist = 100000;
	%colorMatch = 0;
	for(%i = 0;%i < 64;%i++)
	{
		%color = getColorIDTable(%i);
		if(vectorDist(%rgba,getWords(%color,0,2)) < %prevdist && getWord(%rgba,3) - getWord(%color,3) < 0.3 && getWord(%rgba,3) - getWord(%color,3) > -0.3)
		{
			%prevdist = vectorDist(%rgba,%color);
			%colormatch = %i;
		}
	}
	return %colormatch;
}