if(!$ShaderToggle::Binded)
{
	$remapDivision[$remapCount] = "Custom Shaders";
	$remapName[$remapCount] = "Cycle Shaders";
	$remapCmd[$remapCount] = "CycleShader";
	$remapCount++;
	$remapName[$remapCount] = "Scroll Shaders";
	$remapCmd[$remapCount] = "ScrollShaderModifier";
	$remapCount++;

	$ShaderToggle::Binded = true;
}

//Cycle through Shaders (in order)
function CycleShader(%val)
{
	if(!%val) //if trigger up
		return; //stop here
	%num = $Pref::shaderNum; //get shader number
	%num++; //increase num by 1
	setShaderNum(%num); //update Shader number
	toggleShader(); //load the new Shader
	showShaderName(true); //display new shader name
//	echo("Cycled to shader" SPC $Pref::shaderNum);
}

//Scroll through Shaders (with mousewheel)
function ScrollShaderModifier(%val)
{
	$ShaderToggle::ScrollReady = %val; //store key down/up
	if(!%val) //on release
		toggleShader(); //load the new Shader
	showShaderName(!%val); //display shader name centerprint (if release, true)
}

//Scroll Actual
function ScrollShaderActual(%x)
{
	%num = $Pref::shaderNum; //get shader number
	%move = %x > 0 ? %num++ : %num--; //if x is positive, move is num +1, otherwise, move is num -1
	setShaderNum(%move); //Set new Shader Number
	showShaderName(false); //display new shader name
}


//Update Shader Number
function setShaderNum(%num)
{
	if(%num $= "") //if shader not toggled yet
		%num = $Pref::shaderNum; //use saved shader number
	%max = 8; //highest shader number (must match the highest %num)
	if(%num > %max) //if num over the max
		%num = 0; //restart at 0
	if(%num < 0) //if num under 0
		%num = %max; //restart at the max
	$Pref::shaderNum = %num; //update shader num

	if(%num == 0)
	{
		$ShaderToggle::File = "renderCsm";
		$ShaderToggle::Name = "Default";
	}
	if(%num == 1)
	{
		$ShaderToggle::File = "soft";
		$ShaderToggle::Name = "Port's Soft";
	}
	if(%num == 2)
	{
		$ShaderToggle::File = "soft2";
		$ShaderToggle::Name = "Port's New Soft";
	}
	if(%num == 3)
	{
		$ShaderToggle::File = "ultra";
		$ShaderToggle::Name = "Port's Ultra";
	}
	if(%num == 4)
	{
		$ShaderToggle::File = "legultra";
		$ShaderToggle::Name = "LegoPepper's Ultra";
	}
	if(%num == 5)
	{
		$ShaderToggle::File = "performance";
		$ShaderToggle::Name = "ZSNO's Performance";
	}
	if(%num == 6)
	{
		$ShaderToggle::File = "hatasLow";
		$ShaderToggle::Name = "Hata's Low";
	}
	if(%num == 7)
	{
		$ShaderToggle::File = "hatasMed";
		$ShaderToggle::Name = "Hata's Medium";
	}
	if(%num == 8) //this num must match %max
	{
		$ShaderToggle::File = "hatasHigh";
		$ShaderToggle::Name = "Hata's High";
	}
}

//Load new Shader
function toggleShader()
{
	if(getShaderQuality() < 2) //if Shader Quality is less than Low
		return; //stop here

	$Shader::ShaderName = $ShaderToggle::File; //change shader file
	initializeShaderAssets();
	regenerateShadowMapFBOs();
	flushVBOCache();
}

//Display Shader Name
function showShaderName(%done)
{
	%time = %done ? 3 : -1; //display time (if not done, make it infinite)
	%message = %done ? "\c6Shader mode is \c3" @ $ShaderToggle::Name @ "\c6." : "\c6Set Shader mode to \c3" @ $ShaderToggle::Name @ "\c6?";
	clientcmdcenterprint(%message,%time); //do centerprint
	if(%done) //if done
		echo(%message); //mirror centerprint in console
}


package CustomShaders
{
	//Shader Scrolling
	function scrollInventory(%x)
	{
		if($ShaderToggle::ScrollReady) //if holding modifier key
			ScrollShaderActual(%x); //do shader scroll
		else //otherwise
			Parent::scrollInventory(%x); //parent
	}
	//Options menu Shader override fix
	function OptionsDlg::setShaderQuality(%this, %quality)
	{
		Parent::setShaderQuality(%this, %quality);
		$Shader::Quality = %quality;
		setShaderNum(); //fix shader num (on first join)
		toggleShader(); //reload Shader
	}
};activatePackage(CustomShaders);

function getShaderQuality()
{
	if($Shader::Quality !$= "")
		return $Shader::Quality;
	for(%a = 0; %a < 7; %a++)
	{
		%obj = "OPT_ShaderQuality" @ %a;
		if(isObject(%obj) && %obj.getValue())
			return %a;
	}
	return 0;
}