//Prefs
$Check::RTB_On = isFile("Add-Ons/System_ReturnToBlockland/server.cs");
if($Check::RTB_On) //check for RTB or Bl Glass
{
	if(!$WallJumpFix::PrefsLoaded)
	{
		if(!$RTB::RTBR_ServerControl_Hook && $Check::RTB_On && !$Check::Glass_On) //only exec if RTB exists not Glass
			exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
		RTB_registerPref("Enabled", "Wall-Jump Fix", "Pref::WallJumpFix::Enabled", "bool", "Support_WallJumpFix", true);
		RTB_registerPref("First Jump Timeout", "Wall-Jump Fix", "$Pref::WallJumpFix::JumpTimeout", "int 300 800", "Support_WallJumpFix", 600);
		$WallJumpFix::PrefsLoaded = true;
	}
}
else
{
	$Pref::WallJumpFix::Enabled = true;
	$Pref::WallJumpFix::JumpTimeout = 600;
}

function WallJumpFixVelCheck(%player)
{
	if(%player.WallJumpFix_justJumped) //if player first pressed the Jump key less than 400ms ago
		return; //stop here	
	%vel = %player.getVelocity(); //player's velocity vector
	%hVel = getWords(%vel,0,1) SPC 0; //horizontal velocity (z = 0)
	%hLen = vectorLen(%hVel); //player's horizontal speed
	if(%hLen < 1) //if player's horizontal speed is less than 1
	{
		%isWallJumping = WallJumpFixAreaChecks(%player); //Check whether the player can wall jump
	//	%pos = %player.getPosition();
	//	%diff = getWord(%pos,2) - getWord(%player.WallJumpFix_lastFloorPos);
		if(%isWallJumping !$= 0) //|| %diff > 0.1) //if 'isWallJumping' bool true, or new jump position is too far from the last valid ground pos.
		{
			centerPrint(%player.client,"\c6Wall Jump Blocked!",1);
			%iVel = vectorScale(%isWallJumping,-3);
			%upv = getWord(%vel,2);
			%nUpv = getWord(%vel,2) > 0 ? 0 : %upv;
			%nVel = getWords(%iVel,0,1) SPC %nUpv;
			%player.setVelocity(%nVel); //Manually impulse the player downward
		}
	}
	else
	{
		%player.WallJumpFix_justJumped = true; //set 'justJumped' bool to true
		schedule($Pref::WallJumpFix::JumpTimeout,0,eval,%player@".WallJumpFix_justJumped = false;"); //wait 400ms, then reset 'justJumped' bool to false
	}
}

function WallJumpFixAreaChecks(%player)
{
	%pos = %player.getPosition();
	%masks = $TypeMasks::fxBrickObjectType | $Typemasks::TerrainObjectType | $Typemasks::StaticShapeObjectType;
	%isFloor = WallJumpFixBoxCheck(%pos,1.25,0.1,%masks);
	if(%isFloor) //if player is on the ground
	{
		%player.WallJumpFix_justJumped = true; //set 'justJumped' bool to true
		schedule($Pref::WallJumpFix::JumpTimeout,0,eval,%player@".WallJumpFix_justJumped = false;"); //wait 400ms, then reset 'justJumped' bool to false
	//	%player.WallJumpFix_lastFloorPos = %pos; //save last 'grounded' player pos
		return false; //stop here, and return false
	}
	%isWall = WallJumpFixBoxCheck(vectorAdd(%pos,"0 0" SPC 0.2),1.3,0.1,%masks);
	if(%isWall)
	{
		%fvec = %player.getForwardVector();
		%bvec = vectorScale(%fvec,-1);
		%rvec = findRelativeX(%fvec);
		%lvec = vectorScale(%rvec,-1);
		
		%vec0 = HataDirCheck(%fvec);
		%vec1 = HataDirCheck(%bvec);
		%vec2 = HataDirCheck(%rvec);
		%vec3 = HataDirCheck(%lvec);
		
		%wallVec = "0 0 0"; //zero out default wall vector
		for(%a=0;%a<4;%a++)
		{
			%isWall[%a] = WallJumpFixBeamCheck(%pos,%vec[%a],0.8,%masks,%player); //Offset vector-directed Ledge search
			if(%isWall[%a]) //if Wall found
			{
				%WallNum++; //increment number of walls found
				%wallVec = vectorAdd(%wallVec,%vec[%a]);
			//	bottomPrint(%player.client,"Wall Num =" SPC %wallNum,1);
			}
			if(%wallNum > 0 && %wallNum <= 2)
				%impulseReady = true;
			else if(%wallNum > 2)
				break; //stop the loop here
		}
		%wallVec = vectorNormalize(%wallVec);
		
		if(%impulseReady)
			return %wallVec;
	}
	return 0;
}
//Beam Check
function WallJumpFixBeamCheck(%start,%vec,%len,%masks,%player)
{
	%beam = vectorScale(%vec,%len); //ray final vector
	%end = vectorAdd(%start,%beam); //ray endpoint
	%ray = containerRayCast(%start,%end,%masks,%player);
	if(isObject(firstWord(%ray))) //if raycast hit something
		return posFromRaycast(%ray); //return raycast hit position
	return 0; //return 0 (no object)
}

//Box Search
function WallJumpFixBoxCheck(%start,%width,%height,%masks)
{
	initContainerBoxSearch(%start, %width SPC %width SPC %height, %masks);
	while(%col = containerSearchNext())
	{
		if(isObject(%col)) //if a col. object exists
			return %col; //return col. object
	}
	return 0; //return 0 (no object)
}

function WallJumpFixSilentLoop()
{
	cancel($WallJumpFix::SilentSchedule); //prevent double schedules
	for(%i=0;%i<ClientGroup.getCount();%i++)
	{
		%client = ClientGroup.getObject(%i);
		if(!isObject(%player = %client.player) || %player.getState() $= "Dead") //if player DNE, or player is dead
			continue; //skip this player and continue looping
		if(!%player.WallJumpFix_isJumping) //if player is not holding the Jump key
			continue; //skip this player and continue looping
		WallJumpFixVelCheck(%player); //Check for Wall Jumping
		%isWallJumper = true; //at least one player in the correct conditions - e.g. playertype, gamemode, weapon, etc.
	}

	if(%isWallJumper) //if one correct player exists
	{
		$WallJumpFix::SilentSchedule = scheduleNoQuota(1,0,WallJumpFixSilentLoop); //continue the loop
		$WallJumpFix::SilentStarted = true; //note that the loop is started
	}
	else //otherwise
		$WallJumpFix::SilentStarted = false; //note that the loop has ended
}

package WallJumpFix
{
	function Armor::onTrigger(%data,%player,%slot,%val)
	{
		Parent::onTrigger(%data,%player,%slot,%val); //Parent default fcn.
		if(%slot == 2) //if onJump
		{
			%player.WallJumpFix_isJumping = %val; //save boolean Jump trigger to player object
			if(%val) //if onPress
			{
			//	%player.WallJumpFix_justJumped = true; //set 'justJumped' bool to true
			//	schedule(800,0,eval,%player@".WallJumpFix_justJumped = false;"); //wait 400ms, then reset 'justJumped' bool to false
				if(!$WallJumpFix::SilentStarted) //if Silent Loop not yet started
					WallJumpFixSilentLoop(); //start the global silent loop
			}
		}
	}
};activatePackage(WallJumpFix);


//Hata's Cardinal-ize Directional Vector 
function HataDirCheck(%vec) 
{
	//Align (North, South, East, West - to match Brick Grid)
	%vec = vectorNormalize(%vec); //normalize the input vector first
	%vecX = getWord(%vec,0) SPC "0 0"; //make new vector from x component only
	%vecY = 0 SPC getWord(%vec,1) SPC 0; //make new vector from y component only

	%vecXLen = vectorLen(%vecX); //measure length of x vector
	%vecYLen = vectorLen(%vecY); //measure length of y vector

	%dir = vectorNormalize(%vecX); //default dir to normalized x vector
	%dir = %vecYLen > %vecXLen ? vectorNormalize(%vecY) : %dir; //if y vector's length is longer - use normalized y vector, otherwise - keep normalized x vector
	return %dir; //return the newly made cardinal directional vector
}

//Hata's Relative Vector
function findRelativeX(%vec)
{
	%hVec = getWords(%vec,0,1) SPC 0; //build vector from horizontal component of input vector
	%nhVec = vectorNormalize(%hVec); //normalized horizontal vector
	return vectorCross(%nhVec,"0 0 1"); //return rightward vector
}