//Force "Weapon_Sword"
%error = ForceRequiredAddOn("Weapon_Sword");
if(%error == $Error::AddOn_Disabled)
{
        swordItem.uiName = "";
}

if(%error == $Error::AddOn_NotFound)
{
        error("ERROR: Tool_RPG - required add-on Weapon_Sword not found");
}
else
{
        exec("./Tool_Axe.cs");
        exec("./Tool_Pickaxe.cs");

        %total = 8; //types of axe/pickaxe
        %name[0] = "Gold"; //Add the other 6 types to this list
        %name[1] = "Flint";
        %name[2] = "Mithril";
        %name[3] = "Platinum";
        %name[4] = "Iron";
        %name[5] = "Copper";
        %name[6] = "Plastinium";
        %name[7] = "Stone"; //the order does not matter

        for(%n=0;%n<%total;%n++)
        {
                eval("registerInputEvent(fxDTSBrick,onB" @ %name[%n] @ "AxeHit,\"Self fxDTSBrick\" TAB \"Player Player\" TAB \"Client GameConnection\" TAB \"Minigame Minigame\");"); //load Axe events
                eval("registerInputEvent(fxDTSBrick,onB" @ %name[%n] @ "PickaxeHit,\"Self fxDTSBrick\" TAB \"Player Player\" TAB \"Client GameConnection\" TAB \"Minigame Minigame\");"); //load Pickaxe events
        }
}


//Axe & Pickaxe Packages
package NewAxePickaxe
{
        //Start Anim
        function WeaponImage::onPreFire(%data,%obj,%slot)
        {
                if(%data.isNewAxe || %data.isNewPickaxe) //if weapon is one of the new axe's or pickaxe's
                        %obj.playthread(2,armattack); //anim
        }
        //Stop Anim
        function WeaponImage::onStopFire(%data,%obj,%slot)
        {        
                if(%data.isNewAxe || %data.isNewPickaxe) //if weapon is one of the new axe's or pickaxe's
                        %obj.playthread(2,root); //stop anim
        }
        //Events hook
        function ProjectileData::onCollision(%data,%obj,%col,%fade,%pos,%normal)
        {
                Parent::onCollision(%data,%obj,%col,%fade,%pos,%normal);
                if((%data.isNewAxe || %data.isNewPickaxe) && %col.getClassName() $= "fxDTSBrick") //if projectile is from one of the new axe's or pickaxe's, and col is a brick
                {
                        $InputTarget_["Self"] = %col;
                        $InputTarget_["Player"] = %obj.client.player;
                        $InputTarget_["Client"] = %obj.client;
                        if($Server::LAN)
                                $InputTarget_["MiniGame"] = getMiniGameFromObject(%obj.client);
                        else
                        {
                                if(getMiniGameFromObject(%col) == getMiniGameFromObject(%obj.client))
                                        $InputTarget_["MiniGame"] = getMiniGameFromObject(%col);
                                else
                                        $InputTarget_["MiniGame"] = 0;
                        }
                        %name = getWord(%data.uiName,1); //axe/pickaxe type (e.g. Gold)
                        if(%data.isNewAxe) //if axe
                                eval(%col @ ".processInputEvent(onB" @ %name @ "AxeHit,%obj.client);"); //call axe event
                        else //otherwise
                                eval(%col @ ".processInputEvent(onB" @ %name @ "PickaxeHit,%obj.client);"); //call axe event
                }
        }
};activatePackage(NewAxePickaxe);
