//Here's how this works. You use this command and it will basically pull you out of your own minigame to build while the game continues to run.
function serverCmdBuilderMode(%client)
{
	if(isObject(%client.sideminigame)) //Put us back in if we're out
	{
		%client.minigame = %client.sideminigame; //Tell the game that we now have a minigame
		%client.sideminigame = -1; //Erase the fact that we're out, which is used for reference to determine if we've left.
		commandToClient('SetBuildingDisabled', !%client.minigame.enableBuilding);
		commandToClient('SetPaintingDisabled', !%client.minigame.enablePainting); //Set our limitations back how they should be.
		%client.instantrespawn(); //So we don't use this to get somewhere we shouldn't or have something nobody else does.
		messageclient(%client,"","<color:ff00ff>Builder Mode Off.");
	}
	else
	{
		if(!isobject(%client.minigame) || %client.minigame.owner != %client) //Dunno who would trigger this bit, but good to keep it around.
			messageclient(%client,"","<color:ff00ff>You are not running a minigame.");
		if(%client.minigame.owner == %client)
		{
			%client.sideminigame = %client.minigame; //Store our minigame value, basically setting it off to the side.
			%client.minigame = -1; //Make it seem as if we're not in a minigame, so the game will let us build and will keep us safe.
			%client.player.setDatablock(PlayerStandardArmor); //Give us the jets.
			%client.player.giveDefaultEquipment(); //Give us the building tools.
			commandToClient(%client, 'setPaintingDisabled', 0);
			commandToClient(%client, 'setBuildingDisabled', 0); //Tell the client it's ok to build and paint, so the client doesn't restrict them.
			messageclient(%client,"","<color:ff00ff>Builder Mode On.");
		}
	}
}

package BuilderMode
{
	function ServerCmdEndMinigame(%client) //Because otherwise you'll be confusing the server by trying to end a minigame it doesn't think you're in.
	{
		if(isObject(%client.sideMinigame))
			messageclient(%client,"","<color:ff00ff>You cannot end the minigame from Builder Mode. Use /buildermode to return to play first.");
		else
			parent::ServerCmdEndMinigame(%client);
	}
	function ServerCmdSetMinigameData(%client, %Settings) //Same reason as above.
	{
		if(isObject(%client.sideMinigame))
			messageclient(%client,"","<color:ff00ff>You cannot edit the minigame from Builder Mode. Use /buildermode to return to play first.");
		else
			parent::ServerCmdSetMinigameData(%client, %Settings);
	}
	function GameConnection::onClientleaveGame(%client) //So we still end our minigame upon leaving.
	{
		if(isObject(%client.sideMinigame))
			%client.minigame = %client.sideminigame;
		parent::onClientleaveGame(%client);
	}
	function miniGameCanUse(%player, %item) //Fix for players not being able to get items when the minigame host is in builder mode.
	{
		%owner = %item.spawnbrick.client;
		if(isObject(%owner.sideMinigame)) //If the guy who owns this stuff is busy not-minigaming...
		{
			%owner.minigame = %owner.sideminigame; //Drop them back in for a split second...
			%ret = parent::miniGameCanUse(%player, %item); //Run any other calculations we need to run...
			%owner.minigame = -1;//And let them get on with their building.
		}
		else
			%ret = parent::miniGameCanUse(%player, %item); //Don't mess something up if we don't need to.
		return %ret;
	}
};
activatePackage(BuilderMode);