//Prefs
$Check::RTB_On = isFile("Add-Ons/System_ReturnToBlockland/server.cs");
$Check::Glass_On = isFile("Add-Ons/System_BlocklandGlass/server.cs");
if($Check::RTB_On || $Check::Glass_On) //check for RTB or Bl Glass
{
	if(!$VignetteDamage::PrefsLoaded)
	{
		if(!$RTB::RTBR_ServerControl_Hook && $Check::RTB_On && !$Check::Glass_On) //only exec if RTB exists not Glass
			exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
		RTB_registerPref("Enabled", "Vignette Damage", "Pref::VignetteDamage::Enabled", "bool", "Support_VignetteDamage", true);
		RTB_registerPref("Health Regeneration", "Vignette Damage", "Pref::VignetteDamage::RegenOn", "bool", "Support_VignetteDamage", false);
		RTB_registerPref("Bot Health Regen", "Vignette Damage", "Pref::VignetteDamage::BotRegenOn", "bool", "Support_VignetteDamage", false);
		RTB_registerPref("Regen Rate (ms)", "Vignette Damage", "Pref::VignetteDamage::RegenTime", "int 1 800", "Support_VignetteDamage", 50);
		RTB_registerPref("Regen Delay (ms)", "Vignette Damage", "Pref::VignetteDamage::RegenDelay", "int 1000 50000", "Support_VignetteDamage", 10000);
		$VignetteDamage::PrefsLoaded = true;
	}
}
else
{
	$Pref::VignetteDamage::Enabled = true;
	$Pref::VignetteDamage::RegenOn = true;
	$Pref::VignetteDamage::BotRegenOn = true;
	$Pref::VignetteDamage::RegenTime = 50;
	$Pref::VignetteDamage::RegenDelay = 10000;
}

//Damage System
package VignetteDamage
{
	function Armor::onDamage(%data,%obj,%damage)
	{
		Parent::onDamage(%data,%obj,%damage);
		if($Pref::VignetteDamage::Enabled && !$Pref::Adventure::HealthVignette)
		{
			%dmg = %obj.getDamageLevel();
			%max = %data.maxDamage;
			%ratio = 100/%max;
			%scale = %dmg/%ratio;
			%color = %scale*0.01;
			if(%scale == 100)
				commandToClient(%obj.client,'SetVignette',$EnvGuiServer::VignetteMultiply,$EnvGuiServer::VignetteColor);
			else
				commandToClient(%obj.client,'SetVignette',$EnvGuiServer::VignetteMultiply, 1 SPC 1-%color SPC 1-%color SPC %color);
			if(%damage > 0)
			{
				cancel(%obj.VignetteDelayEnd);
				%obj.VignetteDelayEnd = schedule($Pref::VignetteDamage::RegenDelay,0,VignetteHealthRegen,%obj);
			}
		}
	}
	function Armor::onAdd(%data,%obj)
	{
		Parent::onAdd(%data,%obj);
		if($Pref::VignetteDamage::Enabled && !$Pref::Adventure::HealthVignette)
			commandToClient(%obj.client,'setVignette',$EnvGuiServer::VignetteMultiply,$EnvGuiServer::VignetteColor);
	}
	function gameConnection::onDeath(%killed,%killerPlayer,%killer,%a,%b)
	{
		if(isObject(%killed) && $Pref::VignetteDamage::Enabled && !$Pref::Adventure::HealthVignette)
			commandToClient( %killed,'SetVignette',$EnvGuiServer::VignetteMultiply,$EnvGuiServer::VignetteColor);
		Parent::onDeath(%killed,%killerPlayer,%killer,%a,%b);
	}
};activatePackage(VignetteDamage);

//Health Regeneration
function VignetteHealthRegen(%obj)
{
	if(!isObject(%obj) || %obj.getState() $= "Dead" || !$Pref::VignetteDamage::RegenOn)
		return;
	if(%obj.getClassName() $= "Player" || $Pref::VignetteDamage::BotRegenOn)
	{
		%dmg = %obj.getDamageLevel();
		if(%dmg > 0)
		{
			%obj.setDamageLevel(%dmg-1);
			%obj.VignetteRegen = schedule($Pref::VignetteDamage::RegenTime,0,VignetteHealthRegen,%obj);
		}
	}
}