//Prefs
$Check::RTB_On = isFile("Add-Ons/System_ReturnToBlockland/server.cs");
if($Check::RTB_On) //check for RTB
{
	if(!$ClickPickup::PrefsLoaded)
	{
		if(!$RTB::RTBR_ServerControl_Hook && $Check::RTB_On) //only exec if RTB exists
			exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
		RTB_registerPref("Enabled", "Click to Pickup", "Pref::ClickPickup::Enabled", "bool", "Support_ClickPickup", true);
		RTB_registerPref("Click & Touch Pickup", "Click to Pickup", "Pref::ClickPickup::Touch", "bool", "Support_ClickPickup", false);
		RTB_registerPref("Duplicate Pickups", "Click to Pickup", "Pref::ClickPickup::Duplicate", "bool", "Support_ClickPickup", false);
		$ClickPickup::PrefsLoaded = true;
	}
}
else
{
	$Pref::ClickPickup::Enabled = true;
	$Pref::ClickPickup::Touch = false;
	$Pref::ClickPickup::Duplicate = false;
}

package ClickPickup
{
	//Activate Stuff
	function Player::ActivateStuff(%player)
	{
		if($Pref::ClickPickup::Enabled) //if Pref: ClickPickup on
		{
			%player.hasJustActivated = true; //set 'justActivated' bool to true
			schedule(200,0,eval,%player@".hasJustActivated = false;"); //wait 200ms, then reset it to false
			%canPickup = ClickPickupCheck(%player); //do Click Pickup check, return result
		}
		Parent::activateStuff(%player);
	}
	//Item Pickup
	function Player::Pickup(%player,%item,%override)
	{
		if(!$Pref::ClickPickup::Enabled || %override || (%player.hasJustActivated && $Pref::ClickPickup::Touch)) //if Pref: ClickPickup off, or overriding, or (justActivated, AND Pref: ClickPickup-Touch on)
			Parent::Pickup(%player,%item); //Parent default pickup function
	}
};ActivatePackage(ClickPickup);

//Force Drop Item
function ClickPickUpCheck(%player)
{
	%eye = %player.getEyePoint(); //eye point
	%len = 5; //raycast length
	%masks = $TypeMasks::ItemObjectType; //item typemask
	%vec = %player.getEyeVector(); //eye vector
	%ray = ClickPickupBeamCheck(%player,%eye,%len,%masks,%vec); //Do raycast check
	if(%ray == 0) //if Beam Check fcn returned "0" (found nothing)
		return; //stop here
	
	%col = firstWord(%ray); //col item
	if(!$Pref::ClickPickup::Duplicate) //if Pref: Click-Pickup-Duplicate off
	{
		for(%i=0;%i<5;%i++) //check all item slots (only works with default amount)
		{
		//	talk("Col's Item =" SPC %col.dataBlock SPC "  Tool =" SPC %player.tool[%i].getName());
			if(%col.dataBlock.getID() $= %player.tool[%i]) //if the col item is already in player's inventory
				return; //stop here (break is implied)
		}
	}

	%player.pickup(%col,true); //Force pickup
}

//Beam Check
function ClickPickupBeamCheck(%player,%pos,%len,%masks,%vec)
{
	%beam = vectorScale(%vec,%len); //lengthened vector (for calculating the raycast's endpoint)
	%end = vectorAdd(%pos,%beam); //calculated endpoint for raycast
	%ray = containerRayCast(%pos,%end,%masks,%player); //fire raycast
	%ray = isObject(firstWord(%ray)) ? %ray : 0; //if raycast hit - keep ray, else set it to zero
	return %ray; //return the raycast
}