//Prefs
$Check::RTB_On = isFile("Add-Ons/System_ReturnToBlockland/server.cs");
$Check::Glass_On = isFile("Add-Ons/System_BlocklandGlass/server.cs");
if($Check::RTB_On || $Check::Glass_On) //check for RTB or Bl Glass
{
	if(!$Naturalism::PrefsLoaded)
	{
		if(!$RTB::RTBR_ServerControl_Hook && $Check::RTB_On && !$Check::Glass_On) //only exec if RTB exists not Glass
			exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
		RTB_registerPref("Enabled", "Naturalism", "Pref::Naturalism::Enabled", "bool", "Support_Naturalism", 1);
		$Naturalism::PrefsLoaded = true;
	}
}
else
{
	$Pref::Naturalism::Enabled = true;
}

package Swimming
{
	function Armor::onEnterLiquid(%this,%obj)
	{
		Parent::onEnterLiquid(%this,%obj);
		if(%obj.isEnabled() == 1)
			%obj.isSwimming=1;
	}
	function Armor::onLeaveLiquid(%this,%obj)
	{
		Parent::onLeaveLiquid(%this,%obj);
		if(%obj.isEnabled() == 1)
			%obj.isSwimming=0;
	}
};activatepackage(Swimming);

package Naturalism
{
	function Armor::onNewDatablock(%data,%obj)
	{
		parent::onNewDatablock(%data,%obj);
		cancel(%obj.idleL);
		if(!$Pref::Naturalism::Enabled)
			return;
		%obj.idleL = schedule(500,0,animateIdleLoop,%obj);
	}
	function animVelCheck(%obj)
	{
		%vel = %obj.getVelocity();
		if(%vel $= "0 0 0")
			return 1;
		else
			return 0;
	}
	function groundCheck(%obj,%up)
	{
		if(%up $= "")
			%up = 0.1;
		%start = %obj.getPosition();
		initContainerBoxSearch(%start, "1.25 1.25" SPC %up, $TypeMasks::fxBrickObjectType | $Typemasks::TerrainObjectType);
		%col = containerSearchNext();
		return %col;
	}
	function animateIdleLoop(%obj)
	{
		if(!$Pref::Naturalism::Enabled)
			return;
		if(!isObject(%obj) || %obj.getState() $= "Dead")
			return;
		%data = %obj.getDatablock();
		%model = fileName(%data.shapeFile);
		if(%model !$= "m.dts")
			return;
		cancel(%obj.idleL);
		%obj.idleL = schedule(50,0,animateIdleLoop,%obj);
		%noVel = animVelCheck(%obj);
		%floor = groundCheck(%obj);
		if(%obj.getMountedImage(0) != 0)
			%isTooling=1;
		if(%obj.getObjectMount() == 0)
			%isNoVehicle=1;
		if(%noVel && isObject(%floor) && !%isTooling && %isNoVehicle)
		{
			if(!%obj.isFirstIdle)
			{
				%obj.isFirstIdle=1;
				cancel(%obj.animI);
				%obj.animI = schedule(10000,0,animateIdle,%obj);
			}
		}
		else
		{
			cancel(%obj.mv);
			cancel(%obj.mv2);
			cancel(%obj.animI);
			%obj.isFirstIdle=0;
		//	centerPrint(%obj.client,"<font:Palatino Linotype:20><color:72FF72>" SPC "Canceling Anim Idle" SPC "",0.3);
			if(!%isTooling && %obj.isIdleAnim)
			{
				%obj.playthread(0,root);
				%obj.playthread(2,root);
				%obj.playthread(3,root);
			}
		}
	}
	function animateIdle(%obj)
	{
		if(!isObject(%obj))
			return;
		if(!%obj.isSwimming)
		{
			%obj.isFirstIdle=0;
			%random = getRandom(1,4);
			%obj.isIdleAnim=1;
			schedule(1000,0,eval,%obj@".isIdleAnim=0;");
			if(%random $= 1)
			{
				%obj.playthread(0,sit);
				%obj.playthread(2,crouch);
				%obj.setActionThread(root);
				%obj.schedule(50,setThreadDir,0,false);
				%obj.mv = %obj.schedule(1000,playthread,0,plant);
				%obj.mv2 = %obj.schedule(1000,playthread,2,shiftDown);
			}
			else if(%random $= 2)
			{
				%obj.playthread(0,back);
				%obj.playthread(2,spearready);
				%obj.schedule(50,stopthread,0);
				%obj.mv = %obj.schedule(1000,playthread,0,plant);
				%obj.mv2 = %obj.schedule(1000,playthread,2,spearthrow);					
			}
			else if(%random $= 3)
			{
				%obj.playthread(0,activate2);
				%obj.playthread(2,headside);
				%obj.schedule(50,stopthread,0);
				%obj.mv = %obj.schedule(600,playthread,2,undo);
				%obj.mv2 = %obj.schedule(1000,playthread,0,shiftto);
			}
			else if(%random $= 4)
			{
				%obj.playthread(0,leftrecoil);
				%obj.playthread(2,talk);
				%obj.mv = %obj.schedule(500,playthread,2,shiftaway);
				%obj.mv2 = %obj.schedule(1000,playthread,2,plant);
			}
		}
	}
};activatepackage(Naturalism);