//RTB Prefs
$Check::RTB_On = isFile("Add-Ons/System_ReturnToBlockland/server.cs");
if($Check::RTB_On) //check for RTB
{
	if(!$AdventurePlayer::PrefsLoaded)
	{
		//Define RTB prefs.
		if(!$RTB::RTBR_ServerControl_Hook) //only exec if RTB exists
			exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");

		//Climbing | Main
		RTB_registerPref("Climbing Reach (in Bricks)", "Adventure | Climbing", "$Pref::Adventure::ClimbMax", "int 1 10", "Player_Adventure", 4);
		RTB_registerPref("Border Climbing","Adventure | Climbing","$Pref::Adventure::BorderClimb","bool","Player_Adventure",true);
		RTB_registerPref("Corner Turning","Adventure | Climbing","$Pref::Adventure::CornerTurn","bool","Player_Adventure",true);
		RTB_registerPref("Hanging Jump","Adventure | Climbing","$Pref::Adventure::HangingJump","bool","Player_Adventure",true);
		RTB_registerPref("Ledge Safety","Adventure | Climbing","$Pref::Adventure::LedgeSafety","bool","Player_Adventure",true);

		//Climbing | Abilities
		RTB_registerPref("Step-up","Adventure | Abilities","$Pref::Adventure::StepUp","bool","Player_Adventure",true);
		RTB_registerPref("Smart Drop","Adventure | Abilities","$Pref::Adventure::SmartDrop","bool","Player_Adventure",true);
		RTB_registerPref("Dive to Ledge","Adventure | Abilities","$Pref::Adventure::DiveToLedge","bool","Player_Adventure",true);
		RTB_registerPref("Fluid Traversal","Adventure | Abilities","$Pref::Adventure::FluidTraverse","bool","Player_Adventure",true);

		//Fall Damage Scaling
		RTB_registerPref("Fall Damage Scaling (F.D.S.)","Adventure | Falling","$Pref::Adventure::FallDamScaling","bool","Player_Adventure",false);
		RTB_registerPref("F.D.S. min. Damage Speed", "Adventure | Falling", "$Pref::Adventure::minDamSpeed", "int 20 50", "Player_Adventure", 20);
		RTB_registerPref("F.D.S. min. Death Speed", "Adventure | Falling", "$Pref::Adventure::minDeathSpeed", "int 30 50", "Player_Adventure", 30);

		//Cosmetic
		RTB_registerPref("Fancy Hands","Adventure | Aesthetics","$Pref::Adventure::FancyHands","bool","Player_Adventure",true);
		RTB_registerPref("Arm Flailing","Adventure | Aesthetics","$Pref::Adventure::Flailing","bool","Player_Adventure",true);
		$AdventurePlayer::PrefsLoaded = true;
	}
}
else //RTB not found.
{
	//Defining prefs for non-RTB users
	$Pref::Adventure::ClimbMax = 4;
	$Pref::Adventure::BorderClimb = true;
	$Pref::Adventure::CornerTurn = true;
	$Pref::Adventure::HangingJump = true;
	$Pref::Adventure::LedgeSafety = true;
	
	$Pref::Adventure::StepUp = true;
	$Pref::Adventure::SmartDrop = true;
	$Pref::Adventure::DiveToLedge = true;
	$Pref::Adventure::FluidTraverse = true;

	$Pref::Adventure::FallDamScaling = false;
	$Pref::Adventure::minDamSpeed = 20;
	$Pref::Adventure::minDeathSpeed = 30; //same as PlayerStandardArmor

	$Pref::Adventure::FancyHands = true;
	$Pref::Adventure::Flailing = true;
}

//Execute Core Scripts
echo("Loading Adventure Player...");
exec("./Datablocks/Datablocks_Misc.cs"); //Miscellaneous datablocks (e.g. 'HataDebugData', 'HataPlateData', 'HandL', and 'HandR')
exec("./Datablocks/Datablocks_Player.cs"); //Playertype datablocks (e.g. 'PlayerAdventure' and 'PlayerAdventureHang')
exec("./Main_Adventure.cs"); //Main fcns (e.g. 'GlobalSilentLoop', 'AimCheck', 'ClimbUp', and 'Pullup')
exec("./Event_Adventure.cs"); //Events support (i.e. 'onLedgeGrab' and 'onLedgeMove')
exec("./Support/Support_Functions.cs"); //Complex support fcns (e.g. 'LedgeSearch', 'MultiLedgeCheck', and 'VerticalSnap')
exec("./Support/Support_Abilities.cs"); //Major climbing features (e.g. 'StepUp', 'HangingJump', 'FluidTraversal', and 'SmartDrop')
exec("./Support/Support_Aesthetics.cs"); //Detailed animation fcns (e.g. 'StartHangAnim', 'StopHangAnim', and 'ClimbAnimCheck')
exec("./Support/Support_Misc.cs"); //Miscellaneous support fcns (e.g. 'SpawnClimbTool' and 'FancyHandCheck')
exec("./Support/Support_Modules.cs"); //Modular fcns that can be copied to other Add-Ons
exec("./Support/Support_Debug.cs"); //Debugging fcns (e.g. 'serverCmdAdventureDebug', 'LedgeIndicate', and 'RaycastDebugUpdate')
echo("... Loading complete.");
echo("Add-On by Hata, ID: 483");

$Check::MoveInputOn = isFile("Add-Ons/Support_MoveInputDetection/server.cs");
if(!$MoveInputDetectionOn::Server && $Check::MoveInputOn) //Prevent double execution
	exec("Add-Ons/Support_MoveInputDetection/server.cs"); //Force load Move Input Detection