//Prefs
$Check::RTB_On = isFile("Add-Ons/System_ReturnToBlockland/server.cs");
$Check::Glass_On = isFile("Add-Ons/System_BlocklandGlass/server.cs");
if($Check::RTB_On || $Check::Glass_On) //check for RTB or Bl Glass
{
	if(!$HataAmmo::PrefsLoaded)
	{
		if(!$RTB::RTBR_ServerControl_Hook && $Check::RTB_On && !$Check::Glass_On) //only exec if RTB exists not Glass
			exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
		RTB_registerPref("Enabled", "Hata's Ammo", "Pref::HataAmmo::Enabled", "bool", "Support_Ammo", true);
		$HataAmmo::PrefsLoaded = true;
	}
}
else
	$Pref::HataAmmo::Enabled = true;


//Gun Ammo Integration
datablock ShapeBaseImageData(GunAmmoImage : GunImage)
{
   correctMuzzleVector = true;

   shapeFile = "add-ons/weapon_gun/pistol.dts";
   colorShiftColor = GunItem.colorShiftColor;

   stateTransitionOnNoAmmo[1]  = "NoAmmo";
   stateScript[1]			   = "onReady";

   stateName[5]   = "NoAmmo";
   stateTransitionOnAmmo[5] = "Ready";
};
function GunAmmoImage::onFire(%this,%obj,%slot)
{
	%obj.playthread(3,shiftaway);
	Parent::onFire(%this,%obj,%slot);
}

datablock ShapeBaseImageData(BowAmmoImage : BowImage)
{
   correctMuzzleVector = true;

   shapeFile = "add-ons/weapon_bow/bow.dts";
   colorShiftColor = BowItem.colorShiftColor;

   stateTransitionOnNoAmmo[1]  = "NoAmmo";
   stateScript[1]			   = "onReady";

   stateTransitionOnNoAmmo[4]  = "NoAmmo";

   stateName[6]   = "NoAmmo";
   stateTransitionOnAmmo[6] = "Ready";
};

datablock ShapeBaseImageData(SpearAmmoImage : SpearImage)
{
   correctMuzzleVector = true;

   shapeFile = "add-ons/weapon_spear/spear.dts";
   colorShiftColor = SpearItem.colorShiftColor;

   stateTransitionOnNoAmmo[1]  = "NoAmmo";
   stateScript[1]			   = "onReady";

   stateName[6]   = "NoAmmo";
   stateTransitionOnAmmo[6] = "Ready";
};
function spearAmmoImage::onCharge(%this,%obj,%slot)
{
	%obj.playthread(2,spearReady);
}
function spearAmmoImage::onAbortCharge(%this,%obj,%slot)
{
	%obj.playthread(2,root);
}
function spearAmmoImage::onFire(%this,%obj,%slot)
{
	%obj.playthread(2,spearThrow);
	Parent::onFire(%this,%obj,%slot);
}

datablock ShapeBaseImageData(AkimboGunAmmoImage : AkimboGunImage)
{
   correctMuzzleVector = true;

   shapeFile = "add-ons/weapon_gun/pistol.dts";
   colorShiftColor = AkimboGunItem.colorShiftColor;

   stateTransitionOnNoAmmo[1]  = "NoAmmo";
   stateScript[1]			   = "onReady";

   stateName[6]   = "NoAmmo";
   stateTransitionOnAmmo[6] = "Ready";
};
function AkimboGunAmmoImage::onFireAkimbo(%this,%obj,%slot)
{
   %obj.setImageTrigger(1,1);
}
datablock ShapeBaseImageData(LeftAkimboGunAmmoImage : LeftAkimboGunImage)
{
   shapeFile = "add-ons/weapon_gun/pistol.dts";
   colorShiftColor = AkimboGunItem.colorShiftColor;
};
function AkimboGunAmmoImage::onFire(%this,%obj,%slot)
{
	Parent::onFire(%this,%obj,%slot);
	%obj.playThread(2,shiftaway);
}
function LeftAkimboGunAmmoImage::onFire(%this,%obj,%slot)
{
	Parent::onFire(%this,%obj,%slot);
	%obj.playThread(2,leftrecoil);
}
function AkimboGunAmmoImage::onMount(%this,%obj,%slot)
{
   Parent::onMount(%this,%obj,%slot);
   //mount lefthanded gun
   %obj.mountImage(LeftAkimboGunAmmoImage, 1);
   %obj.playthread(1,armreadyboth);
}
function AkimboGunAmmoImage::onUnMount(%this,%obj,%slot)
{
   Parent::onUnMount(%this,%obj,%slot);
   //unmount lefthanded gun
   %obj.unMountImage(1);
}

datablock ShapeBaseImageData(P90AmmoImage : P90Image)
{
   correctMuzzleVector = true;

   shapeFile = "add-ons/weapon_p90_pack/p90.dts";
   colorShiftColor = P90Item.colorShiftColor;

   stateTransitionOnNoAmmo[1]  = "NoAmmo";
   stateScript[1]			   = "onReady";

   stateName[5]   = "NoAmmo";
   stateTransitionOnAmmo[5] = "Ready";
};
function P90AmmoImage::onFire(%this,%obj,%slot)
{
	%spread = 0.0018;
	%canShoot = fireAmmoReduction(%this,%obj,%slot);
	if(%canShoot)
		SpecialFireCheck(%this,%obj,%slot,%spread,%shellcount);
}
function P90AmmoImage::onFire2(%this,%obj,%slot)
{
	%spread = 0.0012;
	%canShoot = fireAmmoReduction(%this,%obj,%slot);
	if(%canShoot)
		SpecialFireCheck(%this,%obj,%slot,%spread,%shellcount);
}
function SpecialFireCheck(%this,%obj,%slot,%spread,%shellcount)
{
	%projectile = %this.projectile;
	if(%shellcount $= "")
		%shellcount = 1;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}

datablock ShapeBaseImageData(ShotgunAmmoImage : ShotgunImage)
{
   correctMuzzleVector = true;

   shapeFile = "add-ons/weapon_shotgun/shotgun.dts";
   colorShiftColor = ShotgunItem.colorShiftColor;

   stateTransitionOnNoAmmo[1]  = "NoAmmo";
   stateScript[1]			   = "onReady";

   stateName[6]   = "NoAmmo";
   stateTransitionOnAmmo[6] = "Ready";
};
function ShotgunAmmoImage::onFire(%this,%obj,%slot)
{
	%spread = 0.001;
	%shellcount = 10;
	%canShoot = fireAmmoReduction(%this,%obj,%slot);
	if(%canShoot)
	{
		SpecialFireCheck(%this,%obj,%slot,%spread,%shellcount);
		%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%obj.client.player.getMuzzleVector(%slot),"-3")));
		%obj.playThread(2,shiftAway);
	}
}


//Ammo System
package HataAmmo
{
	//Drop Weapon And Ammo
	function servercmdDropTool(%client,%slot)
	{
		%obj = %client.player;
		if($Pref::HataAmmo::Enabled)
		{
			%tool = %obj.tool[%slot];
			%currAmmo = getAmmoCount(%obj,%tool);
			%obj.tool[%slot] = 0;
			messageClient(%client,'MsgItemPickup','',%slot,0);
			if(%obj.currTool == %slot)
			{
				%obj.updateArm(0);
				%obj.unMountImage(0);
			}

			%item = new item()
			{
				datablock = %tool;
				Ammo = %currAmmo;
			};
			if(isObject(%item))
			{
				%item.schedulePop();
				%pos = %obj.getPosition();
				%rot = getWords(%obj.getTransform(),3,6);
				%pos = vectorAdd(%pos,"0 0 2.1");
				%fVec = %obj.getEyeVector();

				%item.setTransform(vectorAdd(vectorScale(%fVec,2),%pos) SPC %rot);
				%item.setVelocity(vectorAdd(vectorScale(%fVec,3.5),%obj.getVelocity()));
				%item.miniGame = getMiniGameFromObject(%obj);

				%obj.isFull[%tool] = false;
				%obj.Ammo[%tool] = 0;
				%obj.clip[%tool] = 0;
			}
		}
		else
			Parent::servercmdDropTool(%client,%slot);
	}
	//Mount Weapon
	function WeaponImage::onMount(%this,%obj,%slot)
	{
		Parent::onMount(%this,%obj,%slot);
		%data = %obj.getDatablock();
		%ammoType = %this-1;
		%originalAmmoType = %ammoType;
		%tool = checkForTool(%obj,%ammoType);
		%lefty = %obj.getMountedImage(1);
		%righty = %obj.getMountedImage(0);
		%ammoWep = checkForAmmoWep(%obj,%ammoType);
		if(!%ammoWep)
			return;
		if($Pref::HataAmmo::Enabled && isObject(%righty)) //Gun Ammo Integration
		{
			%obj.defAmmoType = %ammoType;
			if(%righty.getName() $= "gunImage")
				%obj.mountImage(gunAmmoImage,0);
			else if(%righty.getName() $= "akimboGunImage")
				%obj.mountImage(akimboGunAmmoImage,0);
			else if(%righty.getName() $= "P90Image")
				%obj.mountImage(P90AmmoImage,0);
			else if(%righty.getName() $= "ShotgunImage")
				%obj.mountImage(ShotgunAmmoImage,0);
			else if(%righty.getName() $= "bowImage")
				%obj.mountImage(bowAmmoImage,0);
			else if(%righty.getName() $= "spearImage")
				%obj.mountImage(spearAmmoImage,0);
			else if(%ammoType != %tool)
				%obj.defAmmoType = "";
		}
		%Gun = checkForSpecials(%obj);
		%clip = %obj.clip[%ammoType];
		%clipAmmo = getClipAmmo(%ammoType);
		%defAmmo = getDefAmmo(%ammoType);
		if(%Gun $= "valid" && $Pref::HataAmmo::Enabled)
		{
			if(%clip $= "")
				%clip = 0;
			if(%obj.Ammo[%tool] $= "")
				%obj.Ammo[%tool] = %defAmmo;
			if(%clip > %obj.Ammo[%tool])
				%clip = %obj.Ammo[%tool];
			if(%clip < %clipAmmo && %clip < %obj.Ammo[%tool] && !%obj.isReloading)
			{
			//	echo("tool ammo =" SPC %obj.Ammo[%tool] SPC "type ammo =" SPC %obj.Ammo[%ammoType] SPC "clip =" SPC %clip);
				AmmoReloadGun(%obj,%originalAmmotype);
			}
			if(%this.getName() $= "BowImage" || %this.getName() $= "SpearImage")
				%isBowSpear = true;
			if(!%isBowSpear)
				%clipAnd = %clip @ "<color:CCCCCC>/";
			if(!isObject(%lefty) && %tool.image !$= %lefty)
				bottomPrint(%obj.client,"<font:impact:24><br><br><br><br><color:FFF200><just:right>Ammo:<color:FFFFFF>" SPC %clipAnd @ %obj.Ammo[%tool] SPC "",2);
		}
	}
	//Unmount Weapon
	function WeaponImage::onUnMount(%this,%obj,%slot)
	{
		Parent::onUnMount(%this,%obj,%slot);
	}
	//on Ready
	function WeaponImage::onReady(%this,%obj,%slot)
	{
		%ammoType = %this-1;
		%Gun = checkForSpecials(%obj);
		%lefty = %obj.getMountedImage(1);
		if(isObject(%lefty) && %obj.getImageTrigger(1) == 1)
		{
			%tool = %obj.tool;
			%obj.tool = %tool;
		}
		else if(isObject(%lefty))
			%obj.tool = %tool;
		if(%this.getName() !$= "GLPipeImage")
			%tool = %obj.defAmmoType;
		else
			%tool = %ammoType;
		if(%this.getName() $= "BowAmmoImage" || %this.getName() $= "SpearAmmoImage")
			%isBowSpear = true;
		if(%obj.Ammo[%tool] != 0)
		{
			echo("Ammo onReady clip =" SPC %clip);
			%clip = %obj.clip[%tool];
			if(%clip == 0 && !%obj.isReloading && !%isBowSpear)
				AmmoReloadGun(%obj,%tool);
			else if(%obj.isBowSpear)
				%obj.setImageAmmo(0,1);
		}
		else if(%Gun $= "valid" && $Pref::HataAmmo::Enabled)
		{
			%obj.setImageAmmo(0,0);
			%obj.clip[%tool] = 0;
		}
	}
	//Shoot Weapon
	function WeaponImage::onFire(%this,%obj,%slot)
	{
		%canShoot = fireAmmoReduction(%this,%obj,%slot);
		if(%canShoot)
			Parent::onFire(%this,%obj,%slot);
	}
	//Touch an Item
	function Armor::onCollision(%data,%obj,%col,%a,%b,%c,%d,%e,%f)
	{
		if(%col.canPickup && $Pref::HataAmmo::Enabled)
		{
			%usedAmmo = %col.Ammo;
			%colData = %col.getDatablock();
			%ammoWep = checkForAmmoWep(%obj,%colData);
			if(%ammoWep)
			{
				checkAmmo(%obj,%colData,%ammoWep);
				ammoPickUp(%col,%obj,%colData);
				spawnAmmo(%obj,%colData,%usedAmmo);
				return;
			}
		}
		Parent::onCollision(%data,%obj,%col,%a,%b,%c,%d,%e,%f);
	}
};activatePackage(HataAmmo);



//Deduct Ammo on-Fire
function fireAmmoReduction(%this,%obj,%slot)
{
	%data = %obj.getDatablock();
	%ammoType = %this-1;
	%tool = checkForTool(%obj,%ammoType);
	%Gun = checkForSpecials(%obj);
	%lefty = %obj.getMountedImage(1);
	if(isObject(%lefty) && %obj.getImageTrigger(1) == 1)
	{
		%tool = %obj.tool;
		%obj.tool = %tool;
	}
	else if(isObject(%lefty))
		%obj.tool = %tool;
	if(%this.getName() !$= "GLPipeImage")
		%tool = %obj.defAmmoType;
	if(isObject(%tool) && %tool.getName() $= "BowItem" && %obj.Ammo[%tool] == 0)
		%obj.setImageAmmo(0,0);
	if(%this.getName() $= "CraftHammerImage" || %this.getName() $= "CraftHammerRedImage" || %this.getName() $= "LeftCraftHammerImage" || %this.getName() $= "LeftCraftHammerRedImage")
	{
		%canShoot = true;
		%crafting = true;
	}
	if(%obj.Ammo[%tool] != 0 && !%crafting && %this.getName() !$= "BrickImage")
	{
		%clip = %obj.clip[%tool];
		if(%clip !$= "" && %clip > 0 && !%obj.isReloading)
		{
			%canShoot = true;
			%obj.Ammo[%tool] = %obj.Ammo[%tool] - 1;
			%obj.clip[%tool] = %obj.clip[%tool] - 1;
			%obj.isFull[%tool] = false;
		}
		else if(%this.getName() $= "BowAmmoImage" || %this.getName() $= "SpearAmmoImage")
		{
			%canShoot = true;
			%isBowSpear = true;
			%obj.Ammo[%tool] = %obj.Ammo[%tool] - 1;
			%obj.isFull[%tool] = false;
		}
	}
	else if(%Gun $= "valid" && !%crafting && $Pref::HataAmmo::Enabled)
		%obj.clip[%tool] = 0;
	if(%Gun $= "other" || !$Pref::HataAmmo::Enabled)
		%canShoot = true;
	else if($Pref::HataAmmo::Enabled)
	{
		if(!%isBowSpear)
			%clipAnd = %obj.clip[%tool] @ "<color:CCCCCC>/";
		bottomPrint(%obj.client,"<font:impact:24><br><br><br><br><color:FFF200><just:right>Ammo:<color:FFFFFF>" SPC %clipAnd @ %obj.Ammo[%tool] SPC "",2);
	}
	return %canShoot;
}

//Start Reloading
function AmmoReloadGun(%obj,%tool)
{
	%currAmmo = %obj.Ammo[%tool];
	%image = %tool.image;
	if(!isObject(%tool))
		return;
	%obj.setImageAmmo(0,0);
	if(!%obj.isReloading && %currAmmo > 0)
	{
		%clipAmmo = getClipAmmo(%tool);
		%wep = %obj.getMountedImage(0);
		%pos = %obj.getMuzzlePoint(0);
		serverPlay3D(brickchangesound,%pos);
		if(%clipAmmo > %currAmmo)
			%clipAmmo = %currAmmo;
		if(%wep.getName() $= "GLPipeImage" || %wep.getName() $= "P90AmmoImage")
		{
			%obj.isReloading = true;
			%obj.playthread(3,shiftTo);
			%obj.schedule(200,playthread,3,shiftLeft);
			%obj.schedule(400,playthread,3,plant);
			%obj.schedule(600,playthread,3,shiftaway);
			%obj.schedule(800,playthread,3,shiftRight);
			schedule(1000,0,eval,%obj@".isReloading = false;");
			schedule(1000,0,AmmoFinishReload,%obj,%wep,%tool);
			%obj.clip[%tool] = %clipAmmo;
		}
		if(%wep.getName() $= "AkimboGunAmmoImage")
		{
			%obj.isReloading = true;
			%obj.playthread(3,plant);
			%obj.schedule(400,playthread,3,shiftDown);
			%obj.schedule(800,playthread,3,plant);
			schedule(1200,0,eval,%obj@".isReloading = false;");
			schedule(1200,0,AmmoFinishReload,%obj,%wep,%tool);
			%obj.clip[%tool] = %clipAmmo;
		}
		if(%wep.getName() $= "GunAmmoImage" || %wep.getName() $= "BowAmmoImage" || %wep.getName() $= "ShotgunAmmoImage")
		{
			%obj.isReloading = true;
			%obj.playthread(3,shiftTo);
			%obj.schedule(200,playthread,3,shiftLeft);
			schedule(600,0,eval,%obj@".isReloading = false;");
			schedule(600,0,AmmoFinishReload,%obj,%wep,%tool);
			if(%wep.getName() $= "BowAmmoImage")
				%obj.clip[%tool] = "";
			else
				%obj.clip[%tool] = %clipAmmo;
		}
		if(%wep.getName() $= "SpearAmmoImage")
		{
			%obj.isReloading = true;
			%obj.playthread(3,shiftAway);
			%obj.playthread(2,activate);
			%obj.schedule(200,playthread,3,shiftTo);
			schedule(600,0,eval,%obj@".isReloading = false;");
			schedule(600,0,AmmoFinishReload,%obj,%wep,%tool);
			%obj.clip[%tool] = "";
		}
	}
}

//Finish Reloading
function AmmoFinishReload(%obj,%image,%tool)
{
	%obj.setImageAmmo(0,1);
	if(!isObject(%image))
		return;
	%pos = %obj.getHackPosition();
	%vec = %obj.getEyeVector();
	%add = vectorScale(%vec,0.3);
	if(%obj.getMountedImage(0) == %image)
		serverPlay3D(brickplantsound,vectorAdd(%pos,%add));

	%clip = %obj.clip[%tool];
	if(%clip > %obj.Ammo[%tool])
		%clip = %obj.Ammo[%tool];
	%clipAnd = %clip @ "<color:CCCCCC>/";
	bottomPrint(%obj.client,"<font:impact:24><br><br><br><br><color:FFF200><just:right>Ammo:<color:FFFFFF>" SPC %clipAnd @ %obj.Ammo[%tool] SPC "",2);
}

//Check All Tools for Ammo
function checkAmmo(%obj,%ammoType,%ammoWep)
{
	%data = %obj.getDatablock();
	for(%i=0;%i<%data;%i++)
	{
		%tool = %obj.tool[%i];
		if(%tool == %ammoType)
			%weapon = %tool;
	}

	if(!%ammoWep || !isObject(%weapon))
		return;
	%currAmmo = getAmmoCount(%obj,%ammoType);
	%maxAmmo = getMaxAmmo(%ammoType);
	%Ammo = %currAmmo;

	if(%Ammo > 0)
		%obj.setImageAmmo(0,1);
	if(%currAmmo < %maxAmmo)
		%obj.isFull[%ammoType] = false;
	else
		%obj.isFull[%ammoType] = true;
}

//Pick Up Weapon to Get Ammo
function ammoPickUp(%col,%obj,%ammoType)
{
	%data = %obj.getDatablock();
	for(%i=0;%i<%data.maxTools;%i++)
	{
		%tool = %obj.tool[%i];
		if(isObject(%tool) && !%obj.isFull[%ammoType])
		{
			%ammoWep = checkForAmmoWep(%obj,%tool);
			if(%tool == %ammoType && %ammoWep)
			{
				%obj.tool[%i] = 0;
				messageClient(%obj.client,'MsgItemPickup','',%i,0);
				%hasFreeSlot = true;
			}
		}
		else if(!isObject(%tool))
			%hasFreeSlot = true;
	}

	%ammoWep = checkForAmmoWep(%obj,%ammoType);
	if(%obj.isFull[%ammoType] && %ammoWep)
		return;
	if(%hasFreeSlot)
		%obj.pickup(%col);
}

//Add Ammo
function spawnAmmo(%obj,%ammoType,%usedAmmo)
{
	%data = %obj.getDatablock();
	for(%i=0;%i<%data.maxTools;%i++)
	{
		%tool = %obj.tool[%i];
		if(%tool == %ammoType)
			%weapon = %tool;
	}

	%ammoWep = checkForAmmoWep(%obj,%ammoType);
	if(!%ammoWep || !isObject(%weapon))
		return;
	%currAmmo = getAmmoCount(%obj,%ammoType);
	%defAmmo = getDefAmmo(%ammoType);
	%maxAmmo = getMaxAmmo(%ammoType);
	%Ammo = %currAmmo + %usedAmmo;

	if(%Ammo > 0)
		%obj.setImageAmmo(0,1);
	if(%usedAmmo $= "")
		%Ammo = %currAmmo + %defAmmo;
	if(%Ammo >= %maxAmmo)
		%Ammo = %maxAmmo;
	if(%currAmmo < %maxAmmo)
		%obj.isFull[%ammoType] = false;
	else
		%obj.isFull[%ammoType] = true;

	%obj.Ammo[%ammoType] = %Ammo;
	%wep = %obj.getMountedImage(0);
	if(%obj.tool[%obj.currTool] != %ammoType && %Ammo !$= "")
		centerPrint(%obj.client,"<font:impact:24><br><br><br><br><br><br><br><color:FFF200><just:right>Ammo:<color:FFFFFF>" SPC %Ammo SPC "",2);
	else if(isObject(%wep))
	{
		if(%wep.getName() !$= "BowAmmoImage" && %wep.getName() !$= "SpearAmmoImage")
			%clipAnd = %obj.clip[%ammoType] @ "<color:CCCCCC>/";
		bottomPrint(%obj.client,"<font:impact:24><br><br><br><br><color:FFF200><just:right>Ammo:<color:FFFFFF>" SPC %clipAnd @ %Ammo SPC "",2);
	}
}

//Check for Ammo Compatible Guns
function checkForAmmoWep(%obj,%item)
{
	if(!isObject(%item))
		return;
	if(%item.getName() $= "GunItem" || %item.getName() $= "AkimboGunItem" || %item.getName() $= "P90Item" || %item.getName() $= "ShotgunItem" || %item.getName() $= "GLPipeItem" || %item.getName() $= "BowItem" || %item.getName() $= "SpearItem")
		return true;
}

//Check for Ammo Duplicate Guns
function checkForSpecials(%obj)
{
	%wep = %obj.getMountedImage(0);
	if(!isObject(%wep))
		return;
	if(%wep.getName() $= "GunAmmoImage" || %wep.getName() $= "AkimboGunAmmoImage" || %wep.getName() $= "P90AmmoImage" || %wep.getName() $= "ShotgunAmmoImage" || %wep.getName() $= "GLPipeImage" || %wep.getName() $= "BowAmmoImage" || %wep.getName() $= "SpearAmmoImage")
		return "valid";
	else
		return "other";
}

//Find Item in Inventory
function checkForTool(%obj,%ammoType)
{
	%data = %obj.getDatablock();
	if($Pref::HataAmmo::Enabled)
	{
		for(%i=0;%i<%data.maxTools;%i++)
		{
			%tool = %obj.tool[%i];
			if(%tool == %ammoType)
				return %tool;
		}
	}
}

//Check Current Ammo
function getAmmoCount(%obj,%tool)
{
	if(isObject(%tool))
		%currAmmo = %obj.Ammo[%tool];
	return %currAmmo;
}

//Check For Default Pick-up Ammo
function getDefAmmo(%ammoType)
{
	if(!isObject(%ammoType))
		return;
	if(%ammoType.getName() $= "GunItem")
	{
		%defAmmo = 25;
		return %defAmmo;
	}
	if(%ammoType.getName() $= "AkimboGunItem")
	{
		%defAmmo = 50;
		return %defAmmo;
	}
	if(%ammoType.getName() $= "P90Item")
	{
		%defAmmo = 45;
		return %defAmmo;
	}
	if(%ammoType.getName() $= "ShotgunItem")
	{
		%defAmmo = 10;
		return %defAmmo;
	}
	if(%ammoType.getName() $= "GLPipeItem")
	{
		%defAmmo = 6;
		return %defAmmo;
	}
	if(%ammoType.getName() $= "BowItem")
	{
		%defAmmo = 20;
		return %defAmmo;
	}
	if(%ammoType.getName() $= "SpearItem")
	{
		%defAmmo = 15;
		return %defAmmo;
	}
}
//Check For Clip Size
function getClipAmmo(%ammoType)
{
	if(!isObject(%ammoType))
		return;
	if(%ammoType.getName() $= "GunItem")
	{
		%clipAmmo = 17;
		return %clipAmmo;
	}
	if(%ammoType.getName() $= "AkimboGunItem")
	{
		%clipAmmo = 34;
		return %clipAmmo;
	}
	if(%ammoType.getName() $= "P90Item")
	{
		%clipAmmo = 30;
		return %clipAmmo;
	}
	if(%ammoType.getName() $= "ShotgunItem")
	{
		%clipAmmo = 3;
		return %clipAmmo;
	}
	if(%ammoType.getName() $= "GLPipeItem")
	{
		%clipAmmo = 6;
		return %clipAmmo;
	}
}
//Check For Max Ammo Capacity
function getMaxAmmo(%ammoType)
{
	if(%ammoType.getName() $= "GunItem" || %ammoType.getName() $= "AkimboGunItem")
	{
		%maxAmmo = 50;
		return %maxAmmo;
	}
	if(%ammoType.getName() $= "P90Item")
	{
		%maxAmmo = 90;
		return %maxAmmo;
	}
	if(%ammoType.getName() $= "ShotgunItem")
	{
		%maxAmmo = 20;
		return %maxAmmo;
	}
	if(%ammoType.getName() $= "GLPipeItem")
	{
		%maxAmmo = 18;
		return %maxAmmo;
	}
	if(%ammoType.getName() $= "BowItem")
	{
		%maxAmmo = 40;
		return %maxAmmo;
	}
	if(%ammoType.getName() $= "SpearItem")
	{
		%maxAmmo = 30;
		return %maxAmmo;
	}
}