//Prefs
$Check::RTB_On = isFile("Add-Ons/System_ReturnToBlockland/server.cs");
if($Check::RTB_On) //check for RTB
{
	if(!$RelativeExplosiveDamage::PrefsLoaded)
	{
		if(!$RTB::RTBR_ServerControl_Hook && $Check::RTB_On) //only exec if RTB exists
			exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
		RTB_registerPref("Enabled", "Relative Explosive Damage", "Pref::RelativeExplosiveDamage::Enabled", "bool", "Support_RelativeExplosiveDamage", true);
		$RelativeExplosiveDamage::PrefsLoaded = true;
	}
}
else
	$Pref::RelativeExplosiveDamage::Enabled = true;

function RelativeExplosiveDamagePartA(%data,%proj,%pos)
{
//	talk("______________________________");
//	talk("Relative Explosive Damage Part A");
//	talk("data =" SPC %data SPC "  name =" SPC %data.getName());
//	talk("proj =" SPC %proj SPC "  initial velocity =" SPC %proj.initialVelocity);
//	talk("pos =" SPC %pos);
	$RelativeExplosiveDamageVector[%pos] = %proj.initialVelocity;
	schedule(1,0,eval,"$RelativeExplosiveDamageVector[\"" @ %pos @ "\"] = \"\";");
}

function RelativeExplosiveDamagePartB(%data,%victim,%attacker,%pos,%damage,%damageType)
{
//	talk("______________________________");
//	talk("Relative Explosive Damage Part B");
//	talk("data =" SPC %data SPC "  name =" SPC %data.getName());
//	talk("victim =" SPC %victim SPC "  shape name =" SPC %victim.getShapeName());
//	talk("attacker =" SPC %attacker SPC "  shape name =" SPC %attacker.getShapeName());
//	talk("pos =" SPC %pos);
//	talk("damage =" SPC %damage SPC "  rounded up =" SPC mCeil(%damage));
//	talk("damageType =" SPC %damageType SPC "  name =" SPC %damageType.getName());
	%relExDamVec = $RelativeExplosiveDamageVector[%pos];
	if(%relExDamVec $= "") //if relative explosive damage vector array for damage position DNE
		return; //stop here
	%projInitVel = %relExDamVec;
//	talk("Damaging Projectile Initial Velocity =" SPC %projInitVel);
	%vicPos = %victim.getPosition();
	%hitPos = %pos;
	%vhSub = vectorSub(%hitPos,%vicPos);
	%vhSubPIVDot = vectorDot(%vhSub,%projInitVel);
//	talk("victim Position =" SPC %vicPos);
//	talk("hit Position =" SPC %hitPos);
//	talk("hit Vector - Victim Vector =" SPC %vhSub);
//	talk("Dot Product of 'vhSub' and 'PIV' =" SPC %vhSubPIVDot);

	//Store Damage Safety Value to Player, momentarily
	%victim.RelativeExplosiveDamageSafety = %vhSubPIVDot;
	schedule(1,0,eval,%victim @ ".RelativeExplosiveDamageSafety = \"\";");
}

package RelativeExplosiveDamage
{
	function ProjectileData::onExplode(%data,%proj,%pos)
	{
		RelativeExplosiveDamagePartA(%data,%proj,%pos);
		Parent::onExplode(%data,%proj,%pos);
	}
	function Armor::Damage(%data,%victim,%attacker,%pos,%damage,%damageType)
	{
		RelativeExplosiveDamagePartB(%data,%victim,%attacker,%pos,%damage,%damageType);
		%safety = %victim.RelativeExplosiveDamageSafety;
		if(%safety >= -3) //if projectile is hitting from the same side as the player is partly on
		{
			if(%safety <= 0) //if player is partly on the other side of the wall
			{
				%damage = %damage * (3+%safety)/3; //scale the damage down
			//	talk("Scaled Damage Received =" SPC %damage);
			}
		//	else
		//		talk("Full Damage Received =" SPC %damage);
			Parent::Damage(%data,%victim,%attacker,%pos,%damage,%damageType); //Parent default fcn.
		}
	//	else
	//		talk("All Damage Avoided =" SPC %damage);
	}
	function ProjectileData::radiusImpulse(%data,%proj,%victim,%a,%pos,%impulse,%c)
	{
	//	talk("______________________________");
	//	talk("data =" SPC %data SPC "  name =" SPC %data.getName());
	//	talk("proj =" SPC %proj);
	//	talk("victim =" SPC %victim SPC "  name =" SPC %victim.getShapeName());
	//	talk("a =" SPC %a);
	//	talk("pos =" SPC %pos);
	//	talk("impulse =" SPC %impulse);
	//	talk("c =" SPC %c);
		
		%safety = %victim.RelativeExplosiveDamageSafety;
		if(%safety >= -3) //if projectile is hitting from the same side as the player is partly on
		{
			if(%safety <= 0) //if player is partly on the other side of the wall
			{
				%impulse = %impulse * (3+%safety)/3; //scale the damage down
			//	talk("Scaled Impulse Received =" SPC %impulse);
			}
		//	else
		//		talk("Full Impulse Received =" SPC %impulse);
			Parent::radiusImpulse(%data,%proj,%victim,%a,%pos,%impulse,%c); //Parent default fcn.
		}
	//	else
	//		talk("All Impulse Avoided =" SPC %impulse);
	}
};activatePackage(RelativeExplosiveDamage);