//Prefs
$Check::RTB_On = isFile("Add-Ons/System_ReturnToBlockland/server.cs");
if($Check::RTB_On) //check for RTB
{
	if(!$HitLocation::PrefsLoaded)
	{
		if(!$RTB::RTBR_ServerControl_Hook && $Check::RTB_On) //only exec if RTB exists
			exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
		RTB_registerPref("Crital Hits", "Hit Location", "Pref::HitLocation::Crits", "bool", "Support_HitLocation", true);
		RTB_registerPref("Disarming", "Hit Location", "Pref::HitLocation::Disarm", "bool", "Support_HitLocation", true);
		$HitLocation::PrefsLoaded = true;
	}
}
else
{
	$Pref::HitLocation::Crits = true;
	$Pref::HitLocation::Disarm = true;
}


//Main
package HitLocation
{
	//on Damage
	function Armor::Damage(%data,%player,%sourceObject,%position,%damage,%damageType)
	{
		%hitter = %sourceObject.sourceObject; //projectile's source object (shooter)
		%hitter = isObject(%hitter) ? %hitter : %sourceObject; //if hitter DNE, use the brick, or other inanimate object, that spawned the projectile
		if(isObject(%hitter) && %hitter.getType() & $Typemasks::PlayerObjectType) //if hitter exists, and hitter is a player object type
		{
			if(!$Pref::HitLocation::Crits) //if Critical Hits disabled
			{
				Parent::Damage(%data,%player,%sourceObject,%position,%damage,%damageType); //parent (with updated damage)
				return; //stop here
			}

			//Misc.
			%col = %player; //victim
			%proj = %sourceObject.HitLocationProj; //projectile object, pulled from hitter object's stored data
			%vec1 = %col.getForwardVector(); //col's forward facing vector
			%vec2 = %proj.initForwardVec; //initial forward vector of hitter on fire
			%vec2 = vectorNormalize(getWords(%vec2,0,1) SPC 0); //horizontalize the vector
			%vec3 = vectorScale(%vec2,-1); //invert vec2 (initial backward vector of hitter on fire)
						
			//Headshots
			%head = %col.getEyePoint(); //center of head
			%neck = vectorAdd(%head,"0 0 -0.1"); //offset to neck area
			%crit = getWord(%position,2) > getWord(%neck,2); //true if hit position above col's neck (head punch)
			%frnt = vectorDist(%vec1,%vec3) < 1.0; //true if hit from the front
			%crit = %col.isAmCrouch ? %frnt : %crit; //if crouched - use front of player (simulated head), otherwise - use normal head
							
			//Footshots
			%pos = %col.getPosition(); //base of col's player object
			%ankle = vectorAdd(%pos,"0 0 0.3"); //offset to feet area
			%feet = getWord(%position,2) < getWord(%ankle,2); //true if hit position above col's neck (head punch)
			%foot = vectorDist(%vec1,%vec2) < 1.0; //true if hit from the back
			%feet = %col.isAmCrouch ? %foot : %feet; //if crouched - use front of player (simulated head), otherwise - use normal head
			
			//Heartshots
			%rvec = findRelativeX(%vec1); //rightward vector
			%lvec = vectorScale(%rvec,-1); //leftward vector
			%hack = %col.getHackPosition(); //torso position
			%hOff = vectorScale(%lvec,0.25); //leftward offset torso-like position adjustment vector
			%hPos = vectorAdd(%hOff,%hack); //heart position
			%hPosDot = vectorDot(%hPos,%lvec); //vector dot, leftward, of heart position
			%PosiDot = vectorDot(%position,%lvec); //vector dot, leftward, of hit position
			%heart1 = vectorDist(%hPosDot,%PosiDot) < 0.13; //true if shot near the heart
			%heart2 = mAbs(getWord(%hack,2)-getWord(%position,2)) < 0.3; //bug fix (vertical adjustment accounted for, now)
			%heart = %heart1 && %heart2 ? true : false; //Composite, boolean switch.

			//Stealtshots
			%bVec = vectorScale(%vec1,-1); //make backward vector
			%bPosDot = vectorDot(%hack,%bVec); //vector dot forward of victim's hack position
			%PosiDotF = vectorDot(%position,%bVec); //vector dot forward of hit position
			%back = %bPosDot-%PosiDotF <= -0.625; //true if hit from behind
		}
		
		//Apply Hit Location Damages
		if(%player.isHitCrouch) //Default, crouch damage, override
			%damage = %damage/2; //protect them
		if(%heart) //Heartshot (crouch adjusted)
		{
			%damage = 100*%damage; //Kill them
		//	talk("Heartshot!");
		}
		else if(%crit) //Headshot (crouch adjusted)
		{
			%damage = 100*%damage; //Kill them
		//	talk("Headshot!");
		}
		else if(%feet) //Legshot (crouch adjusted)
		{
			%damage = 100*%damage; //Incapacitate them (out of commission, out of the game)
		//	talk("Legshot!");
		}
		else if(%back) //Stealthshot
		{
			%damage = 2*%damage; //Scare them
		//	talk("Stealthshot!");
		}

		//Parent default fcn
		Parent::Damage(%data,%player,%sourceObject,%position,%damage,%damageType); //parent (with updated damage)
	}
	
	//Player on Trigger
	function Armor::onTrigger(%data,%player,%slot,%val)
	{
		if(%slot == 3) //if lcrouching
			%player.isHitCrouch = %val; //store crouch bool to player object
		Parent::onTrigger(%data,%player,%slot,%val); //parent
	}
	
	//Projectile on Hit (via Damage)
	function ProjectileData::Damage(%data,%proj,%col,%fade,%pos,%normal)
	{
		//Hook for Armor::Data (to Add Projectile Object data)
		if(isObject(%player = %proj.sourceObject)) //if hitter exists
			%player.HitLocationProj = %proj; //Store projectile object to hitter object, as data
		Parent::Damage(%data,%proj,%col,%fade,%pos,%normal); //Parent default fcn (IMPORTANT!)
		%player.HitLocationProj = 0; //reset stored projectile object, data
		
		//Drop item if handshot
		%play = %col.getType() & $Typemasks::PlayerObjectType; //col category = player?
		%shape = fileName(%col.getDatablock().shapeFile) $= "m.dts"; //col model = m.dts (main Blockhead model)?
		if(%play && %shape && %col.getState() !$= "Dead" && $Pref::HitLocation::Disarm) //if %play, and %shape, and col is not dead, and Pref: Disarm on
		{
			%muzz = %col.getMuzzlePoint(0); //right hand
			%mvec = %col.getMuzzleVector(0); //aim direction
			%sub = vectorScale(%mvec,-1); //offset length
			%back = vectorAdd(%muzz,%sub); //offset position
			%dist = vectorDist(%back,%pos); //distance between arm/hand and the hit position
			if(%dist < 0.4) //if hit position is close enough to the enemy's hand,
				HitLocForceDropItem(%col,%proj); //Try to drop the weapon
		//	talk("Hand dist =" SPC %dist);
		}
	}
};ActivatePackage(HitLocation);

//Force Drop Item
function HitLocForceDropItem(%player,%source)
{
	%client = %player.client; //define %client
	if(miniGameCanDamage(%source,%player) && (!isObject(%client) || isObject(%client.minigame))) //if the shooter can damage player, and (player has no client, or player's client is in a minigame)
	{
		%player.playthread(1,activate); //anim
		%wep = %player.getMountedImage(0); //right handed Image ID
		if(%player.currTool > -1 && %player.tool[%player.currTool].canDrop) //if %player has a tool, and the tool can be dropped
		{
			servercmdDropTool(%player.client,%player.currTool); //drop it
			return; //stop
		}

		%item = %wep-1; //find Item from Weapon Image
		if(!isObject(%wep) || !%item.canDrop) //if no weapon, or its Item cannot be dropped
			return; //stop

		%player.unmountImage(0); //remove Image from right hand
		%item = new item() //spawn new Item (fake drop, for bots)
		{
			datablock = %item;
		};
		if(isObject(%item)) //if Item created properly, spawn it
		{
			%item.schedulePop();
			%pos = %player.getPosition();
			%rot = getWords(%player.getTransform(),3,6);
			%pos = vectorAdd(%pos,"0 0 1.7");
			%fVec = %player.getForwardVector();

			%item.setTransform(vectorAdd(vectorScale(%fVec,1.5),%pos) SPC %rot);
			%item.setVelocity(vectorAdd(vectorScale(%fVec,7),%player.getVelocity())); //throw it forward (like normal item dropping)
			%item.miniGame = getMiniGameFromObject(%player);
		}
	}
}

//Hata's Relative Vector
function findRelativeX(%vec)
{
	%hVec = getWords(%vec,0,1) SPC 0; //build vector from horizontal component of input vector
	%nhVec = vectorNormalize(%hVec); //normalized horizontal vector
	return vectorCross(%nhVec,"0 0 1"); //return rightward vector
}