//Projectile
datablock ProjectileData(WeakDaggerProjectile : SwordProjectile)
{
	directDamage 		= 11;
	lifetime            = 65;
	fadeDelay           = 65;
	uiName = "";
};

//Item
datablock ItemData(WeakDaggerItem : swordItem)
{
	shapeFile = "add-ons/weapon_sword/sword.dts";
	uiName = "Weak Dagger";
	doColorShift = true;
	colorShiftColor = "0.1 0 0 1";
	image = WeakDaggerImage;
};

//Image
datablock ShapeBaseImageData(WeakDaggerImage)
{
   // Basic Item properties
   shapeFile = "add-ons/weapon_sword/sword.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";
   rotation = eulerToMatrix("-180 0 0");
   eyeOffset = 0; //"0.7 1.2 -0.5";
   correctMuzzleVector = false;
   className = "WeaponImage";

   item = WeakDaggerItem;
   ammo = " ";
   projectile = WeakDaggerProjectile;
   projectileType = Projectile;

   melee = true;
   armReady = true;

   doColorShift = true;
   colorShiftColor = WeakDaggerItem.colorShiftColor;

   // Initial start up state
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.5;
	stateTransitionOnTimeout[0]     = "Ready";
	stateSound[0]                   = swordDrawSound;

	stateName[1]                    = "Ready";
	stateTransitionOnTriggerDown[1] = "PreFire";
	stateAllowImageChange[1]        = true;

	stateName[2]					= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
//	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]			= true;

	stateName[4]					= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]			= true;
//	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";
};

function WeakDaggerImage::onFire(%this,%obj,%slot)
{	
//	%player = %obj;
//	%muz = %player.getMuzzleVector(0);
//	%fwd = %player.getForwardVector();
//	%muz = getWord(%muz,2);
//	%fwd = getWord(%fwd,2);
//	%med = -0.3;
//	%isSwung = swungCheck(%player,%muz);
//	if(%isSwung)
//	{
//	//	echo("muz =" SPC %muz);
//		if(!%player.isFirstSwung && %muz > %med)
//		{
//			%player.isFirstSwung=1;
//			schedule(800,0,eval,%player@".isFirstSwung=0;");
//		}
//	}
//	%player.muz = %muz;
//	%player.isSwung = %isSwung;
	Parent::onFire(%this,%obj,%slot);
	%obj.playthread(3,shiftaway);
	%obj.playthread(2,activate);
}
function WeakDaggerProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
//	%player = %obj.sourceObject;
//	if(%player.isFirstSwung && %player.isSwung)
//	{
		Parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);
	//	makeSwordExplosion(%player,%pos);
//	}
}
function swungCheck(%obj,%muz)
{
	%old = %obj.muz;
	%dist = vectorDist(%old,%muz);
//	echo("old =" SPC %old);
//	echo("dist =" SPC %dist);
	if(%dist > 0.05 && %old !$= "" && %old > %muz)
		return 1;
}
function makeSwordExplosion(%obj,%pos)
{
	if(isObject(%obj.sEx))
		%obj.sEx.delete();
	%sEx = new Projectile()
	{
		dataBlock = WeakDaggerExplosionProjectile;
		initialPosition = %pos;
		initialVelocity = %normal;
		sourceObject = %obj;
		client = %obj.client;
	};
	MissionCleanup.add(%sEx);
	%sEx.explode();
	%obj.sEx = %sEx;
}


function WeakDaggerImage::onMount(%this,%obj,%slot)
{
	Parent::onMount(%this,%obj,%slot);
//	%obj.setArmThread(armattack);
}
function WeakDaggerImage::onUnMount(%this,%obj,%slot)
{
	Parent::onUnMount(%this,%obj,%slot);
//	%obj.setArmThread(look);
}