//RTB Prefs
$Check::RTB_On = isFile("Add-Ons/System_ReturnToBlockland/server.cs");
if($Check::RTB_On && !$KingdomHearts::PrefsLoaded) //if RTB file exists, and Prefs not already loaded
{
	if(!$RTB::RTBR_ServerControl_Hook && $Check::RTB_On) //if RTB exists
		exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs"); //exec this hook
	
	//Stats
	RTB_registerPref("Leveling (by XP)","Kingdom Hearts | Stats","$Pref::KingdomHearts::Leveling","bool","Player_KingdomHearts",true);
	RTB_registerPref("Max Level","Kingdom Hearts | Stats","$Pref::KingdomHearts::LvlMax","int 3 21","Player_KingdomHearts",9);
	RTB_registerPref("Level XP Requirement","Kingdom Hearts | Stats","$Pref::KingdomHearts::LvlXP","int 5 50","Player_KingdomHearts",25);
	
	RTB_registerPref("Default MP","Kingdom Hearts | Stats","$Pref::KingdomHearts::defMP","int 50 100","Player_KingdomHearts",50);
	RTB_registerPref("Default HP","Kingdom Hearts | Stats","$Pref::KingdomHearts::defHP","int 50 100","Player_KingdomHearts",50);
	
	RTB_registerPref("MP+ Per Level-up","Kingdom Hearts | Stats","$Pref::KingdomHearts::LvlMP","int 10 100","Player_KingdomHearts",50);
	RTB_registerPref("HP+ Per Level-up","Kingdom Hearts | Stats","$Pref::KingdomHearts::LvlHP","int 10 100","Player_KingdomHearts",50);
	
	//Prize Orbs (on Death drops)
	RTB_registerPref("Orbs Dropped","Kingdom Hearts | Prize Orbs","$Pref::KingdomHearts::OrbNum","int 0 10","Player_KingdomHearts",10);
	RTB_registerPref("Orb MP+ Value","Kingdom Hearts | Prize Orbs","$Pref::KingdomHearts::OrbMP","int 5 50","Player_KingdomHearts",10);
	RTB_registerPref("Orb HP+ Value","Kingdom Hearts | Prize Orbs","$Pref::KingdomHearts::OrbHP","int 5 50","Player_KingdomHearts",10);
	$KingdomHearts::PrefsLoaded = true; //set 'Prefs Loaded' bool to true
}
else if(!$Check::RTB_On) //if RTB DNE
{
	$Pref::KingdomHearts::Leveling = true;
	$Pref::KingdomHearts::LvlMax = 9;
	$Pref::KingdomHearts::LvlXP = 25;
	
	$Pref::KingdomHearts::defMP = 50;
	$Pref::KingdomHearts::defHP = 50;
	
	$Pref::KingdomHearts::LvlMP = 50;
	$Pref::KingdomHearts::LvlHP = 50;
	
	$Pref::KingdomHearts::OrbNum = 10;
	$Pref::KingdomHearts::OrbMP = 10;
	$Pref::KingdomHearts::OrbHP = 10;
}

//Scripts
exec("./Tool_CommandMenus.cs"); //Menu items
exec("./Main_KingdomHearts.cs"); //Main script
exec("./Weapon_KingdomSpells.cs"); //Magic


/////////
//Stats//
/////////

//Create Kingdom Hearts Stats file (if it DNE)
if(!isFile("config/server/KingdomHearts.cs"))
{
	$KingdomHearts::Stats[1] = "Kingdom Hearts: Stats save file";
	export("$KingdomHearts::Stats*","config/server/KingdomHearts.cs");
	echo("Kingdom Hearts: Stats file - first created!");
}
//Define a Stat
function KingdomStatFix(%stat,%onTrue)
{
	%result = %stat $= "" ? %onTrue : %stat; //if 'stat' input arg. undefined - use 'onTrue' input arg., else - use 'stat'
	return %result; //return result
}
//Save to Kingdom Hearts Stats file
function KingdomSaveStats(%client,%bl_id)
{
	if(!%client.hasLoadedKingdomStats) //If client's Stats are not yet loaded
		return; //stop here

	%lvlLock = KingdomStatFix(%client.KingdomLevelLock,false); //if Level Lock (XP Zero) state undefined - make it = false
	%curLvl = KingdomStatFix(%client.KingdomLevel,0); //if 'current Level' undefined - set it to 0
	%curXP = KingdomStatFix(%client.KingdomXP,%client.score); //if 'current XP' undefined - use client's minigame score
	
	%statlvlLock = getWord($KingdomHearts::Stats[%bl_id],0); //stored Level Lock (XP Zero) state bool
	%statCurLvl = getWord($KingdomHearts::Stats[%bl_id],1); //stored Level integer
	%statCurXP = getWord($KingdomHearts::Stats[%bl_id],2); //stored XP integer
	
	if((%statLvlLock == %lvlLock) && (%statCurLvl == %curLvl) && (%statCurXP == %curXP)) //if (stored Level Lock bool matches current Level Lock bool) AND (stored Level int. matches current Level int.) AND (stored XP int. matches current XP int.) //Do no update if all current values match stored values
		return; //stop here
	
	$KingdomHearts::Stats[%bl_id] = %lvlLock SPC %curLvl SPC %curXP; //organize Stats into a string, linked to the client's bl_id
	export("$KingdomHearts::Lev*","config/server/KingdomHearts.cs"); //export (write) Stats to 'Kingdom Hearts' config file
//	echo("Saved Level for" SPC %client.name @ ". Saved Level =" SPC $KingdomHearts::Level[%bl_id]);
}
//Load from Kingdom Hearts Stats file
function KingdomLoadStats(%client,%bl_id)
{
	if(!isFile("config/server/KingdomHearts.cs")) //if Stats save file DNE
		return; //stop here
	
	%client.hasLoadedKingdomStats = true; //set 'Loaded Kingdom Hearts Stats' to true for this client
	
	exec("config/server/KingdomHearts.cs"); //execute the Stats save file (to update the following values)

	%client.KingdomLevelLock = getWord($KingdomHearts::Stats[%bl_id],0); //stored Level Lock (XP Zero) state bool
	%client.KingdomLevel = getWord($KingdomHearts::Stats[%bl_id],1); //stored Level integer
	%client.KingdomXP = getWord($KingdomHearts::Stats[%bl_id],2); //stored XP integer
	
//	echo("Loaded Stats for" SPC %client.name @ ". Stats =" SPC %client.KingdomLevel SPC "  XP Zero =" SPC %client.KingdomLevelLock SPC "  XP =" SPC %client.KingdomXP);
}

//Save Stats on Server Exit
package KingdomServerFile
{
	//Save Stas on Client Leave Sever
	function GameConnection::OnClientLeaveGame(%client)
	{
		KingdomSaveStats(%client,%client.bl_ID);
		Parent::OnClientLeaveGame(%client);
	}
	//Save Stats on Host Quit BL Application
	function OnExit()
	{
		for(%i=0;%i<ClientGroup.getCount();%i++)
		{
			%client = ClientGroup.getObject(%i);
			KingdomSaveStats(%client,%client.bl_ID);
		}
		Parent::OnExit();
	}
};activatePackage(KingdomServerFile);