//grenadeLauncher.cs

//audio
datablock AudioProfile(grenadeFireSound)
{
   filename    = "./grenadeL_fire.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(grenadeExplodeSound)
{
   filename    = "./grenadeL_blast.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(grenadeReloadSound)
{
   filename    = "./grenadeL_reload.wav";
   description = AudioDefault3d;
   preload = true;
};

//shell

//grenade trail effects
datablock ParticleData(grenadeTrailParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 1.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 825;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 1 0.2";
	colors[1]     = "1 1 0.3 0.07";
	colors[2]     = "1 1 0.2 0.0";
	sizes[0]      = 0.38;
	sizes[1]      = 0.12;
	sizes[2]	  = 0.01;
	times[0]      = 0.0;
	times[1]	  = 0.1;
	times[2]      = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(grenadeTrailEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "grenadeTrailParticle";
};


datablock ParticleData(grenadeLExplosionParticle)
{
   dragCoefficient      = 8;
   gravityCoefficient   = -5;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 700;
   lifetimeVarianceMS   = 300;
   textureName          = "base/data/particles/cloud";
   spinSpeed		= 10.0;
   spinRandomMin		= -50.0;
   spinRandomMax		= 50.0;
   colors[0]     = "0.9 0.5 0.0 0.9";
   colors[1]     = "0.0 0.0 0.0 0.9";
   colors[2]     = "0.0 0.0 0.0 0.0";

   sizes[0]      = 5.9;
   sizes[1]      = 6.0;
   sizes[2]      = 7.0;

   times[0] = 0.0;
   times[1] = 0.2;
   times[2] = 1.0;

   useInvAlpha = true;
};
datablock ParticleEmitterData(grenadeLExplosionEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 15;
   velocityVariance = 1.0;
   ejectionOffset   = 1.2;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "grenadeLExplosionParticle";
};

datablock ParticleData(grenadeLExplosionRingParticle)
{
   dragCoefficient      = 8;
   gravityCoefficient   = -0.5;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 40;
   lifetimeVarianceMS   = 10;
   textureName          = "base/data/particles/star1";
   spinSpeed		= 10.0;
   spinRandomMin		= -500.0;
   spinRandomMax		= 500.0;
   colors[0]     = "1 0.5 0.0 0.5";
   colors[1]     = "0.9 0.0 0.0 0.0";
   sizes[0]      = 4;
   sizes[1]      = 8;

   useInvAlpha = false;
};
datablock ParticleEmitterData(grenadeLExplosionRingEmitter)
{
   lifeTimeMS = 50;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 3.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "grenadeLExplosionRingParticle";
};


datablock ParticleData(grenadeLExplosionChunkParticle)
{
   dragCoefficient      = 0;
   gravityCoefficient   = 3;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 1400;
   lifetimeVarianceMS   = 1300;
   textureName          = "base/data/particles/chunk";
   spinSpeed		= 10.0;
   spinRandomMin		= -500.0;
   spinRandomMax		= 500.0;
   colors[0]     = "0.1 0.1 0.1 0.5";
   colors[1]     = "0.0 0.0 0.0 0.5";
   sizes[0]      = 0.7;
   sizes[1]      = 0;

   useInvAlpha = true;
};
datablock ParticleEmitterData(grenadeLExplosionChunkEmitter)
{
   lifeTimeMS = 25;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 25;
   velocityVariance = 0.0;
   ejectionOffset   = 3.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "grenadeLExplosionChunkParticle";
};


datablock ExplosionData(grenadeLExplosion)
{
   explosionShape = "";
   soundProfile = grenadeExplodeSound;

   lifeTimeMS = 150;

   particleEmitter = grenadeLExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = grenadeLExplosionRingEmitter;
   emitter[1] = grenadeLExplosionChunkEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 20.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 20;
   lightStartColor = "1 1 0 1";
   lightEndColor = "1 0 0 0";

   damageRadius = 3;
   radiusDamage = 110;

   impulseRadius = 8;
   impulseForce = 3400;

   playerBurnTime = 6000;
};
datablock ProjectileData(grenadeLauncherProjectile)
{
   projectileShapeName = "./grenade.dts";
   directDamage        = 0;
   directDamageType = $DamageType::rocketDirect;
   radiusDamageType = $DamageType::rocketRadius;
   impactImpulse	   = 1000;
   verticalImpulse	   = 0;
   explosion           = grenadeLExplosion;
   particleEmitter     = grenadeTrailEmitter;

   brickExplosionRadius = 3;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 50;             
   brickExplosionMaxVolume = 76;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 98;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   muzzleVelocity      = 35;
   velInheritFactor    = 1.0;

   armingDelay         = 800;
   lifetime            = 2000;
   fadeDelay           = 1500;
   bounceElasticity    = 0.3;
   bounceFriction      = 0.50;
   isBallistic         = true;
   gravityMod = 1;
   explodeondeath = true;

   hasLight    = false;
   lightRadius = 5.0;
   lightColor  = "1 0.5 0.0";

   uiName = "Grenade";
};

//////////
// item //
//////////
datablock ItemData(grenadeLauncherItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./grenadeLauncher.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Grenade Launcher";
	iconName = "./ci_grenadeLauncher";
	doColorShift = false;
	colorShiftColor = "0.100 0.500 0.250 1.000";

	 // Dynamic properties defined by the scripts
	image = grenadeLauncherImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(grenadeLauncherImage)
{
   // Basic Item properties
   shapeFile = "./grenadeLauncher.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = grenadeLauncherProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;
   //colorShiftColor = grenadeLauncherItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

//this is like, right out of the sixshooter. seriously.

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.25;
	stateTransitionOnTimeout[0]       = "Reload";
	stateSequence[0]	= "Activate";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Ammo1";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

//reload passage!

	stateName[2]                     = "Reload";
	stateAllowImageChange[2]         = true;
	stateSequence[2]                = "Reload";
	stateScript[2]                  = "Reload";
	stateSequence[2]	= "Reload";
	stateTransitionOnTimeout[2]     = "Ready";
	stateWaitForTimeout[2]			= true;
	stateTimeoutValue[2]				= 0.95;
	stateSound[2]					= grenadeReloadSound;

	stateName[3]                     = "SKIPPED";

//ammo passage and firing
//first shot

	stateName[4]                    = "Ammo1";
	stateTransitionOnTimeout[4]     = "Ammo1Ready";
	stateTimeoutValue[4]            = 0.84;
	stateFire[4]                    = true;
	stateAllowImageChange[4]        = false;
	stateSequence[4]                = "Fire";
	stateScript[4]                  = "onFire";
	stateWaitForTimeout[4]			= true;
	stateEmitter[4]					= gunFlashEmitter;
	stateEmitterTime[4]				= 0.02;
	stateEmitterNode[4]				= "muzzleNode";
	stateSound[4]					= grenadeFireSound;

	stateName[5]                     = "Ammo1Ready";
	stateTransitionOnTriggerDown[5]  = "Ammo2";
	stateAllowImageChange[5]         = true;
	stateSequence[5]	= "Ready";

//second shot

	stateName[6]                    = "Ammo2";
	stateTransitionOnTimeout[6]     = "Ammo2Ready";
	stateTimeoutValue[6]            = 0.84;
	stateFire[6]                    = true;
	stateAllowImageChange[6]        = false;
	stateSequence[6]                = "Fire";
	stateScript[6]                  = "onFire";
	stateWaitForTimeout[6]			= true;
	stateEmitter[6]					= gunFlashEmitter;
	stateEmitterTime[6]				= 0.02;
	stateEmitterNode[6]				= "muzzleNode";
	stateSound[6]					= grenadeFireSound;

	stateName[7]                     = "Ammo2Ready";
	stateTransitionOnTriggerDown[7]  = "Ammo3";
	stateAllowImageChange[7]         = true;
	stateSequence[7]	= "Ready";

//third shot

	stateName[8]                    = "Ammo3";
	stateTransitionOnTimeout[8]     = "Ammo3Ready";
	stateTimeoutValue[8]            = 0.84;
	stateFire[8]                    = true;
	stateAllowImageChange[8]        = false;
	stateSequence[8]                = "Fire";
	stateScript[8]                  = "onFire";
	stateWaitForTimeout[8]			= true;
	stateEmitter[8]					= gunFlashEmitter;
	stateEmitterTime[8]				= 0.02;
	stateEmitterNode[8]				= "muzzleNode";
	stateSound[8]					= grenadeFireSound;

	stateName[9]                     = "Ammo3Ready";
	stateTransitionOnTriggerDown[9]  = "Ammo4";
	stateAllowImageChange[9]         = true;
	stateSequence[9]	= "Ready";

//fourth shot

	stateName[10]                    = "Ammo4";
	stateTransitionOnTimeout[10]     = "Ammo4Ready";
	stateTimeoutValue[10]            = 0.84;
	stateFire[10]                    = true;
	stateAllowImageChange[10]        = false;
	stateSequence[10]                = "Fire";
	stateScript[10]                  = "onFire";
	stateWaitForTimeout[10]			= true;
	stateEmitter[10]					= gunFlashEmitter;
	stateEmitterTime[10]				= 0.02;
	stateEmitterNode[10]				= "muzzleNode";
	stateSound[10]					= grenadeFireSound;

	stateName[11]                     = "Ammo4Ready";
	stateTransitionOnTriggerDown[11]  = "Ammo5";
	stateAllowImageChange[11]         = true;
	stateSequence[11]	= "Ready";

//fifth shot

	stateName[12]                    = "Ammo5";
	stateTransitionOnTimeout[12]     = "Ammo5Ready";
	stateTimeoutValue[12]            = 0.84;
	stateFire[12]                    = true;
	stateAllowImageChange[12]        = false;
	stateSequence[12]                = "Fire";
	stateScript[12]                  = "onFire";
	stateWaitForTimeout[12]			= true;
	stateEmitter[12]					= gunFlashEmitter;
	stateEmitterTime[12]				= 0.02;
	stateEmitterNode[12]				= "muzzleNode";
	stateSound[12]					= grenadeFireSound;

	stateName[13]                     = "Ammo5Ready";
	stateTransitionOnTriggerDown[13]  = "Ammo6";
	stateAllowImageChange[13]         = true;
	stateSequence[13]	= "Ready";

//sixth shot and loop back to reload

	stateName[14]                    = "Ammo6";
	stateTransitionOnTimeout[14]     = "Reload";
	stateTimeoutValue[14]            = 0.84;
	stateFire[14]                    = true;
	stateAllowImageChange[14]        = false;
	stateSequence[14]                = "Fire";
	stateScript[14]                  = "onFire";
	stateWaitForTimeout[14]			= true;
	stateEmitter[14]					= gunFlashEmitter;
	stateEmitterTime[14]				= 0.02;
	stateEmitterNode[14]				= "muzzleNode";
	stateSound[14]					= grenadeFireSound;
};
